Package: ASpli
Type: Package
Title: Analysis of Alternative Splicing Using RNA-Seq
Version: 2.21.0
Date: 2024-03-22
Author: Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky and Ariel Chernomoretz
License: GPL
biocViews: ImmunoOncology, GeneExpression, Transcription,
        AlternativeSplicing, Coverage, DifferentialExpression,
        DifferentialSplicing, TimeCourse, RNASeq, GenomeAnnotation,
        Sequencing, Alignment
Depends: methods, grDevices, stats, utils, parallel, edgeR, limma,
        AnnotationDbi
Imports: GenomicRanges, GenomicFeatures, BiocGenerics, IRanges,
        GenomicAlignments, Gviz, S4Vectors, Rsamtools, BiocStyle,
        igraph, htmltools, data.table, UpSetR, tidyr, DT, MASS, grid,
        graphics, pbmcapply, txdbmaker
Description: Integrative pipeline for the analysis of alternative
             splicing using RNAseq.
Suggests:
Maintainer: Ariel Chernomoretz <algo107@gmail.com>
git_url: https://git.bioconductor.org/packages/ASpli
git_branch: devel
git_last_commit: 6fd6add
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
NeedsCompilation: no
Packaged: 2025-11-04 21:15:23 UTC; biocbuild

# Make plot for a set of bins
.plotBins <- function( counts, as, bin, factorsAndValues, targets, main ,
    colors ,  panelTitleColors, panelTitleCex, innerMargins , 
    outerMargins, useBarplots, barWidth, barSpacer, las.x, useHCColors,
    legendAtSide, outfolder, outfileType, deviceOpt) {
  
  for ( cBin in bin) {
    print(cBin)
    filename <- if ( ! is.null( outfolder )) {
          file.path( outfolder , .makeValidFileName( paste0(cBin,'.pr.',outfileType ) ) )
        } else {
          outfolder
        }
    
    .plotSingleBin( counts, as, cBin, factorsAndValues, targets, main, colors, 
        panelTitleColors, panelTitleCex, innerMargins, outerMargins, 
        useBarplots, barWidth, barSpacer, las.x, useHCColors, legendAtSide,
        filename, outfileType, deviceOpt )
  }
}

# ---------------------------------------------------------------------------- #
# .getHCColor return a color that should have high contrast with a another given
# color and also with the white background 
.getHCColor <- function ( color ) {
  rgbCol <- col2rgb ( color , alpha = TRUE)
  brightness <- mean( rgbCol [ 1:3,1 ] )
  if ( brightness < 95 ) {
    if ( rgbCol [ 1,1 ] > rgbCol [ 2,1 ] & rgbCol [ 1,1 ] > rgbCol [ 3,1 ] ) {
      return( rgb( 0.3,0.5,1,1 ) )
    }
    if ( rgbCol [ 2,1 ] > rgbCol [ 1,1 ] & rgbCol [ 2,1 ] > rgbCol [ 3,1 ] ) {
      return( rgb( 1, 0.1,0.1,1 ) )
    }
    return( rgb( 0.3,1, 0.5,1 ) )
  } else {
    return( rgb( 0, 0, 0 ,1 ) )
  }
}
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# This function get a vector data for a bin property, with many values as
# samples. Values are averaged by condition a then returned as a list of
# vectors grouped by the main factor values.
.prepareData <- function( samplesProfileData, gridPanels, targets, factorsAndValues ) {
  
  mainFactorIndex <- length( factorsAndValues )
  targets$samplesNames <- rownames( targets)
  
  data <- lapply ( 1:nrow( gridPanels ) , function ( i ) {
        
        samplesData <- merge( targets, gridPanels[ i, , drop = FALSE ], 
            by = colnames( gridPanels[ i, , drop = FALSE ] ) )
        
        mainFactorValues <- factorsAndValues[[ mainFactorIndex ]]
        
        plotData <- sapply ( mainFactorValues, 
            function( x ) { 
              samples <- samplesData[ 
                  samplesData[ , names( factorsAndValues[ mainFactorIndex ] ) ] == x  , 
                  'samplesNames' ]
              rowMeans ( samplesProfileData[ rownames( targets ) %in% samples ] )
            } )
        
        plotData[ is.na( plotData )] <- 0
        return( plotData )
      } )
  return(data)
}
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# .makeLegends creates a top-left legend over a single plot.
.makeLegends <- function( main , useHCColors, col, panelTitleColor, panelTitleCex ) {
  legend( 
      x = "topleft", 
      legend = main,
      adj = c( 0 , 0 ),
      yjust = 0.5,
      bty = "n",
      cex = panelTitleCex,
      text.col = if ( useHCColors ) .getHCColor( col ) else { panelTitleColor } )
}
# ---------------------------------------------------------------------------- #


# -------------------------------------------------------------------------- #
# Function to make a single xy plot 
.plotLines <- function ( data, dataCons, gridPanels, nPoints, xTicksLabels, 
    factorsAndValues, mainFactorIndex, minValue, maxValue, main, col, 
    legendAtSide, las.x , panelTitleCex ) {
  
  plot( x = 1:length( dataCons ) , 
      y = dataCons,
      pch = 20,
      type = 'p',
      col = 'gray',
      ylim = c( minValue, maxValue),
      xlab='',
      xaxt = "n",
      ylab = if ( legendAtSide ) main else '',
      yaxt = 'n',
      cex.lab = panelTitleCex )
  
  secFactorTable <- table( gridPanels[ , ncol(gridPanels)] )
  st = 0
  for ( i in 1:nrow( secFactorTable )) {
    from <-  (st + 1)
    to <- st + secFactorTable[i] * nPoints
    at <- c(from:to)
    axis( side = 1, 
        at = at, 
        labels= xTicksLabels[from:to], 
        las=las.x , 
        cex.axis=0.7, tck=0,
        mgp=c(3,0.3,0),
        col= rgb(0.9,0.9,0.9) )
    st <- to
  }
  
  st = 0
  for( i in 1:nrow( gridPanels )) { 
    lines( x = st + 1:length( factorsAndValues[[ mainFactorIndex ]] ) , 
        y = data[[i]],
        col = col)
    st <- st + length( factorsAndValues[[mainFactorIndex]] )
  }
}
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# Function to make a single bar plot 
.plotBars <- function( dataCons, nPoints, barWidth, barSpacer, maxValue, main, 
    useHCColors, panelTitleColor, xTicksLabels, col, las.x, legendAtSide, panelTitleCex) {
  spacers <- c( (1 - barWidth) / barWidth, barSpacer)
  dataCons <- matrix( dataCons, ncol = nPoints, byrow = TRUE ) 
  barplot ( height = t( dataCons ),
      col = col,
      ylim = c( 0, maxValue),
      xlab = '',
      ylab = if ( legendAtSide ) main else '',
      yaxt = 'n',
      width = barWidth,
      space = spacers,
      border = '#DDDDDDFF',
      beside = TRUE,
      las = 2,
      cex.lab = panelTitleCex)
  
  ticks <- matrix( 1, 
      ncol = ncol(dataCons),
      nrow = nrow(dataCons))
  spacerTick <- barWidth * barSpacer - ( 1 - barWidth )
  ticks <- cbind( ticks, spacerTick )
  
  ticks <- as.vector( t( ticks ) )
  
  ac <- 0
  tickSum <- c()
  for ( i in 1 : (length( ticks ) -1) ) {
    tickSum <- append( tickSum , ac + ticks[i])
    ac <- tickSum[i]
  }
  
  tickSum <- tickSum - ( 1 - ( spacerTick + (1-barWidth) ) ) + barWidth / 2
  
  
  tlblmat <- matrix ( xTicksLabels, byrow=TRUE, ncol = ncol(dataCons) ) 
  tlblmat <- cbind( tlblmat, '' )
  xTicksLabels <- as.vector( t(tlblmat) )[1:( length( tickSum ) )]
  
  axis( 
      side = 1, 
      at = tickSum , 
      labels = xTicksLabels, 
      las = las.x , 
      cex.axis = 0.7, 
      tck=0,
      mgp = c(3,0.3,0),
      col = rgb( 0.9,0.9,0.9, 0 ),
      padj = 0.5 )
}
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# Create the labels for factor corresponding to the x axis of plots. 
.makeXticksLabels <- function( justOneFactor, gridPanels, factorsAndValues, 
    mainFactorIndex, data ) {
  
  if ( ! justOneFactor ) {
    
    xTicksLabels <- rep( apply( gridPanels, 1, 
            function( x ) paste0(x,collapse=  ".") ), sapply( data, length  ) )
    xTicksLabels <- apply( gridPanels, 1, function( x ) paste0(x,collapse=  ".") )
    xTicksLabels <- expand.grid( factorsAndValues[[ mainFactorIndex]], xTicksLabels )
    xTicksLabels <- paste0( xTicksLabels[,2] ,".",  xTicksLabels[,1] )
    
  } else {
    xTicksLabels <- factorsAndValues[[mainFactorIndex]]
  }
  return( xTicksLabels )
}
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# Main plotting function
.makePlot <- function ( data, useBarPlot = FALSE, main, col, factorsAndValues, 
    justOneFactor, gridPanels, nPoints, legendAtSide, las.x, panelTitleCex,
    panelTitleColor, useHCColors, barWidth, barSpacer ) {
  
  mainFactorIndex <- length( factorsAndValues )

  # Get the labels of ticks in the x axis.
  xTicksLabels <- .makeXticksLabels( justOneFactor , gridPanels, 
      factorsAndValues, mainFactorIndex, data )
  
  # Get the y axis minimum and maximum values. Used to scale the plots correctly.
  maxValue <- max ( sapply ( data, max ))
  minValue <- min ( sapply ( data, min ))
  
  # Make a unique vector will all data
  dataCons <- Reduce( function( a, b) { a <- append( a, b )}, data )

  # Remove box around plots
  par( bty = 'n')
  
  # Make the main plot
  if ( ! useBarPlot ) {
    .plotLines (data, dataCons , gridPanels , nPoints, xTicksLabels, 
        factorsAndValues, mainFactorIndex, minValue, maxValue, main, 
        col = col, legendAtSide = legendAtSide , las.x, panelTitleCex )
  } else {
    .plotBars(dataCons, nPoints, barWidth, barSpacer, maxValue, main, 
        useHCColors, panelTitleColor, xTicksLabels, col, las.x, legendAtSide, 
        panelTitleCex )
  }
  
  # Add legend inside plot is required
  if ( ! legendAtSide ) {
    .makeLegends( main, useHCColors, col, panelTitleColor, panelTitleCex )
  }
  
  # Draw y axis ticks
  axis( 2, las=1, cex.axis=0.7 )
  
}
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# .plotbins draw all plots for a given bin
.plotSingleBin <- function( 
    counts, 
    as,
    bin, 
    factorsAndValues, 
    targets,
    main            = NULL,
    colors          = c( '#2F7955', '#79552F', '#465579', '#A04935', '#752020', 
        '#A07C35') ,
    panelTitleColors = '#000000',
    panelTitleCex   = 1,
    innerMargins    = c( 2.1, 3.1, 1.1, 1.1 ),
    outerMargins    = c( 0, 0, 2.4, 0 ), 
    useBarplots     = NULL,
    barWidth        = 0.9,
    barSpacer       = 0.4,
    las.x           = 2,
    useHCColors     = FALSE,
    legendAtSide    = TRUE,
    outfile         = NULL,
    outfileType     = 'png',
    deviceOpt       = NULL
    ) {
  
  # -------------------------------------------------------------------------- #
  # Manipulate factors
  # If just one factor, add another fictional factor with only one value to
  # make computation easier.
  justOneFactor <- FALSE
  if ( length ( factorsAndValues) == 1 ) {
    factorsAndValues <- append( factorsAndValues, list( single = 1 ) )
    colnames( joint(as) ) [ 
        match( unique( targets[,names(factorsAndValues)[[1]]] ), colnames( joint(as) ))
    ] <- paste( unique( targets[,names(factorsAndValues)[[1]]] ), '1',sep='_')
    targets <- cbind( targets, single = 1 )
    justOneFactor <- TRUE
  }
  # Create condition names
  targets <- .condenseTargetsConditions(targets)
  # factorsAndValues is reversed, this is required later in expand.grid.
  factorsAndValues <- factorsAndValues[ rev( names( factorsAndValues ) ) ]
  # Get the index of the first factor before factor list is reversed.
  mainFactorIndex  <- length( factorsAndValues )
  # Get the number of points of main factor
  nPoints          <- length( factorsAndValues[[ mainFactorIndex ]] )
  # -------------------------------------------------------------------------- #

  # -------------------------------------------------------------------------- #
  # Get the combination of all factors other than the main 
  gridPanels <- expand.grid( factorsAndValues[-mainFactorIndex] )
  
  # Subset from all factor combinations those that are present in the targets
  condInTargets <-  unique( apply( targets[ , names( gridPanels ) , drop= FALSE], 1,
          function(x) paste0(x,collapse = "_") ) )
  
  condInGrid <- apply( gridPanels, 1,
      function(x) paste0(x,collapse = "_") )
  
  gridPanels <- gridPanels[ condInGrid %in% condInTargets , , drop=FALSE ]
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Extract data from bin
  binCounts <- .extractCountColumns( countsb( counts )[ bin,] , targets )
  geneLocus <- countsb( counts )[ bin,'locus']
  
  geneCounts <- .extractCountColumns( countsg( counts )[ geneLocus,] , targets )
  
  psir <- joint( as )[ bin, as.character( unique( targets$condition ) ) ]
  psir [ is.na(psir) ] <- 0
  
  J123 <- joint( as )[ bin,  colnames( joint( as ) ) %in%  rownames(targets)]
  ac <- 0
  J1   <- J123[ ( ac + 1 ) : ( ac + nrow(targets) ) ]
  ac <- ac + nrow(targets)
  J2   <- J123[ ( ac + 1 ) : ( ac + nrow(targets) ) ]
  ac <- ac + nrow(targets)
  J3   <- J123[ ( ac + 1 ) : ( ac + nrow(targets) ) ]
  # -------------------------------------------------------------------------- #

  # -------------------------------------------------------------------------- #
  # creates the graphic device
  outputIsAValidFile <- ( ! is.null( outfile ) ) && 
                        ( file.access( dirname( outfile ) , 2 ) == 0 ) 
                    
  if ( outputIsAValidFile ) {

    devicesNames <- c( 'png', 'bmp', 'jpeg', 'tiff', 'pdf')
    devices      <- list( png, bmp, jpeg, tiff, pdf)

    deviceIndex <- match( tolower( outfileType ), devicesNames )
    
    if ( is.na(deviceIndex) ) { 
      dev.new()
      message( paste('Format',outfileType,'is not recognized.',
              'Select png, bmp, jpeg, tiff or pdf') )

    } else {
      device <- devices[[ deviceIndex ]]
      undefDeviceOpt <-  is.null( deviceOpt )
      
      if ( (! is.na( deviceIndex )) && deviceIndex %in%  c(1:4) ) {
        fileNameOpt <- list( filename = outfile)
        defaultDeviceOpt <- list( res = 200, height = 1500, width = 600, 
            pointsize = 12, units = 'px')
      }
      
      if ( (! is.na( deviceIndex )) && deviceIndex ==  5 ) {
        fileNameOpt <- list( file = outfile)
        defaultDeviceOpt <- list( height = 7.5, width = 3, 
            pointsize = 12)        
      }
      
      deviceOpt <- if ( undefDeviceOpt ) 
            append( defaultDeviceOpt, fileNameOpt ) 
          else 
            append( deviceOpt, fileNameOpt )
      do.call( device, deviceOpt )    
      
    }
    
  } else {
    dev.new()
    if ( ! is.null ( outfile ) ) {
      message( paste( "File:",outfile,"cannot be created." ) )
    }
  }
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Draw the plot

  # Define colors. Repeat colors if required
  colors <- rep_len( colors, 6 )
  panelTitleColors <- rep_len( panelTitleColors, 6)

  # Sets plot layout  
  par( mfrow= c( 6 , 1 ) )
  
  # Set inner and outer margins
  par( oma = outerMargins,
       mar = innerMargins )
   
  # If useBarplot is not defined then set it as true if main factor has two or
  # less points to show
  useBarplots <- ( ( ! is.null ( useBarplots ) )  &&  useBarplots ) |
                 ( is.null( useBarplots ) ) && ( ( nPoints <= 2 ) ) 
  
  # Add Bin count data
  data <- .prepareData( binCounts, gridPanels, targets, factorsAndValues )
  .makePlot( data, useBarplots, main = "Bin counts", col = colors[1], 
      factorsAndValues, justOneFactor, gridPanels, nPoints, legendAtSide,
      las.x, panelTitleCex, panelTitleColors[1], useHCColors, barWidth, barSpacer )
  
  # Add Gene count data
  data <- .prepareData( geneCounts, gridPanels, targets, factorsAndValues )
  .makePlot( data, useBarplots, main = "Gene counts", col = colors[2], 
      factorsAndValues, justOneFactor, gridPanels, nPoints, legendAtSide,
      las.x, panelTitleCex, panelTitleColors[2], useHCColors, barWidth, barSpacer )
  
  # Add PSI/PIR count data
  # There is only one psir value for each condition ( instead for each sample as
  # other profiles being plotted. The value for condition is repeated for each
  # sample in that condition and then processed as the other data.
  psir <- psir[, rep( colnames(psir), as.vector( table(targets$condition)[ unique(targets$condition) ] ))]
  colnames(psir) <- rownames( targets )
  data <- .prepareData( psir , gridPanels, targets, factorsAndValues )
  .makePlot( data, useBarplots, main = "PSI / PIR", col = colors[3], 
      factorsAndValues, justOneFactor, gridPanels, nPoints, legendAtSide,
      las.x, panelTitleCex, panelTitleColors[3], useHCColors, barWidth, barSpacer )
  
  # Add J1 Exc count data
  data <- .prepareData( J1, gridPanels, targets, factorsAndValues )
  .makePlot( data, useBarplots, main = "Incl. junc 1", col = colors[4], 
      factorsAndValues, justOneFactor, gridPanels, nPoints, legendAtSide,
      las.x, panelTitleCex, panelTitleColors[4], useHCColors, barWidth, barSpacer )
  
  # Add J2 Exc count data
  data <- .prepareData( J2, gridPanels, targets, factorsAndValues )
  .makePlot( data, useBarplots, main = "Incl. junc 2", col = colors[5], 
      factorsAndValues, justOneFactor, gridPanels, nPoints, legendAtSide,
      las.x, panelTitleCex, panelTitleColors[5], useHCColors, barWidth, barSpacer )
  
  # Add J3 Exc count data
  data <- .prepareData( J3, gridPanels, targets, factorsAndValues )
  .makePlot( data, useBarplots, main = "Exclu. junc", col = colors[6], 
      factorsAndValues, justOneFactor, gridPanels, nPoints, legendAtSide,
      las.x, panelTitleCex, panelTitleColors[6], useHCColors, barWidth, barSpacer )
  
  # Draw the main Title of the plot
  if ( is.null(main) ) { main = bin }
  title( main = bin, outer=TRUE)
  # -------------------------------------------------------------------------- #

  # -------------------------------------------------------------------------- #
  # Close graphic device if required
  if ( outputIsAValidFile ) {
    output <- capture.output( dev.off() )
  } 
  # -------------------------------------------------------------------------- #
  
}


#-------------------------------------------------
#Plot splicing pattern
#-------------------------------------------------
# colnames(reportes$col_16_pcp_16@binbased)[21]   <- "junction.nonuniformity"
# colnames(reportes$col_16_pcp_16@anchorbased)[7] <- "junction.nonuniformity"
# colnames(reportes$col_23_col_16@binbased)[21]   <- "junction.nonuniformity"
# colnames(reportes$col_23_col_16@anchorbased)[7] <- "junction.nonuniformity"
# colnames(reportes$pcp_23_pcp_16@binbased)[21]   <- "junction.nonuniformity"
# colnames(reportes$pcp_23_pcp_16@anchorbased)[7] <- "junction.nonuniformity"
# colnames(reportes$col_23_pcp_23@binbased)[21]   <- "junction.nonuniformity"
# colnames(reportes$col_23_pcp_23@anchorbased)[7] <- "junction.nonuniformity"

#region=NULL;exones=NULL;genePlot=TRUE;zoomRegion=1.5;chrMap=NULL;hCov=0.7;hJun=0.3;useLog=FALSE
#bamFiles <- c("col0_16.star.bam","pcp_16.star.bam")
#mergedBAMs <- data.frame(bam=bamFiles,condition=c("col_16","pcp_16"))
#region <- iss$region[1]
#iss <- integrateSignals(sr, asd)
#chrMap <- as.character(1:5)
#names(chrMap) <- paste0("Chr",1:5)
#.plotSplicingPattern(region, iss, counts, f, mergedBAMs, sr, exones, chrMap = chrMap)
.countJbyCondition<-function(jcoords,counts){
  x<-countsj(counts)[rownames(jcoords),]
  mjsum <-c()
  for(ifila in 1:nrow(x)){
    jsum<-c()
    for(ccond in counts@condition.order){
      cnames <- rownames(targets(counts))[which(targets(counts)$condition%in%ccond)]
      jsum <- c(jsum,sum(x[ifila,cnames]))
    }
    mjsum<-rbind(mjsum,jsum)
  }
  colnames(mjsum)<-counts@condition.order
  rownames(mjsum)<-rownames(x)
  return(mjsum)
} 


# region: coordenadas genomicas de una region de interes (e.g. Chr1:1054200-1054285). 
#         Debe ser elegida a partid del objeto iss (ver abajo)
# iss   : objeto obtenido a partir de integrateSplicingSignals
# counts: ASpliCounts object
# f     : ASpliFeatures object
# mergedBAMs: data frame con dos columnas: full_path_file_name_bam_file condition (compatible con nomenclatura de aspli)
# sr    : ASpliSplicingReport object
# exones: si GRangesList object que contiene GRanges de bines para cada transcripto del genoma. 
#         si es NULL no se plotea estructura de variantes
# genePlot: si TRUE se grafica el esquema de splicing de la region en el contexto del gen al cual pertenece
#           si FALSE se centra la figura en la region
# jCompletelyIncluded: si TRUE solo se grafican junturas no diferenciales que esten completamente incluidas en la region de ploteo
#                      si FALSE se grafican junturas no diferenciales que overlapeen con la region de ploteo
# zoomRegion: factor para magnificar el area ploteada centrada en la region de interes
# chrMap    : vector nombrado que permite mapear nombres de cromosomas *utilizados en la denofinicion de region) en aquellos 
#             utilizados en bams
# 
# chrMap <- 1:5
# names(chrMap) <- c("Chr1", "Chr2", "Chr3", "Chr4", "Chr5")
# mergedBams <- c("/xdata1/porcupine_data/STAR/mergedBAMS/col0_16.star.bam",
#                 "/xdata1/porcupine_data/STAR/mergedBAMS/col0_23.star.bam",
#                 "/xdata1/porcupine_data/STAR/mergedBAMS/pcp_16.star.bam",
#                 "/xdata1/porcupine_data/STAR/mergedBAMS/pcp_23.star.bam")
# mergedBAMs <- data.frame(full_path_file_name_bam_file = mergedBams, condition = c("col_16", "col_23", "pcp_16", "pcp_23"))
#.plotSplicingPattern(region, iss, counts, f, mergedBAMs, sr, chrMap = chrMap)

.plotSplicingPattern<-function(region=NULL,iss,counts,f,mergedBAMs,sr,asd,genePlot=TRUE,jCompletelyIncluded=TRUE,
                              zoomRegion=1.5,useLog=FALSE,tcex=2){
  #region <- r
  #iss <- is
  #counts
  #f <- features
  #mergedBAMs <- mergedBams
  
  if(length(transcriptExons(f))==1){
    warning("transcriptExons(f) has only one element. This could imply that something is wrong with the ASpliFeature object.\n")
  }
  
  variants = transcriptExons(f)
  
  
  #alturas relativas de paneles de coverage y junturas
  hCov=0.7
  hJun=0.3
  
  greg <- region
  nConditions <- nrow(mergedBAMs)
  
  iiss  <- iss[iss$region %in% greg,]
  if(nrow(iiss)==0){
    warning("No valid region provided. Out.\n")
    return()
  }
  
  geneName<-as.character(iiss[,"locus"])
  
  #encuentra x: GRanges para graficar
  if(!genePlot){
    
    #nombre de cromosoma en aspli
    aspli.chr <- strsplit2(strsplit2(iiss$region,":")[1], "Chr")
    if(ncol(aspli.chr) == 2){
      aspli.chr <- aspli.chr[, 2]
    }else{
      aspli.chr <- aspli.chr[, 1]
    }
    
    #nombre de cromosomas en features
    features.chr<-levels(seqnames(featuresb(f))@values)
    
    if(is.na(match(aspli.chr,features.chr))){
      #if(is.null(chrMap)){ #chrMap no se define mas asi que deberia entrar siempre aca
        warning(paste("No se pudo mapear nombres de cromosomas.",
                      "\n aspli.chr=",aspli.chr,
                      "\n features.chr=",paste(features.chr,collapse="/")))
      #}else{
       # chr <- features.chr[match(aspli.chr,features.chr)]
      #}
    }else{
      chr <- aspli.chr
    }
    
    roi   <- as.numeric(strsplit2(strsplit2(iiss$region,":")[2],"-"))
    #si hay una J3 != NA la uso para definir el rango
    if(!is.na(iiss$J3)){
      #si J3 se movio en un cluster, uso el cluster para definir el rango
      #  if(iiss$jl==1){
      #    #TODO
      #  }else{
      
      #roiJ3   <- as.numeric(strsplit2(as.character(iiss$J3),".",fixed=TRUE)[2:3])
      
      #chequeo si tengo mas de una J3
      j3aux <- strsplit2(iiss$J3,";")
      roiJ3<-c()
      for(ij3 in seq_along(j3aux)){
        roiJ3   <- c(roiJ3,as.numeric(strsplit2(j3aux[ij3],".",fixed=TRUE)[2:3]))
      }
      roiJ3 <- range(roiJ3)
      
      #  }
      
      roi[1] <- min(roi,roiJ3)
      roi[2] <- max(roi,roiJ3)
    }
    
    delta <- roi[2]-roi[1]
    
    zroi  <- c(roi[1]-delta*zoomRegion/2 , roi[2]+delta*zoomRegion/2)
    zdelta<-zroi[2]-zroi[1]
    
    gr    <- as(paste0(chr,":",zroi[1],"-",zroi[2]),"GRanges")
    hits  <- findOverlaps(gr,featuresb(f))
    bins  <-featuresb(f)[subjectHits(hits)]
    
    bins  <- bins[mcols(bins)$feature!="Io",]
    
    #redefino la zoomedroi en base a los bines que overlapeaban la zroi original
    delta <- max(end(bins))-min(start(bins))
    #zroi  <- c(start(bins)[1]-delta*zoomRegion/2 , end(bins)[length(bins)]+delta*zoomRegion/2)
    zroi  <- c(start(bins)[1], end(bins)[length(bins)])
    
  }else{
    
    #identifico coordenadas de biones ebinsonicos
    #iE <- which(mcols(featuresb(f))$locus%in%geneName & mcols(featuresb(f))$feature=="E"
    iE <- which(mcols(featuresb(f))$locus%in%geneName)
    if(length(iE)==0){
      #Is this a monoexonic gene?
      if(length(featuresg(f)[[geneName]])==1){
        bins <- featuresg(f)[geneName]
        mcols(bins)<-data.frame(locus=geneName,bin="E001",feature="mono E",
                                symbol=mcols(bins)$symbol,
                                locus_overlap=mcols(bins)$locus_overlap,
                                class="E",
                                event="novel",
                                eventJ="-")
        zroi <- roi <- as.numeric(c(start(bins)[1],end(bins)[length(bins)]))
      }else{
       warning("Something terribly wrong happened...No annotation data
              for",geneName," could be found!\nProbably a monoexonic gene...")
       return()
      }
    }else{
     bins <- featuresb(f)[iE,]
     bins <- bins[mcols(bins)$feature!="Io",]
     zroi <- roi <- c(start(bins)[1],end(bins)[length(bins)])
    }
    
    
    
  }
  
  #Armado del layout
  if(is.null(variants)){
    hh <- c(rep(c(hCov,hJun)/nConditions,nConditions),0.1)
    hh <- hh/sum(hh)
  }else{
    hh <- c(rep(c(hCov,hJun)/nConditions,nConditions),(hCov+hJun)/nConditions)
    hh <- hh/sum(hh)
  }
  #layout(matrix(c((2*nConditions+1):1,rep(1+2*nConditions+1:nConditions,each=2),(3*nConditions+2)),ncol=2),width=c(0.8,.2),height=hh)
  layout(matrix((2*nConditions+1):1),widths=c(0.8,.2),heights=hh)
  
  par(mar=c(.5, 1.1, .5, 1.1))
  
  rownames(mergedBAMs)<-mergedBAMs[,1]
  
  
  # Si hay variants...dibujo variantes
  if(!is.null(variants)){
    #transcriptGene<-strsplit2(names(variants),".",fixed=TRUE)[,1]
    transcriptGene <- mcols(variants)[,"gene"]
    
    ig<-which(transcriptGene%in%geneName)
    tex <- variants[ig]
    tex <- tex[order(names(tex))]
    
    limvariants<-unlist(lapply(tex,function(x){
      return(c(start(x),end(x)))
    }))
    
    plot(0,typ="n",xlim=range(limvariants),ylim=c(0,length(tex)+3),axes=FALSE,xlab="",ylab="")
    
    if(length(tex)>1 | !genePlot){
      for(itex in 1:length(tex)){
        bbins <- tex[[itex]]
        y<-length(tex)-(itex-1)
        lines(c(start(bbins[1]),end(bbins[length(bbins)])),c(y,y),col="gray")
        rect(start(bbins),y-.3,end(bbins),y+0.3,col=rgb(.7,.7,.7),border="black")
        
      }
    }
    ycollapsed <- length(tex)+2
  }else{
    ycollapsed <- 0
  }
  
  # Bines del genoma anotado que overlapean con el roi
  iE   <- mcols(bins)$feature%in%c("E","mono E")
  iroi <- (start(bins)>=roi[1] & start(bins)<roi[2])
  
  nbines <- length(bins)
  delta <- end(bins[nbines])-start(bins[1])
  
  if(is.null(variants)){
    plot(0,typ="n",xlim=c(start(bins[1]),end(bins[nbines])),ylim=c(-.5,.5),axes=FALSE,xlab="",ylab="")
  }
  lines(c(start(bins[1]),end(bins[nbines])),c(ycollapsed,ycollapsed),col="gray")
  rect(start(bins)[iE],ycollapsed-.45,end(bins)[iE],ycollapsed+.45,col="white")
  
  #remarco la roi original
    xroi   <- as.numeric(strsplit2(strsplit2(iiss$region,":")[2],"-"))
    lines(xroi,rep(ycollapsed-.6,2),col="black",lwd=3)
    
  #grafico el zoom
  if(!genePlot){
    lines(c(start(bins[1]),par("usr")[1]),c(ycollapsed+.45,par("usr")[4]),lty=1,col="gray")
    lines(c(end(bins[nbines]),par("usr")[2]),c(ycollapsed+.45,par("usr")[4]),lty=1,col="gray")
  }
  
  #bines diferenciales
  
  #que bines diferenciales hay en la region?
  iE<-which(names(bins)%in%iiss$bin)
  if(length(iE)>0){
    for(iie in seq_along(iE)){
      if(mcols(bins)$feature[iE[iie]]%in%c("Io","I")){
        lines(c(start(bins[iE[iie]]),end(bins[iE[iie]])),
              c(ycollapsed,ycollapsed),col="orange",lwd=3)
      }else{
        if(iiss$b!=0 | iiss$bjs!=0){
         if(iiss$b!=0 & iiss$bjs==0) cc <- "orange"
         if(iiss$b!=0 & iiss$bjs!=0) cc <- "red"
         if(iiss$b==0 & iiss$bjs!=0) cc <- "yellow"
         rect(start(bins[iE[iie]]),
              ycollapsed-.45,
              end(bins[iE[iie]]),
              ycollapsed+.45,col=cc,border=NA)
        } 
      }
    }
  }
  
  
  lines(par("usr")[1:2],rep(ycollapsed-1,each=2),lty=2,col="gray")
  
  # Junturas
  jcount1<-jcount2<-jcount0<-nj0<-nj1<-nj2<-0
  # aspli.chr <- strsplit2(strsplit2(iiss$region,":")[1], "[cC]hr")
  # if(ncol(aspli.chr) == 2){
  #   aspli.chr <- aspli.chr[, 2]
  # }else{
  #   aspli.chr <- aspli.chr[, 1]
  # }
  aspli.chr <- strsplit2(iiss$region,":")[1]
  
  
  
  
  #que junturas estan dentro de la zona?
  jsplit <- strsplit2(rownames(junctionsPJU(asd)),".",fixed=TRUE)
  if(jCompletelyIncluded){
    ijsplit <- which(jsplit[,1]==aspli.chr & as.numeric(jsplit[,2])>=zroi[1] & as.numeric(jsplit[,3])<=zroi[2])
  }else{
    ijsplit <- which(jsplit[,1]==aspli.chr & 
                       ((as.numeric(jsplit[,2])>=zroi[1] & as.numeric(jsplit[,2])<=zroi[2]) |
                          (as.numeric(jsplit[,3])>=zroi[1] & as.numeric(jsplit[,3])<=zroi[2])) )
  }
  

  # busco anchor junctions
  js <- unique(anchorbased(sr)$junction)
  aux <- strsplit2(js,".",fixed=TRUE)
  # ijs <-which(aux[,1]==aspli.chr &
  #               as.numeric(aux[,2])>=zroi[1] &
  #               as.numeric(aux[,2])<=zroi[2])  #ACA HAbia un error!
  if(jCompletelyIncluded){
    ijs <- which(aux[,1]==aspli.chr & as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])
  }else{
    ijs <- which(aux[,1]==aspli.chr & 
                   ((as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,2])<=zroi[2]) |
                      (as.numeric(aux[,3])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])) )
  }
  jcoords1<-c()
  if(length(ijs)>0){
    #jcoords1          <- matrix(as.numeric(aux[ijs,]),ncol=3)
    jcoords1          <- data.frame(aux[ijs,,drop=FALSE],stringsAsFactors = FALSE)
    jcoords1[,2] <- as.numeric(jcoords1[,2])
    jcoords1[,3] <- as.numeric(jcoords1[,3])
    rownames(jcoords1)<-js[ijs]
    nj1               <- nrow(jcoords1)
  }
  
  #analizo locale 
  js <- unique(localebased(sr)$junction)
  aux <- strsplit2(js,".",fixed=TRUE)
  # ijs <-which(aux[,1]==aspli.chr &
  #               as.numeric(aux[,2])>=zroi[1] &
  #               as.numeric(aux[,2])<=zroi[2]) #ACA HAbia un error!
  if(jCompletelyIncluded){
    ijs <- which(aux[,1]==aspli.chr & as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])
  }else{
    ijs <- which(aux[,1]==aspli.chr & 
                   ((as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,2])<=zroi[2]) |
                      (as.numeric(aux[,3])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])) )
  }
  jcoords2<-c()
  if(length(ijs)>0){
    #jcoords2          <- matrix(as.numeric(aux[ijs,]),ncol=3)
    jcoords2          <- aux[ijs,]
    jcoords2          <- data.frame(aux[ijs,,drop=FALSE],stringsAsFactors = FALSE)
    jcoords2[,2] <- as.numeric(jcoords2[,2])
    jcoords2[,3] <- as.numeric(jcoords2[,3])
    
    rownames(jcoords2)<-js[ijs]
    nj2               <- nrow(jcoords2)
  }
  
  # junturas en la region que no son anchor ni locale
  jcoords0<-c()
  if(length(ijsplit)>0){ 
    jcoords0 <- data.frame(chr=jsplit[ijsplit,1],#chr=as.numeric(jsplit[ijsplit,1]),
                           start=as.numeric(jsplit[ijsplit,2]),
                           end=as.numeric(jsplit[ijsplit,3]))
    rownames(jcoords0)<-rownames(junctionsPJU(asd))[ijsplit]
    
    jcoords0 <- jcoords0[!rownames(jcoords0)%in%unique(c(rownames(jcoords1),rownames(jcoords2))),]
    nj0               <- nrow(jcoords0)                       
  }
  
  
  #si detecto locale o anchor lo marco  
  if(nj1>0) abline(v=unique(c(jcoords1[,2],jcoords1[,3])),col="lightblue",lty=3)
  if(nj2>0) abline(v=unique(c(jcoords2[,2],jcoords2[,3])),col="lightgreen",lty=3)
  
  #dibujo paneles por condicion: junturas y coverage en la region de interes
  for(icond in 1:nConditions){
    # print(paste0("samtools depth -r ",
    #              paste0(aspli.chr,":",zroi[1],"-",zroi[2]," "),
    #              mergedBAMs[icond, 1]))
    ad <- system(paste0("samtools depth -r ",
                        paste0(aspli.chr,":",zroi[1],"-",zroi[2]," "),
                        mergedBAMs[icond, 1]), intern = TRUE)
    #ad <- matrix(as.numeric(strsplit2(ad,"\t")),ncol=3)
    ad <- strsplit2(ad,"\t")
    ad <- data.frame(ad,stringsAsFactors = FALSE)
    ad[,2]<-as.numeric(ad[,2])
    ad[,3]<-as.numeric(ad[,3])
    yylim <- range(ad[,3])

    nrep <- table(counts@targets$condition)[mergedBAMs[icond,2]]
    #me quedo con las que pasan un filtro de minima   
    jjcoords0<-jcoords0
    if(nj0>0){
      jcount0 <- .countJbyCondition(jcoords0,counts)[,mergedBAMs[icond,2],drop=FALSE]
      jok     <- rownames(jcount0)[jcount0>5*nrep]
      nj0     <- length(jok)
      if(nj0>0){
        jjcoords0  <- jcoords0[jok,,drop=FALSE]
        jcount0    <- jcount0[jok,,drop=FALSE]
      }  
    }
    
    jjcoords1<-jcoords1
    if(nj1>0){
      jcount1 <- .countJbyCondition(jcoords1,counts)[,mergedBAMs[icond,2],drop=FALSE]
      #   jok     <- rownames(jcount1)[jcount1>5*nrep]
      #   nj1     <- length(jok)
      #   if(nj1>0)  jjcoords1  <- jcoords1[jok,,drop=FALSE]
    }
    
    jjcoords2<-jcoords2
    if(nj2>0){
      jcount2 <- .countJbyCondition(jcoords2,counts)[,mergedBAMs[icond,2],drop=FALSE]
      #   jok     <- rownames(jcount2)[jcount2>5*nrep]
      #   nj2     <- length(jok)
      #   if(nj2>0)  jjcoords2  <- jcoords2[jok,,drop=FALSE]
    }
    

    #panel junturas
    if(FALSE){
      plot(0,typ="n",xlim=c(start(bins[1]),end(bins[nbines])),ylim=c(1,nj0+nj1+nj2+3),axes=FALSE,xlab="",ylab="")
      jmaxcount <- max(c(jcount0,jcount1,jcount2))
      if(nj0>0){
        jcounts <- jcount0
        jcoords <- jjcoords0
        ww <- jcounts/jmaxcount*3
        for(ij in 1:nj0){
          lines(jcoords[ij,2:3],rep(ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightgray")
          points(jcoords[ij,2:3],rep(ij,2),pch=18,cex=0.5,col="lightgray")
        }
      }
      if(nj1>0){
        jcounts <- jcount1
        jcoords <- jjcoords1
        ww <- jcounts/jmaxcount*3
        
        abline(v=unique(c(jcoords[,2],jcoords[,3])),col="lightblue",lty=3)
        for(ij in 1:nj1){
          lines(jcoords[ij,2:3],rep(nj0+ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightblue")
          points(jcoords[ij,2:3],rep(nj0+ij,2),pch=18,cex=0.5,col="lightblue")
          text(mean(as.numeric(jcoords[ij,2:3])),nj0+ij,jcounts[ij],pos=3,cex=tcex)
        }
      }
      if(nj2>0){
        jcounts <- jcount2
        jcoords <- jjcoords2
        ww <- jcounts/jmaxcount*3
        
        abline(v=unique(c(jcoords[,2],jcoords[,3])),col="lightgreen",lty=3)
        for(ij in 1:nj2){
          lines(jcoords[ij,2:3],rep(nj0+nj1+ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightgreen")
          points(jcoords[ij,2:3],rep(nj0+nj1+ij,2),pch=18,cex=0.5,col="lightgreen")
          text(mean(as.numeric(jcoords[ij,2:3])),nj0+nj1+ij,jcounts[ij],pos=3,cex=tcex)
        }
      }
    }
    
    #plot(0,typ="n",xlim=c(start(bins[1]),end(bins[nbines])),ylim=c(1,nj0+nj1+nj2+3),axes=FALSE,xlab="",ylab="")
    
    extra <- 5
    njlevels <- nj0+nj1+nj2+extra
    
    j12      <- intersect(rownames(jcoords1),rownames(jcoords2))
    njlevels <- nj0+nj1+nj2-length(j12)+extra
    
    xx<-as.numeric(c(start(bins[1]),end(bins[nbines])))
    plot(0,typ="n",xlim=xx,ylim=c(1,njlevels),axes=FALSE,xlab="",ylab="")
    jmaxcount <- max(c(jcount0,jcount1,jcount2))
    if(nj0>0){
      jcounts <- jcount0
      jcoords <- jjcoords0
      ww <- jcounts/jmaxcount*3
      for(ij in 1:nj0){
        lines(jcoords[ij,2:3],rep(ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightgray")
        points(jcoords[ij,2:3],rep(ij,2),pch=18,cex=0.5,col="lightgray")
      }
    }
    
    if(njlevels-nj0>extra){
      jcounts<-c()
      if(nj1>0) jcounts<-jcount1
      if(nj2>0){
          if(length(j12)>0){
            jcounts<-rbind(jcounts,jcount2[!rownames(jcount2)%in%j12,,drop=FALSE])
          }else{  
           jcounts<-rbind(jcounts,jcount2)
          }
      }
      #jcoords <- t(apply(cbind(rownames(jcounts,jcounts)),1,function(x){as.numeric(strsplit2(x,"[.]"))}))
      jcoords <- t(apply(cbind(rownames(jcounts,jcounts)),1,function(x){strsplit2(x,"[.]")}))
      rownames(jcoords)<-rownames(jcounts)
    
      ccolor  <- rep("lightgreen",nrow(jcounts))
      names(ccolor)<-rownames(jcounts)
      if(nj2>0) ccolor[rownames(jcount2)]<-"lightblue"
      if(length(j12)>0) ccolor[j12]<-"orange"
      
      ww <- jcounts/jmaxcount*3
      
      abline(v=unique(c(jcoords[,2],jcoords[,3])),col="lightblue",lty=3)
      for(ij in 1:length(ccolor)){
        #yij <- nj0+ij
        yij  <- ij * njlevels*0.8/(nj1+nj2-length(j12))
        lines(jcoords[ij,2:3],rep(yij,2),lwd=max(1,ww[rownames(jcoords)[ij],1]),col=ccolor[ij])
        points(jcoords[ij,2:3],rep(yij,2),pch=18,cex=2,col=ccolor[ij])
        text(mean(as.numeric(jcoords[ij,2:3])),yij,jcounts[ij],pos=2,cex=tcex)
      }
      
    }

    
    #coverage
    xx <- as.numeric(c(start(bins[1]),end(bins[nbines])))
    if(useLog){
      yylim[yylim==0]<-0.1
      ad[ad[,3]==0,3]<-0.1
      plot(0.01,typ="n",xlim=xx,ylim=yylim,axes=FALSE,xlab="",ylab="",log="y")
    }else{
      plot(0,typ="n",xlim=xx,ylim=yylim,axes=FALSE,xlab="",ylab="")
    }
    polygon(c(ad[1,2],ad[,2],ad[nrow(ad),2]),c(0.01,ad[,3],0.01)
            ,border=NA,col=topo.colors(nConditions,1)[icond],fillOddEven = TRUE)
    lines(c(ad[1,2],ad[,2],ad[nrow(ad),2]),  c(0.01,ad[,3],0.01),
          col=topo.colors(nConditions,1)[icond])
    text(ad[1,2],0.01,paste0("[0-",max(ad[,3]),"]"),cex=tcex,adj=c(-.25,-.5))
    
    if(nj1>0)abline(v=unique(c(jcoords1[,2],jcoords1[,3])),col="lightgreen",lty=3)
    if(nj2>0)abline(v=unique(c(jcoords2[,2],jcoords2[,3])),col="lightblue",lty=3)
    
    #remarco la roi original
    if(icond==1){
      xroi   <- as.numeric(strsplit2(strsplit2(iiss$region,":")[2],"-"))
      lines(xroi,rep(par("usr")[3],2),col="black",lwd=3)
      # rect(xroi[1],par("usr")[3],xroi[2],par("usr")[3]+diff(par("usr")[4:3])*.1,col="black",density=2)
    }
    legend("topleft", as.character(mergedBAMs$condition[icond]),bty="n")
  }
  mtext(paste(iiss$locus,iiss$region),line=-.5,cex=0.8)
  
  
  #vamos por el texto:
  if(FALSE){
    # Junturas Anchor
    plot(1,axes=FALSE,type="n",xlab="",ylab="")
    if(iiss$ja==1){
      col1 <- c( "junction","junction.annotated","junction.fdr","junction.nonuniformity","junction.participation","cluster.fdr","dPIR")
      a1 <- sr@anchorbased[sr@anchorbased$junction%in%iiss$J3,col1]
      if(nrow(a1)>0){
        a1[col1[3:7]]<-signif(a1[col1[3:7]],2)
        a1<-cbind(names(a1),t(a1))
        a1<-apply(a1,1,function(x){return(paste(x,collapse=": "))})
        names(a1)<- c("junction","annotated","j.fdr","non-unif","participation","cluster.fdr","D_PIR")
        a1<-paste("  ",a1,sep = "")
        a1<-c("Junction Anchorage:",a1)
        legend("topleft",a1,cex=tcex,bty="n",inset=0.02) 
        
        # a2 <- sr@anchorbased[sr@anchorbased$junction%in%iiss$J3,8+c(6,4,2,5,3,1)]*nrep
        # a2 <- cbind(names(a2),t(a2))
        # a2 <- apply(a2,1,function(x){return(paste(x,collapse=": "))})
        # a2<-paste("  ",a2,sep = "")
        
        # legend("bottomleft",a2,cex=tcex,bty="n",inset=0.02)
      }else{
        a1<-c("Junction Anchorage:","  no J3 passed the filter.")
        legend("topleft",a1,cex=tcex,bty="n",inset=0.02)   
      }
    }
    
    # Junturas locale
    plot(1,axes=FALSE,type="n",xlab="",ylab="")
    if(iiss$jl==1){
      col1 <- c( "junction","junction.annotated","junction.fdr","junction.participation","cluster.fdr")
      a1 <- sr@localebased[sr@localebased$junction%in%iiss$J3,col1]
      a1[col1[3:5]]<-signif(a1[col1[3:5]],2)
      a1<-cbind(names(a1),t(a1))
      a1<-apply(a1,1,function(x){return(paste(x,collapse=": "))})
      names(a1)<- c("junction","annotated","j.fdr","participation","cluster.fdr")
      a1<-paste("  ",a1,sep = "")
      a1<-c("Junction Locale:",a1)
      
      legend("topleft",a1,cex=tcex,bty="n",inset=0.02) 
      
      
    }
    
    # bin info
    plot(1,axes=FALSE,type="n",xlab="",ylab="")
    if(iiss$b==1 | iiss$bjs==1){
      col1 <- c( "bin","bin.fdr","junction.dPIR","junction.dPSI")
      a1 <- sr@binbased[sr@binbased$bin%in%iiss$bin,col1]
      a1[col1[2:4]]<-signif(a1[col1[2:4]],2)
      names(a1)<-c("bin","bin.fdr","D_PIR","D_PSI")
      a1<-cbind(names(a1),t(a1))
      a1<-apply(a1,1,function(x){return(paste(x,collapse=": "))})
      a1<-paste("  ",a1,sep = "")
      a1<-c("Bin:",a1)
      legend("topleft",a1,cex=tcex,bty="n",inset=0.02) 
      
    }
  }
  
}


.plotGenePattern<-function(locus=NULL,is,counts,f,mergedBAMs,sr,asd,genePlot=TRUE,jCompletelyIncluded=TRUE,
                               zoomRegion=1.5,useLog=FALSE,tcex=2){
  #region <- r
  #iss <- is
  #counts
  #f <- features
  #mergedBAMs <- mergedBams
  
  genePlot <- TRUE
  iss <- is@signals
    
  if(length(transcriptExons(f))==1){
    warning("transcriptExons(f) has only one element. This could imply that something is wrong with the ASpliFeature object.\n")
  }
  
  variants = transcriptExons(f)
  nConditions <- nrow(mergedBAMs)
  
  #Locus range
  greg       <- countsg(counts)[locus,"gene_coordinates"]
    
  #alturas relativas de paneles de coverage y junturas
  hCov=0.7
  hJun=0.3

  # iiss  <- iss[iss$region %in% greg,]
  # if(nrow(iiss)==0){
  #   warning("No valid region provided. Out.\n")
  #   return()
  # }
  
  withSignal <-  locus%in%iss$locus
  iiss <- iss[locus==geneName,]
  
  
  geneName<-locus
  
  
  #encuentra x: GRanges para graficar
  if(!genePlot){
    
    #nombre de cromosoma en aspli
    aspli.chr <- strsplit2(strsplit2(iiss$region,":")[1], "Chr")
    if(ncol(aspli.chr) == 2){
      aspli.chr <- aspli.chr[, 2]
    }else{
      aspli.chr <- aspli.chr[, 1]
    }
    
    #nombre de cromosomas en features
    features.chr<-levels(seqnames(featuresb(f))@values)
    
    if(is.na(match(aspli.chr,features.chr))){
      #if(is.null(chrMap)){ #chrMap no se define mas asi que deberia entrar siempre aca
      warning(paste("No se pudo mapear nombres de cromosomas.",
                    "\n aspli.chr=",aspli.chr,
                    "\n features.chr=",paste(features.chr,collapse="/")))
      #}else{
      # chr <- features.chr[match(aspli.chr,features.chr)]
      #}
    }else{
      chr <- aspli.chr
    }
    
    roi   <- as.numeric(strsplit2(strsplit2(iiss$region,":")[2],"-"))
    #si hay una J3 != NA la uso para definir el rango
    if(!is.na(iiss$J3)){
      #si J3 se movio en un cluster, uso el cluster para definir el rango
      #  if(iiss$jl==1){
      #    #TODO
      #  }else{
      
      #roiJ3   <- as.numeric(strsplit2(as.character(iiss$J3),".",fixed=TRUE)[2:3])
      
      #chequeo si tengo mas de una J3
      j3aux <- strsplit2(iiss$J3,";")
      roiJ3<-c()
      for(ij3 in seq_along(j3aux)){
        roiJ3   <- c(roiJ3,as.numeric(strsplit2(j3aux[ij3],".",fixed=TRUE)[2:3]))
      }
      roiJ3 <- range(roiJ3)
      
      #  }
      
      roi[1] <- min(roi,roiJ3)
      roi[2] <- max(roi,roiJ3)
    }
    
    delta <- roi[2]-roi[1]
    
    zroi  <- c(roi[1]-delta*zoomRegion/2 , roi[2]+delta*zoomRegion/2)
    zdelta<-zroi[2]-zroi[1]
    
    gr    <- as(paste0(chr,":",zroi[1],"-",zroi[2]),"GRanges")
    hits  <- findOverlaps(gr,featuresb(f))
    bins  <-featuresb(f)[subjectHits(hits)]
    
    bins  <- bins[mcols(bins)$feature!="Io",]
    
    #redefino la zoomedroi en base a los bines que overlapeaban la zroi original
    delta <- max(end(bins))-min(start(bins))
    #zroi  <- c(start(bins)[1]-delta*zoomRegion/2 , end(bins)[length(bins)]+delta*zoomRegion/2)
    zroi  <- c(start(bins)[1], end(bins)[length(bins)])
    
  }else{
    
    #identifico coordenadas de biones ebinsonicos
    #iE <- which(mcols(featuresb(f))$locus%in%geneName & mcols(featuresb(f))$feature=="E"
    iE <- which(mcols(featuresb(f))$locus%in%geneName)
    if(length(iE)==0){
      #Is this a monoexonic gene?
      if(length(featuresg(f)[[geneName]])==1){
        bins <- featuresg(f)[geneName]
        mcols(bins)<-data.frame(locus=geneName,bin="E001",feature="mono E",
                                symbol=mcols(bins)$symbol,
                                locus_overlap=mcols(bins)$locus_overlap,
                                class="E",
                                event="novel",
                                eventJ="-")
        zroi <- roi <- as.numeric(c(start(bins)[1],end(bins)[length(bins)]))
      }else{
        warning("Something terribly wrong happened...No annotation data
              for",geneName," could be found!\nProbably a monoexonic gene...")
        return()
      }
    }else{
      bins <- featuresb(f)[iE,]
      bins <- bins[mcols(bins)$feature!="Io",]
      zroi <- roi <- c(start(bins)[1],end(bins)[length(bins)])
    }
    
    
    
  }
  
  #Armado del layout
  if(is.null(variants)){
    hh <- c(rep(c(hCov,hJun)/nConditions,nConditions),0.1)
    hh <- hh/sum(hh)
  }else{
    hh <- c(rep(c(hCov,hJun)/nConditions,nConditions),(hCov+hJun)/nConditions)
    hh <- hh/sum(hh)
  }
  
  ## Empiezo el plot
  #layout(matrix(c((2*nConditions+1):1,rep(1+2*nConditions+1:nConditions,each=2),(3*nConditions+2)),ncol=2),width=c(0.8,.2),height=hh)
  layout(matrix((2*nConditions+1):1),widths=c(0.8,.2),heights=hh)
  
  par(mar=c(.5, 1.1, .5, 1.1))
  
  rownames(mergedBAMs)<-mergedBAMs[,1]
  
  
  # Si hay variants...dibujo variantes
  if(!is.null(variants)){
    #transcriptGene<-strsplit2(names(variants),".",fixed=TRUE)[,1]
    transcriptGene <- mcols(variants)[,"gene"]
    
    ig<-which(transcriptGene%in%geneName)
    tex <- variants[ig]
    tex <- tex[order(names(tex))]
    
    limvariants<-unlist(lapply(tex,function(x){
      return(c(start(x),end(x)))
    }))
    
    plot(0,typ="n",xlim=range(limvariants),ylim=c(0,length(tex)+3),axes=FALSE,xlab="",ylab="")
    
    if(length(tex)>1 | !genePlot){
      for(itex in 1:length(tex)){
        bbins <- tex[[itex]]
        y<-length(tex)-(itex-1)
        lines(c(start(bbins[1]),end(bbins[length(bbins)])),c(y,y),col="gray")
        rect(start(bbins),y-.3,end(bbins),y+0.3,col=rgb(.7,.7,.7),border="black")
        
      }
    }
    ycollapsed <- length(tex)+2
  }else{
    ycollapsed <- 0
  }
  
  # Bines del genoma anotado que overlapean con el roi
  iE   <- mcols(bins)$feature%in%c("E","mono E")
  iroi <- (start(bins)>=roi[1] & start(bins)<roi[2])
  
  nbines <- length(bins)
  delta <- end(bins[nbines])-start(bins[1])
  
  if(is.null(variants)){
    plot(0,typ="n",xlim=c(start(bins[1]),end(bins[nbines])),ylim=c(-.5,.5),axes=FALSE,xlab="",ylab="")
  }
  lines(c(start(bins[1]),end(bins[nbines])),c(ycollapsed,ycollapsed),col="gray")
  rect(start(bins)[iE],ycollapsed-.45,end(bins)[iE],ycollapsed+.45,col="white")
  
  # #remarco la roi original
  # xroi   <- as.numeric(strsplit2(strsplit2(iiss$region,":")[2],"-"))
  # lines(xroi,rep(ycollapsed-.6,2),col="black",lwd=3)
   
  #grafico el zoom
  if(!genePlot){
    lines(c(start(bins[1]),par("usr")[1]),c(ycollapsed+.45,par("usr")[4]),lty=1,col="gray")
    lines(c(end(bins[nbines]),par("usr")[2]),c(ycollapsed+.45,par("usr")[4]),lty=1,col="gray")
  }
  
  #bines diferenciales
  
  #que bines diferenciales hay en la region?
  iE<-c()
  if(withSignal) iE<-which(names(bins)%in%iiss$bin)
  if(length(iE)>0){
    for(iie in seq_along(iE)){
      if(mcols(bins)$feature[iE[iie]]%in%c("Io","I")){
        lines(c(start(bins[iE[iie]]),end(bins[iE[iie]])),
              c(ycollapsed,ycollapsed),col="orange",lwd=3)
      }else{
        if(iiss$b!=0 | iiss$bjs!=0){
          if(iiss$b!=0 & iiss$bjs==0) cc <- "orange"
          if(iiss$b!=0 & iiss$bjs!=0) cc <- "red"
          if(iiss$b==0 & iiss$bjs!=0) cc <- "yellow"
          rect(start(bins[iE[iie]]),
               ycollapsed-.45,
               end(bins[iE[iie]]),
               ycollapsed+.45,col=cc,border=NA)
        } 
      }
    }
  }
  
  
  lines(par("usr")[1:2],rep(ycollapsed-1,each=2),lty=2,col="gray")
  
  # Junturas
  jcount1<-jcount2<-jcount0<-nj0<-nj1<-nj2<-0
  # aspli.chr <- strsplit2(strsplit2(iiss$region,":")[1], "[cC]hr")
  # if(ncol(aspli.chr) == 2){
  #   aspli.chr <- aspli.chr[, 2]
  # }else{
  #   aspli.chr <- aspli.chr[, 1]
  # }
 aspli.chr <- strsplit2(greg,":")[1]
  
  
  
  
  #que junturas estan dentro de la zona?
  jsplit <- strsplit2(rownames(junctionsPJU(asd)),".",fixed=TRUE)
  if(jCompletelyIncluded){
    ijsplit <- which(jsplit[,1]==aspli.chr & as.numeric(jsplit[,2])>=zroi[1] & as.numeric(jsplit[,3])<=zroi[2])
  }else{
    ijsplit <- which(jsplit[,1]==aspli.chr & 
                       ((as.numeric(jsplit[,2])>=zroi[1] & as.numeric(jsplit[,2])<=zroi[2]) |
                          (as.numeric(jsplit[,3])>=zroi[1] & as.numeric(jsplit[,3])<=zroi[2])) )
  }
  
  
  # busco anchor junctions
  js <- unique(anchorbased(sr)$junction)
  aux <- strsplit2(js,".",fixed=TRUE)
  # ijs <-which(aux[,1]==aspli.chr &
  #               as.numeric(aux[,2])>=zroi[1] &
  #               as.numeric(aux[,2])<=zroi[2])  #ACA HAbia un error!
  if(jCompletelyIncluded){
    ijs <- which(aux[,1]==aspli.chr & as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])
  }else{
    ijs <- which(aux[,1]==aspli.chr & 
                   ((as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,2])<=zroi[2]) |
                      (as.numeric(aux[,3])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])) )
  }
  jcoords1<-c()
  if(length(ijs)>0){
    #jcoords1          <- matrix(as.numeric(aux[ijs,]),ncol=3)
    jcoords1          <- data.frame(aux[ijs,,drop=FALSE],stringsAsFactors = FALSE)
    jcoords1[,2] <- as.numeric(jcoords1[,2])
    jcoords1[,3] <- as.numeric(jcoords1[,3])
    rownames(jcoords1)<-js[ijs]
    nj1               <- nrow(jcoords1)
  }
  
  #analizo locale 
  js <- unique(localebased(sr)$junction)
  aux <- strsplit2(js,".",fixed=TRUE)
  # ijs <-which(aux[,1]==aspli.chr &
  #               as.numeric(aux[,2])>=zroi[1] &
  #               as.numeric(aux[,2])<=zroi[2]) #ACA HAbia un error!
  if(jCompletelyIncluded){
    ijs <- which(aux[,1]==aspli.chr & as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])
  }else{
    ijs <- which(aux[,1]==aspli.chr & 
                   ((as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,2])<=zroi[2]) |
                      (as.numeric(aux[,3])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])) )
  }
  jcoords2<-c()
  if(length(ijs)>0){
    #jcoords2          <- matrix(as.numeric(aux[ijs,]),ncol=3)
    jcoords2          <- aux[ijs,]
    jcoords2          <- data.frame(aux[ijs,,drop=FALSE],stringsAsFactors = FALSE)
    jcoords2[,2] <- as.numeric(jcoords2[,2])
    jcoords2[,3] <- as.numeric(jcoords2[,3])
    
    rownames(jcoords2)<-js[ijs]
    nj2               <- nrow(jcoords2)
  }
  
  # junturas en la region que no son anchor ni locale
  jcoords0<-c()
  if(length(ijsplit)>0){ 
    jcoords0 <- data.frame(chr=jsplit[ijsplit,1],#chr=as.numeric(jsplit[ijsplit,1]),
                           start=as.numeric(jsplit[ijsplit,2]),
                           end=as.numeric(jsplit[ijsplit,3]))
    rownames(jcoords0)<-rownames(junctionsPJU(asd))[ijsplit]
    
    jcoords0 <- jcoords0[!rownames(jcoords0)%in%unique(c(rownames(jcoords1),rownames(jcoords2))),]
    nj0               <- nrow(jcoords0)                       
  }
  
  
  #si detecto locale o anchor lo marco  
  if(nj1>0) abline(v=unique(c(jcoords1[,2],jcoords1[,3])),col="lightblue",lty=3)
  if(nj2>0) abline(v=unique(c(jcoords2[,2],jcoords2[,3])),col="lightgreen",lty=3)
  
  #dibujo paneles por condicion: junturas y coverage en la region de interes
  for(icond in 1:nConditions){
    # print(paste0("samtools depth -r ",
    #              paste0(aspli.chr,":",zroi[1],"-",zroi[2]," "),
    #              mergedBAMs[icond, 1]))
    ad <- system(paste0("samtools depth -r ",
                        paste0(aspli.chr,":",zroi[1],"-",zroi[2]," "),
                        mergedBAMs[icond, 1]), intern = TRUE)
    #ad <- matrix(as.numeric(strsplit2(ad,"\t")),ncol=3)
    ad <- strsplit2(ad,"\t")
    ad <- data.frame(ad,stringsAsFactors = FALSE)
    ad[,2]<-as.numeric(ad[,2])
    ad[,3]<-as.numeric(ad[,3])
    yylim <- range(ad[,3])
    
    nrep <- table(counts@targets$condition)[mergedBAMs[icond,2]]
    #me quedo con las que pasan un filtro de minima   
    jjcoords0<-jcoords0
    if(nj0>0){
      jcount0 <- .countJbyCondition(jcoords0,counts)[,mergedBAMs[icond,2],drop=FALSE]
      jok     <- rownames(jcount0)[jcount0>5*nrep]
      nj0     <- length(jok)
      if(nj0>0){
        jjcoords0  <- jcoords0[jok,,drop=FALSE]
        jcount0    <- jcount0[jok,,drop=FALSE]
      }  
    }
    
    jjcoords1<-jcoords1
    if(nj1>0){
      jcount1 <- .countJbyCondition(jcoords1,counts)[,mergedBAMs[icond,2],drop=FALSE]
      #   jok     <- rownames(jcount1)[jcount1>5*nrep]
      #   nj1     <- length(jok)
      #   if(nj1>0)  jjcoords1  <- jcoords1[jok,,drop=FALSE]
    }
    
    jjcoords2<-jcoords2
    if(nj2>0){
      jcount2 <- .countJbyCondition(jcoords2,counts)[,mergedBAMs[icond,2],drop=FALSE]
      #   jok     <- rownames(jcount2)[jcount2>5*nrep]
      #   nj2     <- length(jok)
      #   if(nj2>0)  jjcoords2  <- jcoords2[jok,,drop=FALSE]
    }
    
    
    #panel junturas
    if(FALSE){
      plot(0,typ="n",xlim=c(start(bins[1]),end(bins[nbines])),ylim=c(1,nj0+nj1+nj2+3),axes=FALSE,xlab="",ylab="")
      jmaxcount <- max(c(jcount0,jcount1,jcount2))
      if(nj0>0){
        jcounts <- jcount0
        jcoords <- jjcoords0
        ww <- jcounts/jmaxcount*3
        for(ij in 1:nj0){
          lines(jcoords[ij,2:3],rep(ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightgray")
          points(jcoords[ij,2:3],rep(ij,2),pch=18,cex=0.5,col="lightgray")
        }
      }
      if(nj1>0){
        jcounts <- jcount1
        jcoords <- jjcoords1
        ww <- jcounts/jmaxcount*3
        
        abline(v=unique(c(jcoords[,2],jcoords[,3])),col="lightblue",lty=3)
        for(ij in 1:nj1){
          lines(jcoords[ij,2:3],rep(nj0+ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightblue")
          points(jcoords[ij,2:3],rep(nj0+ij,2),pch=18,cex=0.5,col="lightblue")
          text(mean(as.numeric(jcoords[ij,2:3])),nj0+ij,jcounts[ij],pos=3,cex=tcex)
        }
      }
      if(nj2>0){
        jcounts <- jcount2
        jcoords <- jjcoords2
        ww <- jcounts/jmaxcount*3
        
        abline(v=unique(c(jcoords[,2],jcoords[,3])),col="lightgreen",lty=3)
        for(ij in 1:nj2){
          lines(jcoords[ij,2:3],rep(nj0+nj1+ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightgreen")
          points(jcoords[ij,2:3],rep(nj0+nj1+ij,2),pch=18,cex=0.5,col="lightgreen")
          text(mean(as.numeric(jcoords[ij,2:3])),nj0+nj1+ij,jcounts[ij],pos=3,cex=tcex)
        }
      }
    }
    
    #plot(0,typ="n",xlim=c(start(bins[1]),end(bins[nbines])),ylim=c(1,nj0+nj1+nj2+3),axes=FALSE,xlab="",ylab="")
    
    extra <- 5
    njlevels <- nj0+nj1+nj2+extra
    
    j12      <- intersect(rownames(jcoords1),rownames(jcoords2))
    njlevels <- nj0+nj1+nj2-length(j12)+extra
    
    xx<-as.numeric(c(start(bins[1]),end(bins[nbines])))
    plot(0,typ="n",xlim=xx,ylim=c(1,njlevels),axes=FALSE,xlab="",ylab="")
    jmaxcount <- max(c(jcount0,jcount1,jcount2))
    if(nj0>0){
      jcounts <- jcount0
      jcoords <- jjcoords0
      ww <- jcounts/jmaxcount*3
      for(ij in 1:nj0){
        lines(jcoords[ij,2:3],rep(ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightgray")
        points(jcoords[ij,2:3],rep(ij,2),pch=18,cex=0.5,col="lightgray")
      }
    }
    
    if(njlevels-nj0>extra){
      jcounts<-c()
      if(nj1>0) jcounts<-jcount1
      if(nj2>0){
        if(length(j12)>0){
          jcounts<-rbind(jcounts,jcount2[!rownames(jcount2)%in%j12,,drop=FALSE])
        }else{  
          jcounts<-rbind(jcounts,jcount2)
        }
      }
      #jcoords <- t(apply(cbind(rownames(jcounts,jcounts)),1,function(x){as.numeric(strsplit2(x,"[.]"))}))
      jcoords <- t(apply(cbind(rownames(jcounts,jcounts)),1,function(x){strsplit2(x,"[.]")}))
      rownames(jcoords)<-rownames(jcounts)
      
      ccolor  <- rep("lightgreen",nrow(jcounts))
      names(ccolor)<-rownames(jcounts)
      if(nj2>0) ccolor[rownames(jcount2)]<-"lightblue"
      if(length(j12)>0) ccolor[j12]<-"orange"
      
      ww <- jcounts/jmaxcount*3
      
      abline(v=unique(c(jcoords[,2],jcoords[,3])),col="lightblue",lty=3)
      for(ij in 1:length(ccolor)){
        #yij <- nj0+ij
        yij  <- ij * njlevels*0.8/(nj1+nj2-length(j12))
        lines(jcoords[ij,2:3],rep(yij,2),lwd=max(1,ww[rownames(jcoords)[ij],1]),col=ccolor[ij])
        points(jcoords[ij,2:3],rep(yij,2),pch=18,cex=2,col=ccolor[ij])
        text(mean(as.numeric(jcoords[ij,2:3])),yij,jcounts[ij],pos=2,cex=tcex)
      }
      
    }
    
    
    #coverage
    xx <- as.numeric(c(start(bins[1]),end(bins[nbines])))
    if(useLog){
      yylim[yylim==0]<-0.1
      ad[ad[,3]==0,3]<-0.1
      plot(0.01,typ="n",xlim=xx,ylim=yylim,axes=FALSE,xlab="",ylab="",log="y")
    }else{
      plot(0,typ="n",xlim=xx,ylim=yylim,axes=FALSE,xlab="",ylab="")
    }
    polygon(c(ad[1,2],ad[,2],ad[nrow(ad),2]),c(0.01,ad[,3],0.01)
            ,border=NA,col=topo.colors(nConditions,1)[icond],fillOddEven = TRUE)
    lines(c(ad[1,2],ad[,2],ad[nrow(ad),2]),  c(0.01,ad[,3],0.01),
          col=topo.colors(nConditions,1)[icond])
    text(ad[1,2],0.01,paste0("[0-",max(ad[,3]),"]"),cex=tcex,adj=c(-.25,-.5))
    
    if(nj1>0)abline(v=unique(c(jcoords1[,2],jcoords1[,3])),col="lightgreen",lty=3)
    if(nj2>0)abline(v=unique(c(jcoords2[,2],jcoords2[,3])),col="lightblue",lty=3)
    
    #remarco la roi original
    if(icond==1){
      xroi   <- as.numeric(strsplit2(strsplit2(greg,":")[2],"-"))
      lines(xroi,rep(par("usr")[3],2),col="black",lwd=3)
      # rect(xroi[1],par("usr")[3],xroi[2],par("usr")[3]+diff(par("usr")[4:3])*.1,col="black",density=2)
    }
    legend("topleft", as.character(mergedBAMs$condition[icond]),bty="n")
  }
  mtext(paste(geneName,greg),line=-.5,cex=0.8)
  
  
  #vamos por el texto:
  if(FALSE){
    # Junturas Anchor
    plot(1,axes=FALSE,type="n",xlab="",ylab="")
    if(iiss$ja==1){
      col1 <- c( "junction","junction.annotated","junction.fdr","junction.nonuniformity","junction.participation","cluster.fdr","dPIR")
      a1 <- sr@anchorbased[sr@anchorbased$junction%in%iiss$J3,col1]
      if(nrow(a1)>0){
        a1[col1[3:7]]<-signif(a1[col1[3:7]],2)
        a1<-cbind(names(a1),t(a1))
        a1<-apply(a1,1,function(x){return(paste(x,collapse=": "))})
        names(a1)<- c("junction","annotated","j.fdr","non-unif","participation","cluster.fdr","D_PIR")
        a1<-paste("  ",a1,sep = "")
        a1<-c("Junction Anchorage:",a1)
        legend("topleft",a1,cex=tcex,bty="n",inset=0.02) 
        
        # a2 <- sr@anchorbased[sr@anchorbased$junction%in%iiss$J3,8+c(6,4,2,5,3,1)]*nrep
        # a2 <- cbind(names(a2),t(a2))
        # a2 <- apply(a2,1,function(x){return(paste(x,collapse=": "))})
        # a2<-paste("  ",a2,sep = "")
        
        # legend("bottomleft",a2,cex=tcex,bty="n",inset=0.02)
      }else{
        a1<-c("Junction Anchorage:","  no J3 passed the filter.")
        legend("topleft",a1,cex=tcex,bty="n",inset=0.02)   
      }
    }
    
    # Junturas locale
    plot(1,axes=FALSE,type="n",xlab="",ylab="")
    if(iiss$jl==1){
      col1 <- c( "junction","junction.annotated","junction.fdr","junction.participation","cluster.fdr")
      a1 <- sr@localebased[sr@localebased$junction%in%iiss$J3,col1]
      a1[col1[3:5]]<-signif(a1[col1[3:5]],2)
      a1<-cbind(names(a1),t(a1))
      a1<-apply(a1,1,function(x){return(paste(x,collapse=": "))})
      names(a1)<- c("junction","annotated","j.fdr","participation","cluster.fdr")
      a1<-paste("  ",a1,sep = "")
      a1<-c("Junction Locale:",a1)
      
      legend("topleft",a1,cex=tcex,bty="n",inset=0.02) 
      
      
    }
    
    # bin info
    plot(1,axes=FALSE,type="n",xlab="",ylab="")
    if(iiss$b==1 | iiss$bjs==1){
      col1 <- c( "bin","bin.fdr","junction.dPIR","junction.dPSI")
      a1 <- sr@binbased[sr@binbased$bin%in%iiss$bin,col1]
      a1[col1[2:4]]<-signif(a1[col1[2:4]],2)
      names(a1)<-c("bin","bin.fdr","D_PIR","D_PSI")
      a1<-cbind(names(a1),t(a1))
      a1<-apply(a1,1,function(x){return(paste(x,collapse=": "))})
      a1<-paste("  ",a1,sep = "")
      a1<-c("Bin:",a1)
      legend("topleft",a1,cex=tcex,bty="n",inset=0.02) 
      
    }
  }
  
}


.plotSplicingPattern.orig<-function(region=NULL,iss,counts,f,mergedBAMs,sr,asd,genePlot=TRUE,jCompletelyIncluded=TRUE,
                               zoomRegion=1.5,useLog=FALSE,tcex=1){
  #region <- r
  #iss <- is
  #counts
  #f <- features
  #mergedBAMs <- mergedBams
  
  if(length(transcriptExons(f))==1){
    warning("transcriptExons(f) has only one element. This could imply that something is wrong with the ASpliFeature object.\n")
  }
  
  exones = transcriptExons(f)
  
  
  #alturas relativas de paneles de coverage y junturas
  hCov=0.7
  hJun=0.3
  
  greg <- region
  nConditions <- nrow(mergedBAMs)
  
  iiss  <- iss[iss$region %in% greg,]
  if(nrow(iiss)==0){
    warning("No valid region provided. Out.\n")
    return()
  }
  
  geneName<-as.character(iiss[,"locus"])
  
  #encuentra x: GRanges para graficar
  if(!genePlot){
    
    #nombre de cromosoma en aspli
    aspli.chr <- strsplit2(strsplit2(iiss$region,":")[1], "Chr")
    if(ncol(aspli.chr) == 2){
      aspli.chr <- aspli.chr[, 2]
    }else{
      aspli.chr <- aspli.chr[, 1]
    }
    
    #nombre de cromosomas en features
    features.chr<-levels(seqnames(featuresb(f))@values)
    
    if(is.na(match(aspli.chr,features.chr))){
      #if(is.null(chrMap)){ #chrMap no se define mas asi que deberia entrar siempre aca
      warning(paste("No se pudo mapear nombres de cromosomas.",
                    "\n aspli.chr=",aspli.chr,
                    "\n features.chr=",paste(features.chr,collapse="/")))
      #}else{
      # chr <- features.chr[match(aspli.chr,features.chr)]
      #}
    }else{
      chr <- aspli.chr
    }
    
    roi   <- as.numeric(strsplit2(strsplit2(iiss$region,":")[2],"-"))
    #si hay una J3 != NA la uso para definir el rango
    if(!is.na(iiss$J3)){
      #si J3 se movio en un cluster, uso el cluster para definir el rango
      #  if(iiss$jl==1){
      #    #TODO
      #  }else{
      
      #roiJ3   <- as.numeric(strsplit2(as.character(iiss$J3),".",fixed=TRUE)[2:3])
      
      #chequeo si tengo mas de una J3
      j3aux <- strsplit2(iiss$J3,";")
      roiJ3<-c()
      for(ij3 in seq_along(j3aux)){
        roiJ3   <- c(roiJ3,as.numeric(strsplit2(j3aux[ij3],".",fixed=TRUE)[2:3]))
      }
      roiJ3 <- range(roiJ3)
      
      #  }
      
      roi[1] <- min(roi,roiJ3)
      roi[2] <- max(roi,roiJ3)
    }
    
    delta <- roi[2]-roi[1]
    
    zroi  <- c(roi[1]-delta*zoomRegion/2 , roi[2]+delta*zoomRegion/2)
    zdelta<-zroi[2]-zroi[1]
    
    gr    <- as(paste0(chr,":",zroi[1],"-",zroi[2]),"GRanges")
    hits  <- findOverlaps(gr,featuresb(f))
    bins  <-featuresb(f)[subjectHits(hits)]
    
    bins  <- bins[mcols(bins)$feature!="Io",]
    
    #redefino la zoomedroi en base a los bines que overlapeaban la zroi original
    delta <- max(end(bins))-min(start(bins))
    #zroi  <- c(start(bins)[1]-delta*zoomRegion/2 , end(bins)[length(bins)]+delta*zoomRegion/2)
    zroi  <- c(start(bins)[1], end(bins)[length(bins)])
    
  }else{
    
    #identifico coordenadas de biones ebinsonicos
    #iE <- which(mcols(featuresb(f))$locus%in%geneName & mcols(featuresb(f))$feature=="E"
    iE <- which(mcols(featuresb(f))$locus%in%geneName)
    if(length(iE)==0){
      #Is this a monoexonic gene?
      if(length(featuresg(f)[[geneName]])==1){
        bins <- featuresg(f)[geneName]
        mcols(bins)<-data.frame(locus=geneName,bin="E001",feature="mono E",
                                symbol=mcols(bins)$symbol,
                                locus_overlap=mcols(bins)$locus_overlap,
                                class="E",
                                event="novel",
                                eventJ="-")
        zroi <- roi <- as.numeric(c(start(bins)[1],end(bins)[length(bins)]))
      }else{
        warning("Something terribly wrong happened...No annotation data
                for",geneName," could be found!\nProbably a monoexonic gene...")
        return()
      }
    }else{
      bins <- featuresb(f)[iE,]
      bins <- bins[mcols(bins)$feature!="Io",]
      zroi <- roi <- c(start(bins)[1],end(bins)[length(bins)])
    }
    
    
    
    }
  
  #Armado del layout
  if(is.null(exones)){
    hh <- c(rep(c(hCov,hJun)/nConditions,nConditions),0.1)
    hh <- hh/sum(hh)
  }else{
    hh <- c(rep(c(hCov,hJun)/nConditions,nConditions),(hCov+hJun)/nConditions)
    hh <- hh/sum(hh)
  }
  #layout(matrix(c((2*nConditions+1):1,rep(1+2*nConditions+1:nConditions,each=2),(3*nConditions+2)),ncol=2),width=c(0.8,.2),height=hh)
  layout(matrix((2*nConditions+1):1),widths=c(0.8,.2),heights=hh)
  
  par(mar=c(.5, 1.1, .5, 1.1))
  
  rownames(mergedBAMs)<-mergedBAMs[,1]
  
  
  # Si hay exones...dibujo variantes
  if(!is.null(exones)){
    transcriptGene<-strsplit2(names(exones),".",fixed=TRUE)[,1]
    
    ig<-which(transcriptGene%in%geneName)
    tex <- exones[ig]
    tex <- tex[order(names(tex))]
    
    limExones<-unlist(lapply(tex,function(x){
      return(c(start(x),end(x)))
    }))
    
    plot(0,typ="n",xlim=range(limExones),ylim=c(0,length(tex)+3),axes=FALSE,xlab="",ylab="")
    
    if(length(tex)>1 | !genePlot){
      for(itex in 1:length(tex)){
        bbins <- tex[[itex]]
        y<-length(tex)-(itex-1)
        lines(c(start(bbins[1]),end(bbins[length(bbins)])),c(y,y),col="gray")
        rect(start(bbins),y-.3,end(bbins),y+0.3,col=rgb(.7,.7,.7),border="black")
        
      }
    }
    ycollapsed <- length(tex)+2
  }else{
    ycollapsed <- 0
  }
  
  # Bines del genoma anotado que overlapean con el roi
  iE   <- mcols(bins)$feature%in%c("E","mono E")
  iroi <- (start(bins)>=roi[1] & start(bins)<roi[2])
  
  nbines <- length(bins)
  delta <- end(bins[nbines])-start(bins[1])
  
  if(is.null(exones)){
    plot(0,typ="n",xlim=c(start(bins[1]),end(bins[nbines])),ylim=c(-.5,.5),axes=FALSE,xlab="",ylab="")
  }
  lines(c(start(bins[1]),end(bins[nbines])),c(ycollapsed,ycollapsed),col="gray")
  rect(start(bins)[iE],ycollapsed-.45,end(bins)[iE],ycollapsed+.45,col="white")
  
  #remarco la roi original
  xroi   <- as.numeric(strsplit2(strsplit2(iiss$region,":")[2],"-"))
  lines(xroi,rep(ycollapsed-.6,2),col="black",lwd=3)
  
  #grafico el zoom
  if(!genePlot){
    lines(c(start(bins[1]),par("usr")[1]),c(ycollapsed+.45,par("usr")[4]),lty=1,col="gray")
    lines(c(end(bins[nbines]),par("usr")[2]),c(ycollapsed+.45,par("usr")[4]),lty=1,col="gray")
  }
  
  #bines diferenciales
  
  #que bines diferenciales hay en la region?
  iE<-which(names(bins)%in%iiss$bin)
  if(length(iE)>0){
    for(iie in seq_along(iE)){
      if(mcols(bins)$feature[iE[iie]]%in%c("Io","I")){
        lines(c(start(bins[iE[iie]]),end(bins[iE[iie]])),c(ycollapsed,ycollapsed),col="orange",lwd=3)
      }else{
        if(iiss$b!=0 | iiss$bjs!=0){
          if(iiss$b!=0 & iiss$bjs==0) cc <- "orange"
          if(iiss$b!=0 & iiss$bjs!=0) cc <- "red"
          if(iiss$b==0 & iiss$bjs!=0) cc <- "yellow"
          rect(start(bins[iE[iie]]),ycollapsed-.45,end(bins[iE[iie]]),ycollapsed+.45,col=cc,border=NA)
        } 
      }
    }
  }
  
  
  lines(par("usr")[1:2],rep(ycollapsed-1,each=2),lty=2,col="gray")
  
  # Junturas
  jcount1<-jcount2<-jcount0<-nj0<-nj1<-nj2<-0
  aspli.chr <- strsplit2(strsplit2(iiss$region,":")[1], "[cC]hr")
  if(ncol(aspli.chr) == 2){
    aspli.chr <- aspli.chr[, 2]
  }else{
    aspli.chr <- aspli.chr[, 1]
  }
  
  #que junturas estan dentro de la zona?
  jsplit <- strsplit2(rownames(junctionsPJU(asd)),".",fixed=TRUE)
  if(jCompletelyIncluded){
    ijsplit <- which(jsplit[,1]==aspli.chr & as.numeric(jsplit[,2])>=zroi[1] & as.numeric(jsplit[,3])<=zroi[2])
  }else{
    ijsplit <- which(jsplit[,1]==aspli.chr & 
                       ((as.numeric(jsplit[,2])>=zroi[1] & as.numeric(jsplit[,2])<=zroi[2]) |
                          (as.numeric(jsplit[,3])>=zroi[1] & as.numeric(jsplit[,3])<=zroi[2])) )
  }
  
  
  # busco anchor junctions
  js <- unique(anchorbased(sr)$junction)
  aux <- strsplit2(js,".",fixed=TRUE)
  # ijs <-which(aux[,1]==aspli.chr &
  #               as.numeric(aux[,2])>=zroi[1] &
  #               as.numeric(aux[,2])<=zroi[2])  #ACA HAbia un error!
  if(jCompletelyIncluded){
    ijs <- which(aux[,1]==aspli.chr & as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])
  }else{
    ijs <- which(aux[,1]==aspli.chr & 
                   ((as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,2])<=zroi[2]) |
                      (as.numeric(aux[,3])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])) )
  }
  jcoords1<-c()
  if(length(ijs)>0){
    jcoords1          <- matrix(as.numeric(aux[ijs,]),ncol=3)
    rownames(jcoords1)<-js[ijs]
    nj1               <- nrow(jcoords1)
  }
  
  #analizo locale 
  js <- unique(localebased(sr)$junction)
  aux <- strsplit2(js,".",fixed=TRUE)
  # ijs <-which(aux[,1]==aspli.chr &
  #               as.numeric(aux[,2])>=zroi[1] &
  #               as.numeric(aux[,2])<=zroi[2]) #ACA HAbia un error!
  if(jCompletelyIncluded){
    ijs <- which(aux[,1]==aspli.chr & as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])
  }else{
    ijs <- which(aux[,1]==aspli.chr & 
                   ((as.numeric(aux[,2])>=zroi[1] & as.numeric(aux[,2])<=zroi[2]) |
                      (as.numeric(aux[,3])>=zroi[1] & as.numeric(aux[,3])<=zroi[2])) )
  }
  jcoords2<-c()
  if(length(ijs)>0){
    jcoords2          <- matrix(as.numeric(aux[ijs,]),ncol=3)
    rownames(jcoords2)<-js[ijs]
    nj2               <- nrow(jcoords2)
  }
  
  # junturas en la region que no son anchor ni locale
  jcoords0<-c()
  if(length(ijsplit)>0){ 
    jcoords0 <- data.frame(chr=as.numeric(jsplit[ijsplit,1]),
                           start=as.numeric(jsplit[ijsplit,2]),
                           end=as.numeric(jsplit[ijsplit,3]))
    rownames(jcoords0)<-rownames(junctionsPJU(asd))[ijsplit]
    
    jcoords0 <- jcoords0[!rownames(jcoords0)%in%unique(c(rownames(jcoords1),rownames(jcoords2))),]
    nj0               <- nrow(jcoords0)                       
  }
  
  
  #si detecto locale o anchor lo marco  
  if(nj1>0) abline(v=unique(c(jcoords1[,2],jcoords1[,3])),col="lightblue",lty=3)
  if(nj2>0) abline(v=unique(c(jcoords2[,2],jcoords2[,3])),col="lightgreen",lty=3)
  
  #dibujo paneles por condicion: junturas y coverage en la region de interes
  for(icond in 1:nConditions){
    # print(paste0("samtools depth -r ",
    #              paste0(aspli.chr,":",zroi[1],"-",zroi[2]," "),
    #              mergedBAMs[icond, 1]))
    ad <- system(paste0("samtools depth -r ",
                        paste0(aspli.chr,":",zroi[1],"-",zroi[2]," "),
                        mergedBAMs[icond, 1]), intern = TRUE)
    ad <- matrix(as.numeric(strsplit2(ad,"\t")),ncol=3)
    yylim <- range(ad[,3])
    
    nrep <- table(counts@targets$condition)[mergedBAMs[icond,2]]
    #me quedo con las que pasan un filtro de minima   
    jjcoords0<-jcoords0
    if(nj0>0){
      jcount0 <- .countJbyCondition(jcoords0,counts)[,mergedBAMs[icond,2],drop=FALSE]
      jok     <- rownames(jcount0)[jcount0>5*nrep]
      nj0     <- length(jok)
      if(nj0>0)  jjcoords0  <- jcoords0[jok,,drop=FALSE]
    }
    
    jjcoords1<-jcoords1
    if(nj1>0){
      jcount1 <- .countJbyCondition(jcoords1,counts)[,mergedBAMs[icond,2],drop=FALSE]
      #   jok     <- rownames(jcount1)[jcount1>5*nrep]
      #   nj1     <- length(jok)
      #   if(nj1>0)  jjcoords1  <- jcoords1[jok,,drop=FALSE]
    }
    
    jjcoords2<-jcoords2
    if(nj2>0){
      jcount2 <- .countJbyCondition(jcoords2,counts)[,mergedBAMs[icond,2],drop=FALSE]
      #   jok     <- rownames(jcount2)[jcount2>5*nrep]
      #   nj2     <- length(jok)
      #   if(nj2>0)  jjcoords2  <- jcoords2[jok,,drop=FALSE]
    }
    
    
    #panel junturas
    if(FALSE){
      plot(0,typ="n",xlim=c(start(bins[1]),end(bins[nbines])),ylim=c(1,nj0+nj1+nj2+3),axes=FALSE,xlab="",ylab="")
      jmaxcount <- max(c(jcount0,jcount1,jcount2))
      if(nj0>0){
        jcounts <- jcount0
        jcoords <- jjcoords0
        ww <- jcounts/jmaxcount*3
        for(ij in 1:nj0){
          lines(jcoords[ij,2:3],rep(ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightgray")
          points(jcoords[ij,2:3],rep(ij,2),pch=18,cex=0.5,col="lightgray")
        }
      }
      if(nj1>0){
        jcounts <- jcount1
        jcoords <- jjcoords1
        ww <- jcounts/jmaxcount*3
        
        abline(v=unique(c(jcoords[,2],jcoords[,3])),col="lightblue",lty=3)
        for(ij in 1:nj1){
          lines(jcoords[ij,2:3],rep(nj0+ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightblue")
          points(jcoords[ij,2:3],rep(nj0+ij,2),pch=18,cex=0.5,col="lightblue")
          text(mean(as.numeric(jcoords[ij,2:3])),nj0+ij,jcounts[ij],pos=3,cex=tcex)
        }
      }
      if(nj2>0){
        jcounts <- jcount2
        jcoords <- jjcoords2
        ww <- jcounts/jmaxcount*3
        
        abline(v=unique(c(jcoords[,2],jcoords[,3])),col="lightgreen",lty=3)
        for(ij in 1:nj2){
          lines(jcoords[ij,2:3],rep(nj0+nj1+ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightgreen")
          points(jcoords[ij,2:3],rep(nj0+nj1+ij,2),pch=18,cex=0.5,col="lightgreen")
          text(mean(as.numeric(jcoords[ij,2:3])),nj0+nj1+ij,jcounts[ij],pos=3,cex=tcex)
        }
      }
    }
    
    #plot(0,typ="n",xlim=c(start(bins[1]),end(bins[nbines])),ylim=c(1,nj0+nj1+nj2+3),axes=FALSE,xlab="",ylab="")
    
    extra <- 5
    njlevels <- nj0+nj1+nj2+extra
    
    j12      <- intersect(rownames(jcoords1),rownames(jcoords2))
    njlevels <- nj0+nj1+nj2-length(j12)+extra
    
    xx<-as.numeric(c(start(bins[1]),end(bins[nbines])))
    plot(0,typ="n",xlim=xx,ylim=c(1,njlevels),axes=FALSE,xlab="",ylab="")
    jmaxcount <- max(c(jcount0,jcount1,jcount2))
    if(nj0>0){
      jcounts <- jcount0
      jcoords <- jjcoords0
      ww <- jcounts/jmaxcount*3
      for(ij in 1:nj0){
        lines(jcoords[ij,2:3],rep(ij,2),lwd=ww[rownames(jcoords)[ij],1],col="lightgray")
        points(jcoords[ij,2:3],rep(ij,2),pch=18,cex=0.5,col="lightgray")
      }
    }
    
    if(njlevels-nj0>extra){
      jcounts<-c()
      if(nj1>0) jcounts<-jcount1
      if(nj2>0){
        if(length(j12)>0){
          jcounts<-rbind(jcounts,jcount2[!rownames(jcount2)%in%j12,,drop=FALSE])
        }else{  
          jcounts<-rbind(jcounts,jcount2)
        }
      }
      jcoords <- t(apply(cbind(rownames(jcounts,jcounts)),1,function(x){as.numeric(strsplit2(x,"[.]"))}))
      rownames(jcoords)<-rownames(jcounts)
      
      ccolor  <- rep("lightgreen",nrow(jcounts))
      names(ccolor)<-rownames(jcounts)
      if(nj2>0) ccolor[rownames(jcount2)]<-"lightblue"
      if(length(j12)>0) ccolor[j12]<-"orange"
      
      ww <- jcounts/jmaxcount*3
      
      abline(v=unique(c(jcoords[,2],jcoords[,3])),col="lightblue",lty=3)
      for(ij in 1:length(ccolor)){
        #yij <- nj0+ij
        yij  <- ij * njlevels*0.8/(nj1+nj2-length(j12))
        lines(jcoords[ij,2:3],rep(yij,2),lwd=max(1,ww[rownames(jcoords)[ij],1]),col=ccolor[ij])
        points(jcoords[ij,2:3],rep(yij,2),pch=18,cex=0.5,col=ccolor[ij])
        text(mean(as.numeric(jcoords[ij,2:3])),yij,jcounts[ij],pos=2,cex=tcex)
      }
      
    }
    
    
    #coverage
    xx <- as.numeric(c(start(bins[1]),end(bins[nbines])))
    if(useLog){
      plot(0.01,typ="n",xlim=xx,ylim=yylim,axes=FALSE,xlab="",ylab="",log="y")
    }else{
      plot(0,typ="n",xlim=xx,ylim=yylim,axes=FALSE,xlab="",ylab="")
    }
    polygon(c(ad[1,2],ad[,2],ad[nrow(ad),2]), c(0.01,ad[,3],0.01)
            ,border=NA,col=topo.colors(nConditions,1)[icond],fillOddEven = TRUE)
    lines(c(ad[1,2],ad[,2],ad[nrow(ad),2]),  c(0.01,ad[,3],0.01),
          col=topo.colors(nConditions,1)[icond])
    text(ad[1,2],0.01,paste0("[0-",max(ad[,3]),"]"),cex=tcex,adj=c(-.25,-.5))
    
    if(nj1>0)abline(v=unique(c(jcoords1[,2],jcoords1[,3])),col="lightblue",lty=3)
    if(nj2>0)abline(v=unique(c(jcoords2[,2],jcoords2[,3])),col="lightgreen",lty=3)
    
    #remarco la roi original
    if(icond==1){
      xroi   <- as.numeric(strsplit2(strsplit2(iiss$region,":")[2],"-"))
      lines(xroi,rep(par("usr")[3],2),col="black",lwd=3)
      # rect(xroi[1],par("usr")[3],xroi[2],par("usr")[3]+diff(par("usr")[4:3])*.1,col="black",density=2)
    }
    legend("topleft", as.character(mergedBAMs$condition[icond]),bty="n")
  }
  mtext(paste(iiss$locus,iiss$region),line=-.5,cex=0.8)
  
  
  #vamos por el texto:
  if(FALSE){
    # Junturas Anchor
    plot(1,axes=FALSE,type="n",xlab="",ylab="")
    if(iiss$ja==1){
      col1 <- c( "junction","junction.annotated","junction.fdr","junction.nonuniformity","junction.participation","cluster.fdr","dPIR")
      a1 <- sr@anchorbased[sr@anchorbased$junction%in%iiss$J3,col1]
      if(nrow(a1)>0){
        a1[col1[3:7]]<-signif(a1[col1[3:7]],2)
        a1<-cbind(names(a1),t(a1))
        a1<-apply(a1,1,function(x){return(paste(x,collapse=": "))})
        names(a1)<- c("junction","annotated","j.fdr","non-unif","participation","cluster.fdr","D_PIR")
        a1<-paste("  ",a1,sep = "")
        a1<-c("Junction Anchorage:",a1)
        legend("topleft",a1,cex=tcex,bty="n",inset=0.02) 
        
        # a2 <- sr@anchorbased[sr@anchorbased$junction%in%iiss$J3,8+c(6,4,2,5,3,1)]*nrep
        # a2 <- cbind(names(a2),t(a2))
        # a2 <- apply(a2,1,function(x){return(paste(x,collapse=": "))})
        # a2<-paste("  ",a2,sep = "")
        
        # legend("bottomleft",a2,cex=tcex,bty="n",inset=0.02)
      }else{
        a1<-c("Junction Anchorage:","  no J3 passed the filter.")
        legend("topleft",a1,cex=tcex,bty="n",inset=0.02)   
      }
    }
    
    # Junturas locale
    plot(1,axes=FALSE,type="n",xlab="",ylab="")
    if(iiss$jl==1){
      col1 <- c( "junction","junction.annotated","junction.fdr","junction.participation","cluster.fdr")
      a1 <- sr@localebased[sr@localebased$junction%in%iiss$J3,col1]
      a1[col1[3:5]]<-signif(a1[col1[3:5]],2)
      a1<-cbind(names(a1),t(a1))
      a1<-apply(a1,1,function(x){return(paste(x,collapse=": "))})
      names(a1)<- c("junction","annotated","j.fdr","participation","cluster.fdr")
      a1<-paste("  ",a1,sep = "")
      a1<-c("Junction Locale:",a1)
      
      legend("topleft",a1,cex=tcex,bty="n",inset=0.02) 
      
      
    }
    
    # bin info
    plot(1,axes=FALSE,type="n",xlab="",ylab="")
    if(iiss$b==1 | iiss$bjs==1){
      col1 <- c( "bin","bin.fdr","junction.dPIR","junction.dPSI")
      a1 <- sr@binbased[sr@binbased$bin%in%iiss$bin,col1]
      a1[col1[2:4]]<-signif(a1[col1[2:4]],2)
      names(a1)<-c("bin","bin.fdr","D_PIR","D_PSI")
      a1<-cbind(names(a1),t(a1))
      a1<-apply(a1,1,function(x){return(paste(x,collapse=": "))})
      a1<-paste("  ",a1,sep = "")
      a1<-c("Bin:",a1)
      legend("topleft",a1,cex=tcex,bty="n",inset=0.02) 
      
    }
  }
  
}

# This function return the names of the unique conditions corresponing to the 
# targets in the order that they are assigned to define the constrat.
getConditions <- function( targets ) {
  return( unique ( .condenseTargetsConditions( targets )$condition ))
}

.createGRangesGenes <- function( genomeTxDb, geneSymbols ) {
  
  # -------------------------------------------------------------------------- #
  # Se generan los rangos de los bins que corresponden a los bins exonicos.
  # Pimero se extraen los exones anotados para cada gen y despues se entrecruzan
  # los exones del mismo gen ( con la funcion disjoin ) dando los rangos de los
  # bins
  exons                  <- exonsBy( genomeTxDb, by="gen" ) #extract exons by gene
  exons.by.gene.disjoint <- disjoin( exons ) 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Agrega datos de la coordenadas genomicas, el solapamiento de genes y 
  # simbolos de los genes
  geneCoordinates <- .createGRangesGenes.getGeneCoordinates( 
      exons.by.gene.disjoint , genomeTxDb )
  locusOverlap    <- .createGRangesGenes.getLocusOverlap( 
      exons.by.gene.disjoint )
  symbol          <- geneSymbols[ names( exons.by.gene.disjoint ), ]
  
  metadata        <- DataFrame( gene_coordinates = geneCoordinates,
      locus_overlap    = locusOverlap,
      symbol           = symbol ) 
  
  mcols( exons.by.gene.disjoint ) <- append(
      mcols( exons.by.gene.disjoint ), metadata )
  # -------------------------------------------------------------------------- #
  
  return( exons.by.gene.disjoint )
}

.createGRangesGenes.getGeneCoordinates <- function ( binsGRangesList , aTxDb) {
  
  geneChr    <- as.character( seqnames( genes( aTxDb ) ) )
  geneStarts <- sapply( start( binsGRangesList ), min )
  geneEnds   <- sapply( end(   binsGRangesList ), max )
  
  geneCoordinates <- paste0( geneChr, ':', geneStarts, '-', geneEnds )
  
  return( geneCoordinates )
}

# deprecated
.createGRangesGenes.getGeneCoordinates.old <- function ( binsGRangesList ) {
  
  chromosome                <- sapply( seqnames( binsGRangesList ),unique )
  chromosome                <- as.character( chromosome )
  
  geneStarts             <- sapply( start( binsGRangesList ), min )
  geneEnds               <- sapply( end( binsGRangesList ), max )
  
  browser                <- paste( chromosome, geneStarts, sep=":" ) 
  
  geneCoordinates <- paste( browser, geneEnds, sep="-" )
  
  return (geneCoordinates)
  
}

.createGRangesGenes.getLocusOverlap <- function ( binsGRangesList ) {
  
  # -------------------------------------------------------------------------- #
  # Busca los rangos que se solapan, debido a que se espera que los rangos de 
  # binsGRangesList sean disjuntos ( es decir, no se solapan para un mismo gen),
  # los solapamientos que se encuentran deben ser entre rangos de genes 
  # diferentes.
  #Modificaciones hechas por AR 20201128
  if(F){
    #if ( packageVersion("IRanges") < 2.6 )
    if (compareVersion(as.character(packageVersion("IRanges")),'2.6')<0){
      locus <- findOverlaps( binsGRangesList, ignoreSelf=TRUE, ignore.strand = T ) 
    } else {
      locus <- findOverlaps( binsGRangesList, drop.self=TRUE, ignore.strand = T ) 
      #locus <- findOverlaps( binsGRangesList[c(i, j)], drop.self=TRUE, ignore.strand = T ) 
    }
    
    
    # -------------------------------------------------------------------------- #
    
    locusOverlap <- rep("-", length( binsGRangesList ) )  
    
    # -------------------------------------------------------------------------- #
    # Si hay genes que se solapan, se recuperan todos los nombres de los genes
    if ( length( locus ) > 0 ) {
      names      <- names( binsGRangesList[ to( locus ) ] )
      geneIndex  <- from ( locus ) 
      aggregated <- data.frame( aggregate( names ~ geneIndex, 
                                           FUN = paste, collapse = ';' ) )
      locusOverlap[ aggregated$geneIndex ] <- aggregated$names
    }
    # -------------------------------------------------------------------------- #
  }else{
    starts   <- aggregate(start ~ group_name, data.frame(binsGRangesList), min)
    ends     <- aggregate(end ~ group_name, data.frame(binsGRangesList), max)
    seqnames <- aggregate(seqnames ~ group_name, data.frame(binsGRangesList), unique)
    strands  <- aggregate(strand ~ group_name, data.frame(binsGRangesList), unique)
    rangos   <- merge(strands, merge(seqnames, merge(starts, ends, by = "group_name"), by = "group_name"), by = "group_name")
    grangos  <- makeGRangesListFromDataFrame(rangos, names.field = "group_name")
    names(grangos) <- rangos$group_name
    #if ( packageVersion("IRanges") < 2.6 )
    if (compareVersion(as.character(packageVersion("IRanges")),'2.6')<0){      
      locus <- findOverlaps( grangos, ignoreSelf=TRUE, ignore.strand = T ) 
    } else {
      locus <- findOverlaps( grangos, drop.self=TRUE, ignore.strand = T ) 
    }
    
    # -------------------------------------------------------------------------- #
    
    locusOverlap <- rep("-", length( grangos ) )  
    
    # -------------------------------------------------------------------------- #
    # Si hay genes que se solapan, se recuperan todos los nombres de los genes
    if ( length( locus ) > 0 ) {
      names      <- names( grangos[ to( locus ) ] )
      geneIndex  <- from ( locus ) 
      aggregated <- data.frame( aggregate( names ~ geneIndex, 
                                           FUN = paste, collapse = ';' ) )
      locusOverlap[ aggregated$geneIndex ] <- aggregated$names
    }
    # -------------------------------------------------------------------------- #    
    
  }
  
  
  
  return ( locusOverlap )
  
}
.createGRangesExons <- function( aTxDb, geneSymbols ) {
  
  # -------------------------------------------------------------------------- #
  # Recupera los exones de los genes con mas de un exon
  exonsM <- .createGRangesExons.getExonsFromMultiExonicGenes( aTxDb )
  # -------------------------------------------------------------------------- # 
  
  # -------------------------------------------------------------------------- #
  # Genera los bins para los exones seleccionados
  exon.bins <- .createGRangesExons.getExonBins ( exonsM )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Genera nombres para los bins creados
  exonData <-  .createGRangesExons.getExonBinNames ( exon.bins )
  exon.bins.names          <- exonData [[1]] 
  exon.gene.names.repeated <- exonData [[2]] 
  exon.bins.id             <- exonData [[3]] 
  # Setea los nombres de los bins
  names( exon.bins ) <- exon.bins.names
  # -------------------------------------------------------------------------- #  
  
  # -------------------------------------------------------------------------- #
  # Agrega metadatos
  feature.exon    <- rep("E", length(exon.bins.id))
  geneSymbolIndex <- match( exon.gene.names.repeated, rownames( geneSymbols ) )  
  symbol          <- geneSymbols[geneSymbolIndex, ]
  
  metadata <- DataFrame( locus   = exon.gene.names.repeated, 
      bin     = exon.bins.id,
      feature = feature.exon,
      symbol  = symbol )
  
  mcols( exon.bins ) <- append ( mcols( exon.bins ), metadata )
  # -------------------------------------------------------------------------- #
  
  return (exon.bins)
}

.createGRangesExons.getExonBinNames <- function ( aGRanges ) {
  
  # -------------------------------------------------------------------------- #
  # Recupera el numero de exones para cada gen.
  nExonsByGene <- table( names( aGRanges ) )          
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Genera un lista que contiene el numero de orden de cada exon
  exon.bins.num <- unlist( lapply( nExonsByGene, seq ) )
  # Genera identificadores de orden para los bins
  exonBinIds  <- sprintf('E%03d', exon.bins.num)
  # Genera los nombre de los bins
  exonGeneNames <- rep( names(nExonsByGene), nExonsByGene) 
  exonBinNames <- paste(exonGeneNames, exonBinIds ,sep=":")
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Devuelve los nombre de los bins, genes y los identificadores de orden de los
  # bins
  return ( list( exonBinNames, exonGeneNames, exonBinIds) )
  # -------------------------------------------------------------------------- #
  
}

.createGRangesExons.getExonsFromMultiExonicGenes <- function ( aTxDb ) {
  
  # Extrae todos los exones
  exons <- exonsBy(aTxDb, by="gen" ) #extract exons by gen 
  # se queda con los GRanges de los genes que tienen mas de un exon
  multipleExons <- exons[ lengths( exons )  > 1 ] 
  
  return ( multipleExons )
  
}

.createGRangesExons.getExonBins <- function ( aGRangesList ) {
  
  # Genera los segmentos que corresponden a los bins
  exon.by.gene.disjoint <- disjoin( aGRangesList )
  
  # Convierte el GRangeList a un GRanges.
  # Se mezclan los GRanges de todos lo genes, es una sola lista
  exon.by.gene.disjoint.unlist <- unlist( exon.by.gene.disjoint )
  
  # Se eliminan GRanges duplicados, esto es porque pueden tener origen en 
  # distintos genes.
  exon.bins <- exon.by.gene.disjoint.unlist[ ! duplicated( exon.by.gene.disjoint.unlist ) ] 
  
  return( exon.bins )
  
}

# ---------------------------------------------------------------------------- #
# .createGRangesIntrons
.createGRangesIntrons <- function( aTxDb, geneSymbols ) {
  
  # -------------------------------------------------------------------------- #
  # Recupera los intrones de la anotacion por transcripto
  introns <- intronsByTranscript( aTxDb, use.names=TRUE )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Convierte el GRangesList de los intrones por transcripto en un GRanges de
  # todos los intrones solamente.
  introns.ulst <- unlist( introns )
  # Elimina intrones duplicados
  introns.no.dups <- introns.ulst[ ! duplicated( introns.ulst ) ]
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Recupera los nombres de los genes de cada transcripto
  introns.tx.names <- names( introns.no.dups ) 
  suppressMessages ( 
      introns.map <- select( 
          aTxDb, 
          keys    = introns.tx.names, 
          keytype = 'TXNAME', 
          columns = 'GENEID' )
  )
  # Elimina posibles datos con nombres de gen no valido.
  introns.map <- introns.map[ ! is.na( introns.map$GENEID ) , ]
  introns.no.dups <-  introns.no.dups[ ! is.na( introns.map$GENEID ) , ]
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Agrupa los intrones por gen. Devuelve un GRangesList
  introns.by.gene <- split( introns.no.dups, introns.map$GENEID ) 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Recupera todos los rangos del GrangesList en un unico GRanges.
  nIntronsByGene      <- lengths( introns.by.gene )
  intronOrig          <- unlist( introns.by.gene )
  geneNames           <- rep( names( introns.by.gene ), nIntronsByGene )
  names( intronOrig ) <- geneNames
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Procesa los intrones originales
  intronOrigIndex   <- sprintf( 'Io%03d', unlist( lapply( nIntronsByGene, seq ) ) )
  
  names(ranges(intronOrig)) <- paste( geneNames, intronOrigIndex, sep=":" ) 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Agrega metadatos
  feature.o.intron  <- rep( "Io", length( intronOrigIndex ) )
  
  metadata <- DataFrame( locus   = geneNames ,
      bin     = intronOrigIndex,  
      feature = feature.o.intron )
  
  mcols( intronOrig ) <- append( mcols(intronOrig) , metadata)
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Procesa los bins intronicos.
  # Obtiene los rangos de los bins.
  introns.by.gene.disjoint <- disjoin( introns.by.gene )
  # Recupera el numero de intrones por gen
  nIntronsByGene           <- lengths( introns.by.gene.disjoint )
  # Recupera los nombres del gen para cada intron
  geneNames                <- rep (names(introns.by.gene.disjoint),nIntronsByGene )
  # Junta todos los rangos de GRangeList de los intrones en un unido GRanges.
  intron.bins              <- unlist( introns.by.gene.disjoint )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Genera los identificadores de cada intron
  intron.bins.num          <- sprintf( 'I%03d', 
      unlist( lapply( nIntronsByGene, seq ) ) )
  # Agrega los nombes de los genes a cada intron
  intron.bin.names         <- paste( geneNames , 
      intron.bins.num, sep=":" ) 
  names( intron.bins )     <- intron.bin.names  
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Agrega metadatos
  
  feature.intron <- rep("I", length(intron.bins.num) )
  
  
  metadata <- DataFrame( locus   = geneNames,       
      bin     = intron.bins.num,  #add metadata    
      feature = feature.intron  )  #add metadata 
  
  mcols(intron.bins) <- append( mcols( intron.bins ), metadata )                    
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Junta los intrones originales y los bins intronicos.
  # Si hay un intron originales que es igual a uno intronico, se elimina.
  # La eliminacion se hace implicitamente con la funcion unique. Se eliminan
  # los originales porque estan despues que los bins intronicos.
  intrones.totales  <- c( intron.bins, intronOrig )
  intron.tot.u      <- sort( unique( intrones.totales ) )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Agrega los simbolos de los genes
  symbolIndex <- match( mcols(intron.tot.u)[, 'locus'], rownames( geneSymbols ) )
  symbol <- geneSymbols[symbolIndex, ]
  mcols(intron.tot.u) <- append( mcols( intron.tot.u ), DataFrame( symbol = symbol ) )
  # -------------------------------------------------------------------------- #
  
  return (intron.tot.u)
}
# Fin de createGRangesIntrons
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# .createGRangesTranscripts
.createGRangesTranscripts <- function(genome) {
  transcripts <- transcriptsBy(genome)
  return(transcripts)
}
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# .createGRangesJunctions
.createGRangesJunctions <- function( aTxDb ) {
  
  # -------------------------------------------------------------------------- #
  # Recupera los intrones por transcripto
  introns.no.dups <- .createGRangesJunctions.getUniqueIntrons( aTxDb )
  # Recupera los nombres de los transcriptos para cada intron
  introns.tx.names <- names( introns.no.dups )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Agrupa los intrones por gen
  introns.by.gene <- .createGRangesJunctions.intronsByGene( aTxDb, 
      introns.tx.names , introns.no.dups )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Genera las junturas a partir de los intrones 
  nIntronsByGene <- lengths( introns.by.gene )
  geneNames      <- rep( names( introns.by.gene ) , nIntronsByGene )
  junctions <- .createGRangesJunctions.getJunctions( introns.by.gene, nIntronsByGene, geneNames  )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Modifica el rangos de las junturas
  start( junctions ) <- start( junctions ) - 1
  end( junctions )   <- end( junctions ) + 1
  # -------------------------------------------------------------------------- #

  # -------------------------------------------------------------------------- #
  # Agrega metadatos
  mcols( junctions) <- append( mcols( junctions ), DataFrame( locus = geneNames ) ) 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Ordena las junturas
  junctions <- sort( junctions )
  # -------------------------------------------------------------------------- #
  
  return (junctions)
  
}

.createGRangesJunctions.getUniqueIntrons <- function ( aTxDb ) {
  
  introns <- intronsByTranscript( aTxDb, use.names=TRUE )
  
  introns.ulst <- unlist( introns )          
  
  introns.no.dups <- introns.ulst[ !duplicated( introns.ulst ) ]
  
  return ( introns.no.dups  ) 
}

.createGRangesJunctions.intronsByGene <- function ( aTxDb, transcripts, introns.no.dups ) {
  suppressMessages(
      introns.map <- select( aTxDb, 
          keys    = transcripts, 
          keytype = 'TXNAME', 
          columns = 'GENEID' )
  )
  introns.map <- introns.map[ !is.na( introns.map$GENEID ),  ]
  introns.no.dups <- introns.no.dups[ ! is.na( introns.map$GENEID ) ]
  # Agrupa los intrones por gen
  introns.by.gene <- split( introns.no.dups, introns.map$GENEID )
  
  return ( introns.by.gene )
}

.createGRangesJunctions.getJunctions <- function ( intronsByGene, nIntronsByGene, geneNames  ) {
  junctions          <- unlist( intronsByGene ) 
  introns.num        <- sprintf( 'J%03d',  unlist( lapply( nIntronsByGene, seq ) ) )
  junction.names     <- paste( geneNames, introns.num, sep = ":" ) 
  names( junctions ) <- junction.names
  return( junctions )
}
# Fin de .createGRangesJunctions
# ---------------------------------------------------------------------------- #

.shiftVector <- function ( x, positions,  dir="right", default = NA ) {
  invert    <- positions < 0
  positions <- if (invert) -positions else positions
  positions <- positions %% length(x)
  
  dir <- tolower( dir )
  dir <- if (dir == 'right') 0 else if (dir == 'left') 1 else NA
  dir <- if (invert) dir <- 1 - dir else dir
  
  if ( dir == 0 ) {
    return( c( rep( default, times=positions ), x[1:(length(x)-positions )] ) )
  } else 
  if ( dir == 1 ) {
    return( c( x[(positions+1):length(x)], rep( default, times=positions )) )
  }
  warning("Direction no recognized. Return unmodified value.")
  return (x)
}


# ---------------------------------------------------------------------------- #
# .findAsBin 
.findAsBin <- function( exons, exon.bins, intron.bins, transcripts, junctions, logTo = NULL) {
  
  # -------------------------------------------------------------------------- #
  # Get all alternative bins. I.e. those that are shared between exons bins and
  # intron bins.
  as.bins <- findOverlaps( exon.bins, intron.bins, type = c( "equal" ) ) 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Add 'as' tag to alternative bins
  exon.as   <- rep( "-", length( exon.bins ) ) 
  intron.as <- rep( "-", length( intron.bins ) ) 
  exon.as[ from( as.bins ) ] <- "Undefined AS" 
  intron.as[ to( as.bins ) ] <- "Undefined AS" 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Looks for terminal bins.
  # A bin has one 5' and 3' terminal bin for each transcript.
  transcripts.unlist  <- unlist( transcripts )
  find.external.start <- findOverlaps( exon.bins, transcripts.unlist, type=c( "start" ) ) 
  find.external.end   <- findOverlaps( exon.bins, transcripts.unlist, type=c( "end" ) )
  # Add the 'terminal' tag to a bin. If a bin has a 'as' tag already, the new 
  # 'tag' overwrites the older one.
  exon.as[ find.external.start@from ] <- "external" 
  exon.as[ find.external.end@from ] <- "external" 
  # -------------------------------------------------------------------------- #
  
  
  # -------------------------------------------------------------------------- #
  # Add 'as' and 'external' tags to introns
  mcols(intron.bins) <- append( mcols( intron.bins ), DataFrame(class=intron.as)) 
  # and exons.
  mcols(exon.bins)   <- append( mcols( exon.bins ), DataFrame(class=exon.as)) 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Join all bins
  bins <- unique ( sort( append( exon.bins, intron.bins ) ) ) 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Assign a splice event to each alternative bin y putative junctions if 
  # possible.
  auxdf <- data.frame( feature = as.character( mcols( bins )$feature), 
      class   = as.character( mcols( bins )$class),
      strand  = as.character( strand( bins) ) )
  # Preassign default values            
  auxdf$events <- as.character(auxdf$class)
  auxdf$eventsJ <- as.character(auxdf$class)
  # -------------------------------------------------------------------------- #
  
  
  # -------------------------------------------------------------------------- #
  # Add class information of neighbor bins.
  auxdf$classPrev <- .shiftVector(as.character(auxdf$class),1, default = '-')
  auxdf$classNext <- .shiftVector(as.character(auxdf$class),-1, default = '-')
  isAS <- auxdf$class == 'Undefined AS'
  neighbourIsAS <- auxdf$classPrev =='Undefined AS' | auxdf$classNext == 'Undefined AS'
  # -------------------------------------------------------------------------- #
  
  
  # -------------------------------------------------------------------------- #
  # Looks for bins that overlap perfectly with a junction
  ji <- junctions
  start(ji) <- start(junctions)+1
  end(ji) <- end(junctions)-1
  
  over <- findOverlaps( bins, ji, type="equal")
  binOverlapsJunction <- rep( FALSE ,  nrow(auxdf) ) 
  binOverlapsJunction[queryHits(over)] <- TRUE
  # -------------------------------------------------------------------------- #

  # -------------------------------------------------------------------------- #
  # Looks for bins that overlap perfectly with an exon
  over <- findOverlaps( bins, exons, type="equal")
  binOverlapsExon <- rep( FALSE ,  nrow(auxdf) ) 
  binOverlapsExon[queryHits(over)] <- TRUE
  # -------------------------------------------------------------------------- #

  
  # -------------------------------------------------------------------------- #
  # Looks for bins that overlaps with the start or the end of a junction 
  jranges.start <- junctions
  start(jranges.start) <- end(jranges.start)
  st <- findOverlaps(type = "start", bins, jranges.start )
  binOverlapsJunctionStart <- rep( FALSE ,  nrow(auxdf) )
  binOverlapsJunctionStart[ queryHits( st ) ] <- TRUE
  
  jranges.end <- junctions
  end(jranges.end) <- start(jranges.end)
  end <- findOverlaps( type="end", bins, jranges.end )
  binOverlapsJunctionEnd <- rep( FALSE ,  nrow(auxdf) )
  binOverlapsJunctionEnd[ queryHits( end ) ] <- TRUE
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  isPlusStrand <- auxdf$strand == '+'
  isMinusStrand <- auxdf$strand == '-'
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Add information about the neighbor bins
  auxdf$featurePrev <- .shiftVector( as.character( auxdf$feature ),  1 , default = "-")
  auxdf$featureNext <- .shiftVector( as.character( auxdf$feature ), -1 , default = "-")
  neighborsAreExons <- auxdf$featurePrev == "E" & auxdf$featureNext == "E" 
  neighborsAreIntrons <- auxdf$featurePrev == "I" & auxdf$featureNext == "I" 
  neighborsAreExonAndIntron <- auxdf$featurePrev == "E" & auxdf$featureNext == "I" 
  neighborsAreIntronAndExon <- auxdf$featurePrev == "I" & auxdf$featureNext == "E" 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Assign a splicing event type to bins and junctions.
  # If at least one of the neighbor bins is AS (i.e.), the classification is 
  # made using annotated junctions. Otherwise is made using exon or intron 
  # annotation.
  
  auxdf[ isAS & neighbourIsAS & binOverlapsJunction , 'events' ] <- "IR*"
  #auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  binOverlapsJunctionStart & binOverlapsJunctionEnd, 'events' ] <- "ES*"
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  binOverlapsExon, 'events' ] <- "ES*"
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  binOverlapsJunctionStart & ! binOverlapsJunctionEnd & isPlusStrand, 'events' ] <- "Alt3ss*" 
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  binOverlapsJunctionStart & ! binOverlapsJunctionEnd & isMinusStrand, 'events' ] <- "Alt5ss*"
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  ! binOverlapsJunctionStart & binOverlapsJunctionEnd & isPlusStrand, 'events' ] <- "Alt5ss*" 
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  ! binOverlapsJunctionStart & binOverlapsJunctionEnd & isMinusStrand, 'events' ] <- "Alt3ss*" 
  
  auxdf[ isAS & neighbourIsAS & binOverlapsJunction , 'eventsJ' ] <- "IR"
  #auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  binOverlapsJunctionStart & binOverlapsJunctionEnd, 'eventsJ' ] <- "ES"
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  binOverlapsExon, 'eventsJ' ] <- "ES"
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  binOverlapsJunctionStart & ! binOverlapsJunctionEnd & isPlusStrand, 'eventsJ' ] <- "Alt3ss" 
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  binOverlapsJunctionStart & ! binOverlapsJunctionEnd & isMinusStrand, 'eventsJ' ] <- "Alt5ss"
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  ! binOverlapsJunctionStart & binOverlapsJunctionEnd & isPlusStrand, 'eventsJ' ] <- "Alt5ss"
  auxdf[ isAS & neighbourIsAS & ! binOverlapsJunction &  ! binOverlapsJunctionStart & binOverlapsJunctionEnd & isMinusStrand, 'eventsJ' ] <- "Alt3ss" 
  
  auxdf[ isAS & !neighbourIsAS & neighborsAreExons , 'events' ] <- "IR"
  auxdf[ isAS & !neighbourIsAS & neighborsAreIntrons , 'events' ] <- "ES"
  auxdf[ isAS & !neighbourIsAS & neighborsAreExonAndIntron & isPlusStrand, 'events' ] <- "Alt5ss"
  auxdf[ isAS & !neighbourIsAS & neighborsAreExonAndIntron & isMinusStrand, 'events' ] <- "Alt3ss"
  auxdf[ isAS & !neighbourIsAS & neighborsAreIntronAndExon & isPlusStrand, 'events' ] <- "Alt3ss"
  auxdf[ isAS & !neighbourIsAS & neighborsAreIntronAndExon & isMinusStrand, 'events' ] <- "Alt5ss"
  
  auxdf[ isAS & !neighbourIsAS & neighborsAreExons , 'eventsJ' ] <- "IR"
  auxdf[ isAS & !neighbourIsAS & neighborsAreIntrons , 'eventsJ' ] <- "ES"
  auxdf[ isAS & !neighbourIsAS & neighborsAreExonAndIntron & isPlusStrand, 'eventsJ' ] <- "Alt5ss"
  auxdf[ isAS & !neighbourIsAS & neighborsAreExonAndIntron & isMinusStrand, 'eventsJ' ] <- "Alt3ss"
  auxdf[ isAS & !neighbourIsAS & neighborsAreIntronAndExon & isPlusStrand, 'eventsJ' ] <- "Alt3ss"
  auxdf[ isAS & !neighbourIsAS & neighborsAreIntronAndExon & isMinusStrand, 'eventsJ' ] <- "Alt5ss"
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Count events by type.
  AsNotExternal <- sum( intron.as == "Undefined AS" )
  totAS <- sum( auxdf$class == "Undefined AS" )
  
  ES     <- sum( auxdf$events == "ES" )
  IR     <- sum( auxdf$events == "IR" )
  Alt5ss <- sum( auxdf$events == "Alt5ss" )
  Alt3ss <- sum( auxdf$events == "Alt3ss" )
  
  mult       <- sum( isAS & neighbourIsAS )
  multES     <- sum( auxdf$events == "ES*" )
  multIR     <- sum( auxdf$events == "IR*" )
  multAlt5ss <- sum( auxdf$events == "Alt5ss*" )
  multAlt3ss <- sum( auxdf$events == "Alt3ss*" )
  # -------------------------------------------------------------------------- #
  
  
  # -------------------------------------------------------------------------- #
  # Append junction metadata to bins 
  mcols(bins) <- append(mcols(bins), DataFrame(event=auxdf$events))
  mcols(bins) <- append(mcols(bins), DataFrame(eventJ=auxdf$eventsJ))
  # -------------------------------------------------------------------------- #
  
  exportTextMessage <- function (totAS, AsNotExternal, ES, IR, Alt5ss, Alt3ss, 
      mult, multES,multIR, multAlt5ss, multAlt3ss   ) {
    
    paste0("* Number of AS bins (not include external) = ", totAS, "\n",
        "* Number of AS bins (include external) = ", AsNotExternal,"\n",
        "* Classified as: \n",
        "\tES bins = ", ES, "\t(",round(ES/totAS*100), "%)\n", 
        "\tIR bins = " , IR,"\t(",round(IR/totAS*100), "%)\n",
        "\tAlt5'ss bins = ", Alt5ss, "\t(",round(Alt5ss/totAS*100), "%)\n", 
        "\tAlt3'ss bins = ", Alt3ss,"\t(",round(Alt3ss/totAS*100), "%)\n",
        "\tMultiple AS bins = ", mult, "\t","(",round(mult/totAS*100), "%)\n", 
        "\tclassified as:\n",
        "\t\t\t", "ES bins = ", multES, "\t(",round(multES/mult*100), "%)\n", 
        "\t\t\t","IR bins = " , multIR,"\t(",round(multIR/mult*100), "%)\n",
        "\t\t\t","Alt5'ss bins = ", multAlt5ss, "\t(",round(multAlt5ss/mult*100), "%)\n", 
        "\t\t\t","Alt3'ss bins = ", multAlt3ss,"\t(",round(multAlt3ss/mult*100), "%)\n" )
  }
  
  textMsg <- exportTextMessage( totAS, AsNotExternal, ES, IR, Alt5ss, Alt3ss,
      mult, multES,multIR, multAlt5ss, multAlt3ss )
  message(textMsg)
  
  if ( sink.number() > 0 ) { 
    cat( textMsg )
    sink()
  }
  
  # -------------------------------------------------------------------------- #
  
  return(bins)
}
# ---------------------------------------------------------------------------- #

aspliTargetsExample <- function( ) {
  
  bamfiles <- system.file( 'extdata', 
      c('A_C_0.bam', 'A_C_1.bam', 'A_C_2.bam',
          'A_D_0.bam', 'A_D_1.bam', 'A_D_2.bam',
          'B_C_0.bam', 'B_C_1.bam', 'B_C_2.bam',
          'B_D_0.bam', 'B_D_1.bam', 'B_D_2.bam' ),
      package = "ASpli") 
  
  targets <- data.frame(
      row.names = c( 'A_C_0', 'A_C_1', 'A_C_2',
          'A_D_0', 'A_D_1', 'A_D_2',
          'B_C_0', 'B_C_1', 'B_C_2',
          'B_D_0', 'B_D_1', 'B_D_2' ),
      bam = bamfiles,
      f1  = rep( c('A','B'), each=6 ),
      f2  = rep( c('C','D'), 2, each=3 ),
      stringsAsFactors = FALSE )
  
  return( targets )
  
}

aspliExampleGTF <- function( ) {
  
  system.file( 'extdata', 'genes.mini.gtf' , package = "ASpli" )
  
}

aspliExampleBamList <- function( ) {
  bamFileNames <- paste( 
      rep( c( 'A', 'B' ), each = 6 ), 
      rep( c( 'C', 'D' ), 2, each=3 ), 
      paste0( rep(0:2,2), '.bam'),
      sep='_' )
  
  system.file( 'extdata', bamFileNames , package = "ASpli")
}

aspliBamsExample <- function( ) {
  targets <- aspliTargetsExample()
  loadBAM( targets )
} 

aspliDUexample1 <- function( ) {
  .loadASpliObject( "ASpliDU", 'du', 
      c('genes', 'bins', 'junctions'),
      c( 'genesDE', 'binsDU', 'junctionsDU' ) )
}

aspliDUexample2 <- function( ) {
  .loadASpliObject( "ASpliDU", 'du', 
      c('genes', 'bins' ),
      c( 'genesDE', 'binsDU' ) )
}

aspliASexample <- function( ) {
  .loadASpliObject( "ASpliAS", 'as', 
      c('altPSI', 'esPSI', 'irPIR', 'join', 'junctionsPIR', 'junctionsPSI'),
      c( 'altPSI', 'esPSI', 'irPIR', 'joint', 'junctionsPIR', 'junctionsPSI') )
}

aspliJunctionDUexample <- function( ) {
  .loadASpliObject( "ASpliDU", 'du', 
      c( 'junctions'),
      c( 'junctionsDU' ) )
}

aspliCountsExample <- function( ) {
  .loadASpliObject( "ASpliCounts", 'counts', 
      c( 'bin.rd' , 'e1i.counts', 'exon.intron.counts', 'gene.counts', 
          'gene.rd', 'ie2.counts', 'junction.counts'),
      c( 'rdsb' , 'countse1i', 'countsb', 'countsg', 'rdsg', 'countsie2',
          'countsj') )
}

aspliFeaturesExample <- function( ) {
  
  # -------------------------------------------------------------------------- #
  # Create dummy gene features
  genesGRL <- GRangesList()
  genesGRL$GENE01 <- GRanges( 'reference', IRanges( start= c(1,301,501), 
          end=c( 300,500,700 ) ), '+')
  genesGRL$GENE02 <- GRanges( 'reference', IRanges( start= c(1001,1301,1601), 
          end=c( 1250,1400,1800 ) ), '+')
  genesGRL$GENE03 <- GRanges( 'reference', IRanges( start= c(2001,2251,2501), 
          end=c( 2250,2350,2800 ) ), '+')
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Create summy bin features
  binsGR <- GRanges( 'reference', IRanges( 
          start = c( 1, 301, 501, 1001, 1251, 1301, 1401, 1601, 2001, 2251, 
              2351, 2501 ),
          end =   c( 300,  500,  700, 1250, 1300, 1400, 1600, 1800, 2250, 2350,
              2500, 2800  ) ),
      strand = '+')
  
  names( binsGR ) <- c( 'GENE01:E001', "GENE01:E002", "GENE01:E003", 
      "GENE02:E001", "GENE02:I001", "GENE02:E002", "GENE02:I003", "GENE02:E003",
      "GENE03:E001", "GENE03:E002", "GENE03:I002", "GENE03:E003" )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Create dummy junction features
  junctionsGR <- GRanges( 'reference', IRanges( 
              start = c( 300, 1250, 1250, 1400, 2250, 2350 ),
              end =   c( 501, 1301, 1601, 1601, 2501, 2501 ) ),
          strand = '+')
  
  names( junctionsGR ) <- c( "GENE01:J001", "GENE02:J001", "GENE02:J003", 
      "GENE02:J002", "GENE03:J002", "GENE03:J001" )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Create dummy ASpliFeatures object
  features <- new("ASpliFeatures")
  featuresg( features ) <- genesGRL
  featuresb( features ) <- binsGR
  featuresj( features ) <- junctionsGR
  # -------------------------------------------------------------------------- #
  
  return( features )
  
}

.loadASpliObject <- function ( Class, prefix, slotNames, setters ) {
  obj <- new( Class )
  if (length (slotNames) == length( setters) ) {
    for ( i in 1:length( slotNames ) ) {
      fn <- paste0( prefix, '.',slotNames[i] )
      fn <- system.file("extdata", fn,  package="ASpli")
      
      slot.table <- read.table( fn, sep = "\t", stringsAsFactors = FALSE, check.names = FALSE )
      obj <- do.call( paste0(setters[i],'<-'), list( obj , slot.table ) )
    }
  }
  return( obj )
}

# ---------------------------------------------------------------------------- #
# Getters and setters for ASpliFeatures
setGeneric( name = "featuresg", def = function( x ) standardGeneric("featuresg") )
setMethod( f = "featuresg", signature = "ASpliFeatures",
            definition = function(x){  x@genes } )

setGeneric( name = "featuresg<-", def = function( x, value ) standardGeneric("featuresg<-") )
setReplaceMethod( f = "featuresg", signature = c( "ASpliFeatures", 'GRangesList' ),
    definition = function( x , value){  x@genes <- value; return( x ) } )

setGeneric( name = "featuresj", def = function( x ){ standardGeneric("featuresj") } )
setMethod( f = "featuresj", signature = "ASpliFeatures", 
    definition = function(x){ x@junctions })

setGeneric( name = "featuresj<-", def = function( x, value ){ standardGeneric("featuresj<-") } )
setReplaceMethod( f = "featuresj", signature = c("ASpliFeatures", "GRanges"), 
    definition = function( x, value ){ x@junctions <- value; return ( x )})

setGeneric( name = "featuresb", def = function( x ) standardGeneric("featuresb"))
setMethod( f = "featuresb",signature = "ASpliFeatures",
           definition = function( x ){ x@bins })

setGeneric( name = "featuresb<-", def = function( x, value ) standardGeneric("featuresb<-"))
setReplaceMethod( f = "featuresb",signature = c( "ASpliFeatures","GRanges" ),
   definition = function( x, value ){ x@bins <- value; return( x ) } )

setGeneric( name = "transcriptExons", def = function( x ) standardGeneric("transcriptExons"))
setMethod( f = "transcriptExons",signature = "ASpliFeatures",
           definition = function( x ){ x@transcriptExons })

setGeneric( name = "transcriptExons<-", def = function( x, value ) standardGeneric("transcriptExons<-"))
setReplaceMethod( f = "transcriptExons",signature = c( "ASpliFeatures","GRangesList" ),
                  definition = function( x, value ){ x@transcriptExons <- value; return( x ) } )
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# Getters and Setters for ASpliCounts
setGeneric( name= "countsg", def=function( x ) standardGeneric("countsg") )
setMethod( f = "countsg", signature = "ASpliCounts",
    definition = function( x ){ x@gene.counts} )
       
setGeneric( name= "countsg<-", def=function( x, value ) standardGeneric("countsg<-") )
setReplaceMethod( f = "countsg", signature = c( "ASpliCounts", "data.frame") ,
   definition = function( x, value ){ x@gene.counts <- value; return ( x )} )
       
setGeneric ( name = "countsj", def = function( x ) standardGeneric("countsj") )
setMethod (f = "countsj", signature = "ASpliCounts", 
    definition = function( x ){ x@junction.counts })

setGeneric ( name = "countsj<-", def = function( x, value ) standardGeneric("countsj<-") )
setReplaceMethod (f = "countsj", signature = c( "ASpliCounts","data.frame"), 
    definition = function( x, value ){ x@junction.counts <- value ; return (x) })
       
setGeneric( name = "countsb", def = function( x ) standardGeneric("countsb") )
setMethod( f = "countsb", signature = "ASpliCounts", 
    definition = function( x ){ x@exon.intron.counts } )

setGeneric( name = "countsb<-", def = function( x, value ) standardGeneric("countsb<-") )
setReplaceMethod( f = "countsb", signature = c("ASpliCounts","data.frame"), 
    definition = function( x, value ){ x@exon.intron.counts <- value; return( x ) } )

setGeneric( name = "countse1i", def = function( x ) standardGeneric("countse1i") )
setMethod (f = "countse1i", signature = "ASpliCounts", 
    definition = function( x ){ x@e1i.counts })

setGeneric( name = "countse1i<-", def = function( x, value ) standardGeneric("countse1i<-") )
setReplaceMethod (f = "countse1i", signature = c("ASpliCounts", "data.frame"), 
    definition = function( x, value ){ x@e1i.counts <- value; return( x ) } )

setGeneric( name = "countsie2", def = function( x ) standardGeneric("countsie2"))
setMethod( f = "countsie2", signature = "ASpliCounts", 
    definition = function( x ){ x@ie2.counts })

setGeneric( name = "countsie2<-", def = function( x, value ) standardGeneric("countsie2<-"))
setReplaceMethod( f = "countsie2", signature = c("ASpliCounts","data.frame"), 
    definition = function( x, value ){ x@ie2.counts <- value; return( x ) })

setGeneric( name = "rdsg", def = function( x ) standardGeneric("rdsg"))
setMethod( f = "rdsg", signature = "ASpliCounts",
    definition = function( x ){ x@gene.rd })

setGeneric( name = "rdsg<-", def = function( x, value ) standardGeneric("rdsg<-"))
setReplaceMethod( f = "rdsg", signature = c("ASpliCounts","data.frame"),
    definition = function( x, value ){ x@gene.rd <- value; return( x )})

setGeneric( name = "rdsb", def = function( x ) standardGeneric("rdsb") )
setMethod( f = "rdsb", signature = "ASpliCounts", 
    definition = function( x ){ x@bin.rd })

setGeneric( name = "rdsb<-", def = function( x, value ) standardGeneric("rdsb<-") )
setReplaceMethod( f = "rdsb", signature = c("ASpliCounts","data.frame"), 
    definition = function( x, value ){ x@bin.rd <- value; return ( x )})

setGeneric( name = "condition.order", def = function( x ) standardGeneric("condition.order") )
setMethod( f = "condition.order", signature = "ASpliCounts", 
           definition = function( x ){ x@condition.order })

setGeneric( name = "targets", def = function( x ) standardGeneric("targets") )
setMethod( f = "targets", signature = "ASpliCounts", 
           definition = function( x ){ x@targets })
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# Getters and Setters for ASpliAS
setGeneric( name =  "irPIR", def = function( x ) standardGeneric("irPIR") )
setMethod( f = "irPIR", signature =  "ASpliAS", 
    definition = function( x ){ x@irPIR } )

setGeneric( name =  "irPIR<-", def = function( x, value ) standardGeneric("irPIR<-") )
setReplaceMethod( f = "irPIR", signature = c("ASpliAS",'data.frame'), 
    definition = function( x, value ){ x@irPIR <- value; return( x ) } )       

setGeneric( name =  "altPSI", def = function( x ) standardGeneric("altPSI"))
setMethod(f = "altPSI", signature = "ASpliAS", 
    definition = function( x ) { x@altPSI })

setGeneric( name =  "altPSI<-", def = function( x, value ) standardGeneric("altPSI<-"))
setReplaceMethod( f = "altPSI", signature = c("ASpliAS","data.frame"), 
    definition = function( x, value ) { x@altPSI <- value; return( x ) })

setGeneric( name = "esPSI", def = function( x ) standardGeneric("esPSI"))
setMethod( f = "esPSI", signature = "ASpliAS",
    definition = function( x ) { x@esPSI })

setGeneric( name = "esPSI<-", def = function( x, value ) standardGeneric("esPSI<-"))
setReplaceMethod( f = "esPSI", signature = c("ASpliAS","data.frame"),
    definition = function( x, value ) { x@esPSI <- value; return( x ) })

setGeneric( name = "junctionsPIR", def = function( x ) standardGeneric("junctionsPIR"))
setMethod( f ="junctionsPIR", signature = "ASpliAS", 
    definition = function( x ){ x@junctionsPIR })

setGeneric( name = "junctionsPIR<-", def = function( x, value ) standardGeneric("junctionsPIR<-"))
setReplaceMethod( f ="junctionsPIR", signature = c("ASpliAS","data.frame"), 
    definition = function( x, value){ x@junctionsPIR <- value; return( x ) })

setGeneric( name = "junctionsPJU", def = function( x ) standardGeneric("junctionsPJU"))
setMethod( f = "junctionsPJU", signature = "ASpliAS",
    definition = function( x ){ x@junctionsPJU } )

setGeneric( name = "junctionsPJU<-", def = function( x, value ) standardGeneric("junctionsPJU<-"))
setReplaceMethod( f = "junctionsPJU", signature = c("ASpliAS","data.frame"),
    definition = function( x, value ){ x@junctionsPJU <- value; return( x )} )

setGeneric( name = "joint", def = function( x ) standardGeneric("joint") )
setMethod( f = "joint", signature = "ASpliAS", 
    definition = function( x ){ x@join })

setGeneric( name = "joint<-", def = function( x, value ) standardGeneric("joint<-") )
setReplaceMethod( f = "joint", signature = c("ASpliAS","data.frame"), 
    definition = function( x, value ){ x@join <- value; return( x ) })
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# Getters and Setters for ASpliDU
setGeneric( name = "genesDE", def = function( x ) standardGeneric("genesDE"))
setMethod( f = "genesDE", signature = "ASpliDU", 
    definition = function( x ){ x@genes })

setGeneric( name = "genesDE<-", def = function( x, value ) standardGeneric("genesDE<-"))
setReplaceMethod( f = "genesDE", signature = c("ASpliDU","data.frame"), 
    definition = function( x,value ){ x@genes <- value; return( x )})

setGeneric( name = "binsDU", def = function( x ) standardGeneric("binsDU"))
setMethod( f = "binsDU", signature = "ASpliDU", 
    definition = function( x ){ x@bins })

setGeneric( name = "binsDU<-", def = function( x, value ) standardGeneric("binsDU<-"))
setReplaceMethod( f = "binsDU", signature = "ASpliDU", 
    definition = function( x, value ){ x@bins <- value; return( x ) })

setGeneric(  name = "junctionsDU", def = function( x ) standardGeneric("junctionsDU") )
setMethod( f = "junctionsDU", signature = "ASpliDU", 
    definition = function( x ){ x@junctions })

setGeneric(  name = "junctionsDU<-", def = function( x, value ) standardGeneric("junctionsDU<-") )
setReplaceMethod( f = "junctionsDU", signature = c( "ASpliDU", 'data.frame'), 
    definition = function( x, value ){ x@junctions <- value; return( x ) } )
#-----------------------------------------------------------------------

setGeneric( name = "filters", def = function( x ) standardGeneric("filters"))
setMethod( f = "filters", signature = "ASpliIntegratedSignals",
           definition = function( x ){ x@filters } )

setGeneric( name = "filters<-", def = function( x, value ) standardGeneric("filters<-"))
setReplaceMethod( f = "filters", signature = c("ASpliIntegratedSignals","data.frame"),
                  definition = function( x, value ){ x@filters <- value; return( x )} )

setGeneric( name = "signals", def = function( x ) standardGeneric("signals") )
setMethod( f = "signals", signature = "ASpliIntegratedSignals", 
           definition = function( x ){ x@signals })

setGeneric( name = "signals<-", def = function( x, value ) standardGeneric("signals<-") )
setReplaceMethod( f = "signals", signature = c("ASpliIntegratedSignals","data.frame"), 
                  definition = function( x, value ){ x@signals <- value; return( x ) })
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# show methods
setMethod( 'show', 'ASpliFeatures', function( object ) {
      cat("Object of class", class(object),"\n")
      cat("Genes: GRangesList of length ", 
          length(object@genes),
          "Access using featuresg(object)", "\n")
      cat("Bins: GRanges of length", 
          length(object@bins),
          "Access using featuresb(object)", "\n")
      cat("Junctions: GRanges of length", 
          length(object@junctions),
          "Access using featuresj(object)","\n")
      cat("Transcript Exons: GRanges of length", 
          length(object@transcriptExons),
          "Access using transcriptExons(object)","\n")
    })

setMethod( 'show', 'ASpliCounts', function( object ) {
      cat("Object of class", class(object),"\n")
      cat("Gene counts:", 
          dim(object@gene.counts)[1], "genes analysed.",
          "Access using countsg(object)", "\n")
      cat("Gene RD:", 
          dim(object@gene.rd)[1], "genes analysed.",
          "Access using rdsg(object)", "\n")
      cat("Bin counts:", 
          dim(object@exon.intron.counts)[1], "bins analysed.",
          "Access using countsb(object)", "\n")
      cat("Bin RD:", 
          dim(object@bin.rd)[1],"bins analysed.",
          "Access using rdsb(object)", "\n")
      cat("Junction counts:", 
          dim(object@junction.counts)[1], "junctions analysed.",
          "Access using countsj(object)", "\n")
    })
        
setMethod( 'show', 'ASpliAS', function( object )  {
      cat("Object of class", class(object),"\n")
      cat("IR PIR: ", 
          dim(object@irPIR)[1], "intron bins analysed.",
          sum(!is.na(object@irPIR$J3)), "intron bins passed the filters.",
          "Access using irPIR(object)", "\n")
      cat("ES PSI:", 
          dim(object@esPSI)[1], "exon bins analysed.",
          sum(!is.na(object@esPSI$J3)), "exon bins passed the filters.",
          " Access using esPSI(object)", "\n")
      cat("AltSS PSI:", 
          dim(object@altPSI)[1], "exon bins analysed.",
          sum(!is.na(object@altPSI$J3)), "exon bins passed the filters.",
          " Access using altPSI(object)", "\n")
      cat("Junctions PIR:", 
          dim(object@junctionsPIR)[1], "junctions analysed.",
          "Access using junctionsPIR(object)", "\n")
      cat("Junctions PJU:", 
          dim(object@junctionsPJU)[1], "junctions analysed.",
          "Access using junctionsPJU(object)", "\n")
    })

setMethod('show', 'ASpliDU', function( object ) {
      cat("Object of class", class(object),"\n")
      if ( containsGenesAndBins( object ) ) {
        cat("Gene DE:", 
            dim(object@genes)[1], "genes analysed.",
            "Access using genesDE(object)", "\n")
        
        cat("Bins DU:", 
            dim(object@bins)[1], "bins analysed.",
            "Access using binsDU(object)", "\n")
      }
      if ( containsJunctions( object ) ) {
        cat("Junctions DU:", 
            dim(object@junctions)[1],"junctions analysed.",
            "Access using junctionsDU(object)", "\n")
      }
    })

setMethod('show', 'ASpliJDU', function( object ) {
  cat("Object of class", class(object),"\n")
  
  cat("Locale Junctions:", 
      nrow(localej(object)), "junctions.",
      "Access using localej(object)", "\n")

  cat("Locale Clusters:", 
      nrow(localec(object)), "clusters",
      "Access using localec(object)", "\n")
  
  cat("Anchor Junctions:", 
      nrow(anchorj(object)), "junctions.",
      "Access using anchorj(object)", "\n")
  
  cat("Anchor Clusters:", 
      nrow(anchorc(object)), "clusters",
      "Access using anchorc(object)", "\n")
  
  cat("Intron Retention Junctions:",
      nrow(jir(object)), "junctions.",
      "Access using jir(object)", "\n")
  
  cat("Exon Skipping Junctions:", 
      nrow(jes(object)), "junctions.",
      "Access using jes(object)", "\n")
  
  cat("Alternative Splicing Junctions:", 
      nrow(jalt(object)), "junctions.",
      "Access using jalt(object)", "\n")
})

setMethod( 'show', 'ASpliSplicingReport', function( object ) {
  
  # my_table    <- function(data, jcol="junction"){
  #   binNA       <- is.na(data$bin.fdr)
  #   junctionNA  <- is.na(data$junction.fdr)
  #   
  #   binNNA      <- data[!binNA, ]
  #   binNA       <- data[binNA, ]
  #   junctionNNA <- data[!junctionNA, ]
  #   junctionNA  <- data[junctionNA, ]
  #   
  #   binT      <- binNNA$bin.fdr < 0.05
  #   binF      <- unique(binNNA[!binT, colnames(data) == jcol])
  #   binT      <- unique(binNNA[binT, colnames(data) == jcol])
  #   
  #   if("cluster.fdr" %in% colnames(data)){
  #     junctionT <- junctionNNA$junction.fdr < 0.05 | junctionNNA$cluster.fdr < 0.05
  #   }else{
  #     junctionT <- junctionNNA$junction.fdr < 0.05
  #   }
  #   junctionF <- unique(junctionNNA[!junctionT, colnames(data) == jcol])
  #   junctionT <- unique(junctionNNA[junctionT, colnames(data) == jcol])
  #   
  #   binNA     <- unique(binNA[, colnames(data) == jcol])
  #   binNNA    <- unique(binNNA[, colnames(data) == jcol])
  #   
  #   junctionNA  <- unique(junctionNA[, colnames(data) == jcol])
  #   junctionNNA <- unique(junctionNNA[, colnames(data) == jcol])
  #   
  #   m         <- matrix(c(length(intersect(binF, junctionF)), 
  #                         length(intersect(binF, junctionT)), 
  #                         length(intersect(binF, junctionNA)), 
  #                         length(intersect(binT, junctionF)), 
  #                         length(intersect(binT, junctionT)),
  #                         length(intersect(binT, junctionNA)),
  #                         length(intersect(binNA, junctionF)),
  #                         length(intersect(binNA, junctionT)),
  #                         length(intersect(binNA, junctionNA))),
  #                       nrow=3, ncol=3, byrow=T)
  #   rownames(m) <- c("Bin F", "Bin T", "Bin <NA>")                           
  #   colnames(m) <- c("Junction F", "Junction T", "Junction <NA>")
  #   return(m)
  # }
  
  if(FALSE){
    integratedSignals <- integrateSignals(object, asd = new(Class = "ASpliAS"))
    cat("Object of class", class(object),"\n")
    
    cat("Locale based: \n") 
    cat("De novo junctions: ", sum(is.na(integratedSignals$feature[integratedSignals$jl == 1])), "\n")
    cat("Annotated features:\n")
    print(table(integratedSignals[integratedSignals$jl == 1,c("feature","bin.event")]))
    cat("Access using localebased(object)\n\n")
    #print(table(bin=localebased(object)$bin.fdr < 0.05, junction=(localebased(object)$junction.fdr < 0.05 | localebased(object)$cluster.fdr < 0.05), useNA = "always"))
      
    cat("Anchor based: \n")
    cat("De novo junctions: ", sum(is.na(integratedSignals$feature[integratedSignals$ja == 1])), "\n")
    cat("Annotated features:\n")
    print(table(integratedSignals[integratedSignals$ja == 1,c("feature","bin.event")]))
    cat("Access using anchorbased(object)\n\n")
    #print(table(bin=anchorbased(object)$bin.fdr < 0.05, junction=(anchorbased(object)$junction.fdr < 0.05 | anchorbased(object)$cluster.fdr < 0.05), useNA = "always"))  
  
    cat("Bin based: \n") 
    cat("Annotated features:\n")  
    print(table(integratedSignals[integratedSignals$b == 1,c("feature","bin.event")]))
    #print(table(bin=binbased(object)$bin.fdr < 0.05, junction=binbased(object)$junction.fdr < 0.05, useNA = "always"))
    cat("Access using binbased(object)\n\n")  
  }else{
    cat("Object of class", class(object),"\n")
    cat("Locale based: \n") 
    cat("Access using localebased(object)\n\n")

    cat("Anchor based: \n")
    cat("Access using anchorbased(object)\n\n")

    cat("Bin based: \n") 
    cat("Access using binbased(object)\n\n")  
  }
})
# ---------------------------------------------------------------------------- #


# ---------------------------------------------------------------------------- #
# Write methods
setGeneric ( name =  "writeCounts",
  def = function( counts,  output.dir = "counts" ) standardGeneric( "writeCounts" ) )

setMethod(
  f = "writeCounts",
  signature = "ASpliCounts",
  definition = function( counts, output.dir = "counts" ) {
    genesFile <- file.path( output.dir, "genes", "gene.counts.tab" )       
    exonsFile <- file.path( output.dir, "exons", "exon.counts.tab")       
    intronsFile    <- file.path( output.dir, "introns", "intron.counts.tab")
    intronsIE1File <- file.path( output.dir, "introns", "e1i.counts.tab")
    intronsEI2File <- file.path( output.dir, "introns", "ie2.counts.tab")
    junctionsFile <- file.path( output.dir, "junctions", "junction.counts.tab")              	     	     	     	     	    
    
    file.exists( output.dir ) || dir.create ( output.dir )
    for (folder in unique( lapply( c(genesFile, exonsFile, intronsIE1File, 
                intronsEI2File, junctionsFile ), 
            dirname ))) {
      dir.create( folder )
    }

    # Export genes 
    write.table(countsg(counts), genesFile, sep="\t", quote=FALSE, col.names=NA)

    # Export exons
    ec <- countsb(counts)[ countsb(counts)$feature=="E",]
    ec <- ec[ ec$event != "IR", ]
    ec <- ec[ ec$event != "IR*", ]
    write.table( ec, exonsFile, sep="\t", quote=FALSE, col.names=NA)

    # Export introns
    ic <- rbind( countsb( counts )[ countsb( counts )$feature == "I",], 
                 countsb( counts )[ countsb( counts )$feature == "Io",], 
                 countsb( counts )[ countsb( counts )$event == "IR",],
                 countsb( counts )[ countsb( counts )$event == "IR*",])
    write.table(ic, intronsFile, sep="\t", quote=FALSE, col.names=NA)
    write.table(countse1i(counts), intronsIE1File, sep="\t", quote=FALSE, 
        col.names=NA)
    write.table(countsie2(counts), intronsEI2File, sep="\t", quote=FALSE, 
        col.names=NA)
    
    # Export junctions 
    write.table(countsj(counts), junctionsFile, sep="\t", quote=FALSE, 
        col.names=NA)
  }
)

setGeneric ( name = "writeRds", 
    def = function( counts, output.dir="rds" ) standardGeneric( "writeRds" ) )

setMethod(
  f = "writeRds",
  signature = "ASpliCounts",
  definition = function( counts, output.dir="rds") {
    
    # Create output folder structure
    file.exists( output.dir ) || dir.create( output.dir )
    
    genesFile   <- file.path( output.dir, "genes", "gene.rd.tab" )       
    exonsFile   <- file.path( output.dir, "exons", "exon.rd.tab" )       
    intronsFile <- file.path( output.dir, "introns", "intron.rd.tab" )

    # Export gene read densities
    write.table( rdsg(counts), genesFile, sep="\t", quote = FALSE, 
        col.names = NA )

    # Export exon read densities
    erd <- rdsb(counts)[rdsb(counts)$feature == "E",]
    erd <- erd[erd$event != "IR",]
    erd <- erd[erd$event != "IR*",]
    write.table( erd, exonsFile, sep="\t", quote = FALSE, col.names = NA )

    # Export Intron read densities
    ird <- rbind( rdsb(counts)[rdsb(counts)$feature == "I",], 
                  rdsb(counts)[rdsb(counts)$feature == "Io",], 
                  rdsb(counts)[rdsb(counts)$eventJ  == "IR",])
    write.table( ird, intronsFile, sep="\t", quote = FALSE, col.names = NA )
  }
)

setGeneric ( name = "writeAll", 
    def = function( counts, du, as, output.dir="output" ) 
      standardGeneric( "writeAll" ) )

setMethod(
  f = "writeAll",
  signature = 'ASpliCounts',
  definition = function( counts, du, as, output.dir="output" ) {
    
    # Exports Counts, read densities, AS y DU
    suppressWarnings( writeCounts( counts, output.dir ) )
    suppressWarnings( writeRds( counts, output.dir ) )
    suppressWarnings( writeAS( as, output.dir ) )
    suppressWarnings( writeDU( du, output.dir ) )
    
    # Export as+du table
    colnames( irPIR( as ) ) <- colnames( altPSI( as ) )
    conP <- rbind( altPSI(as), esPSI(as), irPIR(as) )
    ii   <- match( rownames( binsDU( du ) ), row.names(conP) )
    bins.join <- data.frame( binsDU(du), conP[ii,])
    bins.join$feature <- NULL
    bins.join$event.1 <- NULL
    file <- file.path( output.dir, "bins_du_psi_pir.tab" )
    write.table( bins.join, file, sep="\t", quote=FALSE, col.names=NA )
    
    # Export Summary
    group <- colnames(countsg(counts))[ 8 : ncol( countsg(counts) ) ]
    summary <- bins.join[ , c(1:11) ]
    summary <- cbind( summary, bins.join[ , colnames( bins.join ) == levels( group ) ] )
    file <- file.path( output.dir, "summary.tab")
    write.table( summary, file, sep="\t", quote=FALSE, col.names = NA)  
    
  })
# End of write methods
# ---------------------------------------------------------------------------- # 
#
# ---------------------------------------------------------------------------- #
# Getters and Setters for ASpliJDU
setGeneric( name = "localej", def = function( x ) standardGeneric("localej"))
setMethod( f = "localej", signature = "ASpliJDU", 
           definition = function( x ){ x@localej })

setGeneric( name = "localej<-", def = function( x, value ) standardGeneric("localej<-"))
setReplaceMethod( f = "localej", signature = c("ASpliJDU","data.frame"), 
                  definition = function( x,value ){ x@localej <- value; return( x )})

setGeneric( name = "localec", def = function( x ) standardGeneric("localec"))
setMethod( f = "localec", signature = "ASpliJDU", 
           definition = function( x ){ x@localec })

setGeneric( name = "localec<-", def = function( x, value ) standardGeneric("localec<-"))
setReplaceMethod( f = "localec", signature = c("ASpliJDU","data.frame"), 
                  definition = function( x,value ){ x@localec <- value; return( x )})

setGeneric( name = "anchorj", def = function( x ) standardGeneric("anchorj"))
setMethod( f = "anchorj", signature = "ASpliJDU", 
           definition = function( x ){ x@anchorj })

setGeneric( name = "anchorj<-", def = function( x, value ) standardGeneric("anchorj<-"))
setReplaceMethod( f = "anchorj", signature = c("ASpliJDU","data.frame"), 
                  definition = function( x,value ){ x@anchorj <- value; return( x )})

setGeneric( name = "anchorc", def = function( x ) standardGeneric("anchorc"))
setMethod( f = "anchorc", signature = "ASpliJDU", 
           definition = function( x ){ x@anchorc })

setGeneric( name = "anchorc<-", def = function( x, value ) standardGeneric("anchorc<-"))
setReplaceMethod( f = "anchorc", signature = c("ASpliJDU","data.frame"), 
                  definition = function( x,value ){ x@anchorc <- value; return( x )})

setGeneric( name = "jir", def = function( x ) standardGeneric("jir"))
setMethod( f = "jir", signature = "ASpliJDU", 
           definition = function( x ){ x@jir })

setGeneric( name = "jir<-", def = function( x, value ) standardGeneric("jir<-"))
setReplaceMethod( f = "jir", signature = c("ASpliJDU","data.frame"), 
                  definition = function( x,value ){ x@jir <- value; return( x )})

setGeneric( name = "jes", def = function( x ) standardGeneric("jes"))
setMethod( f = "jes", signature = "ASpliJDU", 
           definition = function( x ){ x@jes })

setGeneric( name = "jes<-", def = function( x, value ) standardGeneric("jes<-"))
setReplaceMethod( f = "jes", signature = c("ASpliJDU","data.frame"), 
                  definition = function( x,value ){ x@jes <- value; return( x )})

setGeneric( name = "jalt", def = function( x ) standardGeneric("jalt"))
setMethod( f = "jalt", signature = "ASpliJDU", 
           definition = function( x ){ x@jalt })

setGeneric( name = "jalt<-", def = function( x, value ) standardGeneric("jalt<-"))
setReplaceMethod( f = "jalt", signature = c("ASpliJDU","data.frame"), 
                  definition = function( x,value ){ x@jalt <- value; return( x )})

# ---------------------------------------------------------------------------- #

#
# ---------------------------------------------------------------------------- #
# Getters and Setters for ASpliSplicingReport
setGeneric( name = "binbased", def = function( x ) standardGeneric("binbased"))
setMethod( f = "binbased", signature = "ASpliSplicingReport", 
           definition = function( x ){ x@binbased })

setGeneric( name = "binbased<-", def = function( x, value ) standardGeneric("binbased<-"))
setReplaceMethod( f = "binbased", signature = c("ASpliSplicingReport","data.frame"), 
                  definition = function( x,value ){ x@binbased <- value; return( x )})

setGeneric( name = "localebased", def = function( x ) standardGeneric("localebased"))
setMethod( f = "localebased", signature = "ASpliSplicingReport", 
           definition = function( x ){ x@localebased })

setGeneric( name = "localebased<-", def = function( x, value ) standardGeneric("localebased<-"))
setReplaceMethod( f = "localebased", signature = c("ASpliSplicingReport","data.frame"), 
                  definition = function( x,value ){ x@localebased <- value; return( x )})

setGeneric( name = "anchorbased", def = function( x ) standardGeneric("anchorbased"))
setMethod( f = "anchorbased", signature = "ASpliSplicingReport", 
           definition = function( x ){ x@anchorbased })

setGeneric( name = "anchorbased<-", def = function( x, value ) standardGeneric("anchorbased<-"))
setReplaceMethod( f = "anchorbased", signature = c("ASpliSplicingReport","data.frame"), 
                  definition = function( x,value ){ x@anchorbased <- value; return( x )})

# ---------------------------------------------------------------------------- #

.junctionDUreportExt <- function(
    asd, 
    minAvgCounts                       = 5, 
    contrast                           = NULL,
    filterWithContrasted               = TRUE,
    runUniformityTest                  = FALSE,
    mergedBams                         = NULL,
    maxPValForUniformityCheck          = 0.2,
    strongFilter                       = TRUE,
    maxConditionsForDispersionEstimate = 24,
    formula                            = NULL,
    coef                               = NULL,
    maxFDRForParticipation             = 0.05,
    useSubset                          = FALSE

  ){
  
  if(is.null(contrast) & is.null(formula)){
    stop("Must provide either contrast or formula.")
  }
  
  targets <- asd@targets
  
  # Generate conditions combining experimental factors
  if(!"condition" %in% colnames(targets)){
    targets             <- .condenseTargetsConditions(targets)
  }

  #If no contrast provided takes last two and warns 
  #AR
  #if(is.null(contrast)){
  #  contrast <- c(rep(0, times=length(unique(targets$condition))-2), -1, 1)
  #  warning(paste0("Null contrast povided, using following constrast: ", paste(contrast, collapse=",")))
  #}
  
  # Create result object                   
  jdu <- new( Class="ASpliJDU" )
  
  #Contrast comes before formula
  if(!is.null(contrast)){
    jdu@contrast       <- contrast
    formula            <- NULL
  }else{
    design             <- model.matrix( formula, data = targets )
    contrast           <- ginv(design)
    if(is.null(coef)){
      coef <- nrow(contrast)
    }
    contrast               <- contrast[coef, ] #the first one is the intercept
    contrast[abs(contrast) < 1e-5] <- 0  
    contrastAggregated <- aggregate(contrast~targets$condition,FUN=sum)
    contrast <- setNames(contrastAggregated[,2],contrastAggregated[,1])[getConditions(targets)]
    jdu@contrast        <- contrast    
    
  }  
  jdu@contrast <- setNames(contrast, getConditions(targets))
  
  ##############
  #junctionsPJU#
  ##############
  message("Running junctionsPJU test")
  data                  <- junctionsPJU(asd)

  #Only keep data related to current conditions. AR. AdHoc a borrar.
  if(useSubset){
    icols <-  c(1:8, 
                  which(colnames(data) %in% c(rownames(targets), targets$condition, 
                                              "StartHit", "EndHit", 
                                              paste(targets$condition, rep(c("start", "end"), each=nrow(targets)), sep="."))
                  ))
    columns <- colnames(data)[icols]
    data <- data[, icols]
    names(data) <- columns
  }
      
  start_J1              <- grep("StartHit", colnames(data)) + 1
  start_J2              <- grep("EndHit", colnames(data)) + 1
  start_J3              <- 9
  end_J3                <- start_J3 + nrow(targets) - 1
  
  junctions_of_interest <- .filterJunctionBySampleWithContrast(data[,start_J3:end_J3], targets=targets, threshold = minAvgCounts, filterWithContrasted, contrast )
  
  if(nrow(junctions_of_interest) == 0) stop("No junctions to analyze! Is minReadLength less than bam read length? Maybe set strongFilter to FALSE? ")
  
  J1                    <- as.character(data$StartHit[rownames(data) %in% rownames(junctions_of_interest)])
  J2                    <- as.character(data$EndHit[rownames(data) %in% rownames(junctions_of_interest)])
  J3                    <- rownames(junctions_of_interest)
  
  if(length(J1) == 0 | length(J2) == 0 | length(J3) == 0) stop("No junctions to analyze! Is minReadLength less than bam read length? Maybe set strongFilter to FALSE?")
  clusters              <- .makeClusters(J1, J2, J3, strongFilter)
  
  if(clusters$no == 0) stop("No junctions to analyze! Is minReadLength less than bam read length? Maybe set strongFilter to FALSE?")
  
  countData             <- .makeCountDataWithClusters(data[names(clusters$membership),start_J3:end_J3], clusters)
  
  #We reduce data so dispersion estimates can be computed in a reasonable ammount of time
  reduxData             <- .makeReduxData(countData, targets, contrast, maxConditionsForDispersionEstimate)  
  ltsp                  <- .binsDUWithDiffSplice(reduxData$countData, reduxData$targets, reduxData$contrast, formula = formula, coef = coef)
  
  tsp                   <- ltsp[["junction"]]  #use junction statistics (notice bogus bin.fdr columnames) 
  
  jPSI                  <- tsp
  mean.counts           <- rowMeans(countData[rownames(jPSI), rownames(targets)[targets$condition %in% getConditions(targets)[contrast != 0]]])
  jPSI$log.mean         <- log2(mean.counts)

  #for every junction, the maximal participation value observed across contrasted condiction
  #is considered.
  mean.counts.per.condition     <- sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(countData[rownames(jPSI), rownames(targets)[targets$condition %in% i], drop = FALSE]))})
  participation                 <- aggregate(mean.counts.per.condition ~ jPSI$locus, FUN = function(r){return(rowSums(t(r)))})
  rownames(participation)       <- participation$locus
  participation                 <- participation[jPSI$locus, -1]
  participation                 <- mean.counts.per.condition/participation
  maxparticipation              <- apply(participation, 1, max)
  minparticipation              <- apply(participation, 1, min)
  deltapariticipation           <- maxparticipation - minparticipation 
  participation                 <- maxparticipation

  jPSI                          <- jPSI[, c("locus", "log.mean", "logFC", "pvalue", "bin.fdr")]
  jPSI$annotated                <- ifelse(data[rownames(jPSI), "junction"] != "noHit", "Yes", "No")
  jPSI$participation            <- participation
  jPSI$dParticipation           <- deltapariticipation

  #arrange columnames
  colnames(jPSI)[match(c("locus","bin.fdr"),colnames(jPSI))] <- c("cluster","FDR")
  
  jPSI                  <- cbind(jPSI, counts = mean.counts.per.condition)
  localej(jdu)          <- jPSI

  #build localec
  ltsp       <- ltsp[["cluster"]]
  junturas   <- strsplit2(rownames(jPSI), "[.]")
  rango      <- merge(aggregate(as.numeric(junturas[, 2]) ~ jPSI$cluster, FUN=min), 
                      aggregate(as.numeric(junturas[, 3]) ~ jPSI$cluster, FUN=max))
  rango      <- apply(rango[jPSI$cluster, 2:3], 1, paste, collapse=".")
  rango      <- apply(cbind(junturas[, 1], rango), 1, paste, collapse=".")
  #rango      <- junturas[, 1], , collapse=".")
  ltsp$range <- rango[rownames(ltsp)]
  
  # the participation and dparticipation cluster values come from the 
  # significant junction (jPSI$FDR<maxFDRForParticipation) presenting maximal participation value inside the cluster
  junturasDeInteres       <- jPSI[jPSI$FDR < maxFDRForParticipation, ]
  if(nrow(junturasDeInteres) > 0){
    participacion           <- aggregate(participation ~ cluster, junturasDeInteres, FUN = max)
    delta                   <- aggregate(participation ~ cluster, junturasDeInteres, FUN = which.max)
    dParticipation          <- c()
    for(i in 1:nrow(delta)){
      dParticipation <- c(dParticipation, junturasDeInteres[junturasDeInteres$cluster == delta$cluster[i], ][delta$participation[i], "dParticipation"])
    }
    names(dParticipation)   <- rownames(participacion) <- participacion[, 1]
    ltsp$participation      <- participacion[rownames(ltsp), 2] #llena con NA las participaciones que no estan
    ltsp$dParticipation     <- dParticipation[rownames(ltsp)] #llena con NA las participaciones que no estan
  }else{
    ltsp$participation      <- NA #llena con NA las participaciones que no estan
    ltsp$dParticipation     <- NA #llena con NA las participaciones que no estan
  }
  ltsp$size               <- as.numeric(table(jPSI$cluster)[rownames(ltsp)])
  ltsp                    <- ltsp[, c("size", "cluster.LR", "cluster.pvalue", "cluster.fdr", "range", "participation", "dParticipation")]
  colnames(ltsp)          <- c("size", "cluster.LR", "pvalue", "FDR", "range", "participation", "dParticipation")
  localec(jdu)            <- ltsp
  
  ##############
  #junctionsPIR# 
  ##############
  message("Running junctionsPIR test")
  data                  <- junctionsPIR(asd)
  
  
  #Only keep data related to current conditions. AR. AdHoc a borrar.
  if(useSubset){
    icols <-  which(colnames(data) %in% c(rownames(targets), targets$condition, "hitIntron", "hitIntronEvent"))
    columns <- colnames(data)[icols]
    data <- data[, icols]
    names(data) <- columns
  }
    
  start_J1              <- 3
  start_J2              <- 3+nrow(targets)
  start_J3              <- 3+2*nrow(targets)
  
  Js                    <- .makeJunctions(data, targets, start_J1, start_J2, start_J3, minAvgCounts, filterWithContrasted, contrast, strongFilter)
  
  if(nrow(Js$J3) == 0) stop("No junctions to analyze! Is minReadLength less than bam read length? Maybe set strongFilter to FALSE?")
  countData             <- .makeCountData(Js$J3, Js$J1, Js$J2)
  
  #We reduce data so dispersion estimates can be computed in a razonable ammount of time
  reduxData             <- .makeReduxData(countData, targets, contrast, maxConditionsForDispersionEstimate)
  ltsp                  <- .binsDUWithDiffSplice(reduxData$countData, reduxData$targets, reduxData$contrast, formula = formula, coef = coef)#, test = "gene")

  #keep only J3 rows
  tsp                   <- ltsp[["junction"]]
  J1                    <- tsp[grep("[.][1]$", rownames(tsp)), ]
  rownames(J1)          <- J1$locus
  J2                    <- tsp[grep("[.][2]$", rownames(tsp)), ]
  rownames(J2)          <- J2$locus
  tsp                   <- tsp[-(grep("[.][1-2]$", rownames(tsp))), ] #Saco las junturas que no son J3
  
  tsp$P.Value           <- ltsp$cluster[as.character(tsp$locus), "cluster.pvalue"]
  #tsp$FDR               <- p.adjust(ltsp$cluster[as.character(tsp$locus), "cluster.fdr"], "fdr") #bug? fdr(fdr)
  tsp$FDR               <- ltsp$cluster[as.character(tsp$locus), "cluster.fdr"]
  
  tsp$LR                <- ltsp$cluster[as.character(tsp$locus), "cluster.LR"]    
  tsp$J1.pvalue         <- J1[rownames(tsp), "pvalue"]
  tsp$J2.pvalue         <- J2[rownames(tsp), "pvalue"]
  jPIR                  <- tsp

  #  
  mean.counts           <- rowMeans(countData[rownames(jPIR), rownames(targets)[targets$condition %in% getConditions(targets)[contrast != 0]], drop = FALSE])
  jPIR$log.mean         <- log2(mean.counts)
  

  #Run  non-Uniformity only for IR junction sets with fdr less than maxFDRForUniformityCheck threshold
  if(runUniformityTest){
    data_unif             <- data[rownames(jPIR), getConditions(targets)[contrast != 0]]
    data_unif$FDR         <- jPIR$FDR
    message("Testing uniformity in junctionsPIR")
    jPIR$NonUniformity       <- .testUniformity(data_unif, mergedBams, maxPValForUniformityCheck, targets, contrast)
  }else{
    jPIR$NonUniformity       <- rep(NA, nrow(jPIR)) 
  }

  #Add J1, J2 and J3 count data
  jPIR      <- cbind(jPIR, countsJ1 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J1[paste0(rownames(jPIR), ".1"), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  jPIR      <- cbind(jPIR, countsJ2 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J2[paste0(rownames(jPIR), ".2"), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  jPIR      <- cbind(jPIR, countsJ3 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J3[rownames(jPIR), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  
  #dPIR estimation
  icols                 <- which(colnames(data) %in% getConditions(targets))
  #if(is.null(formula)){
  icols                 <- icols[(length(icols) - length(getConditions(targets)) + 1):length(icols)]
  #}else{
  #  icols                 <- icols[(length(icols) - nrow(targets) + 1):length(icols)]
  #}
  
  dpir      <- data[rownames(jPIR), icols]
  jPIR$dPIR <- apply(dpir,1,function(x){
    
    aux <- x[which(contrast != 0)]
    if(any(is.nan(aux))) {
      aux <- NA
    }else{
      aux <- sum(x*contrast,na.rm = TRUE)  
    }
    
    return(aux)
  }) 
  
  #participation      <- jPIR[, grep("countsJ3", colnames(jPIR))]/(jPIR[, grep("countsJ1", colnames(jPIR))] + jPIR[, grep("countsJ2", colnames(jPIR))] + jPIR[, grep("countsJ3", colnames(jPIR))])
  #jPIR$participation <- apply(participation, 1, max)
  #jPIR$dParticipation <- jPIR$participation-apply(participation, 1, min)

  jPIR$annotated        <- ifelse(!is.na(data[rownames(jPIR), "hitIntron"]), "Yes", "No")
  jPIR                  <- jPIR[, c("log.mean", "logFC", "LR", "P.Value", "FDR", "J1.pvalue", "J2.pvalue", "NonUniformity", "dPIR", "annotated", colnames(jPIR)[grep("counts", colnames(jPIR))])]
                       #
  colnames(jPIR)[match("P.Value",colnames(jPIR))] <- "pvalue"          
  anchorj(jdu)          <- jPIR
  
  aux                  <- ltsp[["cluster"]][,!colnames(ltsp[["cluster"]])%in%"size"]
  colnames(aux)        <- c("cluster.LR", "pvalue", "FDR")
  anchorc(jdu)         <- aux

  
  #######
  #irPIR for annotated junctions
  #######
  message("Running irPIR test")
  data                  <- irPIR(asd)

  #Only keep data related to current conditions. AR. AdHoc a borrar.
  if(useSubset){
    icols <-  which(colnames(data) %in% c(rownames(targets), targets$condition, "event", "J1", "J2", "J3"))
    columns <- colnames(data)[icols]
    data <- data[, icols]
    names(data) <- columns
  }
  
  start_J1              <- grep("J1", colnames(data)) + 1
  start_J2              <- grep("J2", colnames(data)) + 1
  start_J3              <- grep("J3", colnames(data)) + 1
  
  data                  <- data[!is.na(data$J3), ]
  Js                    <- .makeJunctions(data, targets, start_J1, start_J2, start_J3, minAvgCounts, filterWithContrasted, contrast, strongFilter)
  if(nrow(Js$J3) == 0) stop("No junctions to analyze! Is minReadLength less than bam read length? Maybe set strongFilter to FALSE?")
  
  countData             <- .makeCountData(Js$J3, Js$J1,  Js$J2)
  
  #We reduce data so dispersion estimates can be computed in a razonable ammount of time
  reduxData             <- .makeReduxData(countData, targets, contrast, maxConditionsForDispersionEstimate)
  ltsp                  <- .binsDUWithDiffSplice(reduxData$countData, reduxData$targets, reduxData$contrast, formula = formula, coef = coef)
  tsp                   <- ltsp[["junction"]]
  #keep only J3 data
  tsp                   <- tsp[-(grep("[.][1-2]$", rownames(tsp))), ]
  
  tsp$pvalue            <- ltsp$cluster[as.character(tsp$locus), "cluster.pvalue"]
  #tsp$bin.fdr          <- p.adjust(ltsp$cluster[as.character(tsp$locus), "cluster.fdr"], "fdr")
  tsp$bin.fdr           <- ltsp$cluster[as.character(tsp$locus), "cluster.fdr"]
  tsp$bin.LR            <- ltsp$cluster[as.character(tsp$locus), "cluster.LR"]
  
  jirPIR                <- tsp[, c("logFC", "pvalue", "bin.fdr", "bin.LR")]
  jirPIR$log.mean       <- log2(rowMeans(countData[rownames(jirPIR), rownames(targets)[targets$condition %in% getConditions(targets)[contrast != 0]], drop = FALSE]))

  if(runUniformityTest){
    data_unif             <- data[rownames(jirPIR), getConditions(targets)[contrast != 0]]
    rownames(data_unif)   <- data[rownames(jirPIR), "J3"]
    data_unif$FDR         <- jirPIR$bin.fdr#pmin(jirPIR$bin.fdr,tsp$bin.fdr)  #corro unif test si bin o juntura son suficientemente significativos
    message("Testing uniformity in irPIR")
    jirPIR$NonUniformity     <- .testUniformity(data_unif, mergedBams, maxPValForUniformityCheck, targets, contrast)
  }else{
    jirPIR$NonUniformity     <- rep(NA, nrow(jirPIR))
  }

  
  jirPIR$J3             <- data[rownames(jirPIR), "J3"]
  jirPIR                <- jirPIR[, c("J3", "logFC", "log.mean", "pvalue", "bin.fdr", "bin.LR", "NonUniformity")]
  
  icols                 <- which(colnames(irPIR(asd)) %in% getConditions(targets))
  #if(is.null(formula)){
  icols                 <- icols[(length(icols) - length(getConditions(targets)) + 1):length(icols)]
  #}else{
  #  icols                 <- icols[(length(icols) - nrow(targets) + 1):length(icols)]
  #}
  
  dpir                  <- irPIR(asd)[rownames(jirPIR), icols]
  jirPIR$dPIR           <- apply(dpir,1,function(x){
    
    aux <- x[which(contrast != 0)]
    if(any(is.nan(aux))) {
      aux <- NA
    }else{
      aux <- sum(x*contrast,na.rm = TRUE)  
    }
    
    return(aux)
  }) 
  colnames(jirPIR)      <- c("J3", "logFC", "log.mean", "pvalue", "FDR", "LR", "NonUniformity","dPIR")
  jirPIR$multiplicity   <- "No"
  jirPIR$multiplicity[grep(";", jirPIR$J3)] <- "Yes"
  
  #Sacamos "cluster" de anchorj 
  jirPIR        <- cbind(jirPIR, countsJ1 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J1[paste0(rownames(jirPIR), ".1"), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  jirPIR        <- cbind(jirPIR, countsJ2 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J2[paste0(rownames(jirPIR), ".2"), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  jirPIR        <- cbind(jirPIR, countsJ3 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J3[rownames(jirPIR), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  
  #jirPIR$dPIR   <- apply(jirPIR,1,function(x){sum(x*contrast)}) 
  #participation        <- jirPIR$countsJ3/(jirPIR$countsJ1 + jirPIR$countsJ2 + jirPIR$countsJ3)
  #jirPIR$participation <- apply(participation, 1, max)
  
  jir(jdu)              <- jirPIR
  
  ########
  #ES PSI#
  ########
  message("Running esPSI test")
  data                  <- esPSI(asd)
  
  #Only keep data related to current conditions. AR. AdHoc a borrar.
  if(useSubset){
    icols <-  which(colnames(data) %in% c(rownames(targets), targets$condition, "event", "J1", "J2", "J3"))
    columns <- colnames(data)[icols]
    data <- data[, icols]
    names(data) <- columns
  }
  
  start_J1              <- grep("J1", colnames(data)) + 1
  start_J2              <- grep("J2", colnames(data)) + 1
  start_J3              <- grep("J3", colnames(data)) + 1
  
  data                  <- data[!is.na(data$J3), ]
  
  Js                    <- .makeJunctions(data, targets, start_J1, start_J2, start_J3, minAvgCounts, filterWithContrasted, contrast, strongFilter)
  if(nrow(Js$J3) == 0) stop("No junctions to analyze! Is minReadLength less than bam read length? Maybe set strongFilter to FALSE?")
  
  countData             <- .makeCountData(Js$J3, Js$J1, Js$J2)

  #We reduce data so dispersion estimates can be computed in a razonable ammount of time
  reduxData             <- .makeReduxData(countData, targets, contrast, maxConditionsForDispersionEstimate)
  ltsp                  <- .binsDUWithDiffSplice(reduxData$countData, reduxData$targets, reduxData$contrast, formula = formula, coef = coef)#, test = "gene")
  tsp                   <- ltsp[["junction"]]
  tsp                   <- tsp[-(grep("[.][1-2]$", rownames(tsp))), ]
  
  tsp$pvalue            <- ltsp$cluster[as.character(tsp$locus), "cluster.pvalue"]
  #tsp$bin.fdr           <- p.adjust(ltsp$cluster[as.character(tsp$locus), "cluster.fdr"], "fdr")
  tsp$bin.fdr           <- ltsp$cluster[as.character(tsp$locus), "cluster.fdr"]
  tsp$bin.LR            <- ltsp$cluster[as.character(tsp$locus), "cluster.LR"]  

  jesPSI                <- tsp[, c("logFC", "pvalue", "bin.fdr", "bin.LR")]
  jesPSI$log.mean       <- log2(rowMeans(countData[rownames(jesPSI), rownames(targets)[targets$condition %in% getConditions(targets)[contrast != 0]], drop = FALSE]))
  jesPSI$event          <- data[rownames(jesPSI), "event"]
  jesPSI$J3             <- data[rownames(jesPSI), "J3"]
  jesPSI                <- jesPSI[, c("event", "J3", "logFC", "log.mean", "pvalue", "bin.fdr", "bin.LR")]
  
  icols                 <- which(colnames(esPSI(asd)) %in% getConditions(targets))
  #if(is.null(formula)){
  icols                 <- icols[(length(icols) - length(getConditions(targets)) + 1):length(icols)]
  #}else{
  #  icols                 <- icols[(length(icols) - nrow(targets) + 1):length(icols)]
  #}
  dpsi                  <- esPSI(asd)[rownames(jesPSI), icols]

  #clipedContrast <- contrast
  #clipedContrast[clipedContrast > 0] <- 1
  #clipedContrast[clipedContrast < 0] <- -1
  
  jesPSI$dPSI           <- apply(dpsi,1,function(x){
    
    aux <- x[which(contrast != 0)]
    
    if(any(is.nan(aux))) {
      aux <- NA
    }else{
      aux <- sum(x*contrast,na.rm = TRUE)  
    }
    
    return(aux)
  }) 
  colnames(jesPSI)      <- c("event", "J3", "logFC", "log.mean", "pvalue", "FDR", "LR", "dPSI")
  jesPSI$multiplicity   <- "No"
  jesPSI$multiplicity[grep(";", jesPSI$J3)] <- "Yes"
  
  jesPSI      <- cbind(jesPSI, countsJ1 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J1[paste0(rownames(jesPSI), ".1"), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  jesPSI      <- cbind(jesPSI, countsJ2 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J2[paste0(rownames(jesPSI), ".2"), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  jesPSI      <- cbind(jesPSI, countsJ3 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J3[rownames(jesPSI), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  
  jes(jdu)              <- jesPSI
  
    
  #########
  #ALT PSI#
  #########
  message("Running altPSI test")
  data                  <- altPSI(asd)
  
  #Only keep data related to current conditions. AR. AdHoc a borrar.
  if(useSubset){
    icols <-  which(colnames(data) %in% c(rownames(targets), targets$condition, "event", "J1", "J2", "J3"))
    columns <- colnames(data)[icols]
    data <- data[, icols]
    names(data) <- columns
  }

  start_J1              <- grep("J1", colnames(data)) + 1
  start_J2              <- grep("J2", colnames(data)) + 1
  start_J3              <- grep("J3", colnames(data)) + 1
  
  data                  <- data[!is.na(data$J3), ]
  
  Js                    <- .makeJunctions(data, targets, start_J1, start_J2, start_J3, minAvgCounts, filterWithContrasted, contrast, strongFilter, alt = T)
  if(nrow(Js$J3) == 0) stop("No junctions to analyze! Is minReadLength less than bam read length? Maybe set strongFilter to FALSE?")
  
  countData             <- .makeCountData(Js$J3, Js$J1 + Js$J2)
  
  ltsp                  <- .binsDUWithDiffSplice(countData, targets, contrast, formula = formula, coef = coef)#, test = "gene")
  tsp                   <- ltsp[["junction"]]
  tsp                   <- tsp[-(grep("[.][1-2]$", rownames(tsp))), ]
  
  tsp$pvalue            <- ltsp$cluster[as.character(tsp$locus), "cluster.pvalue"]
  #tsp$bin.fdr           <- p.adjust(ltsp$cluster[as.character(tsp$locus), "cluster.fdr"], "fdr")
  tsp$bin.fdr           <- ltsp$cluster[as.character(tsp$locus), "cluster.fdr"]
  tsp$bin.LR            <- ltsp$cluster[as.character(tsp$locus), "cluster.LR"]  
  
  jaltPSI               <- tsp[, c("logFC", "pvalue", "bin.fdr", "bin.LR")]
  jaltPSI$log.mean      <- log2(rowMeans(countData[rownames(jaltPSI), rownames(targets)[targets$condition %in% getConditions(targets)[contrast != 0]], drop = FALSE]))  
  jaltPSI$event         <- data[rownames(jaltPSI), "event"]
  jaltPSI$J3            <- data[rownames(jaltPSI), "J3"]
  jaltPSI               <- jaltPSI[, c("event", "J3", "logFC", "log.mean", "pvalue", "bin.fdr", "bin.LR")]
  
  icols                 <- which(colnames(altPSI(asd)) %in% getConditions(targets))
  #if(is.null(formula)){
  icols                 <- icols[(length(icols) - length(getConditions(targets)) + 1):length(icols)]
  #}else{
  #  icols                 <- icols[(length(icols) - nrow(targets) + 1):length(icols)]
  #}
  
  dpsi                  <- altPSI(asd)[rownames(jaltPSI), icols]
  jaltPSI$dPSI          <- apply(dpsi,1,function(x){
    
    aux <- x[which(contrast != 0)]
    if(any(is.nan(aux))) {
      aux <- NA
    }else{
      aux <- sum(x*contrast,na.rm = TRUE)  
    }
    
    return(aux)
  }) 
  colnames(jaltPSI)     <- c("event", "J3", "logFC", "log.mean", "pvalue", "FDR", "LR", "dPSI")
  jaltPSI$multiplicity  <- "No"
  jaltPSI$multiplicity[grep(";", jaltPSI$J3)] <- "Yes"

  
  jaltPSI      <- cbind(jaltPSI, countsJ1 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J1[paste0(rownames(jaltPSI), ".1"), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  jaltPSI      <- cbind(jaltPSI, countsJ2 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J2[paste0(rownames(jaltPSI), ".2"), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))
  jaltPSI      <- cbind(jaltPSI, countsJ3 = sapply(getConditions(targets)[contrast != 0], function(i){return(rowMeans(Js$J3[rownames(jaltPSI), rownames(targets)[targets$condition %in% i], drop = FALSE]))}))

  jalt(jdu)             <- jaltPSI
  
  return(jdu)
}

.filterJunctionBySampleWithContrast <- function( 
  df0,
  targets,
  threshold,
  filterWithContrasted = TRUE,
  contrast = NULL 
) {
  
  # Simple function to compute the minimum of values of two vectors, by position
  # Example:
  # vecMin( c(1,2,3), c(2,0,0) ) -> c(1,0,0)
  vecMin <- function ( a, b ) {
    at <- a < b
    bt <- a >= b
    av <- rep( NA, length( a ) )
    bv <- rep( NA, length( b ) )
    av[ at ] <- a[ at ]
    av[ !at ] <- 0
    bv[ bt ] <- b[ bt ]
    bv[ !bt ] <- 0
    return( av + bv )
  }
  
  
  if(filterWithContrasted){
    if(is.null(contrast)) warning("Constrast should be provided if filterWithContrast=TRUE")
    uniqueConditions <- getConditions(targets)[contrast!=0]
    auxtargets       <- targets[targets$condition%in%uniqueConditions,]
    cropped          <- .extractCountColumns( df0, auxtargets ) 
  }else{
    uniqueConditions <- getConditions(targets)
    auxtargets       <- targets
  }
  cropped          <- .extractCountColumns( df0, auxtargets )
  
  
  # Creates an matrix with Inf ( the neutral element for Min function)
  filter <- matrix( Inf ,
                    ncol = length( uniqueConditions ) ,
                    nrow = nrow( cropped ) )
  
  # Iterates over conditions and over samples of each condition
  # uses filter matrix to compute partial min operations
  for ( i in 1:length( uniqueConditions ) ) {
    byCond <- cropped[ , auxtargets$condition == uniqueConditions[ i ] , drop = FALSE]
    for ( j in 1:ncol( byCond ) ) {
      filter[ , i ] <- vecMin( filter[ , i ] , byCond[ , j ]  )
    }
  }
  
  # Filter the initial dataframe
  filter <- rowSums( filter > threshold ) > 0
  return( df0[ filter,  ] )
  
}

.makeClusters <- function(
  J1, 
  J2, 
  J3, 
  bStrongFilter = FALSE
){
  junctions_of_interest <- !is.na(J3) & J3 != "-"
  J1       <- J1[junctions_of_interest]
  J2       <- J2[junctions_of_interest]
  J3       <- J3[junctions_of_interest]
  
  #JJ3      <- J3[junctions_of_interest]
  JJ3      <- strsplit(J3, ";")
  main_junctions <- unlist(lapply(JJ3, function(s){return(s[1])}))
  nJJ3     <- unlist(lapply(JJ3, length))-1
  JJ3      <- unlist(lapply(JJ3[nJJ3 > 0], function(s){return(s[-1])}))
  resMed   <- cbind(rep(main_junctions, times=nJJ3), JJ3)
  
  junctions_of_interest <- J1 != "-" & !is.na(J1)
  J1       <- J1[junctions_of_interest]
  J1       <- strsplit(J1, ";")
  nJ1      <- unlist(lapply(J1, length))
  J1       <- unlist(J1)
  resStart <- cbind(rep(main_junctions[junctions_of_interest], times=nJ1), J1)
  
  junctions_of_interest <- J2 != "-" & !is.na(J2)
  J2       <- J2[junctions_of_interest]
  J2       <- strsplit(J2, ";")
  nJ2      <- unlist(lapply(J2, length))
  J2       <- unlist(J2)
  resEnd   <- cbind(rep(main_junctions[junctions_of_interest], times=nJ2), J2)
  
  #saco nodos que no pasaron el filtro (y que estaban en el string list starthit o endhit)
  if(bStrongFilter){
    resStart <- resStart[which(resStart[,1] %in% J3 & resStart[,2] %in% J3),]
    resEnd   <- resEnd[which(resEnd[,1] %in% J3 & resEnd[,2] %in% J3),]
  }
  
  g     <- graph_from_edgelist(rbind(resEnd, resStart, resMed),directed = FALSE)
  gclus <- clusters(g)
  
  return(gclus)
  
}

.binsJDUWithDiffSplice <- function( 
  countData,
  targets,
  contrast,
  ignoreExternal = FALSE,
  ignoreIo = TRUE,
  ignoreI = FALSE,
  maxConditionsForDispersionEstimate = 4
) {
  
  # Filter bins
  countData = countData[ ! ignoreExternal | countData$event != "external" ,] 
  countData = countData[ ! ignoreIo | countData$feature != "Io" ,] 
  countData = countData[ ! ignoreI | countData$feature != "I" ,] 
  
  # Define group and contrast
  group <- targets$condition
  if( is.null( contrast ) ) contrast <- .getDefaultContrasts( group )
  
  # make DU analysis
  y <- DGEList( counts = .extractCountColumns( countData, targets ),
                group = factor( group, levels = getConditions(targets), ordered = TRUE) ,
                genes = .extractDataColumns(countData, targets) ) #Must use regular targets in order to effectively remove the target columns
  
  # TODO: Este filtro es muy resctrictivos
  #  keep <- rowSums( cpm( y ) > 1) >= 2
  #  y <- y[ keep, , keep.lib.sizes = FALSE ]
  y <- calcNormFactors( y )
  
  
  # model.matrix sort columns alphabetically if formula has characters instead 
  # of factors. Therefore to preserve order group is converted to ordered factors 
  groupFactor <- factor( group, unique( group ), ordered = TRUE )
  
  design <- model.matrix( ~0 + groupFactor, data = y$samples )
  
  y   <- estimateDisp( y, design , robust=TRUE)
  fit <- glmFit( y, design )
  ds  <- diffSpliceDGE( fit, contrast = contrast, geneid = "locus", 
                        exonid = NULL, verbose = FALSE )
  tsp <- topSpliceDGE( ds, test = "exon", FDR = 2, number = Inf )
  
  tspg <- topSpliceDGE( ds, test = "gene", FDR = 2, number = Inf )
  
  # make column names equal to the results of DUReport method
  #colnames( tsp )[ match( 'FDR', colnames( tsp )) ] <- 'bin.fdr'
  #colnames( tsp )[ match( 'P.Value', colnames( tsp )) ] <- 'pvalue'
  #tsp$exon.LR <- NULL
  
  tsp <- tsp[,c("locus","logFC","P.Value","FDR")]
  colnames(tsp)[1]<-"cluster"
  
  rownames(tspg) <- tspg$locus
  tspg <- tspg[,c("NExons","gene.LR","P.Value","FDR")]
  colnames(tspg)[1:2] <- c("size","cluster.LR")
  
  return( list(junction=tsp,cluster=tspg) )
  
} 

.makeCountDataWithClusters <- function(
  countData, 
  clusters
){
  countData                <- countData[names(clusters$membership), ]
  countData                <- cbind(length = "", countData)
  countData                <- cbind(end = "", countData)
  countData                <- cbind(start = "", countData)
  countData                <- cbind(gene_coordinates = "", countData)
  countData                <- cbind(symbol =  "", countData)
  countData                <- cbind(locus_overlap = "", countData)
  countData                <- cbind(locus = clusters$membership, countData)
  countData                <- cbind(event = "", countData)
  countData                <- cbind(feature = "", countData)
  countData                <- countData[order(rownames(countData)), ]
  return(countData)
}

.makeJunctions <- function(
  data,
  targets,
  start_J1,
  start_J2,
  start_J3,
  minAvgCounts,
  filterWithContrasted = TRUE,
  contrast = NULL,
  strongFilter = TRUE,
  alt = FALSE
){
  
  #Pasamos todos los NA a 0
  data[, start_J1:(start_J1 + nrow(targets) - 1)][is.na(data[, start_J1:(start_J1 + nrow(targets) - 1)])] <- 0
  data[, start_J2:(start_J2 + nrow(targets) - 1)][is.na(data[, start_J2:(start_J2 + nrow(targets) - 1)])] <- 0
  data[, start_J3:(start_J3 + nrow(targets) - 1)][is.na(data[, start_J3:(start_J3 + nrow(targets) - 1)])] <- 0
  
  J1 <- data[, start_J1:(start_J1 + nrow(targets) - 1)]
  J2 <- data[, start_J2:(start_J2 + nrow(targets) - 1)]
  J3 <- data[, start_J3:(start_J3 + nrow(targets) - 1)]  
  
  #reliables <- rep(FALSE, times=nrow(J3))
  #for(condition in unique(targets$condition)[contrast != 0]){
  #  reliables <- reliables | (rowMeans(J1[, grep(condition, colnames(J1))]) > minAvgCounts &
  #                              rowMeans(J2[, grep(condition, colnames(J2))]) > minAvgCounts &
  #                              rowMeans(J3[, grep(condition, colnames(J3))]) > minAvgCounts)
  #}
  reliables <- list()
  reliables[["J1"]] <- .filterJunctionBySampleWithContrast( J1, targets, minAvgCounts, filterWithContrasted = filterWithContrasted, contrast )
  if(nrow(reliables[["J1"]]) > 0) reliables[["J1"]] <- rownames(reliables[["J1"]])
  reliables[["J2"]] <- .filterJunctionBySampleWithContrast( J2, targets, minAvgCounts, filterWithContrasted = filterWithContrasted, contrast )
  if(nrow(reliables[["J2"]]) > 0) reliables[["J2"]] <- rownames(reliables[["J2"]])
  reliables[["J3"]] <-.filterJunctionBySampleWithContrast( J3, targets, minAvgCounts, filterWithContrasted = filterWithContrasted, contrast )
  if(nrow(reliables[["J3"]]) > 0) reliables[["J3"]] <- rownames(reliables[["J3"]])
  
  if(strongFilter){
    #No queremos filtrar todas las junturas de alt, solo que tenga o J1 o J2
    if(!alt){
      reliables <- Reduce(intersect, reliables)
    }else{
      reliables <- unique(c(intersect(reliables[["J1"]], reliables[["J3"]]), 
                     intersect(reliables[["J2"]], reliables[["J3"]])))
    }
  }else{
    reliables <- reliables[["J3"]]
  }
  
  #for(condition in unique(targets$condition)[contrast != 0]){
  #  reliables <- reliables | rowMeans(J3[, grep(condition, colnames(J3))]) > minAvgCounts
  #}  
  #reliables <- reliables & apply(data, 1, function(s){return(!any(is.na(s)))})
  rownames(J1) <- paste0(rownames(J3), ".1") 
  rownames(J2) <- paste0(rownames(J3), ".2") 
  J1 <- J1[paste0(reliables, ".1"), ]
  J2 <- J2[paste0(reliables, ".2"), ]
  J3 <- J3[reliables, ]
  return(list(J1 = J1, J2 = J2, J3 = J3))
}

.makeCountData <- function(
  J3,
  Jaux1,
  Jaux2 = NULL
){
  reps                 <- 2
  countData            <- rbind(J3, Jaux1)
  if(!is.null(Jaux2)){
    countData            <- rbind(countData, Jaux2)
    reps         <- 3
  }
  countData            <- cbind(length = "", countData)
  countData            <- cbind(end = "", countData)
  countData            <- cbind(start = "", countData)
  countData            <- cbind(gene_coordinates = "", countData)
  countData            <- cbind(symbol =  "", countData)
  countData            <- cbind(locus_overlap = "", countData)
  countData            <- cbind(locus = rep(rownames(J3), times=reps), countData)
  countData            <- cbind(event = "", countData)
  countData            <- cbind(feature = "", countData)
  countData            <- countData[order(rownames(countData)), ]
  return(countData)
}

.testUniformity <- function(
  data, 
  mergedBams,
  maxFDRForUniformityCheck,
  targets,
  contrast
){
  
  if(is.null(mergedBams)){
    warning("Can't run uniformity test without merged bams.")
    return(rep(NA, length=nrow(data))) 
  }
  if(class(mergedBams)=="data.frame"){
    mergedBams <- as.character(mergedBams[,1])
  }
  if(!is.character(mergedBams)){
    warning("Can't run uniformity test. Problems with merged bams specifications.")
    return(rep(NA, length=nrow(data))) 
  }
  
  if(!all(file.exists(c(mergedBams, paste0(mergedBams, ".bai"))))){
    warning("Can't run uniformity test. Couldn't find merged bams or their index.")
    return(rep(NA, length=nrow(data))) 
  }

  ii                   <- rownames(data)[data$FDR < maxFDRForUniformityCheck]
  Uniformity           <- rep(NA, length=nrow(data))
  names(Uniformity)    <- rownames(data)
  if(length(ii) == 0){
    message("No junctions with FDR < maxFDRForUniformityCheck to run uniformity test to")
    return(Uniformity)  
  }
  # +     pb <- txtProgressBar(style=3)
  # +     setTxtProgressBar(pb, i)
  # +     close(pb
  i = 0
  pb <- txtProgressBar(min=1,max=length(ii),style=3)
  Uniformity[ii] <- sapply(ii, function(p){
    #if(i %% 100 == 0) print(paste(i/length(elementos), "%"))
    i <- i + 1
    setTxtProgressBar(pb,i)
    # if(i %% 10 == 0){
    #   message(paste0("Uniformity test: ", round(i/length(ii)*100), "% completed"))
    # }
    
    #reader <- bamReader(mergedBams[2], idx=TRUE)
    #reader <- readers[[which.max(data[p, getConditions(targets)])]]
    
    pp      <- strsplit2(p, "[.]")[1, ]
    ad <- system(paste0("samtools depth -r ", paste0(pp[1], ":", (as.numeric(pp[2])-10), "-",  (as.numeric(pp[3])+10)), " ", mergedBams[which.max(data[p, getConditions(targets)[contrast != 0]])]), intern = T)
    if(length(ad) > 40){
      ad <- as.numeric(strsplit2(ad, "\t")[, 3])
      #if(refid[pp[1]] < 5){
      #for(i in 1:100){
      #reader  <- bamReader(mergedBams[which.max(data[p, getConditions(targets)])], idx=TRUE)
      #brange  <- bamRange(reader,c(refid[pp[1]],(as.numeric(pp[2])-10), (as.numeric(pp[3])+10)), complex = FALSE)
      #brange  <- bamRange(reader,c(0, 10, 10000))
      #ad      <- alignDepth(brange)
      #bamClose(reader)
      #}
      
      b      <- sd(ad[11:(length(ad)-12)])
      a      <- mean(c(ad[1:10], ad[(length(ad)-11):length(ad)]))
      return(b/a)
    }else{
      return(NA)
    }
    #bamClose(reader)
  })
  close(pb)
  
  #for(i in 1:length(readers)){
  #  bamClose(readers[[i]])
  #}
  
  return(Uniformity)
  
}

#Para que el test corra en un tiempo razonable en datasets muy grandes, evaluamos en un subconjunto
.makeReduxData <- function(countData, targets, contrast, maxConditionsForDispersionEstimate){
  group                 <- targets$condition 
  ugroup                <- unique(group)
  names(contrast)       <- ugroup
  contrast_groups       <- ugroup[contrast != 0]
  other_groups          <- ugroup[contrast == 0]
  other_groups          <- sample(other_groups, min(length(other_groups), abs(maxConditionsForDispersionEstimate-length(contrast_groups))))
  final_groups          <- c(contrast_groups, other_groups)
  final_groups          <- names(contrast)[names(contrast) %in% final_groups]
  redux_targets         <- targets[targets$condition %in% final_groups, ]
  contrast              <- contrast[final_groups]
  targets               <- targets[targets$condition %in% redux_targets$condition, ]
  
  countData             <- cbind(.extractDataColumns(countData, targets), .extractCountColumns( countData, redux_targets ))
  reduxData             <- list(countData = countData, targets = targets, contrast = contrast)
  return(reduxData)
}

# Filter junctions that has in at least one condition a given (threshold) number
# of junction for all samples.
.filterJunctionBySample <- function( df0, targets, threshold) {

  # Simple function to compute the minimum of values of two vectors, by position
  # Example:
  # vecMin( c(1,2,3), c(2,0,0) ) -> c(1,0,0)
  vecMin <- function ( a, b ) {
    #at <- a < b
    #bt <- a >= b
    #av <- rep( NA, length( a ) )
    #bv <- rep( NA, length( b ) )
    #av[ at ] <- a[ at ]
    #av[ !at ] <- 0
    #bv[ bt ] <- b[ bt ]
    #bv[ !bt ] <- 0
    #return( av + bv )
    return(pmin(a, b))
  }
  
  cropped <- .extractCountColumns( df0, targets ) 
  uniqueConditions <- unique( targets$condition )

  # Creates an matrix with Inf ( the neutral element for Min function)
  filter <- matrix( Inf ,
      ncol = length( uniqueConditions ) ,
      nrow = nrow( cropped ) )
  
  # Iterates over conditions and over samples of each condition
  # uses filter matrix to compute partial min operations
  for ( i in 1:length( uniqueConditions ) ) {
    byCond <- cropped[ , targets$condition == uniqueConditions[ i ] , drop = FALSE]
    for ( j in 1:ncol( byCond ) ) {
      filter[ , i ] <- vecMin( filter[ , i ] , byCond[ , j ]  )
    }
  }
  
  # Filter the initial dataframe
  filter <- rowSums( filter > threshold ) > 0
  return( df0[ filter,  ] )

}

# Recover junctions that corresponds exactly to introns.
.e1e2JPIR <- function( intronGRanges, jcounts, targets ) {
  
  # Creates a GRanges from junction names and modifies its to match the 
  # corresponding intron.
  jranges <- sort( .createGRangesExpJunctions( rownames( jcounts ) ) )
  start( jranges ) <- start( jranges ) + 1  
  end( jranges ) <- end( jranges ) - 1
  
  # Looks junctions that overlaps exactly with introns
  overlapped <- findOverlaps( jranges, intronGRanges, type="equal" ) 

  # reorder junction counts by query names  
  queryNames   <- names( jranges )[ queryHits( overlapped ) ]
  subjectNames <- names( intronGRanges )[ subjectHits( overlapped ) ]
  queryOrder   <- match( queryNames, rownames( jcounts ) )
  jc <- .extractCountColumns( jcounts, targets )[ queryOrder, ]
  
  result <- data.frame( J3 = queryNames, 
                        jbin = subjectNames,
                        jc,
                        stringsAsFactors = FALSE)
  return( result )
}

# Get junction PSI for junction overlapping different exon regions.
# The possible overlapping types are: start, end and within
.getJPSIByOverlap <- function ( jranges, exonGRanges, jcounts, targets, overlapType ) {
  
  jranges.edge <- jranges
  
  if ( overlapType == 'start' ) {
    start( jranges.edge ) <- end( jranges.edge )
  } else if ( overlapType == 'end' ){
    end( jranges.edge ) <- start( jranges.edge )
  }
  
  overlapped <- findOverlaps( exonGRanges, jranges.edge, type = overlapType )
  
  overlappedQueryNames <- names( exonGRanges[ queryHits( overlapped ) ] )
  overlappedSubjectNames <- names( jranges.edge[ subjectHits( overlapped ) ] )
  
  df1 <- data.frame( 
    names = overlappedQueryNames ,
    .extractCountColumns( jcounts[ subjectHits( overlapped ), ] ,targets ),
    row.names = NULL )
  
  result <- merge(
    x = data.frame( aggregate( . ~ names, data = df1, sum ) ),
    y = data.frame( aggregate( 
            overlappedSubjectNames ~ overlappedQueryNames, 
            FUN = paste, collapse=";")),
    by.x = 1,
    by.y = 1
  )
  rownames( result ) <- result$names
  result[ , 1 ] <-  NULL
  return( result )
  
}

.createGRangesExpJunctions <- function( jnames ) {
  split <- data.frame( matrix( unlist( strsplit( jnames,  "[.]" ) ),
          byrow = TRUE, ncol = 3 ),   
      row.names = jnames,
      stringsAsFactors = FALSE )  
  colnames(split)  <- c("chrom","start","end")
  split$start <- as.numeric(split$start)  
  split$end <- as.numeric(split$end)
  split$chrom <- as.character(split$chrom)
  jranges <- GRanges( seqnames = split$chrom, 
      ranges = IRanges(
          start= split$start, 
          end = split$end,
          names = jnames)    )
  # jranges <- sort(jranges)
  return( jranges )
}

.junctionsDiscover <- function( df,
                                minReadLength, 
                                targets, 
                                features, 
                                minAnchor,
                                bam) 
  
  {
  cores=1
  
  # This function get the counts of the junctions that overlaps the an 
  # intron/exon region of a bin. The junction must overlap completely and at 
  # least an minAnchor% into the exon region and the intron region.
  # The regions can be exon1-intron or intron-exon2. All junctions are assumed 
  # to correspond to a intron.
  getExonIntronCounts <- function( jranges, 
                                   targets, 
                                   bams, 
                                   minReadLength, 
                                   regionType, 
                                   minAnchor ) {
    
    cores = 1
    exonIntron <- jranges

    minAnchor <- round( minAnchor * minReadLength / 100 )
    
    start( exonIntron ) <- if ( regionType == 'e1i' ) start( jranges ) else end( jranges )
    start( exonIntron ) <- start( exonIntron ) - ( minReadLength - minAnchor ) - 1
    end( exonIntron )   <- if ( regionType == 'e1i' ) start( jranges ) else end( jranges )
    end( exonIntron )   <- end( exonIntron ) + ( minReadLength - minAnchor ) - 1
    
    
    hits <- lapply( bams, function( x ) { 
      x <- GRanges(x)    
    
countOverlaps( exonIntron, x, ignore.strand = TRUE, minoverlap = minReadLength )      
    } )    
    hits <- do.call( cbind.data.frame, hits )
    
    return( hits )
  }
  
  # Get the counts of junctions
  jcounts <- .extractCountColumns( df, targets )

  # Convert junctions names to GRanges (the GRanges object do noy have the same
  # order that the initial data ).
  jranges <- sort( .createGRangesExpJunctions( rownames( df ) ) )

  # Extract the junction that has no gaps
  ungappedBams <- lapply( bam, function( x ) { x[ njunc( x ) == 0 , ] } ) 
  # Get counts for junction overlapping the exon1-intron region and intron-exon2
  # region
  e1i <- getExonIntronCounts( jranges, 
                              targets, 
                              ungappedBams, 
                              minReadLength, 
                              'e1i',  
                              minAnchor)
  
  ie2 <- getExonIntronCounts( jranges, 
                              targets, 
                              ungappedBams, 
                              minReadLength , 
                              'ie2', 
                              minAnchor)  
  # Calculates the PIR value 
  j1 <- .sumByCond( e1i,     targets )
  j2 <- .sumByCond( ie2,     targets )
  j3 <- .sumByCond( jcounts, targets )
  pirValues <- ( j1 + j2 ) / ( j1 + j2 + 2 * j3 )
  
  
  # Search junctions that overlaps exacly with annotated introns
  intronBins <- featuresb( features )
  
  start( intronBins ) <- start( intronBins ) - 1
  end( intronBins ) <- end( intronBins ) + 1

  overlapped <- findOverlaps( jranges, intronBins, ignore.strand = TRUE, 
      type="equal" )
  
  queryNames <- names( jranges[ queryHits( overlapped ) ] )
  subjectNames <- names( intronBins[ subjectHits( overlapped ) ] )

  # sort the names of the junctions-matching bins and the event type of those 
  # bins by the order of the junction data in the GRanges object .
  orderIndex <- match( names( jranges ), queryNames )
  
  hitIntron <- subjectNames[ orderIndex ]
  
  hitIntronEvent <- mcols( intronBins )[ subjectHits( overlapped ) , 
      'event' ][ orderIndex ]

  # Creates string representing genomic coordinates of each junction
  genomicCoordinates <- paste( 
      seqnames( jranges ), 
      start( jranges ),
      end( jranges ),
      sep=".")
  
  # Creates result data.frame
  # construir con do.call( cbind )
  result <- do.call( cbind , 
      list( hitIntron = hitIntron, 
            hitIntronEvent = hitIntronEvent,
            e1i, 
            ie2,
            jcounts,
            pirValues ) )
  rownames( result ) <- genomicCoordinates

  return( result )

}

.junctionsPSI_SUM <- function( df, targets ) {
  
  # This function gets the complete set of all junctions and returns a data 
  # frame containing information of junctions that shares its start or end.
  # The result value is a data.frame that has :
  # 1. the names of the junctions shared by each junction (the 'Hit' column of 
  #    the data frame), 
  # 2. the sums ( by sample ) of the shared junctions 
  # 3. the junction ratio ( counts of given junction / sum of counts of shared junctions ).
  getBoundarySharedData <- function(
      allJunctionCounts,
      junctionsGRanges, 
      boundaryType = "start" ) {
    
    junctionNames <- rownames( allJunctionCounts )
    
    j.boundary <- findOverlaps( jranges, drop.self=TRUE, drop.redundant=FALSE, type=boundaryType)
    
    # Search for the names of the junctions that share the boundary
    queryNames   <- names( jranges[ queryHits( j.boundary ) ] )
    subjectNames <- names( jranges[ subjectHits( j.boundary ) ] )
    sharedNames  <- data.frame( 
        aggregate( subjectNames ~ queryNames, FUN = paste, collapse = ";" ) )
    
    # extract the counts of junctions 'indexed' by the name of the query junctions
    junctionCounts <- data.frame( 
        names = queryNames, 
        .extractCountColumns( allJunctionCounts[ subjectNames, ], targets ),
        row.names = NULL ) 
    

    
    # Sum the rows of the junctions that share the boundary
    sharedRowSum <- data.frame( aggregate( . ~ names, data = junctionCounts, sum ) )
    
    colnames( sharedRowSum )[-1] <- rownames(targets)
    rownames( sharedRowSum ) <- sharedRowSum$names
    sharedRowSum <- .extractCountColumns( sharedRowSum, targets  )
    
    
    # Creates an new empty data.frame to store the counts of summed counts 
    # ordered by the original junction data frame
    sharedRowSumOrdered <- data.frame( 
        row.names = junctionNames, 
        matrix( NA, 
            nrow = nrow( allJunctionCounts ), 
            ncol = ncol( sharedRowSum ) ) )
    colnames( sharedRowSumOrdered ) <- colnames( sharedRowSum )
    
    orderIndex <- match( row.names( sharedRowSum ), junctionNames ) 
    sharedRowSumOrdered[ orderIndex, ] <- sharedRowSum#OK
    sharedRowSumOrdered[ is.na( sharedRowSumOrdered ) ] <- 0
    
    # Reorder shared names
    orderIndex <- match( sharedNames$queryNames, junctionNames )
    sharedNamesOrdered <- as.character( rep("-", nrow( sharedRowSumOrdered ) ) )
    sharedNamesOrdered[ orderIndex ] <- sharedNames$subjectNames

    # Calculates jratio
    j1 <- .sumByCond( .extractCountColumns( allJunctionCounts, targets ), targets  )
    j2 <- .sumByCond( sharedRowSumOrdered , targets  )
    jratioResult <- j1 / ( j1 + j2 )
    colnames( jratioResult ) <- paste( colnames( jratioResult ), boundaryType, sep="." )
    
    #Fix for the columns starting with X (targets starting with a number)
    result <- data.frame( sharedNamesOrdered, sharedRowSumOrdered, jratioResult, check.names=FALSE  )
 
    # Sets the name of the 'Hit' column in the result dataframe 
    colnames( result ) [1] <- if ( boundaryType == 'start' ) 'StartHit' else 'EndHit'
    
    return( result )
    
  }
  
  # Get names of the junctions
  junctionNames <- rownames( df )
  
  # Create a Granges object from the names ( the names has the pattern:
  # 'chromosome.start.end' )
  jranges <- sort( .createGRangesExpJunctions( junctionNames ) )
  
  # Retrieve data from junctions that shares their starts
  sharedStartData <- getBoundarySharedData( df, jranges, "start" )

  # Retrieve data from junctions that shares their ends
  sharedEndData <- getBoundarySharedData( df, jranges, "end" )
  
  # Assign putative events 
#  pAS <- rep( "-", nrow( df ) )
#  pAS[ ( sharedStartData[ , 1 ] != "-" & df$strand == "-" ) | ( sharedEndData[ , 1 ] != "-" & df$strand == "+" ) ] <- "Alt5ss"
#  pAS[ ( sharedStartData[ , 1 ] != "-" & df$strand == "+" ) | ( sharedEndData[ , 1 ] != "-" & df$strand == "-" ) ] <- "Alt3ss"
#  pAS[ sharedStartData[ , 1 ] != "-" & sharedEndData[ , 1 ] != "-"] <- "ES" 
  
   #: construir con do.call( cbind, ... ) para evitar que aparezcan .1 y .2 
  # en los nombre de las muestras y puedan filtrarse
  result <- do.call( cbind, list (
          df,
          sharedStartData,
          sharedEndData
      #  , pAS )
          ) )
  return( result )
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     

.filter.ASpliDU <- function( aspliDU, what = c( 'genes','bins','junctions'), fdr = 1, 
    logFC = 0, absLocFC = TRUE, logFCgreater = TRUE ) {
  
  whatValidValues <- c( 'genes','bins','junctions')
  
  if ( all( tolower( what ) %in% whatValidValues ) ) {

    for ( slotName in tolower(what) ) {
      
      currentSlot <- slot( aspliDU, slotName )
      
      fdrCol <- switch( match( slotName, whatValidValues ), 'gen.fdr', 'bin.fdr', 
          'fdr' )
      
      if ( nrow( currentSlot ) > 0 ) {

        logFCfun <- if ( logFCgreater ) function(a,b) a >= b else function(a,b) a <= b
        
        abFun <- if ( absLocFC ) abs else identity
        
        passFdrCutoff   <- currentSlot[ , fdrCol ] <= fdr
        passLogFcCutOff <- logFCfun( abFun( currentSlot[,'logFC'] ) ,  logFC )
        
        currentSlot <- currentSlot[ passFdrCutoff & passLogFcCutOff , ]
        
        slot( aspliDU, slotName ) <- currentSlot
                
      } else {
        warning( simpleWarning( paste(slotName, ' in ASpliDU object is empty.')  ) )
      }
      
    }
    
    return( aspliDU )
    
  } else {
    stop( simpleError( "Argument 'what' contains invalid values. Valid values are: c( 'genes','bins','junctions')" ) )        
  }
  
}

makeExample02Data <- function() {

  # Get example counts and as, just for object skeleton
  counts <- aspliCountsExample()
  as     <- aspliASexample()

  # Define synthetic targets
  targets <- data.frame(
      row.names = paste( rep( c('A','B'),each=6), rep( c('C','D'),2,each=3) , rep( 0:2, 4), sep = '_') , 
      bam = "s" ,
      f1 = rep( c('A','B'),each=6) ,
      f2 = rep( c('C','D'),2,each=3),
      stringsAsFactors = FALSE )
  
  # Define factors and values to plot
  fv <- list( 
          f1 = c( 'A', 'B' ), 
          f2 = c( 'C' ) )
  
  # Make the plots
  plotBins( counts, as, 'GENE02:E002', factorsAndValues = fv, targets,
      legendAtSide = TRUE, outfolder = 'grplots'
      , outfileType='pdf', deviceOpt=list( width = 3, height = 7 ) ,
      innerMargins    = c( 2.1, 5.1, 1.1, 1.1 ), las.x=1
  )
}

# TODO agregar verbosity

.getBamMatrix <- function( conditionMatrix, mergedFiles ) { 
  
  apply( conditionMatrix, c(1,2), 
      function( x ) {
        a <- unlist( mergedFiles[ mergedFiles$cond == x , 'bams' ] )
        if (any( is.na(a) ) ) { return(NA) }
        return(a)
      }
  )
} 

.mergeBamsByCondition <- function ( targets , regions , tempFolder = './tmp', 
    keepOld = FALSE, verbose) {
  
  targets <- cbind( targets[ rep(1:nrow(targets), length( regions )),], 
      data.frame( region = rep( c(1:length(regions)), each = nrow(targets)) ) )
  targets$filt <- file.path( tempFolder, paste0( 'sample.', 1:nrow(targets) ,'.bam') )
  
  destBams <- data.frame( cond = getConditions(targets) )
  destBams$bams <- file.path( tempFolder, 
      paste0( 'cond.', getConditions(targets),'.bam') )
  
  file.exists( tempFolder) || dir.create( tempFolder , recursive = TRUE)
  if ( ! keepOld ) {
    if (verbose) message("Extracting and merging reads from bam files")
    for ( i in 1:nrow( targets ) ) {
      
      indexBam( targets$bam[i] )
      
      filterBam(
          file = targets$bam[i],
          destination = targets$filt[i],
          param = ScanBamParam( which = regions[targets$region[i]] ),
          indexDestination = TRUE )
      if (verbose) message(paste("Extraction completed:", as.character(i), "/", as.character(nrow( targets )) ) )
    }
    
    lapply( getConditions(targets), function( cond ) {
          sourceBams <- as.character( targets$filt[ targets$condition == cond ] )
          
          fn <- mergeBam( 
              files = sourceBams , 
              destination = file.path( tempFolder, paste0( 'cond.', cond,'.bam') ) , 
              indexDestination = TRUE, overwrite = TRUE )
        } )
    if (verbose) message("Merging completed" )
    
  } else {
    if (verbose) message("Re-using previously extracted and merged reads")
  }
  return( destBams )
}


.definePlottingRegions <- function( x, xIsBin, verbose, features, genomeTxDb ) {
  
  binFeatures  <- featuresb( features )
  geneFeatures <- featuresg( features )
#  geneCounts <- countsg( counts )
  
  if ( xIsBin ) {
    if (verbose) message( "Extracting gene regions of selected bins" )
    selectedGenes <- unique( mcols(featuresb( features )[ names( featuresb( features ) ) %in% x ])[,'locus'] )
    #selectedGenes <- unique( countsb( counts )[ rownames(  countsb( counts ) ) %in% x ,'locus'] )
  } else {
    if (verbose) message( "Extracting gene regions of selected genes" )
    selectedGenes <- x
  }
  if ( length( selectedGenes ) > 0 ) {
   
#    geneCoordinates <- ranges( geneFeatures[ selectedGenes ] )
#    
#    geneCoordinates <- geneCounts [ selectedGenes, 'gene_coordinates', drop = FALSE ]
#    
#    geneCoordinates <- as.character( geneCoordinates[ 
#            !duplicated( geneCoordinates), 1 ] )
#    geneCoordinates <- strsplit( geneCoordinates, '[-:]')
#    geneCoordinates <- do.call( rbind , geneCoordinates )
#    geneCoordinates <- data.frame(geneCoordinates, stringsAsFactors = FALSE)
#    
#    geneCoordinates[,2] <- as.integer( geneCoordinates[,2] )
#    geneCoordinates[,3] <- as.integer( geneCoordinates[,3] )
#    
#    regions <- GRanges( geneCoordinates[,1], 
#        IRanges( geneCoordinates[,2] , geneCoordinates[,3]) , strand='+')
#    
#    names( regions ) <- selectedGenes
    
    regions <- genes(genomeTxDb)[ selectedGenes ]
   
    return( regions )
    
  } else {
    if (verbose) message( "No valid gene regions recovered" )
    return( GRanges( NULL, IRanges( NULL, NULL ) ) )
  }
}

.arrangeLayout <- function( targets, layout, colors, plotTitles, verbose ) {
  
  .colorsFromConditionMatrix <- function( conditionMatrix , colors, verbose ) {
    if ( length( colors ) == 1 && tolower( colors ) == 'auto' ) {
      if (verbose) message( "Automatic selection of colors" )
      colors <- colors()[1:(length(conditionMatrix)) + 15]
      matrix( colors, ncol = ncol(conditionMatrix) )
    } else {
      if (verbose) message( "Using colors given by user" )        
      matrix( colors, 
          ncol = ncol( conditionMatrix ),
          nrow = nrow( conditionMatrix ),
          byrow = TRUE)
    }
  }
  
  # Check if auto layout is required
  if ( is.character( layout ) && tolower( layout ) == 'auto' ) {
    
    expFactors <- colnames( targets )[ 
        ! colnames( targets ) %in% c( 'bam', 'condition' ) ]
    
    nExpFactors <- length( expFactors )
    
    # ------------------------------------------------------------------------ #
    # Case 1: just one experimental factor
    # result matrix is 1 x n
    if ( verbose ) message( "Auto arrange for one experimental factor: 1 x n matrix")
    if ( nExpFactors == 1 ) {
      conditionMatrix <- matrix( getConditions(targets), 
          ncol = length( getConditions(targets) ) )
      plotTitles <- conditionMatrix
      colors <- .colorsFromConditionMatrix( conditionMatrix, colors, verbose )
    } 
    # ------------------------------------------------------------------------ #
    
    # ------------------------------------------------------------------------ #
    # Case 2: more than one experimental factor and n * m * ... conditions. 
    # result matrix is n * ( m * ... ), where n is the number of values of the 
    # first factor and m * ... are the number of combination of remaining 
    # factors.
    if ( nExpFactors > 1 ) {
      nComb <- prod( apply( targets[, expFactors], 2 , 
              function( x ) length( unique( x ) ) ) )
      
      if ( length( getConditions( targets ) == nComb ) ) {
        if ( verbose ) message( "Auto arrange for more than one experimental factor: m x n matrix")
        conditionMatrix <- matrix( getConditions( targets ), 
            nrow = length( unique( targets[expFactors][,1]) ),
            byrow = TRUE )
        plotTitles <- conditionMatrix
        colors <- .colorsFromConditionMatrix(conditionMatrix, colors, verbose)
        
      } else {
        if ( verbose ) message( "Auto arrange for more than one experimental factor: 1 x n matrix")
        conditionMatrix <- matrix( getConditions( targets ), 
            ncol = length( getConditions(targets) ) )
        plotTitles <- conditionMatrix     
        colors <- .colorsFromConditionMatrix(conditionMatrix, colors, verbose)
      }
    } 
    # ------------------------------------------------------------------------ #
    
  } else {
    
    # ------------------------------------------------------------------------ #
    # Case 3: No auto arrange required. 
    # Matching matrix dimensions of layout, colors and plotTitles matrixes is 
    # checked.
    
    if ( ! is.matrix( layout ) ) { 
      stop(simpleError("Layout must be a matrix or 'auto'" ))
    }
    if ( ! is.matrix( colors ) ) {
      colors <- .colorsFromConditionMatrix( layout, colors, verbose )
    }
    if ( is.character( plotTitles ) && plotTitles == 'auto' ) {
      plotTitles <- layout
    }

   if ( ( ncol( plotTitles ) != ncol(layout) ) | 
         ( nrow( plotTitles ) != nrow(layout) ) |
         ( ncol( colors )     != ncol(layout) ) | 
         ( nrow( colors )     != nrow(layout) ) ) {
      stop( simpleError(
              "The number of columns and rows of colors and plotTitles must match to layout" ))
    }
    if ( verbose ) message( "Using given layout matrix to arrange plots")
    conditionMatrix <- layout
    # ------------------------------------------------------------------------ #
  }
  result <- list()
  result$conditionMatrix <- conditionMatrix
  result$plotTitles <- plotTitles
  result$colors <- colors
  return( result )
}

.plotGenomicRegions <- function( x, genomeTxDb, features, targets, xIsBin = TRUE, 
    layout = 'auto', colors = 'auto', plotTitles = 'auto', sashimi = FALSE, 
    zoomOnBins = FALSE, deviceOpt = NULL, highLightBin = TRUE, outfolder = NULL, 
    outfileType = 'png', mainFontSize = 24, annotationHeight = 0.2,
    annotationCol = 'black', annotationFill = 'gray', annotationColTitle = 'black',
    preMergedBAMs = NULL, useTransparency = TRUE, tempFolder = 'tmp', 
    avoidReMergeBams= FALSE, verbose = TRUE  ) {
  
  targets <- .condenseTargetsConditions( targets )
  
  # -------------------------------------------------------------------------- #
  # Autoarrange 
  layoutPars <- .arrangeLayout( targets, layout, colors, plotTitles, verbose )
  conditionMatrix <- layoutPars$conditionMatrix
  colors <- layoutPars$colors
  plotTitles <- layoutPars$plotTitles
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Keep existing genes and bins in the data set
  if ( xIsBin ) {
    if (verbose) message( "Selecting Bins" )
    #x <- x[ x %in% rownames( countsb( counts ) ) ]
    x <- x[ x %in% names( featuresb( features ) ) ]
  } else {
    if (verbose) message( "Selecting Genes" )
    #x <- x[ x %in% rownames( countsg( counts ) ) ]
    x <- x[ x %in% names( featuresg( features ) ) ]
  }
  if ( length( x ) == 0 ) {
    stop( simpleError( "Bin and/or genes names are incorrect." ) )
  } 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Collect and merge bam files
  regions <- .definePlottingRegions( x, xIsBin, verbose, features, genomeTxDb )
  if ( is.null( preMergedBAMs) ) {
    if (verbose) message("Using selected regions to extract and merge reads")
    mergedFiles <- .mergeBamsByCondition( targets, regions, 
        keepOld = avoidReMergeBams, tempFolder, verbose )
  } else {
    if (verbose) message("Using pre merged bams files")
    mergedFiles <- data.frame( 
        cond = rownames( preMergedBAMs ),
        bams = as.character( preMergedBAMs[,1] ), stringsAsFactors = FALSE)
  }
  bamfiles <- .getBamMatrix( conditionMatrix , mergedFiles  )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Plot
  plotCounter = 0
  for ( xi in x ) {
    plotCounter <- plotCounter +1 
    #currentGene <- if ( xIsBin ) countsb( counts )[ xi, c('locus') ] else xi
    currentGene <- if ( xIsBin ) mcols(featuresb( features )[xi])[,'locus'] else xi
    highLightBin <- highLightBin & xIsBin

    zoomOnBins <- if ( ! zoomOnBins | ! xIsBin ) FALSE else  zoomOnBins 
    
    genLims <- c( start( regions[currentGene] ), end( regions[currentGene] ) )
#    binLims <- if ( xIsBin ) as.integer( countsb( counts )[ 
#                  xi, c( 'start', 'end' ) ] ) else NULL 
    binLims <- if ( xIsBin ) {
          df <- as.data.frame( featuresb( features )[xi] )
          rownames(df) <- df$names
          c( df[1, 'start'], df[1,'end']) 
        } else NULL
    
    if ( ! is.null( outfolder ) ) {
      dir.exists( outfolder ) || dir.create( outfolder )
      outfile <- file.path( outfolder, 
          .makeValidFileName( paste0( xi,'.gr.', outfileType ) ) )
    } else { 
      outfile <- NULL
    }
    if ( verbose ) message( paste( "Plotting", xi, "(",
              as.character(plotCounter),"/", as.character(length(x)) ,")" ) )
    
    .makeGenomeRegionPlot( 
      main = xi, 
      genLims = genLims ,
      binLims = binLims ,
      chromosome = as.character( seqnames( regions[currentGene] ) ),
      outfile = outfile,
      genome = genomeTxDb,
      bamFiles = bamfiles,
      plotNames = plotTitles,
      colors = colors,
      mainFontSize = mainFontSize,
      sashimi = sashimi,
      zoomOnBins = zoomOnBins,
      outfileType = outfileType,
      deviceOpt = deviceOpt,
      highLightBin = highLightBin,
      annotationHeight = annotationHeight,
      annotationCol = annotationCol,
      annotationFill = annotationFill,
      annotationColTitle = annotationColTitle,
      useTransparency = useTransparency )
      
   }
  # -------------------------------------------------------------------------- #
}

.makeGenomeRegionPlot <- function ( 
    main , 
    genLims , 
    binLims , 
    chromosome ,  
    genome , 
    outfile , 
    bamFiles = NULL ,    # a matrix of H x V 
    plotNames = NULL ,   # a matrix of H x V
    colors = NULL ,      # a matrix of H x V  
    mainFontSize = 24,
    sashimi = TRUE , 
    zoomOnBins = FALSE, 
    individualWidth = 1024,
    individualHeight = 800,
    highLightBin = TRUE,
    outfileType = 'png',
    deviceOpt = NULL,
    annotationHeight = 0.2,
    annotationCol = 'black',
    annotationFill = 'gray',
    annotationColTitle = 'black',
    useTransparency = FALSE ) {
  
  # -------------------------------------------------------------------------- #
  # Extrae la cantidad de plots horizontales y verticales
  hplots <- ncol ( bamFiles )
  vplots <- nrow ( bamFiles )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Zoom on Bins
  if ( zoomOnBins  ) {
    minZoomFactor <- abs( binLims[2] - binLims[1] ) / abs(genLims[2]-genLims[1])
    zoomOnBins <- min( max( zoomOnBins, minZoomFactor ) , 1 )
    
    deltaB <- abs( binLims[2] - binLims[1] )
    deltaG <- deltaB / zoomOnBins 
    
    binMean    <- ( binLims[2] + binLims[1] ) / 2
    genLims[1] <- max( binMean - deltaG / 2, genLims[ 1 ] )
    genLims[2] <- min( binMean + deltaG / 2, genLims[ 2 ] )
    genLims[1] <- genLims[1] - as.integer( abs( genLims[ 2 ] - genLims[ 1 ] ) * 0.1 ) 
    genLims[2] <- genLims[2] + as.integer( abs( genLims[ 2 ] - genLims[ 1 ] ) * 0.1 ) 
    
    genLims <- as.integer( genLims )
  }
  # -------------------------------------------------------------------------- #

  # -------------------------------------------------------------------------- #
  # Functions to define tracks
  alnTrack <- function( rangeFile, name, colors, size  ) {
    AlignmentsTrack( 
        range = rangeFile,
        isPaired = FALSE, 
        name=name,
        col= colors,
        fill.coverage = colors,
        col.coverage = colors,
        background.title = if (useTransparency ) 'transparent' else { 'white' },
        type = c( 'coverage', 'sashimi' )[c( TRUE, sashimi ) ],
        sashimiHeight = 0.5,
        coverageHeight = 0.5,      
        lwd.sashimiMax = 3,
        lwd.sashimiMin = 0.5,        
        showTitle = TRUE,
        lwd = 0,
        col.axis = 'black',
        cex.axis = 0.6,
        cex.title = 0.6,
        col.title = 'black',
        size = size,
        margin= 20
    )
  }

  binHighLight <- function ( tracks ) {
    tracks <- tracks[ ! is.na (tracks )]
    colRGB <- if( useTransparency ) rgb(0.5,0.5,0.5, 0.3) else rgb(0.5,0.5,0.5) 
    fillRGB <- if( useTransparency ) rgb( 0.5,0.5,0.5,0.25) else rgb( 0.8,0.8,0.8 )   
    inBackGround <- ! useTransparency
    
    HighlightTrack(
        trackList = tracks, 
        start = binLims[1], 
        end = binLims[2],
        chromosome = chromosome,
#        col="transparent",
        col=colRGB,
        fill=fillRGB,
        lwd=1,
        frame = TRUE,
        inBackground=inBackGround
    )
  }
  # -------------------------------------------------------------------------- #

  # -------------------------------------------------------------------------- #
  # Define tracks
  alntracks <- lapply(1:hplots, function ( y ) { lapply(1:vplots, function( z ) { NA } ) } )
  for ( h in 1:hplots ) {
    for ( v in 1:vplots) {
      if ( ! is.na( bamFiles[ v, h ] ) ) {
        cTrack <- alnTrack ( 
            rangeFile = bamFiles [ v, h ],
            name      = plotNames[ v, h ],
            colors    = colors   [ v, h ],
            size      = 10000 * ( 1 - annotationHeight )  / sum( ! is.na( bamFiles[,h]))) 
        alntracks[[ h ]][[ v ]] <- cTrack 
      } 
    }
  }
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  geneAnnotationTrack <- GeneRegionTrack(genome, 
      chromosome = chromosome,
      start = genLims[1], 
      end = genLims[2],
      options(ucscChromosomeNames=FALSE),
      name = "", 
      transcriptAnnotation = "symbol",
      size = annotationHeight * 10000,  
      fill = annotationFill ,
      col = annotationCol,
      shape = "arrow",
      col.title = annotationColTitle )
  # -------------------------------------------------------------------------- #


  
  if ( highLightBin ) {
    columnTracks <- lapply( alntracks, function (x) {
          binHighLight ( x )
        } )
  } else {
    columnTracks <- alntracks
  }

  
  # -------------------------------------------------------------------------- #
  # creates the graphic device
  outputIsAValidFile <- ( ! is.null( outfile ) ) && 
      ( file.access( dirname( outfile ) , 2 ) == 0 ) 
  
  if ( outputIsAValidFile ) {
    
    devicesNames <- c( 'png', 'bmp', 'jpeg', 'tiff', 'pdf')
    devices      <- list( png, bmp, jpeg, tiff, pdf)
    
    deviceIndex <- match( tolower( outfileType ), devicesNames )
    
    if ( is.na(deviceIndex) ) { 
      dev.new()
      message( paste('Format',outfileType,'is not recognized.',
              'Select png, bmp, jpeg, tiff or pdf') )
      
    } else {
      device <- devices[[ deviceIndex ]]
      undefDeviceOpt <-  is.null( deviceOpt )
      
      if ( (! is.na( deviceIndex )) && deviceIndex %in%  c(1:4) ) {
        fileNameOpt <- list( filename = outfile)
        defaultDeviceOpt <- list( res = 200, height = individualHeight * vplots, 
            width = individualWidth  * hplots, 
            pointsize = 12, units = 'px')
      }
      
      if ( (! is.na( deviceIndex )) && deviceIndex ==  5 ) {
        fileNameOpt <- list( file = outfile)
        defaultDeviceOpt <- list( height = 8 * vplots, width = 8 * hplots, 
            pointsize = 12)        
      }
      
      deviceOpt <- if ( undefDeviceOpt ) 
            append( defaultDeviceOpt, fileNameOpt ) 
          else 
            append( deviceOpt, fileNameOpt )
      do.call( device, deviceOpt )    
      
    }
    
  } else {
    dev.new()
    if ( ! is.null ( outfile ) ) {
      message( paste( "File:",outfile,"cannot be created." ) )
    }
  }
  # -------------------------------------------------------------------------- #


  grid.newpage()
  
  pushViewport( 
      viewport( layout = grid.layout( 
              nrow = 2, 
              ncol = hplots , 
              heights = unit( c ( 1, 5 ) , "null") ) ) )
  
  grid.text(main, gp=gpar( fontsize = mainFontSize ) , 
      vp = viewport(layout.pos.row = 1, layout.pos.col = 1:hplots) )
  
  first <- TRUE
  for ( i in 1:hplots) {
    pushViewport(viewport(layout.pos.col=i, layout.pos.row=2))
    
    plotTracks( c( columnTracks [[ i ]] ,geneAnnotationTrack ), 
        chromosome        = chromosome, 
        from              = genLims[1], 
        to                = genLims[2], 
        min.height        = 0, 
        minCoverageHeight = 0, 
        min.width         = 2, 
        min.distance      = 5,
        background.title  = 'white',
        margin            = 10,
        innerMargin       = 5,
        add               = TRUE
    ) 
    first <- FALSE
    popViewport(1)
  }
  # -------------------------------------------------------------------------- #
  # Close graphic device 
  if ( outputIsAValidFile ) {
    output <- capture.output( dev.off() )
  } 
  # -------------------------------------------------------------------------- #
}

# TODO: Add comment
# 
# Author: javier
###############################################################################


# ------------------------------------------------ #
# quantifier | grouping | type   | whom  | filter  #
# ------------------------------------------------ #
# min        | set      | count  | gene  | all     #
# avg        | cond.    | rd     | bin   | any     #
#            |          |        | junc. |         #
# -------------------------------------------------#

#bamFileNames <- c( 
#    "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
#    "A_D_0.bam", "A_D_1.bam", "A_D_2.bam",
#    "B_C_0.bam", "B_C_1.bam", "B_C_2.bam", 
#    "B_D_0.bam", "B_D_1.bam", "B_D_2.bam" )
#
#targets <- data.frame( 
#    row.names = sub( ".bam","",bamFileNames ),
#    bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
#    factor1 = c( 'C','C','C','D','D','D','C','C','C','D','D','D'),
#    factor2 = c( 'A','A','A','A','A','A','B','B','B','B','B','B'),
#    stringsAsFactors = FALSE )


.vecMin <- function ( a, b ) {
  at <- a < b
  bt <- a >= b
  av <- rep( NA, length( a ) )
  bv <- rep( NA, length( b ) )
  av[ at ] <- a[ at ]
  av[ !at ] <- 0
  bv[ bt ] <- b[ bt ]
  bv[ !bt ] <- 0
  return( av + bv )
}

.rowMin <- function ( x ) {
  result <- x[,1]
  for ( i in 1:ncol(x) ) {
    result <- .vecMin(result, x[,i])
  }
  result
}

.extractValuesToFilter <- function ( counts, type, what, targets ) {
  
  typeAcceptedValues <- c('count','rd')
  whatAcceptedValues <- c('gene','bin','junction')
  
  if ( ! type %in% typeAcceptedValues || ! what %in% whatAcceptedValues ) {
    stop( simpleError( "Type or what argument has an unaccepted value.\nAccepted values are:\n\ttype: 'count','rd'\n\twhat: 'gene','bin','junction'") )
  }
  
  accFunction <- if ( type == 'count' && what == 'gene') { countsg } else 
                 if ( type == 'count' && what == 'bin' ) { countsb } else 
                 if ( type == 'count' && what == 'junction' ) { countsj } else
                 if ( type == 'rd' && what == 'gene' ) { rdsg } else
                 if ( type == 'rd' && what == 'bin' ) { rdsb } else
                 if ( type == 'rd' && what == 'junction' ) {
                   stop( simpleError( "junction read density is not defined"))
                 } else stop( "You should not be here" )

  targets <- .condenseTargetsConditions( targets )
  .extractCountColumns( accFunction(counts) , targets )  
  
}

.evaluateByGroup <- function( values, quantifier, grouping, targets ) {
  
  qFunc <- if ( quantifier == 'min' ) { .rowMin } else 
           if ( quantifier == 'avg' ) { rowMeans } else {
             stop( simpleError( "Quantifier not recognized. Accepted values are: 'min', 'avg'"))
           } 
  
  targets <- .condenseTargetsConditions(targets)
  
  colGroups <- if ( grouping == 'set' ) { list( rep( TRUE, ncol(values)) ) } else
               if ( grouping == 'cond') {
                 lapply( unique( targets$condition ), function( x )  targets$condition %in% x )
               } else
               { stop(simpleError( "Set argument has an unaccepted value.\nAccepted values are: 'set', 'cond'")) }
  
  result <- lapply( colGroups, function( g ) { qFunc( values[ ,g ] ) } )
  do.call( cbind, result )

}
.filterByGroup <- function( values, filter, cutoff ) {
  
  n <- if ( filter == 'any') { 1 } else 
       if ( filter == 'all') { ncol(values) } else { 
        stop( simpleError( "Filter argument has an unaccepted value. Accepted values are: 'any', 'all'" ) ) }
  values <- values >= cutoff
  
  rowSums( values ) >= n
  
}

#a <- .extractValuesToFilter( counts , type = 'count', 'gene', targets )
#b <- .evaluateByGrouping( a, 'min', 'set', targets ) 
#c1 <- .filterByGroup( b, 'any', 310 )

.filterReadCounts <- function( counts, targets, cutoffValue, type=NULL, 
    quantifier=NULL, what= NULL, grouping = NULL, filter = NULL ) {

  typeAcceptedValues <- c('count','rd')
  whatAcceptedValues <- c('gene','bin','junction')
  quantifierAcceptedValues <- c('min', 'avg')
  groupingAcceptedValues <- c( 'cond', 'set' )
  filteAcceptedValues <- c( 'all', 'any' )  
  
  what <- tolower( what )
  quantifier <- tolower( quantifier )
  grouping <- tolower( grouping )
  type <- tolower( type )
  filter <- tolower(filter)
  
  targets <-.condenseTargetsConditions( targets )
  values <- .extractValuesToFilter( counts , type , what, targets )
  values <- .evaluateByGroup( values, quantifier,grouping, targets ) 
  filterMask <- .filterByGroup( values, filter , cutoffValue)
  
  if ( what == 'gene') {
    countsg( counts ) <- countsg( counts )[ filterMask , ]
    rdsg( counts )    <- rdsg( counts )[ filterMask , ]
  } else 
  if ( what == 'bin') {
    countsb( counts ) <- countsb( counts )[ filterMask , ]
    rdsb( counts )    <- rdsb( counts )[ filterMask , ]
  } else 
  if ( what == 'junction') {
    countsj( counts ) <- countsj( counts )[ filterMask , ]
  }
  return( counts )
}

#a <- .filterReadCounts( counts, targets, 315, 'count', 'min', 'gene', 'cond', 'all' )

## Deprecated
#.binsDU_DEXSeq <-
#  function(df,targets, group)
#  {
#    countsSt <- ncol(df)-nrow(targets)+1
#    GeneInfo <- data.frame(Gene.Exon=rownames(df), 
#                         matrix(unlist(strsplit(as.character(rownames(df)), ":")), 
#                                nrow=nrow(df), ncol=2, byrow=TRUE ) )
#    colnames(GeneInfo) = c("GeneExon","GeneID","ExonID")
#    countData <- df[,countsSt:ncol(df)]
#    sampleData <- data.frame(condition=group)
#    design1 <- formula( ~ sample + exon + condition:exon )
#    groupID <- GeneInfo$GeneID
#    featureID <- GeneInfo$GeneExon
#    data <- DEXSeqDataSet( countData, sampleData, design1,featureID, groupID )
#    dx <- estimateSizeFactors( data )
#    dx <- estimateDispersions( dx)
#    dx <- testForDEU( dx )
#    dx <- DEXSeqResults( dx)
#    rownames(dx) <- rownames(df)
#    logFC <- dx$exonBaseMean
#    pvalue <- dx$pvalue
#    bin.fdr <- dx$padj
#  
#    splicing_full <- data.frame (df[,-(countsSt:ncol(df))],
#                                logFC, 
#                                pvalue,
#                                bin.fdr,
#                                stringsAsFactors=FALSE)
#    rownames(splicing_full) <- rownames(df)
#    return(splicing_full)
#  }
###################################################################
#
## Deprecated
#.junctionsDU_SUM_DEXSeq <- function(df, 
#                           targets, 
#                           genesde, group)
#  
#{
#  ######################################################
#  jratio<-function(x){
#    x[is.na(x)] <- 0 # we have to remove NAs
#    res <- x[1]/(x[1]+x[2])
#    return(res)  }
#  ##############################################################################################################3  
#  countsSt <- ncol(df)-nrow(targets)+1
#  GeneInfo <- data.frame(Gene.Exon=rownames(df), 
#                       matrix(unlist(strsplit(as.character(rownames(df)), ":")), 
#                       nrow=nrow(df), ncol=2, byrow=TRUE ) )
#  colnames(GeneInfo) <- c("GeneExon","GeneID","ExonID")
#  countData <- df[,countsSt:ncol(df)]
#  sampleData <- data.frame(condition=group)
#  design1 <- formula( ~ sample + exon + condition:exon )
#  groupID <- GeneInfo$GeneID
#  featureID <- GeneInfo$GeneExon
#  data <- DEXSeqDataSet( countData, sampleData, design1,featureID, groupID )
#  data <- estimateSizeFactors( data )
#  dispersions(data) <- 0.1
#  dx <- testForDEU( data )
#  dx <- DEXSeqResults( dx)
#  rownames(dx) <- rownames(df)
#  logFC <- dx$exonBaseMean
#  pvalue <- dx$pvalue
#  fdr <- dx$padj
#  ############those sharing 3', 5', total etc#################
#  jranges <- .createGRangesExpJunctions(rownames(df))
#  if (packageVersion("IRanges")<2.6) 
#  {
#    j.start <- findOverlaps(jranges, ignoreSelf=TRUE,
#                            ignoreRedundant=FALSE,type="start")
#    
#  }
#  else
#  {
#  j.start <- findOverlaps(jranges, drop.self=TRUE,
#                          drop.redundant=FALSE,type="start")
#  }
#  jjstart <- as.data.frame(j.start)
#  jjstart$queryHits <- names(jranges[jjstart$queryHits])
#  jjstart$subjectHits <- names(jranges[jjstart$subjectHits])
#  shareStart <- data.frame(aggregate(subjectHits ~ queryHits, 
#                                     data = jjstart, paste, collapse=";")) 
#  #counts matrix
#  start <- ncol(df) - nrow(targets) +1 #ok
#  end <- ncol(df)#ok
#  #aca no hay cuentas solo recupero los counts usando el indexado de subjectHits
#  dfCountsStart <- data.frame( names=jjstart$queryHits, 
#                            df[jjstart$subjectHits,start:end],
#                            row.names=NULL) #recover counts
#  #tiene como names al query y como counts todos los subjects que dan con ese query. 
#  #en teoria podria haber mas de 1 sbject, por eso hace el aggregate-
#  #si es solo 1 hit deberian coincidir, cruzandose
#  #aca hace el agregate y tengo los counts de todas las junturas que comparten start con esa menos ella
#  dfSumStart <- data.frame(aggregate(. ~ names, data = dfCountsStart, sum))
#  sumJ <- paste(colnames(dfSumStart), "jsum", sep=".")
#  colnames(dfSumStart) <- sumJ
#  rownames(dfSumStart) <-  dfSumStart$names.jsum
#  dfSumStart$names.jsum <- NULL
#  #armo un nuevo data frame
#  dffStart <- data.frame(matrix(NA, nrow =  nrow(df), 
#                              ncol = ncol(dfSumStart)) )
#  rownames(dffStart) <- rownames(df)
#  colnames(dffStart) <- colnames(dfSumStart)
#  mSumStart <- match(row.names(dfSumStart), row.names(dffStart)) 
#  #reordeno el dffSumStart de acuerdo al df
#  dffStart[mSumStart,] <- dfSumStart#OK
#  dffStart[is.na(dffStart)] <- 0
#  mbin_start_hit <- match(shareStart$queryHits, row.names(dffStart))
#  #aca reacomodo el bin_start_hit con el indexado de dffStart
#  bin_start_hit <- as.character(rep("-", nrow(dffStart)) )
#  bin_start_hit[mbin_start_hit] <- shareStart$subjectHits
#  ################################################
#  ratioStart <- data.frame(df[,countsSt:ncol(df)],
#                         dffStart)
#  colnames(ratioStart) <- rep(rownames(targets),2)
#  #aca hay que armar un df itnermedio con la suma por condicion:
#  ff <- rep(targets$condition,2)
#  colnames(ratioStart) <- paste(ff, rep(1:2,each=length(targets$condition)))
#  dfSum <- t(apply(ratioStart, 1, function(x){tapply(as.numeric(x), INDEX=colnames(ratioStart), sum  )}))
#  colnames(dfSum) <- rep(unique(targets$condition),each=2)
#  jratioStartRes <- t(apply(dfSum, 1, function(x){tapply(as.numeric(x), INDEX=colnames(dfSum), jratio )}))
#  ################################################
#  if (packageVersion("IRanges")<2.6) 
#  {
#    j.end <- findOverlaps(jranges, 
#                       ignoreSelf=TRUE,
#                       ignoreRedundant=FALSE,
#                       type="end")
#  }
#  else
#  {
#  j.end <- findOverlaps(jranges, 
#                     drop.self=TRUE,
#                     drop.redundant=FALSE,
#                     type="end")
#  }
#  jjend <- as.data.frame(j.end)
#  jjend$queryHits <- names(jranges[jjend$queryHits])
#  jjend$subjectHits <- names(jranges[jjend$subjectHits])
#  shareEnd <- data.frame(aggregate(subjectHits ~ queryHits,
#                                data = jjend, paste, collapse=";")) 
#  dfCountsEnd <- data.frame( names=jjend$queryHits, 
#                          df[jjend$subjectHits,start:end],
#                          row.names=NULL) #recover counts
#  dfSumEnd <- data.frame(aggregate(. ~ names, data = dfCountsEnd, sum))   
#  sumJ <- paste(colnames(dfSumEnd), "jsum", sep=".")
#  colnames(dfSumEnd) <- sumJ
#  rownames(dfSumEnd) <- dfSumEnd$names.jsum
#  dfSumEnd$names.jsum <- NULL
#  dffEnd  <- data.frame(matrix(NA, nrow =  nrow(df), ncol = ncol(dfSumEnd)) )
#  rownames(dffEnd) <- rownames(df)
#  colnames(dffEnd) <- colnames(dfSumEnd)
#  ########################################################################
#  mSumEnd <- match(row.names(dfSumEnd), row.names(dffEnd))
#  dffEnd[mSumEnd,] <-  dfSumEnd
#  dffEnd[is.na(dffEnd)] <- 0
#  ########################################################################
#  mbin_end_hit <- match(shareEnd$queryHits, row.names(dffEnd))
#  bin_end_hit <- rep("-", nrow(dffEnd))
#  bin_end_hit[mbin_end_hit] <- shareEnd$subjectHits
#  ########################################################################
#  ratioEnd <- data.frame(df[,countsSt:ncol(df)],dffEnd)
#  ff <- rep(targets$condition,2)
#  colnames(ratioEnd) <- paste(ff, rep(1:2,each=length(targets$condition)))
#  dfSum <- t(apply(ratioEnd, 1, function(x){tapply(as.numeric(x), 
#                                                 INDEX=colnames(ratioEnd), sum  )}))
#  colnames(dfSum) <- rep(levels(targets$condition),each=2)
#  jratioEndRes <- t(apply(dfSum, 1, function(x){tapply(as.numeric(x), 
#                                                     INDEX=colnames(dfSum), jratio )}))
#  #########################################################################
#  et_merge <- data.frame(df,                       
#                       logFC,
#                       pvalue, 
#                       fdr,
#                       bin_start_hit,
#                       dffStart,
#                       jratioStartRes,
#                       bin_end_hit,
#                       dffEnd,
#                       jratioEndRes)
#  return(et_merge)
#}                        
###################################################
#
## Deprecated
#.genesDE_DESeq <-
#  function(df, targets, pair)
#  { 
#    countsSt <- ncol(df)-nrow(targets)+1
#    colData <- data.frame(condition=targets$condition, row.names=row.names(targets))
#    #########################################################
#    dds <- DESeqDataSetFromMatrix(countData = df[,countsSt:ncol(df)],
#                                  colData = colData,
#                                  design = ~ condition)
#    dds <- DESeq(dds)
#    res <- results(dds, contrast=c("condition",pair))
#    fdr.gen <- res$padj
#    #########################################################
#    genes_full <- data.frame(df[,-(countsSt:ncol(df))],
#                           logFC=as.numeric(res$log2FoldChange), 
#                           pvalue=as.numeric(res$pvalue), 
#                           gen.fdr=as.numeric(fdr.gen), 
#                           stringsAsFactors=FALSE)
#    rownames(genes_full) <- rownames(df)
#    return(genes_full)
#  }
###################################################

loadBAM <- function( targets, cores = 1, libType, strandMode ) {
  if(!is.null(cores)){ #Uses cores as flag for ASpli version. NULL means v2
    .Deprecated("", msg = "loadBAM is deprecated and is no longer needed. See ?gbCounts.")
   }
    datac <- lapply( as.character(targets$bam), function(x){

    #option to load as SE o PE, default PE:
    if(libType=="SE"){ 
      r <- readGAlignments(x) 
    }
    else {
      r <- readGAlignmentPairs(x, strandMode=strandMode) 
    }
      #Normalize seqnames. If . present in name, changes it to _ and warns the user
      if(length(grep("[.]", seqlevels(r)) > 0)){
        seqlevels(r) <- gsub("[.]", "_", seqlevels(r))
        warning("Some seqnames had a '.' present in their names. ASpli had to normalize them using '_'.")
      }
      gc()
      return(r)
    })
  names( datac ) <- rownames(targets)
  
  return(datac)
  
}

# ---------------------------------------------------------------------------- #
# Class definitions
setClass( Class = "ASpliFeatures",
          representation = representation(
            genes = "GRangesList",
            bins = "GRanges",
            junctions = "GRanges",
            transcriptExons = "GRangesList"))

setClass( Class = "ASpliCounts",
          representation = representation(
            gene.counts = "data.frame", 
            exon.intron.counts = "data.frame",
            junction.counts = "data.frame",
            e1i.counts = "data.frame", 
            ie2.counts = "data.frame",
            gene.rd = "data.frame",
            bin.rd = "data.frame", 
            targets = "data.frame",
            condition.order = "character",
            .ASpliVersion = "character"))

setClass( Class="ASpliAS",
          representation = representation(
            irPIR = "data.frame",
            altPSI = "data.frame",
            esPSI = "data.frame",
            junctionsPIR = "data.frame",
            junctionsPJU = "data.frame",
            join = "data.frame", 
            targets = "data.frame",
            .ASpliVersion = "character") )

setClass( Class = "ASpliDU",
          representation = representation(
            genes = "data.frame",
            bins = "data.frame",
            junctions = "data.frame",
            contrast = "numeric",
            .ASpliVersion = "character" ))

setClass( Class = "ASpliJDU",
          representation = representation(
            localec = "data.frame",
            localej = "data.frame",
            anchorc = "data.frame",
            anchorj = "data.frame",
            jir     = "data.frame",
            jes     = "data.frame",
            jalt    = "data.frame",
            contrast= "numeric",
            .ASpliVersion = "character"))

setClass( Class = "ASpliSplicingReport",
          representation = representation(
            binbased    = "data.frame",
            localebased = "data.frame",
            anchorbased = "data.frame",
            contrast    = "numeric",
            .ASpliVersion = "character"))

setClass( Class = "ASpliIntegratedSignals",
          representation = representation(
            signals      = "data.frame",
            filters      = "data.frame",
            .ASpliVersion = "character"))
# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #
# Set methods
setGeneric ( name = "binGenome", 
             def = function( genome, geneSymbols = NULL, 
                             logTo = "ASpli_binFeatures.log", cores = 1 ) standardGeneric( "binGenome" ) )

setMethod(
  f = "binGenome",
  signature = "TxDb",
  definition = function ( genome, geneSymbols = NULL, logTo = "ASpli_binFeatures.log", cores = 1) {
    
    #Normalize seqnames. If . present in name, changes it to _ and warns the user
    if(length(grep("[.]", seqlevels(genome))) > 0){
      seqlevels(genome) <- gsub("[.]", "_", seqlevels(genome))
      warning("Some seqnames had a '.' present in their names. ASpli had to normalize them using '_'.")
    }
    
    features <- new( Class = "ASpliFeatures" )
    
    if ( is.null( geneSymbols ) ) {
      # Recupera los nombres de los genes
      geneSymbols <- data.frame( names( transcriptsBy(genome) ), stringsAsFactors = FALSE)
      row.names(geneSymbols) <- names( transcriptsBy(genome) )
      colnames(geneSymbols)  <- "symbol" 
    }
    if ( ! is.null ( logTo ) ) {
      sink( file = logTo )
    }
    genes.by.exons <- .createGRangesGenes( genome, geneSymbols ) 
    
    msg <- paste( "* Number of extracted Genes =" , length( genes.by.exons ) )
    message( msg )
    if ( sink.number() > 0 ) cat( paste( msg, "\n" ) )
    
    
    exon.bins <- .createGRangesExons(genome, geneSymbols)
    #add locus_overlap
    index <- match(exon.bins@elementMetadata$locus, names(genes.by.exons))
    locus_overlap <- rep("-", length(exon.bins))
    locus_overlap <- genes.by.exons@elementMetadata$locus_overlap[index]
    mcols(exon.bins) <- append(mcols(exon.bins), DataFrame(locus_overlap=locus_overlap))
    
    msg <- paste( "* Number of extracted Exon Bins =", length( exon.bins ) )
    message( msg )
    if ( sink.number() > 0 ) cat( msg, "\n" ) 
    
    
    intron.tot <- .createGRangesIntrons(genome, geneSymbols)
    #add locus_overlap
    index <- match(intron.tot@elementMetadata$locus, names(genes.by.exons))
    locus_overlap <- rep("-", length(intron.tot))
    locus_overlap <- genes.by.exons@elementMetadata$locus_overlap[index]
    mcols(intron.tot) <- append( mcols(intron.tot), 
                                 DataFrame(locus_overlap=locus_overlap) )
    
    msg <- paste( "* Number of extracted intron bins =", length( intron.tot ) )
    message( msg )
    if ( sink.number() > 0 ) cat( paste( msg, "\n" ) )
    
    transcripts <- .createGRangesTranscripts(genome)
    
    msg <- paste( "* Number of extracted trascripts =" , length( unlist( transcripts ) ) )
    message( msg )
    if ( sink.number() > 0 ) cat( paste( msg,"\n") )
    
    junctions <- .createGRangesJunctions( genome ) 
    
    #add locus_overlap
    index <- match( junctions@elementMetadata$locus, names( genes.by.exons ) )
    locus_overlap <- rep( "-", length( junctions ) )
    locus_overlap <- genes.by.exons@elementMetadata$locus_overlap[ index ]
    mcols(junctions) <- append( mcols( junctions ), 
                                DataFrame( locus_overlap = locus_overlap ) )
    
    msg <- paste("* Number of extracted junctions =", length(junctions) )
    message( msg)
    if ( sink.number() > 0 ) cat( paste( msg, "\n" ) )
    
    intron.bins <- intron.tot[ intron.tot@elementMetadata$feature == "I"  ]
    intron.orig <- intron.tot[ intron.tot@elementMetadata$feature == "Io" ]
    
    class  <- rep("fullI", length( intron.orig ))
    mcols( intron.orig ) <- append( mcols( intron.orig ), DataFrame( class=class ))
    event  <- rep("-", length( intron.orig ))
    eventJ <- rep("-", length( intron.orig ))
    mcols( intron.orig ) <- append( mcols( intron.orig ), DataFrame( event=event ))
    mcols( intron.orig ) <- append( mcols( intron.orig ), DataFrame( eventJ=eventJ ))
    
    exons <- exons( genome )
    
    exons.introns <- .findAsBin( exons, exon.bins, intron.bins, transcripts, 
                                 junctions, logTo )
    fullT <- c(exons.introns,intron.orig)
    
    transcriptExons <- exonsBy(genome, use.names=TRUE)

    tByGene    <- transcriptsBy(genome, by = "gene")
    
    a         <- unlist(tByGene)
    #geneNames <- DataFrame(gene=names(a),tx=mcols(a)$tx_name)
    geneNames <- DataFrame(gene=names(a))
    rownames(geneNames)<-mcols(a)$tx_name
    mcols( transcriptExons ) <- append ( mcols( transcriptExons ), geneNames[names(transcriptExons), , drop=FALSE] )

    features@genes <- genes.by.exons
    features@bins <- fullT
    features@junctions <- junctions
    features@transcriptExons <- transcriptExons
    
    #TODO hacer el disjoin directo con fullT y tratar de machear los rangos que no coinciden en el disjoin con 
    #los originales de fullT. Esto tiene el problema del overlap de locus y de perder la referencia de los bines
    #de donde salio el disjoin.
    
    # Start the clock!
    #ptm <- proc.time()
    
    locus <- unique(fullT$locus)
    fullTcorregido <- fullT[fullT$locus %in% locus]
    dtFullTcorregido <- as.data.table(fullTcorregido)
    lFullTcorregidos <- split(dtFullTcorregido, dtFullTcorregido$locus)
    
    message( "Correcting Io ends, this might take a while..." )
    #pb <- txtProgressBar(min=1,max=length(lFullTcorregidos),style=3)
    #i <- 0
    fullTcorregido <- pbmclapply(lFullTcorregidos, mc.cores = cores, function(l){
      #print(l$locus[1])
      lIo    <- l[l$feature == "Io", ]
      lSinIo <- l[l$feature != "Io", ]
      rangos <- GRanges(seqnames = lSinIo$seqnames, ranges = IRanges(lSinIo$start, lSinIo$end, lSinIo$width), strand = lSinIo$strand)
      dis    <- disjoin(rangos)
      #Si los elementos disjuntos son menos que los rangos, es porque hay elementos que no deberian estar (ej AT1G02010). Los remuevo
      #Si no, simplemente ajusto los rangos
      if(length(dis) != length(rangos)){
        #Si los elementos disjuntos son mayores que los rangos, es porque no sabemos que pasa (ej AT2G31902).
        if(length(dis) > length(rangos)){
          #print(l$locus[1])
        }else{
          ol <- data.frame(findOverlaps(rangos, dis, type = "equal"))
          lSinIo <- lSinIo[ol$queryHits]
        }
      }else{
        #Si es la misma cantidad simplemente alcanza con reemplazar los rangos anteriores (ej AT1G05860).
        dis <- data.frame(ranges(dis))        
        lSinIo$start <- dis$start
        lSinIo$end   <- dis$end
        lSinIo$width <- dis$width
      }
      return(rbind(lSinIo, lIo))
    })

    fullTcorregido <- rbindlist(fullTcorregido)
    fullTcorregido <- GRanges(seqnames      = fullTcorregido$seqnames, 
                              ranges        = IRanges(start = fullTcorregido$start, end = fullTcorregido$end, width = fullTcorregido$width),
                              strand        = fullTcorregido$strand, 
                              locus         = fullTcorregido$locus, 
                              bin           = fullTcorregido$bin, 
                              feature       = fullTcorregido$feature, 
                              symbol        = fullTcorregido$symbol, 
                              locus_overlap = fullTcorregido$locus_overlap,
                              class         = fullTcorregido$class, 
                              event         = fullTcorregido$event, 
                              eventJ        = fullTcorregido$eventJ)
    # Stop the clock
    #proc.time() - ptm
    names(fullTcorregido) <- paste0(fullTcorregido$locus, ":", fullTcorregido$bin)
    features@bins <- fullTcorregido
    message( "Genome binning completed" )
    return( features ) 
  })


setGeneric( name = "rds",
            def = function( counts, targets ) standardGeneric("rds") )

# TODO: Las densidades de reads de genes y bins se calculan dos veces. Una 
# vez aca y otra vez cuando se hace el filtrado para hacer DU.
setMethod(
  f= "rds",
  signature = "ASpliCounts",
  definition = function(counts, targets) {
    geneStart <- ncol(countsg(counts))-nrow(targets)+1
    gene.rd <- cbind( countsg(counts)[,1:geneStart-1], 
                      countsg(counts)[,geneStart:ncol(countsg(counts))] / 
                        countsg(counts)$effective_length
    )
    binStart <- ncol(countsb(counts))-nrow(targets)+1
    bin.rd <- cbind(countsb(counts)[, 1:binStart-1], 
                    countsb(counts)[,binStart:ncol(countsb(counts))]
                    /countsb(counts)$length)
    
    tb <- match(bin.rd$locus, rownames(gene.rd))
    rdfinalb=cbind(bin.rd, bin.rd[,binStart:ncol(bin.rd)]
                   /gene.rd[tb,geneStart:ncol(countsg(counts))])
    
    counts@gene.rd <- gene.rd
    counts@bin.rd <- rdfinalb
    # counts@targets <- .condenseTargetsConditions(targets)
    # group                  <- count@targets$condition
    # counts@condition.order <- levels(factor( group, unique( group ), ordered = TRUE ))
    return(counts)
  }
)

# gbCounts is a wrapper around readCounts for improved legibility
setGeneric (
  name = "gbCounts",
  def = function( features, 
                  targets, minReadLength, maxISize, 
                  minAnchor = 10,
                  libType="SE",
                  strandMode=0,
                  alignFastq = FALSE,
                  dropBAM = FALSE)
    standardGeneric("gbCounts") )

setMethod(
  f = "gbCounts",
  signature = "ASpliFeatures",
  definition = function( features, targets,  minReadLength,  
                         maxISize, minAnchor = 10,
                         libType="SE",
                         strandMode=0,
                         alignFastq = FALSE,
                         dropBAM = FALSE) {
    counts <- readCounts( features = features, bam = NULL, targets = targets, readLength = minReadLength, maxISize = maxISize, minAnchor = minAnchor,
                          libType=libType,
                          strandMode=strandMode, alignFastq = alignFastq, dropBAM = dropBAM)
    counts@.ASpliVersion = "2" #Marks ASpliCounts object with the ASpli update 2.0.0
    return(counts)
  }
)

# readCounts
setGeneric (
  name = "readCounts",
  def = function( features, 
                  bam,
                  targets, 
                  cores = 1, 
                  readLength, 
                  maxISize, 
                  minAnchor = 10,
                  libType=libType,
                  strandMode=strandMode,
                  alignFastq = FALSE,
                  dropBAM = FALSE
                  )
    standardGeneric("readCounts") )

setMethod(
  f = "readCounts",
  signature = "ASpliFeatures",
  definition = function( features, bam, targets, cores = 1, readLength,  
                         maxISize, minAnchor = 10,
                         libType=libType,
                         strandMode=strandMode, alignFastq = FALSE, dropBAM = FALSE) {

    if(!is.null(bam)){
      .Deprecated("gbCounts")
    }
    
    #Check if alignFastq then targets must have one extra column with fastqs.
    #Also, if not, check if all bams exist before running
    if(alignFastq){
      if(!("alignerCall" %in% colnames(targets))){
        stop("Targets data frame must have a column named alignerCall with complete call to aligner for each sample.\n ie: STAR --runMode alignReads --outSAMtype BAM SortedByCoordinate --readFilesCommand zcat --genomeDir /path/to/STAR/genome/folder -runThreadN 4 --outFileNamePrefix {sample name} --readFilesIn  /path/to/R1 /path/to/R2. Output must match bam files provided in targets.")
      }
    }else{
      #All files exist?
      bams <- targets[, "bam"]
      bamFilesExist <- file.exists(bams)
      if(!all(bamFilesExist)){
        stop(paste0("Some bam files don't exist: ", paste0(bams[!bamFilesExist], collapse=", ")))
      }
    }
    
    minReadLength <- readLength
    cores <- 1 #Allways use 1 core.
 
    #Create result object
    counts <- new(Class="ASpliCounts")
    counts@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0.
    
    #Generates sample names in case there arent any
    targets <- .generateSamplesNames(targets)
    counts@targets <- .condenseTargetsConditions(targets) #ACH
    group                  <- counts@targets$condition
    counts@condition.order <- levels(factor( group, unique( group ), ordered = TRUE ))
    
    #Minimal anchors
    minAnchor <- if ( ! is.null(minAnchor) ) minAnchor else 10
    minA <- round( minAnchor * minReadLength / 100 )
    ptm <- proc.time()
    if(is.null(bam)) {
      ntargets <- nrow(targets)
    }else{
      ntargets <- 1
    }
    
    for(target in 1:ntargets){
      
      if(ntargets > 1 | is.null(bam)){
        #Verbose
        message(paste("Summarizing", rownames(targets)[target]))
        
        #Checks if must align first
        if(alignFastq){
            #Run alignment
            tryCatch(
              {
                message(paste0("Aligning using: ", targets[target, "alignerCall"]))
                system(targets[target, "alignerCall"])
              },
              error=function(cond) {
                stop(cond)
              },
              warning=function(cond) {
                stop(cond)
              },
              finally={
              }
            )
          #Check if bam exists or die
          if(!file.exists(targets[target, "bam"])){
            stop(paste0("Could not align or bam was not correctly created. Was expecting: ", targets[target, "bam"]))
          }
          
          #Make bai
          #Run alignment
          tryCatch(
            {
              message(paste0("Building bam index"))
              system(paste0("samtools index ", targets[target, "bam"]))
            },
            error=function(cond) {
              stop(cond)
            },
            warning=function(cond) {
              stop(cond)
            },
            finally={
            }
          )
          #Check if bai exists or die
          if(!file.exists(paste0(targets[target, "bam"], ".bai"))){
            stop(paste0("Could not create bai file. Make sure samtools is installed and accesible in PATH"))
          }
        }
              
        #Load bam from current target
        bam <- loadBAM(targets[target, ], cores = NULL,
                       libType=libType, 
                       strandMode=strandMode) #With cores = NULL wont print deprecated message
        
        #If dropBAM drops bam and bai but only if alignFastq = TRUE
        if(alignFastq & dropBAM){
          file.remove(paste0(targets[target, "bam"], ".bai"))
          file.remove(targets[target, "bam"])
        }
      }      
      
      # Count Genes
      gene.hits <- .counterGenes( bam, featuresg( features ))
      if(ncol(counts@gene.counts) == 0){
        counts@gene.counts <- gene.hits
      }else{
        counts@gene.counts <- cbind(counts@gene.counts, .extractCountColumns(gene.hits, targets[target, ]))
        colnames(counts@gene.counts)[ncol(counts@gene.counts)] <- rownames(targets)[target]
      }
      if(ntargets == 1) message("Read summarization by gene completed")
      
      # Count exons 
      bins <- featuresb( features )
      exons.hits <- .counterBin( bam, bins, gene.hits)
      if(ncol(counts@exon.intron.counts) == 0){
        counts@exon.intron.counts <- exons.hits
      }else{
        counts@exon.intron.counts <- cbind(counts@exon.intron.counts, .extractCountColumns(exons.hits, targets[target, ]))
        colnames(counts@exon.intron.counts)[ncol(counts@exon.intron.counts)] <- rownames(targets)[target]      
      }
      if(ntargets == 1) message( "Read summarization by bin completed" )
      
      # Count introns
      introns <- c( bins[ mcols(bins)$feature == "I" ], 
                    bins[ mcols(bins)$feature == "Io"],
                    bins[ mcols(bins)$eventJ  == "IR"])
      
      # Count exon1 - intron regions
      e1i <- introns
      start( e1i ) <- start( introns ) - ( minReadLength - minA )
      end( e1i )   <- start( introns ) + ( minReadLength - minA )
      e1i.hits     <- .counterJbin(bam, e1i, gene.hits, minReadLength)
      if(ncol(counts@e1i.counts) == 0){
        counts@e1i.counts <- e1i.hits
      }else{
        counts@e1i.counts <- cbind(counts@e1i.counts, .extractCountColumns(e1i.hits, targets[target, ]))
        colnames(counts@e1i.counts)[ncol(counts@e1i.counts)] <- rownames(targets)[target]         
      }
      if(ntargets == 1) message("Read summarization by ei1 region completed")
      
      # Count intron - exon2 regions
      ie2 <- introns
      start( ie2 ) <- end( introns ) - ( minReadLength - minA )
      end( ie2 )   <- end( introns ) + ( minReadLength - minA )
      ie2.hits     <- .counterJbin( bam, ie2, gene.hits, minReadLength )
      if(ncol(counts@ie2.counts) == 0){
        counts@ie2.counts <- ie2.hits
      }else{
        counts@ie2.counts <- cbind(counts@ie2.counts, .extractCountColumns(ie2.hits, targets[target, ]))
        colnames(counts@ie2.counts)[ncol(counts@ie2.counts)] <- rownames(targets)[target]   
      }
      if(ntargets == 1) message("Read summarization by ie2 region completed")

      # Count junctions
      junction.hits    <- .counterJunctions( features, bam, maxISize )
      if(ncol(counts@junction.counts) == 0){
        counts@junction.counts <- junction.hits
      }else{
        dt1                    <- data.table(counts@junction.counts, keep.rownames = TRUE)
        dt2                    <- data.table(.extractCountColumns(junction.hits, targets[target, ]), keep.rownames = T)
        dt3                    <- data.frame(merge(dt1, dt2, by="rn", all.x=T, all.y=TRUE))
        for(s in c("junction", "gene", "strand", "multipleHit", "symbol", "gene_coordinates", "bin_spanned", "j_within_bin")){
          dt3[, s]           <- as.character(dt3[, s])
          junction.hits[, s] <- as.character(junction.hits[, s])
        }
        rownames(dt3)          <- dt3[, "rn"]
        dt3                    <- dt3[, -1]
        dt3[dt2$rn, 1:8]       <- .extractDataColumns(junction.hits, targets[target, ])
        counts@junction.counts <- dt3
        counts@junction.counts[is.na(counts@junction.counts)] <- 0
      }
      #Sacamos filas que tengan NA en todos lados
      filas_con_na <- which(apply(counts@junction.counts, 1, function(s){any(is.na(s))}))
      if(length(filas_con_na) > 0){
        warning(paste0(length(filas_con_na), " NA functions removed from a total of ",  nrow(counts@junction.counts), " junctions"))
        counts@junction.counts <- counts@junction.counts[-filas_con_na, ]
      }
      
      if(ntargets == 1) message("Junction summarization completed")
      na_junctions <- which(is.na(counts@junction.counts$junction))
      if(length(na_junctions) > 0){
        warning(paste0("Removing ", length(na_junctions), " NA junctions"))
        counts@junction.counts <- counts@junction.counts[-na_junctions, ]
      }
      #if(length(grep("NA", rownames(junction.hits ))) > 0){
      #  print(target)
      #}
      gc()
      if(ntargets > 1){     
        sptm <- (proc.time() - ptm)[3]/target/60        
        message(paste("ETA:", round(sptm*(nrow(targets) - target)), "min"))      
      }
    }
    
    for(s in c("junction", "gene", "strand", "multipleHit", "symbol", "gene_coordinates", "bin_spanned", "j_within_bin")){
      counts@junction.counts[, s] <- as.factor(counts@junction.counts[, s])
    }
    colnames(counts@junction.counts)[9:ncol(counts@junction.counts)] <- rownames(targets)
    junctions.order <- sort(rownames(counts@junction.counts))
    junctions.order <- strsplit2(junctions.order, "[.]")
    junctions.order <- GRanges(seqnames=junctions.order[, 1], IRanges(start=as.numeric(junctions.order[, 2]), end=as.numeric(junctions.order[, 3])))
    #junctions.order <- sort(junctions.order)
    #junctions.order <- paste(junctions.order@seqnames, junctions.order@ranges@start, (junctions.order@ranges@start+junctions.order@ranges@width-1), sep=".")
    junctions.order <- order(junctions.order)
   counts@junction.counts <- counts@junction.counts[junctions.order, ]
    
    # Create result object
    counts <- rds( counts, targets )
    gc()
    return(counts)
    
  }
)

# jCounts is a wrapper around AsDiscover for improved legibility
setGeneric (
  name= "jCounts",
  def = function( counts, 
                  features, 
                  minReadLength, 
                  threshold = 5, 
                  minAnchor = 10,
                  libType="SE",
                  strandMode=0,
                  alignFastq = FALSE, 
                  dropBAM = FALSE) standardGeneric("jCounts") )

setMethod(
  f = "jCounts",
  signature = "ASpliCounts",
  definition = function( counts, 
                         features, 
                         minReadLength, 
                         threshold = 5, 
                         minAnchor = 10,
                         libType="SE",
                         strandMode=0,
                         alignFastq = FALSE, 
                         dropBAM = FALSE) {
    if(!.hasSlot(counts, ".ASpliVersion")){
      counts@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
    }
    if(counts@.ASpliVersion == "1"){
      stop("Your version of ASpliCounts can not be used with this version of ASpli, please run gbCounts first. See vignette for details on the new pipeline.")
    }
    as <- AsDiscover( counts = counts, targets = NULL, features = features, bam = NULL, readLength = minReadLength, threshold = threshold, cores = 1, minAnchor = minAnchor,
                      libType = libType,
                      strandMode = strandMode, alignFastq = alignFastq, dropBAM = dropBAM)
    as@.ASpliVersion = "2" #Marks ASpliCounts object with the ASpli update 2.0.0    
    return(as)
  }
)

setGeneric (
  name= "AsDiscover",
  def = function( counts, 
                  targets,
                  features, 
                  bam, 
                  readLength, 
                  threshold = 5,
                  cores = 1, 
                  minAnchor = 10,
                  libType=libType,
                  strandMode=strandMode,
                  alignFastq = FALSE,
                  dropBAM = FALSE) standardGeneric("AsDiscover") )

setMethod(
  f = "AsDiscover",
  signature = "ASpliCounts",
  definition = function( counts, 
                         targets,
                         features, 
                         bam, 
                         readLength, 
                         threshold = 5,
                         cores = 1, 
                         minAnchor = 10,
                         libType=libType,
                         strandMode=strandMode,
                         alignFastq = FALSE,
                         dropBAM = FALSE) {
    
    if(!.hasSlot(counts, ".ASpliVersion")){
      counts@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
    }
    if(counts@.ASpliVersion == "1"){
      #Version conflict
      if(is.null(bam)){
        stop("Counts object is ASpli v1 but no bam was loaded. Please see vignette for new pipeline.")
      }
      .Deprecated("jCounts")
    }else{
      targets <- counts@targets
    }

    #Check if alignFastq then targets must have one extra column with fastqs.
    #Also, if not, check if all bams exist before running
    if(alignFastq){
      if(!("alignerCall" %in% colnames(targets))){
        stop("Targets data frame must have a column named alignerCall with complete call to aligner for each sample.\n ie: STAR --runMode alignReads --outSAMtype BAM SortedByCoordinate --readFilesCommand zcat --genomeDir /path/to/STAR/genome/folder -runThreadN 4 --outFileNamePrefix {sample name} --readFilesIn  /path/to/R1 /path/to/R2. Output must match bam files provided in targets.")
      }
    }else{
      #All files exist?
      bams <- targets[, "bam"]
      bamFilesExist <- file.exists(bams)
      if(!all(bamFilesExist)){
        stop(paste0("Some bam files don't exist: ", paste0(bams[!bamFilesExist], collapse=", ")))
      }
    }
    minReadLength <- readLength
    cores <- 1
    #libType=libType
    #strandMode=strandMode
    
    as  <- new(Class = "ASpliAS")
    as@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0.    
    as@targets <- targets
    
    df0 <- countsj(counts)[ countsj(counts)$multipleHit == "-", ]
    df0 <- df0[ df0$gene != "noHit" , ]
    
    targets <- .condenseTargetsConditions( targets )
    
    jcounts <- .filterJunctionBySample( df0=df0,
                                        targets=targets,
                                        threshold=threshold )
    
    # Junctions PSI:
    junctionsPSI    <- .junctionsPSI_SUM( df0, targets )
    as@junctionsPJU <- junctionsPSI
    message("Junctions PJU completed")
    
    # Junctions PIR:
    if(is.null(bam)) {
      ntargets <- nrow(targets)
      for(target in 1:ntargets){
         
        if(ntargets > 1){
        
         #Checks if must align first
         if(alignFastq){
           #Run alignment
           tryCatch(
             {
               message(paste0("Aligning using: ", targets[target, "alignerCall"]))
               system(targets[target, "alignerCall"])
             },
             error=function(cond) {
               stop(cond)
             },
             warning=function(cond) {
               stop(cond)
             },
             finally={
             }
           )
           #Check if bam exists or die
           if(!file.exists(targets[target, "bam"])){
             stop(paste0("Could not align or bam was not correctly created. Was expecting: ", targets[target, "bam"]))
           }
           
           #Make bai
           #Run alignment
           tryCatch(
             {
               message(paste0("Building bam index"))
               system(paste0("samtools index ", targets[target, "bam"]))
             },
             error=function(cond) {
               stop(cond)
             },
             warning=function(cond) {
               stop(cond)
             },
             finally={
             }
           )
           #Check if bai exists or die
           if(!file.exists(paste0(targets[target, "bam"], ".bai"))){
             stop(paste0("Could not create bai file. Make sure samtools is installed and accesible in PATH"))
           }
         }
        
         #Load bam from current target
         bam <- loadBAM(targets[target, ], cores = NULL, 
                        libType=libType, strandMode=strandMode) #With cores = NULL wont print deprecated message
         
         #If dropBAM drops bam and bai but only if alignFastq = TRUE
         if(alignFastq & dropBAM){
           file.remove(paste0(targets[target, "bam"], ".bai"))
           file.remove(targets[target, "bam"])
         }
         
         junctionsPIR <- .junctionsDiscover( df=jcounts, 
                                            minReadLength=minReadLength, 
                                            targets=targets[target, ], 
                                            features=features,
                                            minAnchor = minAnchor,
                                            bam=bam)  
        
        }

        if(ncol(as@junctionsPIR) == 0){
          as@junctionsPIR <- junctionsPIR
        }else{
          as@junctionsPIR <- cbind(as@junctionsPIR, junctionsPIR[, 3:6])
        }
      }
      junctions.order <- c(1, 2, 
                           seq(from=3, to=ncol(as@junctionsPIR), by=4),
                           seq(from=4, to=ncol(as@junctionsPIR), by=4),
                           seq(from=5, to=ncol(as@junctionsPIR), by=4))
      as@junctionsPIR <- as@junctionsPIR[, junctions.order]
      colnames(as@junctionsPIR)[c(-2, -1)] <- rep(rownames(targets), times=3)
      inicio_j1 <- 3
      inicio_j2 <- inicio_j1+nrow(targets)
      inicio_j3 <- inicio_j2+nrow(targets)
      j1 <- .sumByCond( as@junctionsPIR[, inicio_j1:(inicio_j1+nrow(targets)-1)],     targets )
      j2 <- .sumByCond( as@junctionsPIR[, inicio_j2:(inicio_j2+nrow(targets)-1)],     targets )
      j3 <- .sumByCond( as@junctionsPIR[, inicio_j3:(inicio_j3+nrow(targets)-1)],     targets )
      pirValues <- ( j1 + j2 ) / ( j1 + j2 + 2 * j3 )
      as@junctionsPIR <- cbind(as@junctionsPIR, pirValues)
    }else{
      
      junctionsPIR <- .junctionsDiscover( df=jcounts, 
                                          minReadLength=minReadLength, 
                                          targets=targets, 
                                          features=features,
                                          minAnchor = minAnchor,
                                          bam=bam) 
      as@junctionsPIR <- junctionsPIR
    }
    message("Junctions PIR completed")
    
    jranges <- .createGRangesExpJunctions( rownames( jcounts ) )
    
    # : refactor this code to other functions 
    # ---------------------------------------------------------------------- #
    # Get all bins that are intronic or are associated to a Intron retention 
    # event
    ic <- rbind( countsb(counts)[countsb(counts)$feature == "I",], 
                 countsb(counts)[countsb(counts)$feature == "Io",], 
                 countsb(counts)[countsb(counts)$event   == "IR*",],
                 countsb(counts)[countsb(counts)$event   == "IR",])
    # Get A GRanges object for intron bins, ordered by ic
    intranges <- featuresb(features)[ rownames(ic) ]
    
    # get exclusion junction counts, and make and index to ordered by ic
    dfe1e2 <- .e1e2JPIR( intranges, jcounts, targets )
    colnames(dfe1e2)[c(-1,-2)] <- rownames(targets)
    indexOrder <- match( dfe1e2$jbin, rownames( ic ) )
    
    # Get counts of inclusion junctions
    e1i <- .extractCountColumns( countse1i( counts ), targets )[ rownames(ic) ,]
    ie2 <- .extractCountColumns( countsie2( counts ), targets )[ rownames(ic) ,]
    
    j3 <- data.frame( matrix( NA, 
                              nrow =  nrow( e1i ), 
                              ncol =  length( targets$condition ) ), 
                      stringsAsFactors = FALSE )
    colnames( j3 ) <- colnames( e1i )  
    
    j3bin <- rep( NA , nrow( j3 ) )
    j3bin[ indexOrder ] <- rownames( dfe1e2 )
    j3[ indexOrder, ] <- .extractCountColumns( dfe1e2, targets )
    
    # Sum exclusion and inclusion counts by condition
    sumE1i <- .sumByCond( e1i, targets )
    sumIe2 <- .sumByCond( ie2, targets )
    sumJ3  <- .sumByCond( j3,  targets )
    
    # Calculates pir
    pirValues <- ( sumE1i + sumIe2 ) / ( sumE1i + sumIe2 + 2 * sumJ3 )  
    
    # Creates result object
    result <- cbind( 
      data.frame( event = ic$event ), 
      data.frame( J1 = paste( rownames( e1i ), "E1I", sep="_") ), 
      e1i, 
      data.frame( J2 = paste( rownames( ie2 ), "IE2", sep="_") ), 
      ie2,
      data.frame( J3 = j3bin ),
      j3, 
      pirValues ) 
    
    
    message("Junctions IR PIR completed")
    
    as@irPIR <- result
    # ---------------------------------------------------------------------- #
    
    # ---------------------------------------------------------------------- #
    # Get all exons, except those that are associated to a intron retention
    # event
    ec <- countsb(counts)[countsb(counts)$feature == "E",]
    ec <- ec[ec$event != "IR",]
    ec <- ec[ec$event != "IR*",]
    
    exranges <- featuresb( features )[ rownames( ec ) ]
    
    fillAndReorderBy <- function( df , orderNames ) {
      indexOrder <- match( rownames( df ) , orderNames )
      result <- data.frame( 
        matrix( 
          NA,
          nrow = length( orderNames ),
          ncol = ncol( df ) ) )
      result[ indexOrder, ] <- df
      colnames( result ) <- colnames( df )
      rownames( result ) <- orderNames
      return( result )
    }
    
    dfstart  <- .getJPSIByOverlap( jranges, exranges, jcounts, targets, 'start' )
    dfstart  <- fillAndReorderBy( dfstart , rownames( ec ) )
    dfend    <- .getJPSIByOverlap( jranges, exranges, jcounts, targets, 'end' )   
    dfend    <- fillAndReorderBy( dfend , rownames( ec ) )
    dfwithin <- .getJPSIByOverlap( jranges, exranges, jcounts, targets, 'within' )
    dfwithin <- fillAndReorderBy( dfwithin , rownames( ec ) )
    
    events   <- mcols( exranges ) $ event
    # ---------------------------------------------------------------------- #
    
    # ---------------------------------------------------------------------- #
    # Get the subset of previosly selected exons and gets only those associated
    # with an alternative splicing site usage event 
    getAlternativeSS <- function( df, events ) {
      rbind(
        df[ events == "Alt3ss", ],
        df[ events == "Alt5ss", ],
        df[ events == "Alt3ss*", ],
        df[ events == "Alt5ss*", ] )
    }
    
    altJ1 <- getAlternativeSS( dfstart , events )
    altJ2 <- getAlternativeSS( dfend , events )
    altJ3 <- getAlternativeSS( dfwithin , events )
    colnames(altJ1)[-ncol(altJ1)] <- rownames(targets)
    colnames(altJ2)[-ncol(altJ2)] <- rownames(targets)
    colnames(altJ3)[-ncol(altJ3)] <- rownames(targets)
      
    sumAltJ1 <- .sumByCond( .extractCountColumns( altJ1, targets ), targets )
    sumAltJ1[is.na(sumAltJ1)] <- 0 
    sumAltJ2 <- .sumByCond( .extractCountColumns( altJ2, targets ), targets )
    sumAltJ2[is.na(sumAltJ2)] <- 0
    sumAltJ3 <- .sumByCond( .extractCountColumns( altJ3, targets ), targets )
    sumAltJ3[is.na(sumAltJ3)] <- 0
    
    altPsiValues <- ( sumAltJ1 + sumAltJ2 ) / ( sumAltJ1 + sumAltJ2 + sumAltJ3 )
    
    result <- cbind( 
      data.frame( event = mcols( exranges[ rownames( altJ1) ] )$ event ), 
      data.frame( J1 = altJ1$overlappedSubjectNames ), 
      .extractCountColumns( altJ1, targets ),
      data.frame( J2 = altJ2$overlappedSubjectNames ), 
      .extractCountColumns( altJ2, targets ),
      data.frame( J3 = altJ3$overlappedSubjectNames ),
      .extractCountColumns( altJ3, targets ), 
      altPsiValues )
    
    message("Junctions AltSS PSI completed")
    altPSI( as ) <- result
    # ---------------------------------------------------------------------- #
    
    # ---------------------------------------------------------------------- #
    # Get the subset of previosly selected exons and gets only those associated
    # with an exon skipping event and those not assigned to any splice event.  
    getES <- function( df, events ) {
      rbind(
        df[ events == "ES", ],
        df[ events == "-", ],
        df[ events == "ES*", ] )
    }
    
    esJ1 <- getES( dfstart , events )
    esJ2 <- getES( dfend , events )
    esJ3 <- getES( dfwithin , events )
    colnames(esJ1)[-ncol(esJ1)] <- rownames(targets)
    colnames(esJ2)[-ncol(esJ2)] <- rownames(targets)
    colnames(esJ3)[-ncol(esJ3)] <- rownames(targets)
    
    sumEsJ1 <- .sumByCond( .extractCountColumns( esJ1, targets ), targets )
    sumEsJ1[is.na(sumEsJ1)] <- 0 
    sumEsJ2 <- .sumByCond( .extractCountColumns( esJ2, targets ), targets )
    sumEsJ2[is.na(sumEsJ2)] <- 0
    sumEsJ3 <- .sumByCond( .extractCountColumns( esJ3, targets ), targets )
    sumEsJ3[is.na(sumEsJ3)] <- 0
    
    esPsiValues <- ( sumEsJ1 + sumEsJ2 ) / ( sumEsJ1 + sumEsJ2 + 2 * sumEsJ3 )
    
    result <- cbind( 
      data.frame( event = mcols( exranges[ rownames( esJ1) ] )$ event ), 
      data.frame( J1 = esJ1$overlappedSubjectNames ), 
      .extractCountColumns( esJ1, targets ), 
      data.frame( J2 = esJ2$overlappedSubjectNames ), 
      .extractCountColumns( esJ2, targets ),
      data.frame( J3 = esJ3$overlappedSubjectNames ),
      .extractCountColumns( esJ3, targets ),
      esPsiValues )
    
    message("Junctions ES PSI completed")
    
    esPSI( as ) <- result
    # ---------------------------------------------------------------------- #
    
    # TODO: joint podria ser un getter, pero no es necesario mantener toda
    # esta data repetida
    joint( as ) <- rbind( altPSI( as ), esPSI( as ), irPIR( as ) )
    
    return( as )
    
  })

setMethod( 
  f = 'subset',
  signature = 'ASpliAS',
  def = function( x, targets, select) .subset.ASpliAS( x, targets, select ) )

# ---------------------------------------------------------------------------- #
# writeAS
setGeneric (
  name = "writeAS",
  def  = function(as, output.dir = "as" )
    standardGeneric( "writeAS" ) )

setMethod(
  f = "writeAS",
  signature = "ASpliAS",
  definition = function( as, output.dir = "as" ) {
    
    # Creates output folder structure
    exonsFilePSI     <- file.path( output.dir, "exons", "exon.altPSI.tab" )       
    exonsFileES      <- file.path( output.dir, "exons", "exon.altES.tab" )       
    intronsFile      <- file.path( output.dir, "introns", "intron.irPIR.tab" )
    junctionsFilePIR <- file.path( output.dir, "junctions", "junction.PIR.tab" )
    junctionsFilePSI <- file.path( output.dir, "junctions", "junction.PSI.tab" )
    asDiscoverFile   <- file.path( output.dir, "as_discovery.tab" )
    
    file.exists( output.dir ) || dir.create( output.dir )
    for ( folder in unique( lapply( c( exonsFilePSI, exonsFileES, intronsFile, 
                                       junctionsFilePIR, junctionsFilePSI ), dirname ) ) ) {
      dir.create( folder )
    }
    
    # Export exons
    write.table( altPSI(as), exonsFilePSI, sep="\t", quote=FALSE, col.names=NA)
    write.table( esPSI(as), exonsFileES, sep="\t", quote=FALSE, col.names=NA)
    
    # Export Introns
    write.table( irPIR(as), intronsFile, sep="\t", quote=FALSE, col.names=NA)
    
    # Export Junctions
    write.table(junctionsPIR(as), junctionsFilePIR, sep="\t", quote=FALSE, col.names=NA)
    write.table(junctionsPJU(as), junctionsFilePSI, sep="\t", quote=FALSE, col.names=NA)
    
    # Export AS discovery table
    write.table( joint(as), asDiscoverFile, sep="\t", quote=FALSE, col.names=NA)
  }
)

# TODO:  Es necesario agregar todos los parametros con valores por default en
# la firma del metodo ? 
setGeneric (
  name = "DUreport.norm",
  def = function( counts, 
                  minGenReads  = 10,
                  minBinReads  = 5,
                  minRds = 0.05,
                  contrast = NULL,
                  ignoreExternal = TRUE,
                  ignoreIo = TRUE, 
                  ignoreI = FALSE,
                  filterWithContrasted = TRUE,
                  verbose = FALSE,
                  threshold = 5
  ) standardGeneric("DUreport.norm") )

#setGeneric (
#  name = "DUreport_DEXSeq",
#  def = function ( counts, ... ) standardGeneric("DUreport_DEXSeq") )

setMethod(
  f = "DUreport.norm",
  signature = "ASpliCounts",
  definition = function( counts, 
                         minGenReads  = 10,
                         minBinReads  = 5,
                         minRds = 0.05,
                         contrast = NULL,
                         ignoreExternal = TRUE,
                         ignoreIo = TRUE, 
                         ignoreI = FALSE,
                         filterWithContrasted = TRUE,
                         verbose = FALSE,
                         threshold = 5
  ) { 
    offset = FALSE
    offsetAggregateMode = c( "geneMode", "binMode" )[1]
    offsetUseFitGeneX = TRUE    
    .DUreport( counts, counts@targets, minGenReads, minBinReads, minRds, offset, 
               offsetAggregateMode, offsetUseFitGeneX, contrast, 
               ignoreExternal, ignoreIo, ignoreI, filterWithContrasted, verbose, threshold  )
  }
)

setGeneric (
  name = "DUreport.offset",
  def = function( counts, 
                  minGenReads  = 10,
                  minBinReads  = 5,
                  minRds = 0.05,
                  offsetAggregateMode = c( "geneMode", "binMode" )[1],
                  offsetUseFitGeneX = TRUE,
                  contrast = NULL,
                  ignoreExternal = TRUE,
                  ignoreIo = TRUE, 
                  ignoreI = FALSE,
                  filterWithContrasted = TRUE,
                  verbose = FALSE
  ) standardGeneric("DUreport.offset") )

setMethod(
  f = "DUreport.offset",
  signature = "ASpliCounts",
  definition = function( counts, 
                         minGenReads  = 10,
                         minBinReads  = 5,
                         minRds = 0.05,
                         offsetAggregateMode = c( "geneMode", "binMode" )[1],
                         offsetUseFitGeneX = TRUE,
                         contrast = NULL,
                         ignoreExternal = TRUE,
                         ignoreIo = TRUE, 
                         ignoreI = FALSE,
                         filterWithContrasted = TRUE,
                         verbose = FALSE
  ) { 
    offset = TRUE
    .DUreport( counts, counts@targets, minGenReads, minBinReads, minRds, offset, 
               offsetAggregateMode, offsetUseFitGeneX, contrast,                ignoreExternal, ignoreIo, ignoreI, filterWithContrasted, verbose  )
  }
)


setGeneric( name = 'gbDUreport',
            def = function( counts, 
                            minGenReads  = 10, minBinReads = 5, 
                            minRds = 0.05, contrast = NULL, 
                            ignoreExternal = TRUE, ignoreIo = TRUE, 
                            ignoreI = FALSE, 
                            filterWithContrasted = TRUE, 
                            verbose = TRUE, 
                            formula = NULL, coef = NULL ) 
              standardGeneric( 'gbDUreport'))

setMethod( 
  f = 'gbDUreport',
  signature = 'ASpliCounts',
  definition = function( counts, 
                         minGenReads  = 10, 
                         minBinReads = 5,
                         minRds = 0.05, 
                         contrast = NULL, 
                         ignoreExternal = TRUE,
                         ignoreIo = TRUE, 
                         ignoreI = FALSE, 
                         filterWithContrasted = TRUE,
                         verbose = TRUE, 
                         formula = NULL,
                         coef = NULL) {
  if(!.hasSlot(counts, ".ASpliVersion")){
    counts@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
  }
  if(counts@.ASpliVersion == "1"){
    stop("Your version of ASpliCounts can not be used with this version of ASpli, please run gbCounts first. See vignette for details on the new pipeline.")
  }
  
  du <- .DUreportBinSplice( counts, targets = NULL, minGenReads, minBinReads, minRds, 
                            contrast, forceGLM = NULL, ignoreExternal, ignoreIo, ignoreI, 
                            filterWithContrasted, verbose, formula, coef ) #forceGLM was deprecated
  du@.ASpliVersion <- "2"
  return(du)  
})

setGeneric( name = 'DUreportBinSplice',
            def = function( counts, targets, minGenReads  = 10, minBinReads = 5, 
                            minRds = 0.05, contrast = NULL, forceGLM = FALSE,  
                            ignoreExternal = TRUE, ignoreIo = TRUE, ignoreI = FALSE, 
                            filterWithContrasted = FALSE, verbose = TRUE ) 
              standardGeneric( 'DUreportBinSplice'))

setMethod( 
  f = 'DUreportBinSplice',
  signature = 'ASpliCounts',
  definition = function( counts, 
                         targets, 
                         minGenReads  = 10, 
                         minBinReads = 5,
                         minRds = 0.05, 
                         contrast = NULL, 
                         forceGLM = FALSE, 
                         ignoreExternal = TRUE,
                         ignoreIo = TRUE, 
                         ignoreI = FALSE, 
                         filterWithContrasted = TRUE,
                         verbose = TRUE ) {
    .Deprecated("gbDUreport")
    du <- .DUreportBinSplice( counts, targets, minGenReads, minBinReads, minRds, 
                              contrast, forceGLM, ignoreExternal, ignoreIo, ignoreI, 
                              filterWithContrasted, verbose = TRUE ) 
    du@.ASpliVersion <- "1"
    return(du)
  })


setGeneric( name = "junctionDUreport",
            def = function (  counts, 
                              targets, 
                              appendTo = NULL, 
                              minGenReads = 10,
                              minRds = 0.05,
                              threshold = 5,
                              offset   = FALSE,
                              offsetUseFitGeneX = TRUE,
                              contrast = NULL,
                              forceGLM = FALSE 
            ) standardGeneric("junctionDUreport") )


setMethod(
  f = "junctionDUreport",
  signature = "ASpliCounts",
  definition = function ( 
    counts, 
    targets, 
    appendTo = NULL,
    minGenReads = 10,
    minRds = 0.05,
    threshold = 5,
    offset = FALSE,
    offsetUseFitGeneX = TRUE,
    contrast = NULL,
    forceGLM = FALSE 
    # -------------------------------------------------------------------- #
    # Comment to disable priorcounts usage in bin normalization 
    # , priorCounts = 0 
    # -------------------------------------------------------------------- #
  ) {
    .Deprecated("jDUreport")
    .junctionDUreport( counts, targets, appendTo,  minGenReads,  minRds, 
                       threshold, offset, offsetUseFitGeneX, contrast, 
                       forceGLM ) 
  }
)

setGeneric( name = "jDUreport",
            def = function (asd, 
                            minAvgCounts                       = 5, 
                            contrast                           = NULL,
                            filterWithContrasted               = TRUE,
                            runUniformityTest                  = FALSE,
                            mergedBams                         = NULL,
                            maxPValForUniformityCheck          = 0.2,
                            strongFilter                       = TRUE,
                            maxConditionsForDispersionEstimate = 24,
                            formula                            = NULL,
                            coef                               = NULL,
                            maxFDRForParticipation             = 0.05,
                            useSubset                          = FALSE
            ) standardGeneric("jDUreport") )


setMethod(
  f = "jDUreport",
  signature = "ASpliAS",
  definition = function (
    asd,
    minAvgCounts                       = 5, 
    contrast                           = NULL,
    filterWithContrasted               = TRUE,
    runUniformityTest                  = FALSE,
    mergedBams                         = NULL,
    maxPValForUniformityCheck          = 0.2,
    strongFilter                       = TRUE,
    maxConditionsForDispersionEstimate = 24,
    formula                            = NULL,
    coef                               = NULL,
    maxFDRForParticipation             = 0.2,
    useSubset                          = FALSE
  ) {

    if(!.hasSlot(asd, ".ASpliVersion")){
      asd@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
    }
    if(asd@.ASpliVersion == "1"){
      stop("Your version of ASpliAS can not be used with this version of ASpli, please run jCounts first. See vignette for details on the new pipeline.")
    }
    jdu <- .junctionDUreportExt( asd, 
                                 minAvgCounts, 
                                 contrast, 
                                 filterWithContrasted, 
                                 runUniformityTest, 
                                 mergedBams, 
                                 maxPValForUniformityCheck, 
                                 strongFilter,
                                 maxConditionsForDispersionEstimate, 
                                 formula, 
                                 coef, 
                                 maxFDRForParticipation, 
                                 useSubset) 
    jdu@.ASpliVersion <- "2"
    return(jdu)
  }
)


setGeneric( name = "splicingReport",
            def = function (bdu, 
                            jdu, 
                            counts
            ) standardGeneric("splicingReport") )


setMethod(
  f = "splicingReport",
  signature = "ASpliDU",
  definition = function (
    bdu,
    jdu,
    counts
  ) {
    if(!.hasSlot(bdu, ".ASpliVersion")){
      bdu@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
    }
    if(bdu@.ASpliVersion == "1"){
      stop("Your version of ASpliDU can not be used with this version of ASpli, please run gbDUreport first. See vignette for details on the new pipeline.")
    }
    if(!.hasSlot(jdu, ".ASpliVersion")){
      jdu@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
    }
    if(jdu@.ASpliVersion == "1"){
      stop("Your version of ASpliJDU can not be used with this version of ASpli, please run jDUreport first. See vignette for details on the new pipeline.")
    }
    if(!.hasSlot(counts, ".ASpliVersion")){
      counts@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
    }
    if(counts@.ASpliVersion == "1"){
      stop("Your version of ASpliCounts can not be used with this version of ASpli, please run gbCounts first. See vignette for details on the new pipeline.")
    }    
    sr <- .splicingReport( bdu, jdu, counts ) 
    sr@.ASpliVersion = "2"
    return(sr)
  }
)

setGeneric( name = "integrateSignals",
            def = function (sr = NULL,
                            asd = NULL, 
                            bin.FC = 3,
                            bin.fdr = 0.05,
                            nonunif = 1,
                            usenonunif = FALSE,
                            bin.inclussion = 0.2,
                            bjs.inclussion = 10.3,
                            bjs.fdr = 0.01,
                            a.inclussion = 0.3,
                            a.fdr = 0.01,
                            l.inclussion = 0.3,
                            l.fdr = 0.01,
                            otherSources = NULL,
                            overlapType = "any"
            ) standardGeneric("integrateSignals") )


setMethod(
  f = "integrateSignals",
  signature = "ASpliSplicingReport",
  definition = function (
    sr = NULL,
    asd = NULL, 
    bin.FC = 3,
    bin.fdr = 0.05,
    nonunif = 1,
    usenonunif = FALSE,
    bin.inclussion = 0.2,
    bjs.inclussion = 10.3,
    bjs.fdr = 0.01,
    a.inclussion = 0.3,
    a.fdr = 0.01,
    l.inclussion = 0.3,
    l.fdr = 0.01,
    otherSources = NULL,
    overlapType = "any"
  ) {
    if(!.hasSlot(sr, ".ASpliVersion")){
      sr@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
    }
    if(sr@.ASpliVersion == "1"){
      stop("Your version of ASpliSplicingReport can not be used with this version of ASpli, please run splicingReport first. See vignette for details on the new pipeline.")
    }
    if(!.hasSlot(asd, ".ASpliVersion")){
      asd@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
    }
    if(asd@.ASpliVersion == "1"){
      stop("Your version of ASpliAS can not be used with this version of ASpli, please run jCounts first. See vignette for details on the new pipeline.")
    }    
    is <- .integrateSignals(sr, asd, bin.FC, bin.fdr, nonunif, usenonunif, bin.inclussion, bjs.inclussion, bjs.fdr, a.inclussion, a.fdr,
                      l.inclussion, l.fdr, otherSources, overlapType) 
    is@.ASpliVersion = "2"
    return(is)
  }
)

setMethod( f = 'subset',
           signature = 'ASpliCounts',
           def = function( x, targets, select ) { .subset.ASpliCounts( x, targets, select ) }  )

setGeneric( 
  name = 'filterDU',
  def = function( du, what = c( 'genes','bins','junctions'), fdr = 1, 
                  logFC = 0, absLogFC = TRUE, logFCgreater = TRUE ) standardGeneric('filterDU') )

setMethod(
  f = 'filterDU',
  signature = "ASpliDU",
  definition = function( du, what = c( 'genes','bins','junctions'), fdr = 1, 
                         logFC = 0, absLogFC = TRUE, logFCgreater = TRUE ) {
    .Deprecated("", msg = "filterDU is deprecated and is no longer needed. See ASpli vignette for new pipeline.")
    .filter.ASpliDU( du, what, fdr, logFC, absLogFC, logFCgreater ) } )


# ---------------------------------------------------------------------------- #
# writeDU

setGeneric( name = 'containsGenesAndBins', 
            def = function ( du ) standardGeneric("containsGenesAndBins") )

setMethod( f = 'containsGenesAndBins', 
           signature = "ASpliDU",
           definition = function ( du ) {
             nrow( genesDE( du ) ) > 0  & nrow( binsDU( du) ) > 0 
           } )

setGeneric( name = 'containsJunctions', 
            def = function ( du ) standardGeneric("containsJunctions") )

setMethod( f = 'containsJunctions', 
           signature = "ASpliDU",
           definition = function ( du ) {
             nrow( junctionsDU( du ) ) > 0
           } )

setGeneric( name = "writeDU", 
            def = function ( du, output.dir="du"  ) standardGeneric( "writeDU" ) )

setMethod(
  f = "writeDU",
  signature = "ASpliDU",
  definition = function( du, output.dir="du" ) {

    file.exists( output.dir ) || dir.create( output.dir , recursive = TRUE)
    output.dir <- paste(output.dir, paste(names(du@contrast)[du@contrast != 0], collapse="-"), sep="/")
    file.exists( output.dir ) || dir.create( output.dir , recursive = TRUE )

    if ( containsGenesAndBins( du ) ) {
      # Export Genes  
      write.table( genesDE( du ), paste(normalizePath(output.dir), "gene.de.tab", sep="/"), sep = "\t", quote = FALSE, 
                   col.names = NA )
      
      # Export Exons
      exonBins <- binsDU(du)[binsDU(du)$feature == "E",]
      exonBins <- exonBins[exonBins$event !="IR",]
      write.table( exonBins, paste(normalizePath(output.dir), "exon.du.tab", sep="/"), sep="\t", quote=FALSE, col.names=NA)
      
      # Export Introns 
      intronBins <- rbind( 
        binsDU(du)[binsDU(du)$feature == "I" ,], 
        binsDU(du)[binsDU(du)$feature == "Io",],
        binsDU(du)[binsDU(du)$event   == "IR",])
      write.table( intronBins, paste(normalizePath(output.dir), "intron.du.tab", sep="/"), sep = "\t", quote = FALSE, 
                   col.names = NA )
    }
    # Export Junctions
    if ( containsJunctions( du ) ) {
      write.table( junctionsDU( du ), paste(normalizePath(output.dir), "junction.du.tab", sep="/"), sep = "\t", quote = FALSE, 
                   col.names=NA )
    }
  }
)

setGeneric( name = "writeJDU", 
            def = function ( jdu, output.dir="jdu"  ) standardGeneric( "writeJDU" ) )

setMethod(
  f = "writeJDU",
  signature = "ASpliJDU",
  definition = function( jdu, output.dir="jdu" ) {
    
    file.exists( output.dir ) || dir.create( output.dir , recursive = TRUE )
    output.dir <- paste(output.dir, paste(names(jdu@contrast)[jdu@contrast != 0], collapse="-"), sep="/")
    file.exists( output.dir ) || dir.create( output.dir , recursive = TRUE )
    
    for(slotName in slotNames(jdu)){
      # Export Genes  
      write.table( slot(jdu, slotName), paste(output.dir, paste0(slotName, ".txt"), sep="/"), sep = "\t", quote = FALSE, col.names = NA, row.names = TRUE )
    }
    
  }
)

setGeneric( name = "writeSplicingReport", 
            def = function ( sr, output.dir="sr"  ) standardGeneric( "writeSplicingReport" ) )

setMethod(
  f = "writeSplicingReport",
  signature = "ASpliSplicingReport",
  definition = function( sr, output.dir="sr" ) {
    
    file.exists( output.dir ) || dir.create( output.dir , recursive = TRUE)
    
    for(slotName in slotNames(sr)){
      # Export Genes  
      if(class(slot(sr, slotName)) == "data.frame"){
        write.table( slot(sr, slotName), paste(output.dir, paste0(slotName, ".txt"), sep="/"), sep = "\t", 
                     quote = FALSE, col.names = TRUE, row.names = FALSE )
      }
    }
    
  }
)


setGeneric( name = 'mergeBinDUAS',
            def = function( du, as, targets, contrast = NULL  ) 
              standardGeneric( 'mergeBinDUAS' ))

setMethod( f = 'mergeBinDUAS',
           signature = c( 'ASpliDU', 'ASpliAS' ),
           definition = function( du, as, targets, contrast = NULL  ) {
             .Deprecated("", msg = "mergeBinDUAS is deprecated and is no longer needed. See ASpli vignette for new pipeline.")
             .mergeBinDUAS( du, as, targets, contrast ) } )


setGeneric( name = "exportSplicingReports", 
            def = function ( sr, output.dir="sr" , openInBrowser = FALSE, maxBinFDR = 0.2, maxJunctionFDR = 0.2 ) standardGeneric( "exportSplicingReports" ) )

setMethod(
  f = "exportSplicingReports",
  signature = "ASpliSplicingReport",
  definition = function( sr, output.dir="sr" , openInBrowser = FALSE, maxBinFDR = 0.2, maxJunctionFDR = 0.2 ) {
    output.dir <- paste0(output.dir, "/", paste0(names(sr@contrast)[sr@contrast != 0], collapse="-"))
    file.exists( output.dir ) || dir.create( output.dir , recursive = TRUE)
    
    
    for(s in slotNames(sr)){
      if(class(slot(sr, s)) == "data.frame"){
        b <- slot(sr, s)
        if(s == "binbased"){
            b <- b[union(which(b$bin.fdr < maxBinFDR), which(b$junction.fdr < maxJunctionFDR)), ]
            b$feature <- as.factor(b$feature)
            b$bin.event <- as.factor(b$bin.event)
            #b[, c(10:12, 15:ncol(b))] <- apply(b[, c(10:12, 15:ncol(b))], 2, function(s){return(signif(as.numeric(s), digits = 4))})
        }else{
            b <- b[union(which(b$bin.fdr < maxBinFDR), which(b$cluster.fdr < maxJunctionFDR)), ] 
        }
        if(nrow(b)==0){
          cat("Not a single",s,"event passed the filtering step. You might consider relaxing thresholds.\n")
          next
        }
        columnas_numericas <- which(sapply(b, class) == "numeric")
	      b[, columnas_numericas] <- apply(b[, columnas_numericas], 2, function(s){return(signif(as.numeric(s), digits = 4))})
        titulo <- paste0('ASpli: ', s, ". Contrasts: ", paste(names(sr@contrast)[sr@contrast != 0], collapse = " - "))
        if(s != "localebased"){
          y <- datatable(b,
                         escape = TRUE,
                         filter ="top",
                         extensions = c('Buttons', 'KeyTable'), 
                         options = list(dom = 'lfrtBip',
                                        buttons = c('copy', 'csv', 'excel', 'pdf', 'print', I('colvis')),
                                        columnDefs = list(
                                          #  list(visible = FALSE, targets = c(0, 2, 3)),
                                          list(orderable = FALSE, className =
                                                 'details-control', targets = 1)
                                        ),
                                        keys = TRUE
                         ),   caption = htmltools::tags$caption(
                           style = 'caption-side: top; text-align: left;',
                           htmltools::h1(titulo)
                         ))    
        }else{
          clusters  <- unique(b[, c("junction.cluster", "cluster.locus", "cluster.size", "cluster.LR", "cluster.pvalue", "cluster.fdr", "cluster.range", "cluster.participation")])
          
          b <- slot(sr, s)
          columnas_numericas <- which(sapply(b, class) == "numeric")
          b[, columnas_numericas] <- apply(b[, columnas_numericas], 2, function(s){return(signif(as.numeric(s), digits = 4))})
          
          junctions <- unique(b[, c("junction.cluster", colnames(b)[!colnames(b) %in% colnames(clusters)])])
          colnames(clusters)[1] <- "cluster"
          subtables <- "var subtables = [];"
          
          for (i in clusters$cluster) {
            cluster_junctions <- junctions[junctions$junction.cluster == i, ]
            datos_bin         <- data.frame(bin = as.character(aggregate(bin ~ junction, cluster_junctions, FUN=function(s){paste(s, collapse=";")}, na.action=na.pass)[, 2]),
                                            bin.pvalue = as.character(aggregate(bin.pvalue ~ junction, cluster_junctions, FUN=function(s){paste(s, collapse=";")}, na.action=na.pass)[, 2]),
                                            bin.fdr = as.character(aggregate(bin.fdr ~ junction, cluster_junctions, FUN=function(s){paste(s, collapse=";")}, na.action=na.pass)[, 2]),
                                            stringsAsFactors = FALSE)
            cluster_junctions <- unique(cluster_junctions[, !colnames(cluster_junctions) %in% c("bin", "bin.pvalue", "bin.fdr")])
            cluster_junctions <- data.frame(cluster_junctions, datos_bin)
            subtables <- paste0(subtables, "subtables[", i, "] = '<table><tr>")
            subtables <- paste0(subtables, paste0(paste0("<th bgcolor=\"#808080\">", colnames(cluster_junctions), "</th>"), collapse=""))
            color <- "#FFFFFF"
            subtables <- paste0(subtables, "</tr>")         
            for(j in 1:nrow(cluster_junctions)){
              subtables <- paste0(subtables, '<tr>')
              aux <- gsub("rcolor", color, paste0(paste0("<td bgcolor=\"rcolor\">", cluster_junctions[j, ], "</td>"), collapse=""))
              subtables <- paste0(subtables, aux)
              subtables <- paste0(subtables, "</tr>")
              color <- ifelse(color == "#FFFFFF", "#CDCDCD", "#FFFFFF")
            }
            subtables <- paste0(subtables, "</table>';")
          }
                      
          text <- ";var format = function(d) { text = '<div>' + subtables[d[1]] + '</div>'; return text;};"
          y <- datatable(cbind(' ' = '&oplus;', clusters),
                         rownames = FALSE,
                         escape = -1,
                         filter ="top",
                         fillContainer = FALSE,
                         extensions = c('Buttons', 'KeyTable'), 
                         options = list(dom = 'lfrtBip',
                                        buttons = c('copy', 'csv', 'excel', 'pdf', 'print', I('colvis')),
                                        columnDefs = list(
                                          #  list(visible = FALSE, targets = c(0, 2, 3)),
                                          list(orderable = FALSE, className =
                                                 'details-control', targets = 0)
                                        ),
                                        keys = TRUE
                         ),   caption = htmltools::tags$caption(
                           style = 'caption-side: top; text-align: left;',
                           htmltools::h1(titulo)
                         ), 
                         callback = JS(paste0("
                                      table.order([5, 'asc']).draw();
                                      table.column(0).nodes().to$().css({cursor: 'pointer'});",
                                      subtables,
                                      text,
                                      " 
                                        table.on('click', 'td.details-control', function() {
                                         var td = $(this), row = table.row(td.closest('tr'));
                                         if (row.child.isShown()) {
                                            row.child.hide();
                                            td.html('&oplus;');
                                        } else {
                                            row.child(format(row.data())).show();
                                            td.html('&CircleMinus;');
                                        }
                                     });"))
                  )       
        }
        ffile <- paste0(normalizePath(output.dir), "/", s, "Report.html")
        suppressWarnings(saveWidget(y, file = ffile, selfcontained = FALSE, title = paste0(names(sr@contrast)[sr@contrast != 0], collapse="-")))
        if(openInBrowser == TRUE) browseURL(ffile)
      }
    }    
  }
)

setGeneric( name = "exportIntegratedSignals", 
            def = function ( is, output.dir="is", 
                             sr, counts, features, asd,
                             mergedBams, 
                             jCompletelyIncluded = FALSE, 
                             zoomRegion = 1.5, 
                             useLog = FALSE, 
                             tcex = 1, 
                             ntop = NULL, 
                             openInBrowser = FALSE, 
                             makeGraphs = TRUE,
                             bforce=FALSE
                             ) standardGeneric( "exportIntegratedSignals" ) )

setMethod(
  f = "exportIntegratedSignals",
  signature = "ASpliIntegratedSignals",
  definition = function( is, output.dir="is", sr, counts, features, asd, mergedBams, jCompletelyIncluded = FALSE, zoomRegion = 1.5, useLog = FALSE, tcex = 1, ntop = NULL, 
                         openInBrowser = FALSE, makeGraphs = TRUE,bforce=FALSE) {

    if(class(is) != "ASpliIntegratedSignals"){
      stop("is must be an ASpliIntegratedSignals object")
    }
        
    if(class(sr) != "ASpliSplicingReport"){
      stop("sr must be an ASpliSplicingReport object")
    }

    if(class(counts) != "ASpliCounts"){
      stop("counts must be an ASpliCounts object")
    }

    if(class(features) != "ASpliFeatures"){
      stop("features must be an ASpliFeatures object")
    }
    
    if(class(asd) != "ASpliAS"){
      stop("asd must be an ASpliAS object")
    }
    
    if(nrow(mergedBams) > 4 & makeGraphs == TRUE){
      continue <- ""
      while(!continue %in% c("y", "n")){
        continue <- readline(prompt=paste("Warning, we are about to generate", nrow(mergedBams), "images for every event. This could take too long, do you want to continue? (y/n)"))
      }
      if(continue == "n"){
        return()
      }
    }
    filters <- is@filters
    is <- is@signals
    
    saux <- names(sr@contrast)[sr@contrast != 0]
    ina <- which(is.na(match(saux,mergedBams$condition)))
    if(length(ina)>0){
      stop("Check merged-bams data.frame.\nContrast condition(s)", paste(saux[ina],collapse=", ")," not found in any merged-bam data.frame condition category.")  
    }
    
    mergedBams <- mergedBams[mergedBams$condition %in% saux, ]
    if(nrow(mergedBams) == 0 ){
      stop("Merged bams dont match with contrasts")  
    }
    
    output.dir <- paste0(output.dir, "/", paste0(names(sr@contrast)[sr@contrast != 0], collapse="-"))
    output.dir <- substr(output.dir, 1, 255) #maximum dir length is 255
    file.exists( output.dir ) || dir.create( output.dir, recursive = TRUE)
    file.exists( paste0(output.dir, "/img") ) || dir.create( paste0(output.dir, "/img") )
    
    is$feature[is.na(is$feature)] <- "-"
    is$b <- as.factor(is$b)
    is$bjs <- as.factor(is$bjs)
    is$ja <- as.factor(is$ja)
    is$jl <- as.factor(is$jl)
    is$feature <- as.factor(is$feature)
    is$bin.event <- as.factor(is$bin.event)
    
  
    is$b.fdr <- signif(as.numeric(is$b.fdr), 4)
    is$b.logfc <- signif(as.numeric(is$b.logfc), 4)    
    is$bjs.lr <- signif(as.numeric(is$bjs.lr), 4)
    is$bjs.fdr <- signif(as.numeric(is$bjs.fdr), 4)    
    is$bjs.nonuniformity <- signif(as.numeric(is$bjs.nonuniformity), 4)
    is$bjs.inclussion <- signif(as.numeric(is$bjs.inclussion), 4)    
    is$a.lr <- signif(as.numeric(is$a.lr), 4)
    is$a.fdr <- signif(as.numeric(is$a.fdr), 4)        
    is$a.nonuniformity <- signif(as.numeric(is$a.nonuniformity), 4)
    is$l.lr <- signif(as.numeric(is$l.lr), 4)    
    is$l.fdr <- signif(as.numeric(is$l.fdr), 4)
    is$l.participation <- signif(as.numeric(is$l.participation), 4)    
    is$l.dparticipation <- signif(as.numeric(is$l.dparticipation), 4)
    is$a.dpir <- signif(as.numeric(is$a.dpir), 4)        
     
    is$bjs.inclussion_sign <- as.factor(.my_replace_na(sign(as.numeric(is$bjs.inclussion)), 0))     
    is$a.dpir_sign <- as.factor(.my_replace_na(sign(as.numeric(is$a.dpir)), 0))    
    is$a.dpir      <- abs(is$a.dpir)
    

    message("Generating graphs...")
    if(!is.numeric(ntop)){
        ntop <- length(is$region)
    }else{
      if(ntop < 1){
        ntop <- length(is$region)
      }
    }
    if(ntop > 1){
      pb <- txtProgressBar(min=1,max=ntop,style=3)
      if(makeGraphs){
        for(i in 1:ntop){
          r <- is$region[i]
          #if(i %% 10 == 0){
          # message(paste0(signif(i/ntop, 2)*100, "% completed"))
          #}
          setTxtProgressBar(pb,i)
          tryCatch({
            if(bforce | !file.exists(paste0(normalizePath(output.dir), "/img/", r, "_gene.png"))){
              png(width = 1400, height=700, filename = paste0(normalizePath(output.dir), "/img/", gsub("-", "_", gsub(":", "_", r)), "_gene.png"))
              .plotSplicingPattern(r, is, counts, features, mergedBams, sr, asd, genePlot = TRUE, jCompletelyIncluded, zoomRegion, useLog, tcex)
              dev.off()
            }
          }, warning = function(warning_condition) {
              #message(warning_condition)   
              #dev.off()
          }, error = function(error_condition) {
              #message(error_condition)
              #dev.off()
          }, finally={
            
          })
        }
      }
    }
    #close(pb)
    titulo <- paste(paste('ASpli: integrated signals. Contrasts:', 
                     paste(names(sr@contrast)[sr@contrast != 0], collapse = " - ")))
    sketch = htmltools::withTags(table(
      class = 'display',
      tags$thead(
        tags$tr(
          tags$th(rowspan = 2, 'View'),
          tags$th(rowspan = 2, 'Region'),
          tags$th(rowspan = 2, 'Event'),
          tags$th(rowspan = 2, 'Locus'),
          tags$th(rowspan = 2, 'Locus overlap'),
          tags$th(rowspan = 2, 'Bin Evidence'),
          tags$th(rowspan = 2, 'Bin SJ Evidence'),
          tags$th(rowspan = 2, 'Anchor Evidence'),
          tags$th(rowspan = 2, 'Locale Evidence'),
          tags$th(rowspan = 2, 'Bin'),
          tags$th(rowspan = 2, 'Feature'),
          tags$th(colspan = 2, 'Bins', bgcolor="#DCDCDC"),
          tags$th(colspan = 5, 'Bin Supporting Junctions', bgcolor="#C0C0C0"),
          tags$th(colspan = 5, 'Anchor Junctions', bgcolor="#DCDCDC"),
          tags$th(colspan = 5, 'Locale Junctions', bgcolor="#C0C0C0")
        ),
        tags$tr(
          lapply(c("logFC", "FDR", "LR", "FDR", "Non Uniformity", "dInclussion", "Sign Inclussion", "LR", "FDR", "Non uniformity", "dInclussion", "Sign Inclussion", "LR", "FDR", "Participation", "dParticipation"), tags$th)
        )
      )
    ))
    y <- datatable(cbind('&oplus;', is[1:ntop,c("region", "bin.event", "locus", "locus_overlap", "b", "bjs", "ja", "jl", "bin", "feature", "b.logfc", "b.fdr", "bjs.lr", "bjs.fdr", "bjs.nonuniformity", "bjs.inclussion", "bjs.inclussion_sign", "a.lr", "a.fdr", "a.nonuniformity", "a.dpir", "a.dpir_sign", "l.lr", "l.fdr", "l.participation", "l.dparticipation")]),
              rownames = FALSE,
              escape = -1,
              filter ="top",
              fillContainer = FALSE,
              extensions = c('Buttons', 'KeyTable'), 
              options = list(dom = 'lfrtBip',
                             buttons = c('copy', 'csv', 'excel', 'pdf', 'print', I('colvis')),
                             columnDefs = list(
                               #  list(visible = FALSE, targets = c(0, 2, 3)),
                               list(orderable = FALSE, className =
                                      'details-control', targets = 0)
                             ),
                             keys = TRUE
              ),   caption = htmltools::tags$caption(
                style = 'caption-side: top; text-align: left;',
                htmltools::h1(titulo), htmltools::h4(paste("Filters:", paste(paste(names(filters), filters, sep="="), collapse="; ")))
              ), container = sketch,
              callback = JS("
            table.order([10, 'asc']).draw();
            table.column(0).nodes().to$().css({cursor: 'pointer'});
            var format = function(d) {
             return '<div><h4>Gene view</h4></br><img src=\"img/' + d[1].replace(\":\", \"_\").replace(\"-\", \"_\") + '_gene.png\" height=\"700\"></img></div>';
            };
            table.on('click', 'td.details-control', function() {
               var td = $(this), row = table.row(td.closest('tr'));
               if (row.child.isShown()) {
                  row.child.hide();
                  td.html('&oplus;');
              } else {
                  row.child(format(row.data())).show();
                  td.html('&CircleMinus;');
              }
           });")
    )    
    
    ffile <- paste0(normalizePath(output.dir), "/integratedSignals.html")
    suppressWarnings(saveWidget(y, file = ffile, title = paste(names(sr@contrast)[sr@contrast != 0], collapse = " - "), selfcontained = F))
    if(openInBrowser == T) browseURL(ffile)
    
  }
)

setGeneric( name = 'filterSignals',
            def = function( sr,
                            bin.FC = 3,
                            bin.fdr = 0.05,
                            nonunif=1,
                            bin.inclussion = 0.1,
                            bjs.inclussion = 0.2,
                            bjs.fdr = 0.1,
                            a.inclussion = 0.3,
                            a.fdr = 0.05,
                            l.inclussion = 0.3,
                            l.fdr = 0.05, 
                            bDetectionSummary=FALSE  ) 
              standardGeneric( 'filterSignals' ))

setMethod( f = 'filterSignals',
           signature = c( 'ASpliSplicingReport' ),
           definition = function( sr,
                                  bin.FC = 3,
                                  bin.fdr = 0.05,
                                  nonunif=1,
                                  bin.inclussion = 0.1,
                                  bjs.inclussion = 0.2,
                                  bjs.fdr = 0.1,
                                  a.inclussion = 0.3,
                                  a.fdr = 0.05,
                                  l.inclussion = 0.3,
                                  l.fdr = 0.05, 
                                  bDetectionSummary=FALSE ) {
             .filterSignals( sr, 
                             bin.FC, 
                             bin.fdr, 
                             nonunif, 
                             bin.inclussion, 
                             bjs.inclussion,
                             bjs.fdr,
                             a.inclussion,
                             a.fdr,
                             l.inclussion,
                             l.fdr, 
                             bDetectionSummary ) } )

# ---------------------------------------------------------------------------- #
# plotBins
setGeneric( name = "plotBins",
            def = function(
              counts, 
              as,
              bin, 
              factorsAndValues, 
              targets,
              main            = NULL,
              colors          = c( '#2F7955', '#79552F', '#465579', '#A04935', '#752020', 
                                   '#A07C35') ,
              panelTitleColors = '#000000',
              panelTitleCex   = 1,
              innerMargins    = c( 2.1, 3.1, 1.1, 1.1 ),
              outerMargins    = c( 0, 0, 2.4, 0 ), 
              useBarplots     = NULL,
              barWidth        = 0.9,
              barSpacer       = 0.4,
              las.x           = 2,
              useHCColors     = FALSE,
              legendAtSide    = TRUE,
              outfolder       = NULL,
              outfileType     = c( 'png', 'bmp', 'jpeg', 'tiff', 'pdf')[1],
              deviceOpt       = NULL ) standardGeneric( 'plotBins' ) )

setMethod( 
  f = "plotBins",
  signature = 'ASpliCounts',
  definition = function( 
    counts, 
    as,
    bin, 
    factorsAndValues, 
    targets,
    main            = NULL,
    colors          = c( '#2F7955', '#79552F', '#465579', '#A04935', 
                         '#752020', '#A07C35') ,
    panelTitleColors = '#000000',
    panelTitleCex   = 1,
    innerMargins    = c( 2.1, 3.1, 1.1, 1.1 ),
    outerMargins    = c( 0, 0, 2.4, 0 ), 
    useBarplots     = NULL,
    barWidth        = 0.9,
    barSpacer       = 0.4,
    las.x           = 2,
    useHCColors     = FALSE,
    legendAtSide    = TRUE,
    outfolder       = NULL,
    outfileType     = c( 'png', 'bmp', 'jpeg', 'tiff', 'pdf')[1],
    deviceOpt       = NULL ) {
    
    .plotBins( counts, as, bin, factorsAndValues, targets, main, colors, 
               panelTitleColors, panelTitleCex, innerMargins, outerMargins, 
               useBarplots, barWidth, barSpacer, las.x, useHCColors, legendAtSide,
               outfolder, outfileType, deviceOpt )
  } 
)
# ---------------------------------------------------------------------------- # 
# ---------------------------------------------------------------------------- #
# plotGenomicRegions
setGeneric( 
  name = "plotGenomicRegions", 
  def = function( 
    #counts,
    features,
    x, 
    genomeTxDb, 
    targets, 
    xIsBin = TRUE, 
    layout = 'auto', 
    colors = 'auto', 
    plotTitles = 'auto', 
    sashimi = FALSE, 
    zoomOnBins= FALSE, 
    deviceOpt = NULL, 
    highLightBin = TRUE, 
    outfolder = NULL, 
    outfileType = 'png', 
    mainFontSize = 24, 
    annotationHeight = 0.2,
    annotationCol = 'black', 
    annotationFill = 'gray', 
    annotationColTitle = 'black',
    preMergedBAMs = NULL,
    useTransparency = FALSE,
    tempFolder = 'tmp',
    avoidReMergeBams = FALSE,
    verbose = TRUE ) standardGeneric( "plotGenomicRegions" ) )

setMethod(
  f = "plotGenomicRegions",
  signature = "ASpliFeatures",
  definition = function ( 
    #        counts,
    features, 
    x, 
    genomeTxDb, 
    targets, 
    xIsBin = TRUE, 
    layout = 'auto', 
    colors = 'auto', 
    plotTitles = 'auto', 
    sashimi = FALSE, 
    zoomOnBins= FALSE, 
    deviceOpt = NULL, 
    highLightBin = TRUE, 
    outfolder = NULL, 
    outfileType = 'png', 
    mainFontSize = 24, 
    annotationHeight = 0.2, 
    annotationCol = 'black', 
    annotationFill = 'gray', 
    annotationColTitle = 'black',
    preMergedBAMs = NULL,
    useTransparency = FALSE,
    tempFolder = 'tmp',
    avoidReMergeBams = FALSE,
    verbose = TRUE ) {
    
    .Deprecated("", msg = "plotGenomicRegions is deprecated and is no longer needed. See ASpli vignette for new pipeline.")
    
    .plotGenomicRegions(
      x, 
      genomeTxDb, 
      #              counts,
      features,
      targets, 
      xIsBin, 
      layout, 
      colors, 
      plotTitles, 
      sashimi, 
      zoomOnBins, 
      deviceOpt, 
      highLightBin, 
      outfolder, 
      outfileType,
      mainFontSize, 
      annotationHeight, 
      annotationCol, 
      annotationFill, 
      annotationColTitle,
      preMergedBAMs,
      useTransparency,
      tempFolder,
      avoidReMergeBams ,
      verbose )
  }
)
# ---------------------------------------------------------------------------- #
#agrego para no romper el old pipeline
# TODO:  Es necesario agregar todos los parametros con valores por default en
# la firma del metodo ? 
setGeneric (
  name = "DUreport",
  def = function( counts, 
                  targets, 
                  minGenReads  = 10,
                  minBinReads  = 5,
                  minRds = 0.05,
                  offset = FALSE,
                  offsetAggregateMode = c( "geneMode", "binMode" )[1],
                  offsetUseFitGeneX = TRUE,
                  contrast = NULL,
                  forceGLM = FALSE,
                  ignoreExternal = TRUE,
                  ignoreIo = TRUE, 
                  ignoreI = FALSE,
                  filterWithContrasted = FALSE,
                  verbose = FALSE
  ) standardGeneric("DUreport") )

#setGeneric (
#  name = "DUreport_DEXSeq",
#  def = function ( counts, ... ) standardGeneric("DUreport_DEXSeq") )

setMethod(
  f = "DUreport",
  signature = "ASpliCounts",
  definition = function( counts, 
                         targets, 
                         minGenReads  = 10,
                         minBinReads  = 5,
                         minRds = 0.05,
                         offset = FALSE,
                         offsetAggregateMode = c( "geneMode", "binMode" )[1],
                         offsetUseFitGeneX = TRUE,
                         contrast = NULL,
                         forceGLM = FALSE,
                         ignoreExternal = TRUE,
                         ignoreIo = TRUE, 
                         ignoreI = FALSE,
                         filterWithContrasted = FALSE,
                         verbose = FALSE
  ) { 
    .Deprecated(c("DUreport.offset", "DUreport.norm"))
    .DUreport( counts, targets, minGenReads, minBinReads, minRds, offset, 
               offsetAggregateMode, offsetUseFitGeneX, contrast, forceGLM,
               ignoreExternal, ignoreIo, ignoreI, filterWithContrasted, verbose  )
  }
)

makeExample01Data <- function() {

  # Get example counts and as, just for object skeleton
  counts <- aspliCountsExample()
  as     <- aspliASexample()

  # Define synthetic targets
  targets <- data.frame(
      row.names = paste(rep( c("A","B","C","D"), each=12 ),"t",rep( c(1:12)*4, 4 ),sep = '.') , 
      bam = paste(rep( c("A","B","C","D"), each=12 ),"t",rep( c(1:12)*4, 4 ),sep =  '.'),
      treat = rep( c('A','B','C','D'), each=12 ) ,
      time  = rep( c('T1', 'T2', 'T3', 'T4', 'T5', 'T6', 'T7', 'T8', 'T9', 'T10',
              'T11', 'T12' ), 4),
      stringsAsFactors = FALSE )
  
  # Make synthetic gene expression data
  a <- countsg( counts )
  b <- matrix( runif( 48 * nrow(a), 0, 30 ), ncol = 48, nrow = nrow(a) )
  b <- b + 2000
  b <- apply( b, c(1,2), as.integer) 
  colnames( b ) <- paste( rep( c("A","B","C","D"), each=12 ), "t", rep( c(1:12)*4, 4 ), sep = '.' )
  rownames( b ) <- rownames( a )
  countsg( counts ) <- cbind( a[1:7], b )
  
  # Make synthetic bin counts data
  a <- countsb( counts )
  b <- matrix( runif( 48 * nrow(a), 15, 26 ), ncol = 48, nrow = nrow(a) )
  profile <- c( 0, 0.2, 0.4,  0.8,1,0.1,  0, 0.3, 0.4,  0.75, 0.95,0.1 )
  modprofile <- c( 1 , 0.7, 0.3, 0)
  profile <- rep ( profile, 4) * rep( modprofile, each = 12) 
  b <- b + matrix( rep( profile * 80, nrow(a) ), ncol = 48, byrow=TRUE)
  b <- apply( b, c(1,2), as.integer)
  
  colnames( b ) <- paste( rep( c("A","B","C","D"), each=12 ), "t", rep( c(1:12)*4, 4 ), sep = '.' )
  rownames( b ) <- rownames( a )

  countsb( counts ) <-cbind( a[1:9], b )
  

  # Make synthetic J1 junction counts
  a <- joint( as )
  
  bj1 <- matrix( runif( 48 * nrow(a), 0, 6 ), ncol = 48, nrow = nrow(a) )
  
  profile <- c( 0, 0.2, 0.4,  0.8,1,0.1,  0, 0.3, 0.4,  0.75, 0.95,0.1 )
  modprofile <- c( 1 , 0.7, 0.3, 0)
  profile <- rep ( profile, 4) * rep( modprofile, each = 12) 
  
  bj1 <- bj1 + matrix( rep( profile * 31, nrow(a) ), ncol = 48, byrow=TRUE)
  bj1[bj1 < 0] <- 0 
  bj1 <- apply( bj1, c(1,2), as.integer)
  
  
  # Make synthetic J2 junction counts
  bj2 <- matrix( runif( 48 * nrow(a), 0,6  ), ncol = 48, nrow = nrow(a) )
  
  profile <- c( 0, 0.2, 0.4,  0.8,1,0.1,  0, 0.3, 0.4,  0.75, 0.95,0.1 )
  modprofile <- c( 1 , 0.7, 0.3, 0)
  profile <- rep ( profile, 4) * rep( modprofile, each = 12) 
  
  bj2 <- bj2 + matrix( rep( profile * 28, nrow(a) ), ncol = 48, byrow=TRUE)
  bj2[bj2 < 0] <- 0 
  bj2 <- apply( bj2, c(1,2), as.integer)
  
  
  # Make synthetic J3 junction counts
  bj3 <- matrix( runif( 48 * nrow(a), 22, 27 ), ncol = 48, nrow = nrow(a) )
  
  profile <- c( 0, 0.2, 0.4,  0.8,1,0.1,  0, 0.3, 0.4,  0.75, 0.95,0.1 )
  modprofile <- c( 1 , 0.7, 0.3, 0)
  profile <- rep ( profile, 4) * rep( modprofile, each = 12) 
  
  bj3 <- bj3 - matrix( rep( profile * 22, nrow(a) ), ncol = 48, byrow=TRUE)
  bj3[bj3 < 0] <- 0 
  bj3 <- apply( bj3, c(1,2), as.integer)
  
  # Make synthetic PSI/PIR values
  psir <- (bj1 + bj2) / (bj1 + bj2 + 2 * bj3) 
  
  # update AS object
  asj <- cbind( a[,1:2], bj1, a[,15], bj2, a[,28], bj3, psir )
  
  colnames( asj ) <- c( 'event', 'J1', 
      paste(rep( c("A","B","C","D"), each=12 ),"t",rep( c(1:12)*4, 4 ),sep = '.'),
      c('J2'),
      paste(rep( c("A","B","C","D"), each=12 ),"t",rep( c(1:12)*4, 4 ),sep = '.'),
      c('J3'),
      paste(rep( c("A","B","C","D"), each=12 ),"t",rep( c(1:12)*4, 4 ),sep = '.'),
      getConditions( targets ) )
  
  joint(as) <- asj
  
  # Define factors and values to plot
  fv <- list( 
      time = c('T1', 'T2', 'T3', 'T4', 'T5', 'T6', 'T7', 'T8', 'T9', 'T10', 'T11',
          'T12'  ), treat =  c('A','B','C', 'D') )
  
  # Make the plots
  plotBins( counts, as, 'GENE02:E002', factorsAndValues = fv, targets,
      legendAtSide = FALSE, outfolder = 'grplots', outfileType='pdf', deviceOpt=list(
          width = 7, height = 7 ) )
}

#Splicing Report
#
#
#
#This function integrates differential usage information from different sources.
#Receives bin usage and junction usage and merges them in three steps.
#First merges all bin based junction information (jir, jes, jalt).
#Then merges locale information with coverage information in the regions.
#Finally does the same with anchors.
#################################################################################
.splicingReport <- function(bdu, jdu, counts){
  
  #Sanity check
  if(class(bdu) != "ASpliDU"){
    stop("bdu must be an ASpliDU object, try running gbDUreport first") 
  }
  if(class(jdu) != "ASpliJDU"){
    stop("jdu must be an ASpliJDU object, try running jDUreport first") 
  }
  if(class(counts) != "ASpliCounts"){
    stop("counts must be an ASpliCounts object, try running gbCounts first") 
  }  

  mr <- new( Class="ASpliSplicingReport" )
  mr@contrast <- jdu@contrast
  
  #Mergin bin based junctions
  jir                    <- jir(jdu)
  jir$event              <- NA
  jir$dPSI               <- NA
  jir                    <- jir[, c("event", "J3", "multiplicity", "logFC", "log.mean", "LR", "pvalue", "FDR", "dPIR", "dPSI", "NonUniformity", colnames(jir)[grep("counts", colnames(jir))])]
  colnames(jir)[colnames(jir) %in% c("FDR", "NonUniformity")] <- c("junction.fdr", "nonuniformity")
  #jir$bin                <- rownames(jir)
  
  jes                    <- jes(jdu)
  jes$nonuniformity      <- NA
  jes$dPIR               <- NA
  jes                    <- jes[, c("event", "J3", "multiplicity", "logFC", "log.mean", "LR", "pvalue", "FDR", "dPIR", "dPSI", "nonuniformity", colnames(jes)[grep("counts", colnames(jes))])]
  colnames(jes)[colnames(jes) %in% c("FDR")] <- c("junction.fdr")
  #jes$bin                <- rownames(jes)
  
  jalt                   <- jalt(jdu)
  jalt$nonuniformity     <- NA
  jalt$dPIR              <- NA
  jalt                   <- jalt[, c("event", "J3", "multiplicity", "logFC", "log.mean", "LR", "pvalue", "FDR", "dPIR", "dPSI", "nonuniformity", colnames(jalt)[grep("counts", colnames(jalt))])]
  colnames(jalt)[colnames(jalt) %in% c("FDR")] <- c("junction.fdr")
  #jalt$bin               <- rownames(jalt)
  
  j                      <- data.table(rbind(jir, jes, jalt), keep.rownames = TRUE)
  bins                   <- data.table(binsDU(bdu), keep.rownames = TRUE)
  aux                    <- data.frame(merge(bins, j, by="rn", all=T))
  colnames(aux)          <- c("bin", "feature", "bin.event", "locus", "locus_overlap", "symbol", "gene_coordinates", "start",
                              "end", "length", "bin.logFC", "bin.pvalue", "bin.fdr", "junction.event", "J3", "J3.multiplicity", "J3.logFC",
                              "J3.log.mean", "cluster.LR", "cluster.pvalue", "cluster.fdr", "cluster.dPIR", "cluster.dPSI", "cluster.nonuniformity", colnames(aux)[grep("counts", colnames(aux))])
  
  aux                    <- aux[, !colnames(aux) %in% c("symbol", "junction.event")]
  
  #aux                    <- aux[union(which(aux$bin.fdr < maxBinFDR), which(aux$junction.fdr < maxJunctionFDR)), ]
  aux                    <- aux[order(aux$bin), ]
  rownames(aux)          <- NULL
  
  #Buscamos los elementos sin start y se las asignamos a partir de los features
  sin_start            <- which(is.na(aux$start))
  if(length(sin_start)){
    imputaciones         <- countsb(counts)[aux$bin[sin_start], ]
    aux$start[sin_start] <- imputaciones$start
    aux$end[sin_start]   <- imputaciones$end
    aux$bin.event[sin_start]<-imputaciones$event                   #ACH aver
    aux$gene_coordinates[sin_start] <- imputaciones$gene_coordinates
    aux$feature[sin_start] <- imputaciones$feature
  }
  binbased(mr)         <- aux
  
  ########################################
  localej   <- localej(jdu)
  junctions <- strsplit2(rownames(localej), "[.]")
  seqnames  <- junctions[, 1]
  start     <- as.numeric(junctions[, 2]) + 1
  end       <- as.numeric(junctions[, 3]) - 1
  
  grjunctions <- GRanges(seqnames, IRanges(start, end), strand="*")
  
  seqnames <- strsplit2(binsDU(bdu)$gene_coordinates, "[:]")[, 1]
  start    <- binsDU(bdu)$start
  end      <- binsDU(bdu)$end
  
  grbines      <- GRanges(seqnames, IRanges(start, end), strand="*")
  
  if(!all(unique(grbines@seqnames) %in% unique(grjunctions@seqnames))){
    saux <- "Not every chromosome is present in both bins and locales:\n"
    saux <- c(saux,paste(sort(unique(as.character(grbines@seqnames))),collapse=" "),"\n",
                   paste(sort(unique(as.character(grjunctions@seqnames))),collapse=" ")) 
    warning(saux)
  }
  overlap      <- data.frame(findOverlaps(grbines, grjunctions))
  
  bins <- binsDU(bdu)
  colnames(bins)[colnames(bins) %in% c("logFC")] <- "bin.logFC"
  
  #Unique identifier por locale pvalue
  colnames(localej)[colnames(localej) %in% c("pvalue")] <- "junction.pvalue"
  
  #Merge overlaping bins and locales
  junctionbased_junctions <- data.table(bin=rownames(bins)[overlap$queryHits], bins[overlap$queryHits, ], 
                                        J3 = rownames(localej)[overlap$subjectHits], localej[overlap$subjectHits, ])
  
  
  
  junctions               <- data.table(localej[!rownames(localej) %in% junctionbased_junctions$J3, ], 
                                        keep.rownames = TRUE)
  colnames(junctions)[colnames(junctions) %in% c("rn")]  <- c("J3")
  
  #Adds non overlaping locales
  junctionbased_junctions <- rbindlist(list(junctionbased_junctions, junctions), 
                                       use.names = TRUE,
                                       fill = TRUE)
  
  
  colnames(junctionbased_junctions) <- c("bin", "feature", "event", "locus", "locus_overlap", "symbol", "gene_coordinates", "bin.start", "bin.end",
                                         "bin.length", "bin.logFC", "bin.pvalue", "bin.fdr","junction", "junction.cluster", "junction.log.mean",
                                         "junction.logFC", "junction.pvalue", "junction.fdr", "junction.annotated", "junction.participation", "junction.dparticipation", colnames(junctionbased_junctions)[grep("counts", colnames(junctionbased_junctions))])
  
  #Change type of junction.cluster so we can merge with cluster information
  junctionbased_junctions$junction.cluster <- as.character(junctionbased_junctions$junction.cluster)
  

  localec <- data.table(localec(jdu), keep.rownames = TRUE)

  #Tries to find cluster locus
  junctions  <- strsplit2(localec$range, "[.]")
  seqnames   <- junctions[, 1]
  start      <- as.numeric(junctions[, 2]) + 1
  end        <- as.numeric(junctions[, 3]) - 1
  
  grclusters <- GRanges(seqnames, IRanges(start, end), strand="*")
  
  seqnames   <- strsplit2(genesDE(bdu)$gene_coordinates, "[:]")[, 1]
  start      <- genesDE(bdu)$start
  end        <- genesDE(bdu)$end
  
  grgenes    <- GRanges(seqnames, IRanges(start, end), strand="*")
  
  overlap    <- data.frame(findOverlaps(grclusters, grgenes))
  localec$locus <- NA
  localec$locus[overlap$queryHits] <- as.character(genesDE(bdu)$symbol[overlap$subjectHits])
  colnames(localec) <- c("rn", "cluster.size", "cluster.LR", "cluster.pvalue", "cluster.fdr", "cluster.range", "cluster.participation", "cluster.dparticipation", "cluster.locus")
  
  fulldt <- data.frame(merge(junctionbased_junctions, localec, by.x = "junction.cluster", by.y = "rn",
                             all = TRUE))
  
  fulldt <- fulldt[, 
                   c("junction", "junction.annotated",
                     "junction.log.mean",
                     "junction.logFC", "junction.pvalue", "junction.fdr", 
                     colnames(fulldt)[grep("counts", colnames(fulldt))],
                     "junction.cluster", "junction.participation", "junction.dparticipation",
                     "cluster.locus", "cluster.size", "cluster.LR", "cluster.pvalue", "cluster.fdr", "cluster.range", "cluster.participation", "cluster.dparticipation", 
                     "bin", "bin.pvalue", "bin.fdr")
                   ]
  rownames(fulldt) <- NULL
  #fulldt           <- fulldt[union(which(fulldt$bin.fdr < maxBinFDR), which(fulldt$cluster.fdr < maxJunctionFDR)), ] #Traemos todos
  index.orden      <- strsplit2(fulldt$junction, "[.]")
  index.orden      <- order(GRanges(index.orden[, 1], IRanges(as.numeric(index.orden[, 2]), as.numeric(index.orden[, 3]))))
  fulldt           <- fulldt[index.orden, ] 
  rownames(fulldt) <- NULL
  localebased(mr)  <- fulldt
  
  ########################################
  anchorj  <- anchorj(jdu)
  junctions <- strsplit2(rownames(anchorj), "[.]")
  seqnames <- junctions[, 1]
  start    <- as.numeric(junctions[, 2]) + 1
  end      <- as.numeric(junctions[, 3]) - 1
  
  grjunctions <- GRanges(seqnames, IRanges(start, end), strand="*")
  
  seqnames <- strsplit2(bdu@bins$gene_coordinates, "[:]")[, 1]
  start    <- binsDU(bdu)$start
  end      <- binsDU(bdu)$end
  
  grbines      <- GRanges(seqnames, IRanges(start, end), strand="*")
  
  overlap      <- data.frame(findOverlaps(grbines, grjunctions))
  
  bins <- binsDU(bdu)
  colnames(bins)[colnames(bins) %in% c("logFC")] <- "bin.logFC"

  colnames(anchorj)[colnames(anchorj) %in% c("pvalue")] <- "junction.pvalue"  
  junctionbased_junctions <- data.table(bin=rownames(bins)[overlap$queryHits], bins[overlap$queryHits, ], 
                                        J3 = rownames(anchorj)[overlap$subjectHits], anchorj[overlap$subjectHits, ])
  
  
  junctions               <- data.table(anchorj[!rownames(anchorj) %in% junctionbased_junctions$J3, ], 
                                        keep.rownames = TRUE)
  colnames(junctions)[colnames(junctions) %in% c("rn")]  <- c("J3")
  
  junctionbased_junctions <- rbindlist(list(junctionbased_junctions, junctions), 
                                       use.names = TRUE,
                                       fill = TRUE)
  
  colnames(junctionbased_junctions) <- c("bin", "feature", "event", "locus", "locus_overlap", "symbol", "gene_coordinates", "bin.start", "bin.end",
                                         "bin.length", "bin.logFC", "bin.pvalue", "bin.fdr", "junction", "junction.log.mean",
                                         "junction.logFC", "junction.LR", "junction.pvalue", "junction.fdr", "J1.pvalue", "J2.pvalue",
                                         "junction.nonuniformity", "junction.dPIR", "junction.annotated",
                                         colnames(junctionbased_junctions)[grep("counts", colnames(junctionbased_junctions))])
  
  anchorc <- data.table(anchorc(jdu), keep.rownames = TRUE)  #Tries to find cluster locus
  junctions  <- strsplit2(anchorc$rn, "[.]")
  seqnames   <- junctions[, 1]
  start      <- as.numeric(junctions[, 2]) + 1
  end        <- as.numeric(junctions[, 3]) - 1
 
  grclusters <- GRanges(seqnames, IRanges(start, end), strand="*")
  
  seqnames   <- strsplit2(genesDE(bdu)$gene_coordinates, "[:]")[, 1]
  start      <- genesDE(bdu)$start
  end        <- genesDE(bdu)$end
  
  grgenes    <- GRanges(seqnames, IRanges(start, end), strand="*")
  
  overlap    <- data.frame(findOverlaps(grclusters, grgenes))
  anchorc$locus <- NA
  anchorc$locus[overlap$queryHits] <- as.character(genesDE(bdu)$symbol[overlap$subjectHits])
  
  colnames(anchorc) <- c("rn", "cluster.LR", "cluster.pvalue", "cluster.fdr", "cluster.locus")
  fulldt <- data.frame(merge(junctionbased_junctions, anchorc, by.x = "junction", by.y = "rn", 
                             all = TRUE))
  
  fulldt <- fulldt[, 
                   c("junction", "junction.annotated",
                     "junction.log.mean",
                     "junction.logFC", "junction.LR", "junction.pvalue", "junction.fdr", "J1.pvalue", "J2.pvalue",
                     "junction.nonuniformity", "junction.dPIR",
                     colnames(fulldt)[grep("counts", colnames(fulldt))],
                     "cluster.locus", "cluster.pvalue", "cluster.fdr",
                     "bin", "bin.pvalue", "bin.fdr")
                  ]
  rownames(fulldt) <- NULL
  #fulldt          <- fulldt[union(which(fulldt$bin.fdr < maxBinFDR), which(fulldt$cluster.fdr < maxJunctionFDR)), ]
  index.orden     <- strsplit2(fulldt$junction, "[.]")
  index.orden     <- order(GRanges(index.orden[, 1], IRanges(as.numeric(index.orden[, 2]), as.numeric(index.orden[, 3]))))
  #countsJ1 <- fulldt[, colnames(fulldt)[grep("countsJ1", colnames(fulldt))]]
  #countsJ2 <- fulldt[, colnames(fulldt)[grep("countsJ2", colnames(fulldt))]]
  #countsJ3 <- fulldt[, colnames(fulldt)[grep("countsJ3", colnames(fulldt))]]
  #pir             <- (countsJ1 + countsJ2)/(countsJ1 + countsJ2 + countsJ3)
  #colnames(pir)   <- strsplit2(colnames(pir), "[.]")[, 2]
  #dpir            <- rowSums(t(t(pir)*jdu@contrast[colnames(pir)]))
  #fulldt$dPIR     <- dpir
  fulldt          <- fulldt[index.orden, ] 
  rownames(fulldt)<- NULL
  anchorbased(mr) <- fulldt
  return(mr)
}


.filterSignals<-function(sr,
                         bin.FC = 3,
                         bin.fdr = 0.05,nonunif=1,
                         bin.inclussion = 0.1,
                         bjs.inclussion = 0.2,
                         bjs.fdr = 0.1,
                         a.inclussion = 0.3,
                         a.fdr = 0.05,
                         l.inclussion = 0.3,
                         l.fdr = 0.05,bDetectionSummary=FALSE){
  b <- binbased(sr)
  b <- b[!is.na(b$length), ]
  
  #bin: qv + soporte juntura
  ibin1 <- (!is.na(b$bin.fdr) & b$bin.fdr < bin.fdr) &
    ( (!is.na(b$cluster.dPIR) & abs(b$cluster.dPIR) > bin.inclussion) |
        (!is.na(b$cluster.dPSI) & abs(b$cluster.dPSI) > bin.inclussion))
  
  #bin: qv + FC + nonunif
  ibin2  <- (!is.na(b$bin.fdr) & b$bin.fdr < bin.fdr) &
    abs(b$bin.logFC) > log2(bin.FC) &
    (is.na(b$cluster.nonuniformity) | b$cluster.nonuniformity<nonunif)
  
  ibin   <- ibin1 | ibin2  
  
  #bin a partir de solo soporte de juntura
  b  <- binbased(sr)
  ibjs <- b$cluster.fdr < bjs.fdr &
    ( (!is.na(b$cluster.dPIR) & abs(b$cluster.dPIR) > bjs.inclussion) |
        (!is.na(b$cluster.dPSI) & abs(b$cluster.dPSI) > bjs.inclussion))
  
  #anchor
  b    <- anchorbased(sr)
  ianc <-  b$cluster.fdr < a.fdr & abs(b$junction.dPIR) > a.inclussion
  
  
  b     <- localebased(sr)
  iloc  <- b$cluster.fdr < l.fdr & 
    (!is.na(b$cluster.dparticipation) & abs(b$cluster.dparticipation) > l.inclussion)
  
  lfs <- list(ibin1=which(ibin1),ibin2=which(ibin2),ibjs=which(ibjs),ianc=which(ianc),iloc=which(iloc))
  
  if(bDetectionSummary){
    .plotASpliDetectionSummary(sr,lfs,   bin.FC = bin.FC,
                                     bin.fdr = bin.fdr,nonunif=nonunif,
                                     bin.inclussion = bin.inclussion,
                                     bjs.inclussion = bjs.inclussion,
                                     bjs.fdr = bjs.fdr,
                                     a.inclussion = a.inclussion,
                                     a.fdr = a.fdr,
                                     l.inclussion = l.inclussion,
                                     l.fdr = l.fdr)
  }
  return(lfs)
}

.plotASpliDetectionSummary<-function(sr,lfs,
                          bin.FC = 3,
                          bin.fdr = 0.05,nonunif=1,
                          bin.inclussion = 0.1,
                          bjs.inclussion = 0.2,
                          bjs.fdr = 0.1,
                          a.inclussion = 0.3,
                          a.fdr = 0.05,
                          l.inclussion = 0.3,
                          l.fdr = 0.05){
    
    bplot <- TRUE 
    
    #Seniales de bin y soporte de junturas
    a<-binbased(sr)
    
    #corrijo los locus NA
    ina <- which(is.na(a$locus))
    aux <- a$bin[ina]
    aux <- unlist(lapply(strsplit(aux,":",fixed=TRUE),function(x){x[1]}))
    a$locus[ina] <- aux
    

    ibin1 <- lfs$ibin1
    ibin2 <- lfs$ibin2
    ibjs  <- lfs$ibjs
    ianc  <- lfs$ianc
    iloc  <- lfs$iloc
    
    
    ibin   <- ibin1 | ibin2
    b1loc  <- unique(a$locus[ibin1])
    b2loc  <- unique(a$locus[ibin2])
    bloc   <- unique(a$locus[ibin])
    
    #solo soporte de juntura
    jloc <- unique(a$locus[ibjs])
    
    if(bplot){
      layout(matrix(c(1:6),2,3,byrow=TRUE))
      plot  (a$bin.logFC,-log(a$bin.fdr),col="gray",pch=20,log="y",xlab="bin logFC",ylab="-log bin.fdr")
      points(a$bin.logFC[ibin1],-log(a$bin.fdr)[ibin1],col=rgb(0,1,0,0.5),pch=20)
      points(a$bin.logFC[ibin2],-log(a$bin.fdr)[ibin2],col=rgb(1,1,0,0.5),pch=20)
      abline(h=-log(bin.fdr),lty=2,col="gray")
      points(a$bin.logFC[ibjs],-log(a$bin.fdr)[ibjs],col=rgb(1,0,1,0.5),pch=20)
      
      iqv <- which(a$bin.fdr<bin.fdr)
      aux <- c(abs(a$cluster.dPIR)[iqv],abs(a$cluster.dPSI)[iqv]) 
      aux <- aux[!is.na(aux)]  
      plot(ecdf(aux),xlab="junction support inclussion",main=paste0("signif bins:",length(iqv)))
      abline(v=c(0.1,.2,.3),col="gray",lty=2)
      abline(v=bin.inclussion,col="red",lty=2,lwd=2)
      legend("bottomright",paste0(sum(aux>bin.inclussion)," (",length(b1loc),")"),bty="n")
      text(bin.inclussion,0,pos=4,signif(ecdf(aux)(bin.inclussion),2),bg="white")
      
      
      plot(ecdf(abs(a$bin.logFC[iqv])),xlab="log2 FC",main="")
      abline(v=log2(c(1.5,2,3)),col="gray",lty=2)
      abline(v=log2(bin.FC),col="red",lty=2,lwd=2)
      legend("bottomright",paste0(sum(abs(a$bin.logFC[iqv])>log2(bin.FC))," (",length(b2loc),")"),bty="n")
      text(log2(bin.FC),0,pos=4,signif(ecdf(abs(a$bin.logFC[iqv]))(log2(bin.FC)),2),bg="white")
      
      
      iqv <- which(a$cluster.fdr < bjs.fdr)
      aux <- c(abs(a$cluster.dPIR)[iqv],abs(a$cluster.dPSI)[iqv]) 
      aux <- aux[!is.na(aux)]  
      plot(ecdf(aux),xlab="inclussion",main=paste0("signif junc supp clusters:",length(iqv)))
      abline(v=c(0.1,.2,.3),col="gray",lty=2)
      abline(v=bjs.inclussion,col="red",lty=2,lwd=2)
      legend("bottomright",paste0(sum(aux>bjs.inclussion)," (",length(jloc),")"),bty="n")
      text(bjs.inclussion,0,pos=4,signif(ecdf(aux)(bjs.inclussion),2),bg="white")
      
    }
    
    
    #anchor
    a    <- anchorbased(sr)
    aloc <- unique(a$cluster.locus[ianc])
    if(bplot){
      iq <- which(a$junction.fdr < a.fdr )
      plot(ecdf(abs(a$junction.dPIR)[iq]),main=paste0("signif anchor j-clusters:",length(iq)),xlab="abs dPIR")
      abline(v=c(0.1,.2,.3),col="gray",lty=2)
      abline(v=a.inclussion,col="red",lty=2,lwd=2)
      legend("bottomright",paste0(sum(abs(a$junction.dPIR[ianc])>a.inclussion,na.rm=TRUE)," (",length(aloc),")"),bty="n")
      text(a.inclussion,0,pos=4,signif(ecdf(abs(a$junction.dPIR[iq]))(a.inclussion),2),bg="white")
      
    }
    
    
    #locale
    a     <- localebased(sr)
    iloc  <- a$cluster.fdr < l.fdr & (!is.na(a$cluster.dparticipation) & abs(a$cluster.dparticipation) > l.inclussion) 
    gloc  <- unique(a$cluster.locus[iloc]) 
    if(bplot){
      iq <- which(a$cluster.fdr < l.fdr )
      aux <- a$cluster.dparticipation[iq]
      aux<-aux[!is.na(aux)]
      plot(ecdf(abs(aux)),main=paste0("stat signif locale junctions:",length(aux)),xlab="abs dparticipation")
      abline(v=c(0.1,.2,.3),col="gray",lty=2)
      abline(v=l.inclussion,col="red",lty=2,lwd=2)
      legend("bottomright",paste0(sum(abs(aux)>l.inclussion,na.rm=TRUE)," (",length(gloc),")"),bty="n")
      text(l.inclussion,0,pos=4,signif(ecdf(abs(a$cluster.dparticipation[iq]))(l.inclussion),2),bg="white")
      
    }
    
    # #Combino seniales
    # gasp <- unique(c(gloc,aloc,jloc,bloc))
    # return(gasp)
    # 
}

#Genera un data.table de regiones genicas con seniales diferenciales de diferente naturaleza
#                     region b bjs ja jl
# 1:       Chr1:45560-45645 1   1  0  0
# 2:     Chr1:387673-388267 1   1  1  1
# 3:     Chr1:406793-406902 1   1  0  0
# ...
#
# b: bin coverage signal / bjs: bin junction support signal / ja: junction anchor / jl: junction locale
#
#
# para la senial de junturas soporte de bin coverage se usan criterios basados en dPIN/dPI y 
# adicionalmente es posible usar, o no, el valor de fdr asociado a la juntura J3
# Aca lo que hacemos es ver el overlap entre regiones que tienen seniales diferentes. Para el caso del overlap entre 
# b o bjs y cualquier otro, usamos cualquier overlap, mientras que para el overlap entre ja y jl tienen que ser las mismas regiones
#
# Ademas, filtramos las ja y jl por junction.fdr unicamente. De esa forma, una region que tiene una juntura con uso diferencial, 
# por ejemplo, jl y que se solapa con un bin en al menos 3 pares de bases, aparece con soporte en bjs y en jl, mientras que si se solapa
# con b, solamente de coverage, aparece con b y jl. Las junturas que aparecen reportadas al final son las que aparecen en el bin en caso
# de tratarse de una region meramente "binica" o son la region en caso de venir de ja o jl.
#bin.FC = 3; bin.fdr = 0.05; nonunif = 1; usenonunif = FALSE; bin.inclussion = 0.1; bjs.inclussion = 0.2; bjs.fdr = 0.1; a.inclussion = 0.3; a.fdr = 0.05; l.inclussion = 0.3; l.fdr = 0.05; otherSources = NULL; overlapType = "any"
#bin.FC = 3;bin.fdr = 0.05;nonunif = 1;usenonunif = FALSE;bin.inclussion = 0.1;bjs.inclussion = 10.2;bjs.fdr = 10.1;a.inclussion = 0.3;a.fdr = 0.05;l.inclussion = 0.3;l.fdr = 0.05;otherSources = NULL;overlapType = "any"
.integrateSignals<-function(sr,
                            asd,
                            bin.FC,
                            bin.fdr,
                            nonunif,
                            usenonunif,
                            bin.inclussion,
                            bjs.inclussion,
                            bjs.fdr,
                            a.inclussion,
                            a.fdr,
                            l.inclussion,
                            l.fdr,
                            otherSources,
                            overlapType){
  
  if(class(sr) != "ASpliSplicingReport"){
    stop("sr must be an ASpliSplicingReport object")   
  }
  
  if(class(asd) != "ASpliAS"){
    stop("asd must be an ASpliAS object") 
  }
  
  
  is <- new( Class="ASpliIntegratedSignals" )
  is@filters <- data.frame( bin.FC = bin.FC,
                            bin.fdr = bin.fdr,
                            nonunif = nonunif,
                            usenonunif = usenonunif,
                            bin.inclussion = bin.inclussion,
                            bjs.inclussion = bjs.inclussion,
                            bjs.fdr = bjs.fdr,
                            a.inclussion = a.inclussion,
                            a.fdr = a.fdr,
                            l.inclussion = l.inclussion,
                            l.fdr = l.fdr,
                            overlapType = overlapType)
  
  #
  # Pongo todo lo que quiero comparar en GRanges
  #
  #bines significativos y uniformes 1.130149.130372 
  original_signals <- setNames(vector("list", 4), c("b", "bjs", "ja", "jl"))
  
  #apply filters
  lfs <- .filterSignals(sr, bin.FC=bin.FC, bin.fdr=bin.fdr, bin.inclussion=bin.inclussion, 
                            bjs.inclussion=bjs.inclussion, bjs.fdr=bjs.fdr,
                            a.inclussion=a.inclussion, a.fdr=a.fdr,
                            l.inclussion = l.inclussion,l.fdr = l.fdr)

      
  b <- binbased(sr)
  b <- b[!is.na(b$length), ]
  b <- b[union(lfs$ibin1, lfs$ibin2), ]
  original_signals$b <- b
  
  #Define GRanges associated to bin splicing signals
  if(nrow(b) > 0){
    start   = as.numeric(b$start)#aggregate(start ~ cluster, data=b, FUN=min)
    end     = as.numeric(b$end)#aggregate(end ~ cluster, data=b, FUN=max)
    seqnames = strsplit2(b$gene_coordinates, ":")[, 1]
    strand  = rep("*", times=length(seqnames))
    tipo    = rep("binbased", times=length(seqnames))
    binbased <- GRanges(seqnames, IRanges(start, end), strand, tipo)
  }else{
    binbased <- GRanges()
  }
    

  #Let's start again...looking for junction support signals
  b  <- binbased(sr)
  b  <- b[lfs$ibjs, ]
  
  original_signals$bjs <- b 
  
  #Lets define ranges coming from junction supporte splicing signals
  if(nrow(b) > 0){
    start   = as.numeric(b$start)#aggregate(start ~ cluster, data=b, FUN=min)
    end     = as.numeric(b$end)#aggregate(end ~ cluster, data=b, FUN=max)
    seqnames = strsplit2(b$gene_coordinates, ":")[, 1]
    strand  = rep("*", times=length(seqnames))
    tipo    = rep("binbased", times=length(seqnames))
    binsupport <- GRanges(seqnames, IRanges(start, end), strand, tipo)
  }else{
    binsupport <- GRanges()
  }
  
  #anchor
  b    <- anchorbased(sr)
  b <- b[lfs$ianc, ]
  original_signals$ja <- b
  
  #anchor ranges
  if(nrow(b) > 0){
    aux <- strsplit2(b$junction, "[.]")
    start   = as.numeric(aux[, 2]) + 1#aggregate(start ~ cluster, data=b, FUN=min)
    end     = as.numeric(aux[, 3]) - 1#aggregate(end ~ cluster, data=b, FUN=max)
    seqnames = aux[, 1]
    strand  = rep("*", times=length(seqnames))
    tipo    = rep("anchorbased", times=length(aux[, 1]))
    anchorbased <- unique(GRanges(seqnames, IRanges(start, end), strand, tipo)) #Puede haber duplicados porque machean con varios bines
  }else{
    anchorbased <- GRanges()
  }

  #locale
  b <- localebased(sr) 
  b <- b[lfs$iloc, ]
  original_signals$jl <- b

  #locale ranges  
  if(nrow(b) > 0){
    aux <- strsplit2(b$cluster.range, "[.]") #Reemplazamos la juntura por el rango del cluster al que pertenece que es el dato importante
    start   = as.numeric(aux[, 2])#aggregate(start ~ cluster, data=b, FUN=min)
    end     = as.numeric(aux[, 3])#aggregate(end ~ cluster, data=b, FUN=max)
    seqnames = aux[, 1]
    strand  = rep("*", times=length(seqnames))
    tipo    = rep("localebased", times=length(aux[, 1]))
    localebased <- unique(GRanges(seqnames, IRanges(start, end), strand, tipo)) #Puede haber duplicados porque machean con varios bines
  }else{
    localebased <- GRanges()
  }


  #
  # Overlap estimation (order matters)
  #
  laux  <- list(b=binbased,bjs=binsupport,jl=localebased,ja=anchorbased)
  if(class(otherSources) == "GRanges") laux$otherSources = otherSources
  lover <- list()
  for(i in seq_along(laux)){
    for(j in (i+1):length(laux)){
      if(j>length(laux)) break
      saux <- paste0("overlaps_",paste0(names(laux)[c(i,j)],collapse="_"))

      ttype<-overlapType
      # if(names(laux)[i]%in%c("b","bjs","otherSources") | names(laux)[j]%in%c("b","bjs","otherSources")){
      #   ttype<-overlapType
      # }else{
      #   ttype<-"equal"
      # }

      suppressWarnings(taux <- as.data.table(findOverlaps(laux[[i]],laux[[j]],type=ttype, minoverlap = 3)))
      if(nrow(taux) > 0){
        taux$queryHits   <- paste(names(laux)[i],taux$queryHits,sep=".")
        taux$subjectHits <- paste(names(laux)[j],taux$subjectHits,sep=".")
        colnames(taux) <- names(laux)[c(i,j)]
        lover[[saux]]           <-  taux
      }
    }
  }  
  
  #Genero overlaps_aux: con region y 0/1 si hay evidencia
  overlaps     <- rbindlist(lover, use.names = FALSE)
  overlaps_aux <- data.table(region=character(), b=numeric(), bjs=numeric(), ja=numeric(), jl=numeric())
  if(class(otherSources) == "GRanges") overlaps_aux$otherSources = numeric()
  for(i in unique(c(overlaps$b, overlaps$bjs))){
    j <- c(i, overlaps$bjs[overlaps$b == i], overlaps$b[overlaps$bjs == i])
    d <- data.table(region = i,
                    b=as.numeric(length(grep("b.", j,fixed=TRUE)) > 0),
                    bjs=as.numeric(length(grep("bjs.", j,fixed=TRUE)) > 0),
                    ja=as.numeric(length(grep("ja.", j,fixed=TRUE)) > 0),
                    jl=as.numeric(length(grep("jl.", j,fixed=TRUE)) > 0))
    if(class(otherSources) == "GRanges") d$otherSources = as.numeric(length(grep("otherSources.", j,fixed=TRUE)) > 0)
    overlaps_aux <- rbindlist(list(overlaps_aux, d))
  }
  
  #junction anchorBased que no tienen overlap con otra clase de eventos
  if(length(anchorbased) > 0){
    nooverlap <- setdiff(paste0("ja.", (1:length(anchorbased))), overlaps_aux$region[grep("ja.", overlaps_aux$region,fixed=TRUE)])
    if(length(nooverlap) > 0){
      d <- data.table(region = nooverlap,
                      b=0,bjs=0,ja=1,jl=0)
      if(class(otherSources) == "GRanges") d$otherSources = 0    
      overlaps_aux <- rbindlist(list(overlaps_aux, d))
    }  
  }
  
  #junction localeBased que no tienen overlap con otra clase de eventos
  if(length(localebased) > 0){
    nooverlap <- setdiff(paste0("jl.", (1:length(localebased))), overlaps_aux$region[grep("jl.", overlaps_aux$region,fixed=TRUE)])
    if(length(nooverlap) > 0){
      d <- data.table(region = nooverlap,
                      b=0,bjs=0,ja=0,jl=1)
      if(class(otherSources) == "GRanges") d$otherSources = 0
      overlaps_aux <- rbindlist(list(overlaps_aux, d))
    }
  }
  
  #bin based que no tienen overlap con otra clase de eventos
  if(length(binbased) > 0){
    nooverlap <- setdiff(paste0("b.", (1:length(binbased))), overlaps_aux$region[grep("b.", overlaps_aux$region,fixed=TRUE)])
    if(length(nooverlap) > 0){
      d <- data.table(region = nooverlap,
                      b=1,bjs=0,ja=0,jl=0)
      if(class(otherSources) == "GRanges") d$otherSources = 0
      overlaps_aux <- rbindlist(list(overlaps_aux, d))
    }
  }
  
  #junction bin support que no tienen overlap con otra clase de eventos
  if(length(binsupport) > 0){
    nooverlap <- setdiff(paste0("bjs.", (1:length(binsupport))), overlaps_aux$region[grep("bjs.", overlaps_aux$region,fixed=TRUE)])
    if(length(nooverlap) > 0){
      d <- data.table(region = nooverlap,
                      b=0,bjs=1,ja=0,jl=0)
      if(class(otherSources) == "GRanges") d$otherSources = 0
      overlaps_aux <- rbindlist(list(overlaps_aux, d))
    }
  }
  
  #Other sources que no tienen overlap con otra clase de eventos
  if(class(otherSources) == "GRanges"){
    if(length(otherSources) > 0){
      nooverlap <- setdiff(paste0("otherSources.", (1:length(otherSources))), overlaps_aux$region[grep("otherSources.", overlaps_aux$region,fixed=TRUE)])
      if(length(nooverlap) > 0){
        d <- data.table(region = nooverlap,
                        b=0,bjs=0,ja=0,jl=0, otherSources = 1)
        overlaps_aux <- rbindlist(list(overlaps_aux, d))
      }
    }
  }
  #Hasta aca arme la tabla de 1/0 evidenciaL overlaps_aux 
  # regiones que son reportadas por diferentes seniales aparecen en mas de una fila
   
  
  # i <- grep("ja.", overlaps_aux$region,fixed=TRUE)
  # if(length(i)){
  #   L <- as.data.frame(anchorbased[as.numeric(strsplit2(overlaps_aux$region[i], "ja.")[, 2])])
  #   overlaps_aux$region[i] <- paste0("Chr", L$seqnames, ":", L$start, "-", L$end)
  # }
  
  # i <- grep("jl.", overlaps_aux$region,fixed=TRUE)
  # L <- as.data.frame(localebased[as.numeric(strsplit2(overlaps_aux$region[i], "jl.")[, 2])])
  # overlaps_aux$region[i] <- paste0("Chr", L$seqnames, ":", L$start+1, "-", L$end-1)
  
  #
  #Cambio id de region por Rango genomico
  #
  i <- grep("b.", overlaps_aux$region,fixed=TRUE)
  if(length(i)){
    L <- as.data.frame(binbased[as.numeric(strsplit2(overlaps_aux$region[i], "b.")[, 2])])
    overlaps_aux$region[i] <- paste0(L$seqnames, ":", L$start, "-", L$end)
  }
  
  i <- grep("bjs.", overlaps_aux$region, fixed=TRUE)
  if(length(i)){
    L <- as.data.frame(binsupport[as.numeric(strsplit2(overlaps_aux$region[i], "bjs.")[, 2])])
    overlaps_aux$region[i] <- paste0(L$seqnames, ":", L$start, "-", L$end)
  }
  
  if(class(otherSources) == "GRanges"){
    i <- grep("otherSources.", overlaps_aux$region,fixed=TRUE)
    if(length(i)){
      L <- as.data.frame(otherSources[as.numeric(strsplit2(overlaps_aux$region[i], "otherSources.")[, 2])])
      overlaps_aux$region[i] <- paste0(L$seqnames, ":", L$start, "-", L$end)
    }
  }
  
  i <- grep("jl.", overlaps_aux$region,fixed=TRUE)
  if(length(i)){
    L <- as.data.frame(localebased[as.numeric(strsplit2(overlaps_aux$region[i], "jl.")[, 2])])
    overlaps_aux$region[i] <- paste0(L$seqnames, ":", L$start, "-", L$end)
  }  
  
  #corregi rango de junturas para buscar bounderies de intrones, pero se reporta
  #el rango de la juntura original  
  # se consigna con extremos corregidos para matchear borde de intron del anchor con bin-intronico con senial,
  # si es un rango nuevo, se consigna el rango de la juntura original
  i <- grep("ja.", overlaps_aux$region,fixed=TRUE)
  if(length(i)){
    L <- as.data.frame(anchorbased[as.numeric(strsplit2(overlaps_aux$region[i], "ja.")[, 2])])
    aux_region <- paste0(L$seqnames, ":", L$start, "-", L$end)
    j <- which(aux_region %in% setdiff(aux_region, overlaps_aux$region))
    overlaps_aux$region[i] <- aux_region
    overlaps_aux$region[i[j]] <- paste0(L$seqnames[j], ":", L$start[j] - 1, "-", L$end[j] + 1)
  }  
  
  #comienzo a mergear rangos  
  if(nrow(overlaps_aux) > 0){
    #Let's aggregate signals from identical regions
    a <- by(overlaps_aux[,-1],overlaps_aux$region,function(x){
                      apply(x,2,function(y){any(y!=0)})
                    })
    aa           <- data.frame(region=names(a),matrix(as.numeric(unlist(a)),byrow=TRUE,ncol=ncol(overlaps_aux)-1))
    colnames(aa)[-1] <- colnames(overlaps_aux)[-1]

    overlaps_aux <- data.table(aa)  
    overlaps_aux <- overlaps_aux[order(overlaps_aux$region), ]
      
    #matcheo rango con bin
    roi  <- as.character(overlaps_aux$region)
    rroi <- unlist(lapply(strsplit(roi,":",fixed=TRUE),function(x){return(x[2])}))
    #binbased(sr)
    ii<-match(rroi,paste0(binbased(sr)$start,"-",binbased(sr)$end))
    # table(is.na(ii))
    #table(binbased(sr)[ii,2:3])
    
    aa <- binbased(sr)[ii,c(1:3,7:8,13)]
    aa <- cbind(aa[,-c(4,5)],binreg=paste(aa$start,aa$end,sep="-"))
    
    aa  <-cbind(overlaps_aux,aa)
    roi <- gsub("[:]", ".", roi)
    roi <- gsub("[-]", ".", roi)
    aa$J3 <- as.character(aa$J3)
    aa$J3[is.na(aa$J3)] <- roi[is.na(aa$J3)] #Hacemos esto para machear con los anchor. Recordar restar uno al start y sumar uno al end para machear correctamente
                                             # Nota ACH: me parece mejor dejarlo NA y poner la logica de usar el rango
                                             # de la region cuando haga falta (!)
    
    #Se hizo esto para recalcular el locus de los locales que ahora vienen por cluster
    if(nrow(asd@junctionsPJU) > 0){
      regiones <- aa$region
      regiones <- gsub("[:]", ".", regiones)
      regiones <- gsub("[-]", ".", regiones)
      regiones <- strsplit2(regiones, "[.]")
      regiones <- GRanges(regiones[, 1], ranges = IRanges(start = as.numeric(regiones[, 2]), end = as.numeric(regiones[, 3])))
      genes    <- gsub("[:]", ".", asd@junctionsPJU$gene_coordinates)
      genes    <- gsub("[-]", ".", genes)
      genes    <- strsplit2(genes, "[.]")
      rownames(genes) <- asd@junctionsPJU$symbol
      genes    <- unique(genes)
      grgenes  <- GRanges(genes[, 1], ranges = IRanges(start = as.numeric(genes[, 2]), end = as.numeric(genes[, 3])))
      overlap  <- data.frame(findOverlaps(regiones, grgenes, type="any"))
      aa$locus[overlap$queryHits] <- rownames(genes)[overlap$subjectHits]
    }else{
      aa$locus <- NA
    }
    
    #Traemos los locus del bin si no estan
    genes <- strsplit2(aa$bin, ":")[, 1]
    locus_a_imputar <- which(is.na(aa$locus) & !is.na(aa$bin))
    aa$locus[locus_a_imputar] <- genes[locus_a_imputar]

    #Reordenamos las columnas
    nombre_de_seniales <- c("b", "bjs", "ja", "jl")
    if(class(otherSources) == "GRanges"){
      nombre_de_seniales <- c(nombre_de_seniales, "otherSources")
    }
    aa <- aa[, c("region", "locus", "bin.event", nombre_de_seniales, "bin", "feature", "J3", "binreg"), with = FALSE]
    
    aa$locus_overlap <- "-"
    locus_overlap <- binbased(sr)$locus_overlap[binbased(sr)$locus %in% aa$locus[!is.na(aa$locus)]]
    names(locus_overlap) <- binbased(sr)$locus[binbased(sr)$locus %in% aa$locus[!is.na(aa$locus)]]
    aa$locus_overlap[!is.na(aa$locus)] <- locus_overlap[aa$locus[!is.na(aa$locus)]]
    aa$locus_overlap[is.na(aa$locus_overlap)] <- "-"
       
    aa$b.fdr          <- NA
    aa$b.logfc        <- NA

    aa$bjs.lr            <- NA
    aa$bjs.fdr           <- NA
    aa$bjs.logfc         <- NA
    aa$bjs.nonuniformity <- NA
    aa$bjs.inclussion    <- NA
    
    aa$a.lr            <- NA
    aa$a.fdr           <- NA
    aa$a.logfc         <- NA
    aa$a.nonuniformity <- NA
    aa$a.dpir          <- NA

    aa$l.lr            <- NA
    aa$l.fdr           <- NA
    #aa$l.logfc         <- NA
    aa$l.participation <- NA
    aa$l.dparticipation <- NA

    #Generamos el rango para los bines para clasificar los locales
    bines       <- data.frame(bin = sr@binbased$bin, feature = sr@binbased$feature, gene_coordinates = sr@binbased$gene_coordinates, start = sr@binbased$start, end = sr@binbased$end, 
                              stringsAsFactors = FALSE)
    bines       <- bines[complete.cases(bines), ]
    chromosomes <- strsplit2(bines$gene_coordinates, "[:]")[, 1]
    rango_bines <- GRanges(seqnames = chromosomes, ranges = IRanges(start = bines$start, end = bines$end))
    
    elementos_a_eliminar <- c() #Puede que podamos colapsar algunos elementos, por lo que los duplicados tienen que eliminarse
    
    for(b in 1:nrow(aa)){
      if(aa$b[b] != 0){
        i <- which(original_signals$b$bin == aa$bin[b])
        if(length(i) > 0){
          aa$b.fdr[b] <- original_signals$b$bin.fdr[i[1]]
          aa$b.logfc[b] <- original_signals$b$bin.logFC[i[1]]
        }else{
          aa$b[b] <- "*"
        }
      }
      if(aa$bjs[b] != 0 | aa$b[b] != 0){
        i <- which(original_signals$bjs$J3 == aa$J3[b])
        if(length(i) > 0){
          aa$bjs.lr[b]            <- original_signals$bjs$cluster.LR[i[1]]
          aa$bjs.fdr[b]           <- original_signals$bjs$cluster.fdr[i[1]]
          aa$bjs.logfc[b]         <- original_signals$bjs$J3.logFC[i[1]]
          aa$bjs.nonuniformity[b] <- original_signals$bjs$cluster.nonuniformity[i[1]]
          aa$bjs.inclussion[b]    <- replace_na(original_signals$bjs$cluster.dPSI[i[1]], original_signals$bjs$cluster.dPIR[i[1]])  
        }else{
          if(aa$bjs[b] != 0){
            aa$bjs[b] <- "*"
          }
        }
      }
      if(aa$ja[b] != 0){
        i <- which(original_signals$ja$junction == aa$J3[b])
        if(length(i) > 0){
          aa$a.lr[b] <- original_signals$ja$junction.LR[i[1]]
          aa$a.fdr[b] <- original_signals$ja$junction.fdr[i[1]]
          aa$a.logfc[b] <- original_signals$ja$junction.logFC[i[1]]
          aa$a.nonuniformity[b] <- original_signals$ja$junction.nonuniformity[i[1]]
          aa$a.dpir[b] <- original_signals$ja$junction.dPIR[i[1]]
          #Si no tiene feature se lo tratamos de asignar
          if(is.na(aa$feature[b])){
            i <- which(binbased(sr)$J3 == aa$J3[b])
            if(length(i) > 0){
              if(length(grep("Io", binbased(sr)$bin)) > 0){
                aa$bin.event[b] <- "IoR" #Es un evento conocido, puede venir de un Io  
                aa$bin[b] <- binbased(sr)$bin[i[[1]]]
              }
            }else{            
              if(aa$b[b] == "*"){ #Es un evento complejo, csp
                aa$bin.event[b] <- "CSP" 
              }else if(aa$b[b] == "0"){ #Es un evento nuevo que no se asocia a ningun bin, new alternative splicing pattern
                aa$bin.event[b] <- "Novel ASP" 
              }
            }
          }
        }else{
          aa$ja[b] <- "*"
        }
      }
      if(aa$jl[b] != 0){
        roi <- aa$region[b]
        roi <- gsub("[:]", ".", roi)
        roi <- gsub("[-]", ".", roi)
        i <- which(original_signals$jl$cluster.range == roi)
        if(length(i) > 0){
          aa$l.lr[b] <- original_signals$jl$cluster.LR[i[1]]
          aa$l.fdr[b] <- original_signals$jl$cluster.fdr[i[1]]
          aa$l.participation[b] <- original_signals$jl$cluster.participation[i[1]]
          aa$l.dparticipation[b] <- original_signals$jl$cluster.dparticipation[i[1]]
        }else{ #Vemos si machea con la juntura quizas
          i <- which(original_signals$jl$cluster.range == aa$J3[b])
          if(length(i) > 0){
            aa$l.lr[b] <- original_signals$jl$cluster.LR[i[1]]
            aa$l.fdr[b] <- original_signals$jl$cluster.fdr[i[1]]
            aa$l.participation[b] <- original_signals$jl$cluster.participation[i[1]]
            aa$l.dparticipation[b] <- original_signals$jl$cluster.dparticipation[i[1]]
          }else{
            aa$jl[b] <- "*"
          }
        }
        
        if(aa$jl[b] == 1){ #Encontre el cluster
          if(is.na(aa$feature[b])){ #Tratamos de darle sentido al evento
            junturas <- strsplit2(unique(original_signals$jl$junction[i]), "[.]")
            #Vemos si hay un unico pivot.
            punta_1 <- length(table(junturas[, 2]))
            punta_2 <- length(table(junturas[, 3]))
            
            #Vemos si es alt o complejo              
            if(punta_1 == 1 | punta_2 == 1){
              
              if(punta_1 == 1){
                #Buscamos el rango de las junturas
                rango_min    <- min(as.numeric(junturas[, 3]))
                rango_max    <- max(as.numeric(junturas[, 3]))
                rango        <- GRanges(junturas[1, 1], IRanges(rango_min, rango_max))
                rango_intron <- GRanges(junturas[1, 1], IRanges(rango_min, rango_max - 1))
                
              }else if (punta_2 == 1){ 
                
                #Buscamos el rango de las junturas
                rango_min    <- min(as.numeric(junturas[, 2]))
                rango_max    <- max(as.numeric(junturas[, 2]))
                rango        <- GRanges(junturas[1, 1], IRanges(rango_min, rango_max))
                rango_intron <- GRanges(junturas[1, 1], IRanges(rango_min + 1, rango_max))

              }
              
              #Vemos que tipo de bines atraviezan las junturas. Si son todos del mismo tipo, es alt
              hits        <- data.frame(findOverlaps(rango, rango_bines))
              #if(length(table(bines$feature[hits$subjectHits])) == 1){
              tt <- table(bines$feature[hits$subjectHits])
              tt <- tt[names(tt)!="Io"]
              if(length(tt) == 1){
                aa$bin.event[b] <- "Alt 5'/3'"
              }else{
                #Vemos si se trata de un intron alt
                hits        <- data.frame(findOverlaps(rango_intron, rango_bines))
                tt <- table(bines$feature[hits$subjectHits])
                tt <- tt[names(tt)!="Io"]
                if(length(tt) == 1){
                  aa$bin.event[b] <- "Alt 5'/3'"
                }else{ #No parece ser alt, es complejo entonces
                  aa$bin.event[b] <- "CSP"
                }
              }
              
              #Vemos si el evento es alternativo y si podemos encontrar el bin asociado a este evento
              if(aa$bin.event[b]=="Alt 5'/3'"){
                fo <- data.frame(findOverlaps(rango_intron,rango_bines,type = "equal"))
                if(nrow(fo)==1){
                  rbin <-  data.frame(rango_bines[fo$subjectHits])
                  region_bin <- paste0(rbin[1, 1], ":", rbin[, 2], "-", rbin[, 3])
                  j <- which(as.character(aa$region)== region_bin)
                  if(length(j) > 0){ #Lo encontramos, sacamos directamente esta fila porque coincide con la que ya existe y tiene mas datos.
                    elementos_a_eliminar <- c(elementos_a_eliminar, b)
                    aa[j[1], c("jl", "l.lr", "l.fdr", "l.participation", "l.dparticipation")] <- aa[b, c("jl", "l.lr", "l.fdr", "l.participation", "l.dparticipation")] 
                  }
                  
                } 
              }  
            }else{
              #Vemos si es ES
              if(nrow(junturas) == 3){
                i <- which(original_signals$jl$cluster.range == aa$J3[b])
                if(length(i) > 0){ 
                  aa$bin.event[b] <- "ES"
                  #Vemos si podemos encontrar el bin asociado a este ES o si podemos machear el bin del medio
                  region_intermedia <- paste0(junturas[1, 1], ":", min(as.numeric(junturas[, 3])), "-", max(as.numeric(junturas[, 2])))
                  j <- which(aa$region == aa$J3[b] | aa$region == region_intermedia)
                  if(length(j) > 0){ #Lo encontramos, sacamos directamente esta fila porque coincide con la que ya existe y tiene mas datos.
                    elementos_a_eliminar <- c(elementos_a_eliminar, b)
                    aa[j[1], c("jl", "l.lr", "l.fdr", "l.participation", "l.dparticipation")] <- aa[b, c("jl", "l.lr", "l.fdr", "l.participation", "l.dparticipation")] 
                    #aa$b.fdr[b]   <- binbased(sr)$bin.fdr[j[1]]
                    #aa$b.logfc[b] <- binbased(sr)$bin.logFC[j[1]]
	                  #aa$b[b]       <- 1
                  }
                }else{
                  aa$bin.event[b] <- "CSP"
                }
              }else{ #Si no es nada de lo anterior entonces es complejo
                aa$bin.event[b] <- "CSP"
              }
            }
            #Vemos si es un novel event
            if(any(asd@junctionsPJU$junction[rownames(asd@junctionsPJU) %in% original_signals$jl$junction[i]] == "noHit")){
              aa$bin.event[b] <- paste("Novel", aa$bin.event[b])
            }
          }
        }
      }  
      
      #Tratamos de darle sentido a otros eventos - de bines
      if((aa$b[b] == 1 | aa$bjs[b] == 1 | aa$jl[b] == 1) & aa$bin.event[b] == "-"){
        if(aa$feature[b] == "E"){
          aa$bin.event[b] <- "ASCE"
        }else if(aa$feature[b] == "I"){ 
          if(aa$b[b] != "*" & aa$bjs[b] != "*" & aa$ja[b] != "*" & aa$jl[b] != "*"){
            aa$bin.event[b] <- "IR"
          }else{
            aa$bin.event[b] <- "CSP"
          }
        }
      }      
    }  
    
    #Descartamos elementos duplicados por ES
    if(!is.null(elementos_a_eliminar)){
      aa <- aa[-elementos_a_eliminar, ]
    }
    
    aa <- aa[order(aa$b.fdr), ]
    # r <- strsplit2(unique(aa$region), "Chr")[, 2]
    # chr <- strsplit2(r, ":")[, 1]
    # chr <- sapply(chr, function(s){return(is.na(suppressWarnings(as.numeric(s))))})
    # aa$region[chr] <- r[chr] 
    
    #Finds events with bjs and locale and tries to merge them
    bjs_jl <- aa$b == 0 & aa$bjs == 1 & aa$ja == 0 & aa$jl == 1
    if(any(bjs_jl)){
      regions <- strsplit2(strsplit2(aa$region[bjs_jl], ":")[, 2], "-")
      regions <- cbind(regions, locus=aa$locus[bjs_jl])
      regions <- cbind(regions, bin=aa$bin[bjs_jl])
      regions <- cbind(regions, region_original=aa$region[bjs_jl])
      regions <- as.data.table(regions)
      regions$V1 <- as.numeric(regions$V1)
      regions$V2 <- as.numeric(regions$V2)
      a_descartar <- c()
      for(i in unique(regions$locus)){
        a_ver <- regions[regions$locus == i, ]
        posible_a_descartar <- which(is.na(a_ver$bin))
        if(length(posible_a_descartar) > 0){
          for(j in posible_a_descartar){
            if(any(a_ver$V1 == a_ver$V1[j] + 1 | a_ver$V1 == a_ver$V1[j] - 1 | a_ver$V2 == a_ver$V2[j] - 1 | a_ver$V2 == a_ver$V2[j] - 1)){
              a_descartar <- c(a_descartar, which(aa$region == a_ver$region_original[j] & is.na(aa$bin) & aa$b == 0 & aa$bjs == 1 & aa$ja == 0 & aa$jl == 1))
            }
          }
        }
      }
      if(length(a_descartar)>0){
        aa <- aa[-a_descartar, ]
      }
    }
    
    #Buscamos duplicados
    hash <- apply(aa[, mget(colnames(aa)[!colnames(aa) %in% c("region", "bin.event", "bin", "feature", "binreg")])], 1, paste, collapse = "-")
    duplicados <- table(hash)
    
    #Comparamos los distintos eventos duplicados para mergearlos
    duplicados_a_remover <- c()
    for(duplicado in names(duplicados)[duplicados > 1]){
      if(all(aa$bin.event[hash %in% duplicado] %in% c("Novel ES", "ES", "ASCE"))){
        posibles <- which(hash %in% duplicado)
        duplicados_a_remover <- c(duplicados_a_remover, posibles[is.na(aa$bin[hash %in% duplicado])])
      }
    }
    #Removemos los elementos mergeados
    if(length(duplicados_a_remover) > 0){
      aa <- aa[-duplicados_a_remover, ]
    }
    
  }else{
    aa <- data.table(region = character(), locus = character(), b = numeric(), bjs = numeric(), ja = numeric(),
                     jl = numeric(), bin = character(), feature = character(), bin.event = character(),
                     J3 = character(), binreg = character(), locus_overlap = numeric(), b.fdr = numeric(),
                     b.logfc = numeric(), bjs.lr = numeric(), bjs.fdr = numeric(), bjs.logfc = numeric(), bjs.nonuniformity = numeric(),
                     bjs.inclussion = numeric(), a.lr = numeric(), a.fdr = numeric(), a.logfc = numeric(), a.nonuniformity = numeric(),
                     a.participation = numeric(),
                     a.dparticipation = numeric(), l.lr = numeric(), l.fdr = numeric(), l.logfc = numeric(), l.participation = numeric(),l.dparticipation = numeric())
  }
  is@signals <- aa
  
  return(is)
}

.meanLogCPMIs <- function(is, counts){
  y <- countsb(counts)[, getConditions(counts@targets)]
  y <- apply(cpm(y,log=TRUE),1,mean)
  y <- data.frame(meanLogCPM = y)
  f <- cbind(is@signals, meanLogCPM = y[is@signals$bin,])
  return(f)
}

.counterGenes <- function( reads, feature ) {
  cores = 1
  hits <- mclapply( reads, mc.cores = cores, function( x ) { 
        co <- countOverlaps( feature, x, ignore.strand = TRUE ) 
        gc()
        return(co)
      } )  
  
  # Create result dataframe
  effectiveGeneLength <- sum( width( feature ) )
  geneStarts          <- sapply( start( feature ), min )
  geneEnds            <- sapply( end( feature ), max)
  geneWidths          <- geneEnds - geneStarts + 1
  strand              <- as.character( unlist(runValue( strand( feature ) ) ))
  
  result <- data.frame(
      symbol = feature@elementMetadata$symbol , 
      locus_overlap = feature@elementMetadata$locus_overlap , 
      gene_coordinates = feature@elementMetadata$gene_coordinates , 
      start = geneStarts ,
      end = geneEnds , 
      length = geneWidths , 
      effective_length = effectiveGeneLength)
  #Le ponemos los hits despues porque si los nombres empiezan con un numero se rompen los nombres de las columnas
  for(i in 1:length(hits)){
    result[, names(hits)[i]] <- hits[[i]]
  }
  
  #ACH 20190520: reassure rownames are not lost
  rownames(result) <- names(hits[[1]])
  
  return(result)
}

.counterBin <- function( reads, feature, genes  ) { 
  cores = 1
  hits <- mclapply( reads, mc.cores = cores, function(x) {
        co <- countOverlaps( feature, x, ignore.strand = TRUE)
        gc()
        return(co)
      } )
  
  # Create result dataframe
  binToGeneIndex  <- match( feature@elementMetadata$locus, rownames(genes) )
  geneCoordinates <- genes$gene_coordinates[ binToGeneIndex ]
  
  result <- data.frame( feature@elementMetadata[c ('feature', 'event', 'locus',
              'locus_overlap', 'symbol')], 
      geneCoordinates, 
      as.data.frame( feature@ranges )[ ,c("start", "end", "width")])
  
  #Le ponemos los hits despues porque si los nombres empiezan con un numero se rompen los nombres de las columnas
  for(i in 1:length(hits)){
    result[, names(hits)[i]] <- hits[[i]]
  }
  
  colnames(result)[1:9] <- c( "feature","event","locus","locus_overlap","symbol",
      "gene_coordinates","start","end","length" )
  
  #ACH 20190520: reassure rownames are not lost
  rownames(result) <- names(hits[[1]])
  
  return(result)
}

# ---------------------------------------------------------------------------- #
# .counterJbin Cuenta reads que atraviesan dos bins. 
# TODO: el argumento l es la longitud de una read.  Que pasa con datos que 
#       tienen un tamano de read variable ?
.counterJbin <- function(reads, feature, genes, l) {
  cores=1
  ungapped <- mclapply( reads, mc.cores = cores, function(x) { x[ njunc( x ) == 0 , ] } )
  
  hits <- mclapply( ungapped, mc.cores = cores, function(x) { 
        co <- countOverlaps( feature, x, ignore.strand = TRUE,  minoverlap = l) 
        gc()
        return(co)
      })  
  
  jbinToGeneIndex <- match( feature@elementMetadata$locus, rownames(genes) )
  
  gene_coordinates <- genes$gene_coordinates[jbinToGeneIndex]
  
  result <- data.frame(
      feature@elementMetadata[ c( 'event', 'locus', 'locus_overlap', 'symbol') ], 
      gene_coordinates, 
      as.data.frame(feature@ranges))
  
  #Le ponemos los hits despues porque si los nombres empiezan con un numero se rompen los nombres de las columnas
  for(i in 1:length(hits)){
    result[, names(hits)[i]] <- hits[[i]]
  }
  
  result$names <- NULL
  
  colnames(result)[1:8] <- c( "event", "locus", "locus_overlap", "symbol",
      "gene_coordinates", "start", "end", "length" )
  
  #ACH 20190520: reassure rownames are not lost
  rownames(result) <- names(hits[[1]])
  
  return(result)
  
}

.getGeneGRanges <- function( aspliFeatures ) {
  
  feature <- featuresg( aspliFeatures )
  
  aggregate_first <- function (data, by){
    d = b = NULL # due to NSE notes in R CMD check
    data <- data.table(d=data, b=by) 
    ans  <- data[,list(A = first(d)), by = b]
    return(ans$A)
  }
  
  # Search junctions within genes
  unlistedFeatures <- unlist(feature)
  
  geneAndChr <- paste( names(unlistedFeatures) , as.character( seqnames(unlistedFeatures)), sep="_" )
  geneChr <- aggregate_first( as.data.frame(seqnames(unlistedFeatures))[, 1], by = geneAndChr)
  
  geneStarts <- aggregate( as.data.frame(start(unlistedFeatures)), by = list(geneAndChr), FUN = min)[,2]
  geneEnds <- aggregate( as.data.frame(end(unlistedFeatures)), by = list(geneAndChr), FUN = max)[,2]
  strand <- aggregate_first( as.data.frame(strand(unlistedFeatures))[, 1], by = geneAndChr)
  
  geneCoordinates <- rep( feature@elementMetadata$gene_coordinates ,table(names(unlistedFeatures)))

  geneCoordinates <- aggregate_first( geneCoordinates, by = geneAndChr)
  
  symbols <- rep( feature@elementMetadata$symbol ,table(names(unlistedFeatures)))
  symbols <- aggregate_first( symbols, by = geneAndChr)
  
  geneNames <- aggregate_first( as.data.frame(names(unlistedFeatures),stringsAsFactors=FALSE)[, 1] , by = geneAndChr)
  
  genes <- GRanges(
      seqnames = geneChr ,
      strand = strand,
      ranges = IRanges(geneStarts,geneEnds), 
      gene_coordinates = geneCoordinates,
      symbol=symbols )
  
  mcols(genes)$names <- geneNames
  
  return ( genes )
}

.getJunctionOverlapGeneData <- function(jranges, genes) {
  
  hitGen <- rep("-", length(jranges))
  hitGenStrand <- rep("*", length(jranges))
  gene_coordinates <- rep("-", length(jranges))
  ambiguos <- rep("-", length(jranges))
  symbol <- rep("-", length(jranges))    
  
  overGene <- findOverlaps(jranges, genes, type="within")
  overGeneDF <- as.data.frame(overGene)
  posJrange <- overGeneDF$queryHits 
  posGene <- overGeneDF$subjectHits
  overGeneDF$queryHits <- names(jranges)[as.numeric(overGeneDF$queryHits)]
  overGeneDF$subjectHits <- mcols(genes)$names[as.numeric(overGeneDF$subjectHits)]
  table <- table(overGeneDF$queryHits)

# BUG FIX: aggregate fails with 0-rows dfCountsStart. 
  if ( nrow( overGeneDF  ) > 0 ) {
    ttG <- data.frame(aggregate(subjectHits ~ queryHits, data = overGeneDF, paste, collapse=";"))
  } else {
    ttG <- data.frame( names = character(0) ) 
    for ( i in 1:ncol( overGeneDF ) ) {
      ttG[, i+1] <- integer(0)
    }
    colnames( ttG )[2:ncol(ttG)] <- colnames( overGeneDF )
  }
  
  dd0 <- match(ttG$queryHits, names(jranges))
  hitGen[dd0] <- ttG$subjectHits
  dd <- match(ttG$queryHits, names(table) )
  ttG$undef <- table[dd]
  ttG$tag <- rep("-", nrow(ttG))
  ttG$tag[ttG$undef>1] <- "yes"
  
  ambiguos[dd0] <- ttG$tag
  
  hitGen[posJrange] <-  mcols(genes)$names[posGene]
  hitGen[-posJrange] <- "noHit"
  hitGenStrand[posJrange] <- as.character(strand(genes)[posGene])
  gene_coordinates[posJrange] <- mcols(genes)$gene_coordinates[posGene] 
  symbol[posJrange] <- as.character(genes@elementMetadata$symbol[posGene])
  
  return( list( ambiguos, hitGen, hitGenStrand, gene_coordinates, symbol ) )
}

.getJunctionMatchingBins <- function( features, jranges ) {
  hitBin <- rep("-", length(jranges))
  annJunctions <- featuresj(features)
  overJ <- findOverlaps(jranges, annJunctions, type="equal") #identify annotated junctions
  overJDF <- as.data.frame(overJ) #get a df
  namesJ <- as.numeric(overJDF[,1])  #get index of jrangs that hit against annJunctions
  namesAnnJ <- as.numeric(overJDF[,2]) #get index of annJunctions thta hit against jranges
  #jname[namesJ] <- names(jranges[namesJ])
  hitBin[namesJ] <- names(annJunctions[namesAnnJ]) #ok, metadata vector
  hitBin[-namesJ] <- "noHit" #ok,  metadata vector. 
  return(hitBin)
}

.getJunctionSpanningBins <- function( jranges, exonsBins) {
  over <- findOverlaps(jranges, exonsBins)
  overDF <- as.data.frame(over)
  namesJ <- as.numeric(overDF[,1])
  overDF[,1] <- names(jranges[namesJ])
  namesBins <- as.numeric(overDF[,2])
  overDF[,2] <- names(exonsBins[namesBins])
  
# BUG FIX: aggregate fails with 0-rows dfCountsStart. 
  if ( nrow( overDF  ) > 0 ) {
    tt <- data.frame(aggregate(subjectHits ~ queryHits, data = overDF, paste, collapse=";")) 
  } else {
    tt <- data.frame( names = character(0) ) 
    for ( i in 1:ncol( overDF ) ) {
      tt[, i+1] <- integer(0)
    }
    colnames( tt )[2:ncol(tt)] <- colnames( overDF )
  }
  
  span <- rep("-", length(jranges))
  te <- match(names(jranges), tt$queryHits)
  span[ ! is.na(te) ] <- tt$subjectHits[te][ ! is.na(te) ]
  return(span)
}

.getJunctionWithinBins <- function(jranges, exonsBins) {
  j_within_bin <- rep("-", length(jranges))
  overJunctionWithinBins <- findOverlaps(jranges, exonsBins, type="within")
  if (length (overJunctionWithinBins ) > 0) {
    overJunctionWithinBinsDF <- as.data.frame(overJunctionWithinBins)
    namesJ <- as.numeric(overJunctionWithinBinsDF[,1])
    namesB <- as.numeric(overJunctionWithinBinsDF[,2])
    overJunctionWithinBinsDF[,1] <- names(jranges[namesJ])
    overJunctionWithinBinsDF[,2] <- names(exonsBins[namesB])
    agtt <- data.frame( aggregate( subjectHits ~ queryHits,
            data = overJunctionWithinBinsDF, paste, collapse=";")) 
    tw <- match(names(jranges), agtt$queryHits) 
    j_within_bin[ ! is.na(tw) ] <- agtt$subjectHits[tw][ ! is.na(tw) ]
  }
  return( j_within_bin )
}

.ovBinJunction <- function( features, jranges ) {
  
# Creates GRanges for genes, including repeating genes in different
# chromosomes
  genes <- .getGeneGRanges( features )
  
  # Looks for data of junction overlapping genes
  ovGene <- .getJunctionOverlapGeneData( jranges, genes )
  ambiguos <- ovGene[[1]]
  hitGen <- ovGene[[2]]
  hitGenStrand <- ovGene[[3]]
  gene_coordinates <- ovGene[[4]]
  symbol <- ovGene[[5]]
  
  # Search junction equal to annotated junctions
  hitBin <- .getJunctionMatchingBins(features, jranges)
  
  # Search junctions spanning bins
  exonsBins <- featuresb(features)[featuresb(features)@elementMetadata$feature=="E",]
  span <- .getJunctionSpanningBins(jranges, exonsBins )
  
  # Search junctions within exons!
  j_within_bin <- .getJunctionWithinBins(jranges, exonsBins)

  mcols(jranges) <- append( mcols(jranges), DataFrame(
          hitBin=hitBin, 
          hitGen=hitGen, 
          hitGenStrand=hitGenStrand,
          gene_coordinates=gene_coordinates,
          undef=ambiguos,
          bin_spanned=span,
          j_within_bin=j_within_bin,
          symbol=symbol))
  return(jranges)
}  

.counterJunctions <- function(features, bam, maxISize) {
  cores=1
    ujunctions <- mclapply (bam, mc.cores = cores, function(x)    {  
          junctions <- unlist(junctions(x) )
          strand(junctions) <- "*"
          start(junctions) <- start(junctions)-1
          end(junctions) <- end(junctions)+1
          ujunctions <- unique(junctions)
          gc()
          return(ujunctions)   
        } )
  jranges <- unique( unlist( GRangesList( unlist( ujunctions ) ) ) )
  
  # Filter junctions by Intron size
  maxWidth <-  maxISize+2
  jranges <- jranges[width(jranges)<= maxISize]
  
  #Here I summarize hits agains the element
  fcoord <- paste(seqnames(jranges), 
      start(jranges),
      end(jranges) , sep="." )
  jranges@ranges@NAMES <- fcoord

  jcounts <- mclapply(bam, mc.cores = cores, function(x) {
        junctions <- unlist(junctions(x) )
        strand(junctions)<- "*"
        start(junctions) <- start(junctions)-1
        end(junctions) <- end(junctions)+1
        count <- countMatches(jranges, junctions)    
        jc <- data.frame(row.names=names(jranges), count)
        gc()
        return(jc)
      })
  
  df <- do.call("cbind", jcounts)
  colnames(df) <- names(jcounts)

  jranges <- .ovBinJunction(features, jranges)
  
  jrdf <- data.frame(
      as.data.frame(jranges@elementMetadata$hitBin), 
      as.data.frame(jranges@elementMetadata$hitGen), 
      as.data.frame(jranges@elementMetadata$hitGenStrand),
      as.data.frame(jranges@elementMetadata$undef),
      as.data.frame(jranges@elementMetadata$symbol), 
      as.data.frame(jranges@elementMetadata$gene_coordinates),
      as.data.frame(jranges@elementMetadata$bin_spanned),
      as.data.frame(jranges@elementMetadata$j_within_bin),
      row.names=names(jranges)  )
  
  colnames(jrdf) <- c("junction", 
      "gene", 
      "strand",
      "multipleHit",
      "symbol",
      "gene_coordinates",
      "bin_spanned",
      "j_within_bin")
  
  rownames(jrdf) <- names(jranges)
  aa <- merge(jrdf, df, by.x="row.names", by.y="row.names", sort=FALSE)
  rnames <- paste(start(jranges)-1,end(jranges)+1, sep="-" )
  rownames(aa) <- fcoord
  aa$Row.names <- NULL
  return(aa)
}

.mergeBinDUAS <- function( du, as, targets, contrast = NULL ) { 
  
  targets <- .condenseTargetsConditions( targets )
  bas <- joint( as )
  bdu <- binsDU( du )
  bas$event <- NULL
  
  bas2 <- as.data.frame( matrix( NA, nrow = nrow( bdu ), ncol = ncol( bas ) ) )
  rownames( bas2 ) <- rownames( bdu )
  colnames( bas2 ) <- colnames( bas )
  
  bas2[ intersect( rownames( bas ), rownames( bdu ) ), ] <- bas[ intersect( rownames( bas ), rownames( bdu ) ),  ]
  bas2[,'J1'] <- levels( bas[,'J1'] )[ bas2[,'J1'] ]
  bas2[,'J2'] <- levels( bas[,'J2'] )[ bas2[,'J2'] ]
  bas2[,'J3'] <- levels( bas[,'J3'] )[ bas2[,'J3'] ]
  
  if ( is.null( contrast )) contrast <- .getDefaultContrasts( targets$condition )

  psir <- t( bas2[ , getConditions( targets ) ] )
  psir <- psir * contrast
  psir <- t( psir[ contrast != 0, ] )
  psir <- data.frame( delta = rowSums( psir ) )
  
  r <- cbind( bdu, bas2[ ,], psir )
  colnames( r ) <- c( colnames( bdu), colnames( bas2), 'delta' )
  return( r )
  
}

.DUreport <- function( 
    counts, 
    targets, 
    minGenReads  = 10,
    minBinReads  = 5,
    minRds = 0.05,
    offset = FALSE,
    offsetAggregateMode = c( "geneMode", "binMode" )[1],
    offsetUseFitGeneX = TRUE,
    contrast = NULL,
    ignoreExternal = TRUE,
    ignoreIo = TRUE, 
    ignoreI = FALSE,
    filterWithContrasted = TRUE,
    verbose = FALSE,
    threshold = 5
    # ---------------------------------------------------------------------- #
    # Comment to disable priorcounts usage in bin normalization 
    # , priorCounts = 0 
    # ---------------------------------------------------------------------- #
  ) {
  
  # Create result object                   
  du <- new( Class="ASpliDU" )
  
  # Generate conditions combining experimental factors
  targets <- .condenseTargetsConditions( targets ) 
  
  # Filter genes and calculates differential usage of genes
  du <- .DUreportGenes( du, counts, targets, minGenReads, minRds, contrast, 
      filterWithContrasted, verbose )

  # Filter bins and calculates differential usage of bins 
  du <- .DUReportBins( du, 
                       counts, 
                       targets, 
                       minGenReads, 
                       minBinReads, 
                       minRds,
                       offsetAggregateMode, 
                       offsetUseFitGeneX, 
                       offset, 
                       contrast, 
                       ignoreExternal, 
                       ignoreIo, 
                       ignoreI,
                       filterWithContrasted,
                       verbose ) 
  # ------------------------------------------------------------------------ #
  
  #Adds junctionDUreport if offset is FALSE
  if(offset == FALSE) du <- .junctionDUreport(counts = counts, targets = targets, appendTo = du, 
                                              minGenReads = minGenReads, minRds = minRds, threshold = threshold,
                                              contrast = contrast)

  return( du )
}

.junctionDUreport <- function ( 
    counts, 
    targets, 
    appendTo = NULL, 
    minGenReads = 10,
    minRds = 0.05,
    threshold = 5,
    offset   = FALSE,
    offsetUseFitGeneX = TRUE,
    contrast = NULL,
    forceGLM = FALSE 
    # ------------------------------------------------------------------------ #
    # Comment to disable priorcounts usage in bin normalization 
    # , priorCounts = 0 
    # ------------------------------------------------------------------------ #
) {
  
  du <- if ( is.null( appendTo ) ) new( Class = "ASpliDU" ) else appendTo
  
  targets <- .condenseTargetsConditions( targets )
  
  df0 <- countsg(counts)
  
  dfG0 <- .filterByReads(
      df0 = df0,
      targets = targets,
      min = minGenReads,
      type = "all")
  
  dfGen <- .filterByRdGen(
      df0 = dfG0,
      targets = targets,
      min = minRds,
      type = "all" )
  
  df0 <- countsj(counts)[countsj(counts)[,"gene"]%in%rownames(dfGen),]
  
  df <- .filterJunctionBySample( df0 = df0, 
      targets = targets, 
      threshold = threshold)  #mean > one of the condition
  
  df <- df[ df$multipleHit == "-",]
  
  if( offset ){
    
    warning( simpleWarning( "Junctions DU with offsets is not fully tested. Use results with caution") )
    mOffset <- .getOffsetMatrix( 
        df, 
        dfGen,
        targets,
        offsetAggregateMode = 'geneMode',
        offsetUseFitGeneX= offsetUseFitGeneX )
  } else {
    mOffset <- NULL
  }

  junctionsdeSUM <- .junctionsDU_SUM(
      df = df,
      dfGen = dfGen,
      targets = targets,
      mOffset = mOffset,
      contrast = contrast,
      priorCounts = 0  
      # ------------------------------------------------------------------ # 
      # Comment to disable priorcounts usage in normalizefeatuebygen.         
#          ,priorCounts = priorCounts
      
  # ------------------------------------------------------------------ # 
  )
  
  
  du@junctions <- junctionsdeSUM
  message( "Junctions DU completed" )
  
  return( du )
}


.DUreportBinSplice <- function (  
    counts, 
    targets,
    minGenReads  = 10,
    minBinReads  = 5,
    minRds = 0.05,
    contrast = NULL,
    forceGLM = FALSE,
    ignoreExternal = TRUE, 
    ignoreIo = TRUE, 
    ignoreI = FALSE,
    filterWithContrasted = TRUE,
	  verbose = TRUE,
    formula = NULL,
    coef = NULL) {

  if(is.null(contrast) & is.null(formula)){
    stop("Must provide either contrast or formula.")
  }
  if(is.null(targets)){
    targets <- counts@targets
  }
  
  # Create result object                   
  du <- new( Class="ASpliDU" )
  
  #Contrast comes before formula
  if(!is.null(contrast)){
    du@contrast        <- contrast
    formula            <- NULL
  }else{
    design             <- model.matrix( formula, data = targets )
    contrast           <- ginv(design)
    if(is.null(coef)){
      coef <- nrow(contrast)
    }
    contrast           <- contrast[coef, ] #We add one because the first element is the intercept
    contrast[abs(contrast) < 1e-5] <- 0  
    contrastAggregated <- aggregate(contrast~targets$condition,FUN=sum)
    contrast <- setNames(contrastAggregated[,2],contrastAggregated[,1])[counts@condition.order]
    du@contrast        <- contrast    
  }
  if(!.hasSlot(counts, ".ASpliVersion")){
    counts@.ASpliVersion = "1" #Last version before 2.0.0 was 1.14.0. 
  }
  if(counts@.ASpliVersion == "1"){
    targets <- .condenseTargetsConditions( targets ) 
  }else{
    names(du@contrast) <- counts@condition.order
  }

  # Generate conditions combining experimental factors
  #targets <- .condenseTargetsConditions( targets ) 
  
  # Filter genes and calculates differential usage of genes
  du <- .DUreportGenes( du, counts, targets, minGenReads, minRds, contrast, 
       filterWithContrasted, verbose, formula, coef )
  message("Genes DE completed")

  # Filter bins and calculates differential usage of bins 
  du <- .DUReportBinsWithDiffSplice( counts, targets, contrast, du, minGenReads, 
      minBinReads, minRds, ignoreExternal, ignoreIo, ignoreI, filterWithContrasted, formula, coef )
  message("Bins DE completed")
  
  return( du )
  
}

.DUreportGenes <- function (
    du, 
    counts, 
    targets, 
    minGenReads  = 10,
    minRds = 0.05,
    contrast = NULL,
    filterWithContrasted = TRUE,
    verbose = FALSE,
    formula = NULL,
    coef    = NULL) {
  
  dfGen <- .filterGenes( counts, targets, minGenReads, minRds, contrast, 
      filterWithContrasted, verbose )
  
  genesde <- .genesDE( df=dfGen, targets = targets,
      contrast = contrast, verbose, formula, coef  )
  
  genesDE( du ) <- genesde
  
  return( du )
  
}

.DUReportBins <- function( 
    du, 
    counts, 
    targets, 
    minGenReads, 
    minBinReads, 
    minRds,
    offsetAggregateMode, 
    offsetUseFitGeneX, 
    offset, 
    contrast, 
    ignoreExternal, 
    ignoreIo, 
    ignoreI,
    filterWithContrasted = TRUE,
    verbose = FALSE) {
  
  # Filter bins
  filteringResult <- .filterBins(counts, targets, minGenReads, minBinReads, 
      minRds, ignoreIo, contrast, filterWithContrasted, verbose )
  dfGen <- filteringResult$genes
  df2   <- filteringResult$bins
  
  if ( verbose ) message( "Differential usage of bins:")
  
  # Set offset matrix if required
  if( offset ) {
    if ( verbose ) message( "  Using an offset matrix")
    mOffset <- .getOffsetMatrix(
        df2,
        dfGen,
        targets,
        offsetAggregateMode = offsetAggregateMode,
        offsetUseFitGeneX   = offsetUseFitGeneX,
        verbose)
    mOffset <- mOffset[ rownames( df2 ), ]
  } else {
    mOffset <- NULL
  }
  
  # Calculate bins DU
  binsdu <- .binsDU(
      df = df2,
      dfGen = dfGen,
      targets = targets,
      mOffset = mOffset,
      contrast = contrast,
      ignoreExternal = ignoreExternal,
      ignoreIo = ignoreIo, 
      ignoreI = ignoreI
      # -------------------------------------------------------------------- # 
      # Comment to disable priorcounts usage 
      , priorCounts = 0, 
      # , priorCounts = priorCounts 
      # -------------------------------------------------------------------- #
      verbose
  ) 
  
  binsDU( du ) <- binsdu
  if ( verbose ) message( "Differential usage of bins done")
  return( du )
}

.DUReportBinsWithDiffSplice <- function( counts, targets, contrast, du, 
    minGenReads, minBinReads, minRds, ignoreExternal, ignoreIo, ignoreI, 
	filterWithContrasted, formula, coef ) {
  
  # Filter bins
  countData <- .filterBins( counts, targets, minGenReads, minBinReads, minRds, 
      ignoreIo, contrast, filterWithContrasted )

  binsdu <- .binsDUWithDiffSplice( countData[[2]], targets, contrast, 
		  ignoreExternal, ignoreIo, ignoreI, formula, coef )[[1]]  
  #colnames(binsdu)[1]<-"locus"
  
  binsDU( du ) <- binsdu
  
  return( du )
}



.filterGenes <- function( counts, targets, minGenReads, minRds, contrast= NULL, 
    filterWithContrasted = TRUE, verbose = FALSE ) {
  
  if ( verbose ) { message( "Filtering genes:") }
  
  dfG0 <- .filterByReads( df0 = countsg( counts ), targets = targets,
      min = minGenReads, type = "any", contrast, 
      onlyContrast = filterWithContrasted, verbose )
  
  dfGen <- .filterByRdGen( df0 = dfG0, targets = targets,
      min = minRds, type = "any", contrast, 
      onlyContrast = filterWithContrasted, verbose ) 
  
  if ( verbose ) { message( "Filtering genes done") }
  
  return( dfGen )
  
} 

.filterBins <- function( counts, targets, minGenReads, minBinReads, minRds, 
    ignoreIo, contrast, filterWithContrasted, verbose = FALSE ) {
  
  if ( verbose ) { message( "Filtering bins") }

  if ( verbose ) { message( "  Selection of expressed genes") }
  
  dfG0 <- .filterByReads( df0 = countsg( counts ), targets = targets,
      min = minGenReads, type = "all" , contrast, 
      filterWithContrasted , verbose )
  
  dfGen <- .filterByRdGen( df0 = dfG0, targets = targets, 
      min = minRds, type = "all" , contrast, 
      filterWithContrasted, verbose )
  
  if ( verbose ) { message( "  Selection of expressed genes done") }
  
  dfBin <- countsb(counts)[countsb(counts)[,"locus"]%in%row.names(dfGen),]
  
  if( ignoreIo ) dfBin <- dfBin[dfBin[,"feature"]!="Io",]
  
  if ( verbose ) { message( "  Selection of bins of expressed genes") }
  
  df1 <- .filterByReads( df0=dfBin, targets=targets, 
      min=minBinReads, type="any", contrast, 
      filterWithContrasted, verbose )
  
  df2 <- .filterByRdBinRATIO( dfBin=df1, dfGen=dfGen,
      targets=targets, min=minRds, type="any", contrast , 
      filterWithContrasted, verbose )
  
  if ( verbose ) { message( "Filtering bins done") }
  
  return( list( 'genes'=dfGen, 'bins' = df2 ) )
  
}


.filterByReads <- function( df0, targets, min, type, contrast = NULL, 
    onlyContrast = FALSE, verbose = FALSE ) {

  # subset a working data frame
  cropped <- .extractCountColumns( df0, targets )
  if ( verbose ) { message( "  Filtering by reads.") }
  
  return( .filterByGeneric( cropped, df0, targets, min, type, contrast,
          onlyContrast, verbose  ) )

}


.filterByRdGen <- function( df0, targets, min, type, contrast = NULL, 
    onlyContrast = FALSE, verbose = FALSE ) {
  # keeps those genes which avg rd > min in any condition
  cropped <- .extractCountColumns( df0, targets ) / df0$effective_length
  if ( verbose ) { message( "  Filtering by read density.") }
  
  return( .filterByGeneric( cropped, df0, targets, min, type, contrast,
          onlyContrast, verbose ) )
}

.filterByGeneric <- function( cropped, df0, targets, min, type, contrast = NULL, 
    onlyContrast = FALSE, verbose = FALSE ) {
  
  # Get contrasted conditions
  contrastedConditions <- .getFilteringConditions( targets, contrast, 
      onlyContrast )
  if (verbose) message( paste("  Filtering using", paste( contrastedConditions, 
                collapse = ",") ,"conditions") )
  
  # TODO: vectorize this code
  list <- matrix( unlist(
          lapply( contrastedConditions , 
              function( x ) {
                rowMeans( cropped[ , targets$condition == x , drop = FALSE] ) >= min } )),  
      nrow = nrow( cropped ), 
      byrow = FALSE )
  
  
  if (type=="any")  {
    if (verbose) message( paste("  Filtering any condition with mean minimum value",min) )    
    filteredDF <- df0[ rowSums( list ) > 0             , ]
  } else  {
    if (verbose) message( paste("  Filtering all conditions with mean minimum value",min) )    
    filteredDF <- df0[ rowSums( list ) == length( contrastedConditions ) , ]
  }
  
  return (filteredDF)
}


.filterByRdBinRATIO <- function( 
    dfGen,
    dfBin,
    targets, 
    min, 
    type,
    contrast = NULL,
    onlyContrast = FALSE,
    verbose = FALSE) {

  # -------------------------------------------------------------------------- #
  # Get densities for genes and bins
  genes.rd <- .extractCountColumns( dfGen, targets ) / dfGen$effective_length 
  bins.rd  <- .extractCountColumns( dfBin, targets ) / dfBin$length
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Get contrasted conditions
  contrastedConditions <- .getFilteringConditions( targets, contrast, 
      onlyContrast )
  if (verbose) message( paste("  Filtering using", paste( contrastedConditions, 
                collapse = ",") ,"conditions") )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Calculates avg. bin density by condition
  # TODO: vectorize this code
  avRdBin <- matrix( unlist(
          lapply( contrastedConditions , 
              function( x ) { 
                rowMeans( bins.rd[ , targets$condition == x, drop = FALSE] ) 
              } ) ),  
      nrow = nrow( bins.rd ), 
      byrow = FALSE) 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Calculates avg. gene density by condition
  # TODO: vectorize this code
  avRdGen <- matrix( unlist(
          lapply( contrastedConditions, 
              function(x) rowMeans(genes.rd[ , targets$condition == x, drop = FALSE]))),  
      nrow = nrow(genes.rd), 
      byrow = FALSE)#Ok
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Calculates bin to gene read density ratio
  gen.rdb <- avRdGen[ match( dfBin$locus, rownames( dfGen ) )  , ]
  bin.gen.rd <-  avRdBin / gen.rdb
  bin.gen.rd[ is.na( bin.gen.rd ) ] <- 0 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Apply filter
  if ( type == "any" )  { 
    if (verbose) message( paste("  Filtering any condition with mean minimum value",min) )    
    dfBin <- dfBin[ rowSums( bin.gen.rd >= min ) > 0 ,]
  } else{ 
    if (verbose) message( paste("  Filtering all conditions with mean minimum value",min) )    
    dfBin <- dfBin[ rowSums( bin.gen.rd >= min ) == length( contrastedConditions ) ,]
  }
  # -------------------------------------------------------------------------- #
  
return (dfBin)
}

.getFilteringConditions <- function ( targets, contrast, onlyContrast ) {

  allConditions <- getConditions( targets )
  
  constrast <- if ( is.null( contrast) ) .getDefaultContrasts( targets$condition )
  
  if ( onlyContrast && ( ! is.null( contrast  ) ) ) {
    return( allConditions[ (contrast != 0) ] ) 
  } else {
    return( allConditions )
  }   
}

# ---------------------------------------------------------------------------- #
.normalizeByGenFeature <- function( feature, gene, targets, priorCounts = 0,
    verbose = FALSE) {

  if ( verbose ) message( "  Using bin/gene normalization")
  
  # Search the column with the gene name in the features 
  colLocus <- match( c( "gene", "locus" ), colnames( feature ) )
  colLocus <- colLocus[ ! is.na( colLocus ) ][1]
  
  # Repeat gene rows by the number of bins in that gene 
  f.index <- match( feature[ , colLocus ], rownames(gene) ) 
  counts.genes.f <- gene[f.index,]

  # Extract count data
  counts.genes.f  <- .extractCountColumns( counts.genes.f, targets)
  counts.features <- .extractCountColumns( feature, targets) 
  
  # Calculate mean of gene counts 
  gen.mean.f <- rowMeans( counts.genes.f )   
  
  # Apply normalization
  normalizedCounts <- round( ( as.matrix(  counts.features ) + priorCounts ) / 
                       ( as.matrix( counts.genes.f ) + priorCounts ) * 
                       ( gen.mean.f + priorCounts ) )
  
  # Set invalid results to zero
  normalizedCounts[ is.na( normalizedCounts ) | is.infinite( normalizedCounts) ] <- 0 
  
  # Create result dataframe
  normalizedFull <- cbind( .extractDataColumns( feature , targets ) , normalizedCounts )

  return( normalizedFull )
}
# ---------------------------------------------------------------------------- #

.getDefaultContrasts <- function ( conditions ) {
  contrast <- rep( 0, length( unique( conditions ) ) )
  contrast[1:2] <- c(-1,1)
  return( contrast )
}

.genesDE <- function( df, targets, contrast = NULL,
    verbose = FALSE, formula = NULL, coef = NULL ) { 
  
  if (verbose) message("Genes differential expression:")
  
  if( is.null( contrast ) ) contrast <- .getDefaultContrasts(targets$condition)
  
  if ( verbose ) {
    msg <- paste(mapply( paste0,contrast[contrast!=0],
            getConditions(targets)[contrast!=0 ]),collpase = " ") 
    message("  Contrast:",msg)
  }
  
  cols <- match( rownames( targets ), colnames( df ) )
  
  group <- targets$condition
  
  groupFactor <- factor( group, unique( group ), ordered = TRUE )
  
  er <- DGEList( counts = df[ , cols ], samples=targets, group=groupFactor)
  er <- calcNormFactors( er )
  
  justTwoConditions <- sum( contrast != 0 ) == 2
  
  if( justTwoConditions & !  is.null(formula)){
    if (verbose) message("  Running exact test")
    er   <- estimateDisp( er , robust=TRUE)
    capture.output( er   <- estimateDisp( er, robust=TRUE ) )
    pair <- which( contrast != 0 )
    
    # at this point pair must have just two elements.
    # the first element of pair is assumed to be the control. 
    # Therefore, pair must be adjusted according to contrast 
    pair <- if (contrast[pair][1] == -1) pair else rev(pair)
    et   <- exactTest(er, pair=pair)
  } else {
    if (verbose) message("  Running GLM LRT")
    if(is.null(formula)){
      design   <- model.matrix( ~0 + groupFactor, data = er$samples )
      captured <- capture.output(
          er     <- estimateDisp( er, design = design , robust=TRUE)
      )
      glf    <- glmFit( er, design = design)  
      et     <- glmLRT( glf, contrast = contrast)
    }else{
      if(verbose) message("  Running with formula")
      design   <- model.matrix( formula, data = er$samples )
      captured <- capture.output(
        er     <- estimateDisp( er, design = design , robust=TRUE)
      )
      glf    <- glmFit( er, design = design)  
      et     <- glmLRT( glf, coef = coef )
    }
  } 
  
  fdr.gen <- p.adjust( et$table$PValue, method="BH" )
  
  cols <- match(rownames( targets ), colnames( df ) )
  geneData <- .extractDataColumns( df, targets )
  genesFull <- data.frame( geneData ,
      logFC = as.numeric( et$table$logFC ), 
      pvalue = as.numeric( et$table$PValue ), 
      gen.fdr = as.numeric(fdr.gen), 
      stringsAsFactors = FALSE)
  rownames( genesFull ) <- rownames( df )
  
  if (verbose) message("Genes differential expression done")
  
  return( genesFull )
}


.binsDU <- function (
      df,
      dfGen,
      targets,                   
      ignoreExternal= TRUE, 
      ignoreIo = TRUE, 
      ignoreI = FALSE,
      contrast = NULL,

      mOffset  = NULL,
      priorCounts = 0,
      verbose = TRUE) {

  # -------------------------------------------------------------------------- #
  # Filtrar bins de acuerdo de diferentes criterios
  df = df[ ! ignoreExternal | df$event != "external" ,] 
  df = df[ ! ignoreIo | df$feature != "Io" ,] 
  df = df[ ! ignoreI | df$feature != "I" ,] 
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Normalize bins by gen or filter offsets
  if( is.null( mOffset ) ){
    df <- .normalizeByGenFeature( feature=df, gene=dfGen, targets = targets, 
        priorCounts = priorCounts, verbose )
  } else {
    mOffset <- mOffset[ rownames( df ), ]
  }
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # perform edgeR extact or glm test 
  et <- .edgeRtest( df, dfGen, targets, mOffset, contrast, verbose )
  # -------------------------------------------------------------------------- #
  
  # -------------------------------------------------------------------------- #
  # Build result dataframe
  bin.fdr <- p.adjust( et$table$PValue, method="BH" )
  logFC   <- et$table$logFC
  pvalue  <- et$table$PValue
  
  cols <- match( rownames( targets ), colnames( df ) )

  splicing_full <- data.frame ( df[ , -cols ],
      logFC, 
      pvalue,
      bin.fdr,
      stringsAsFactors = FALSE )
  
  rownames( splicing_full ) <- rownames( df )
  
  return( splicing_full )
  # -------------------------------------------------------------------------- #
  
}

.binsDUWithDiffSplice <- function( countData, targets, contrast, 
    ignoreExternal = FALSE, ignoreIo = TRUE, ignoreI = FALSE, formula = NULL, coef = NULL){
  
  # Filter bins
  countData = countData[ ! ignoreExternal | countData$event != "external" ,] 
  countData = countData[ ! ignoreIo | countData$feature != "Io" ,] 
  countData = countData[ ! ignoreI | countData$feature != "I" ,] 
  
  # Define group and contrast
  #targets$condition <- rep(c("adjacent_non_tumor_tissue", "tumor_tissue"), each=3)
  group <- targets$condition
  if( is.null( contrast ) ) contrast <- .getDefaultContrasts( group )
  
  # make DU analysis
  y <- DGEList( counts = .extractCountColumns( countData, targets ),
      group = factor( group, levels = getConditions(targets), ordered = TRUE) ,
      genes = .extractDataColumns(countData, targets) )       

  # TODO: Este filtro es muy resctrictivos
  #  keep <- rowSums( cpm( y ) > 1) >= 2
  #  y <- y[ keep, , keep.lib.sizes = FALSE ]
	y <- calcNormFactors( y )
  
  
  # model.matrix sort columns alphabetically if formula has characters instead 
  # of factors. Therefore to preserve order group is converted to ordered factors 
  groupFactor <- factor( group, unique( group ), ordered = TRUE )
  
  if(is.null(formula)){
    design <- model.matrix( ~0 + groupFactor, data = y$samples )
    
    y   <- estimateDisp( y, design, robust=TRUE )
    fit <- glmFit( y, design )
    ds  <- diffSpliceDGE( fit, contrast = contrast, geneid = "locus", exonid = NULL, verbose = FALSE )
  }else{
    message("Running with formula")
    y$samples <- targets
    design <- model.matrix( formula, data = y$samples )
    
    y   <- estimateDisp( y, design , robust=TRUE)
    fit <- glmFit( y, design )
    ds  <- diffSpliceDGE( fit, coef = coef, geneid = "locus", exonid = NULL, verbose = FALSE )    
  }
  tsp <- topSpliceDGE( ds, test = "exon", FDR = 2, number = Inf )
  tspg<- topSpliceDGE( ds, test = "gene", FDR = 2, number = Inf )
  
  # make column names equal to the results of DUReport method
  colnames( tsp )[ match( 'FDR', colnames( tsp )) ] <- 'bin.fdr'
  colnames( tsp )[ match( 'P.Value', colnames( tsp )) ] <- 'pvalue'
  tsp$exon.LR <- NULL
  
  #tsp <- tsp[,c("locus","logFC","pvalue","bin.fdr")]
  #colnames(tsp)[1]<-"J3"
  
  rownames(tspg) <- tspg$locus
  tspg <- tspg[,c("gene.LR","P.Value","FDR")]
  colnames(tspg)[1:3] <- c("cluster.LR","cluster.pvalue","cluster.fdr")
  
  return( list(junction=tsp,cluster=tspg) )
  
  
 # return( tsp )
  
} 

.junctionsDU_SUM <- function( df, 
                              dfGen,
                              targets, 
                              mOffset = NULL,
                              contrast = NULL,
                              priorCounts = 0 ) {

  # -------------------------------------------------------------------------- #
  # Inner function to compute junction ratio
  jratio <- function( junctions ) {
    junctions[ is.na( junctions ) ] <- 0 
    return( junctions[1] / ( junctions[1] + junctions[2] ) )
  }
  # -------------------------------------------------------------------------- #
  
  if( is.null( mOffset ) ) {
    df <- .normalizeByGenFeature( feature=df, gene=dfGen, targets, priorCounts )
  }
  
  et <- .edgeRtest( df, dfGen, targets, mOffset, contrast)
  
  fdr <- p.adjust( et$table$PValue, method="BH" )
  logFC <- et$table$logFC
  pvalue <- et$table$PValue
  
  group<- targets$condition
  
  jranges <- .createGRangesExpJunctions( rownames( df ) )

# TODO:  Es Necesario seguir preguntando por una version vieja de IRanges ?
# Ademas, las dos llamadas a la version vieja llaman diferente al parametro
# ignore.redundant ( en la otra llamada es ignoreRedundant )
#  if ( packageVersion("IRanges") < 2.6) {
#    j.start <- findOverlaps( jranges, ignoreSelf=TRUE, ignore.redundant=FALSE,
#        type="start")  
#  } else {
    j.start <- findOverlaps( jranges, drop.self=TRUE, drop.redundant=FALSE,
        type="start")
#  }
  
  jjstart <- as.data.frame( j.start )
  
  jjstart$queryHits <- names(jranges[jjstart$queryHits])
  jjstart$subjectHits <- names(jranges[jjstart$subjectHits])
  
  
  # BUG FIX: aggregate fails when no junction overlaps 
  if ( length( j.start ) > 0) {
    shareStart <- data.frame(aggregate(subjectHits ~ queryHits, 
            data = jjstart, paste, collapse=";"))
  } else {
    shareStart <- data.frame( 
        subjectHits = character(0), 
        queryHits = character(0))
  }
  
  start <- ncol( df ) - nrow(targets) + 1 
  end   <- ncol( df ) 

  dfCountsStart <- data.frame( names=jjstart$queryHits, 
      df[ jjstart$subjectHits, start:end],
      row.names=NULL) 
  
  # BUG FIX: aggregate fails with 0-rows dfCountsStart. 
  if ( nrow( dfCountsStart  ) > 0 ) {
    dfSumStart <- data.frame(aggregate(. ~ names, data = dfCountsStart, sum))
  } else {
    dfSumStart <- data.frame( names = character(0) )
    for ( i in 1:ncol( dfCountsStart ) ) {
      dfSumStart[, i+1] <- integer(0)
    }
    colnames( dfSumStart )[2:ncol(dfSumStart)] <- colnames( dfCountsStart )
  }
  
  
  sumJ <- paste(colnames(dfSumStart), "jsum", sep=".")
  colnames(dfSumStart) <-  sumJ
  rownames(dfSumStart) <- dfSumStart$names.jsum
  
  dfSumStart$names.jsum <- NULL

  dffStart <- data.frame(matrix(NA, nrow =  nrow(df), ncol = ncol(dfSumStart)) )
  rownames(dffStart) <- rownames(df)
  colnames(dffStart) <- colnames(dfSumStart)  
  mSumStart <- match( row.names(dfSumStart), row.names(dffStart)) 
  
  dffStart[mSumStart,] <-  dfSumStart
  dffStart[is.na(dffStart)] <- 0
  
  mbin_start_hit <- match(shareStart$queryHits, row.names(dffStart))
  #aca reacomodo el bin_start_hit con el indexado de dffStart
  bin_start_hit <- as.character(rep("-", nrow(dffStart)) )
  bin_start_hit[mbin_start_hit] <- shareStart$subjectHits
  ################################################
  
  cols <- match( rownames( targets ),colnames(df))
  
  
  ratioStart <- data.frame( df[,cols],dffStart)
  colnames(ratioStart) <- rep(rownames( targets ),2)
  #aca hay que armar un df itnermedio con la suma por condicion:

 

  ff <- rep(group,2)
  colnames(ratioStart) <- paste(ff, rep(1:2,each=length(group)))
  dfSum <- t(apply(ratioStart, 1, function(x){tapply(as.numeric(x), 
                INDEX=colnames(ratioStart), 
                sum)}))
  colnames(dfSum) <- rep(unique(group), each=2) # old version
  
  jratioStartRes <- t(apply(dfSum, 1, function(x){tapply(as.numeric(x), 
                INDEX=colnames(dfSum), 
                jratio )}))

#  if (packageVersion("IRanges")<2.6) { 
#    j.end <- findOverlaps(jranges, 
#        ignoreSelf=TRUE,
#        ignoreRedundant=FALSE,
#        type="end")
#    
#  } else {
    j.end <- findOverlaps( jranges, 
        drop.self = TRUE,
        drop.redundant = FALSE,
        type = "end" )
#  }

  jjend <- as.data.frame(j.end)
  jjend$queryHits <- names(jranges[jjend$queryHits])
  jjend$subjectHits <- names(jranges[jjend$subjectHits])
  
  
  # BUG FIX: aggregate fails when no junction overlaps 
  if ( length( j.end ) > 0) {
    shareEnd <- data.frame(aggregate(subjectHits ~ queryHits, 
            data = jjend, paste, collapse=";"))
  } else {
    shareEnd <- data.frame( 
        subjectHits = character(0), 
        queryHits = character(0))
  }

  
  
  dfCountsEnd <- data.frame( names=jjend$queryHits, 
      df[jjend$subjectHits,start:end],
      row.names=NULL) #recover counts
  

  # BUG FIX: aggregate fails with 0-rows dfCountsStart. 
  if ( nrow( dfCountsEnd  ) > 0 ) {
    dfSumEnd <- data.frame(aggregate(. ~ names, data = dfCountsEnd, sum))
  } else {
    dfSumEnd <- data.frame( names = character(0) )
    for ( i in 1:ncol( dfCountsEnd ) ) {
      dfSumEnd[, i+1] <- integer(0)
    }
    colnames( dfSumEnd )[2:ncol(dfSumEnd)] <- colnames( dfCountsEnd )
  }
  
  sumJ <- paste(colnames(dfSumEnd), "jsum", sep=".")
  colnames(dfSumEnd) <- sumJ
  rownames(dfSumEnd) <- dfSumEnd$names.jsum
  dfSumEnd$names.jsum <- NULL
  dffEnd =data.frame(matrix(NA, nrow =  nrow(df), 
          ncol = ncol(dfSumEnd)) )
  rownames(dffEnd) <- rownames(df)
  colnames(dffEnd) <- colnames(dfSumEnd)
  ########################################################################
  mSumEnd <- match(row.names(dfSumEnd), row.names(dffEnd))
  dffEnd[mSumEnd,] <- dfSumEnd
  dffEnd[is.na(dffEnd)] <- 0
  ########################################################################
  mbin_end_hit <- match(shareEnd$queryHits, row.names(dffEnd))
  bin_end_hit <- rep("-", nrow(dffEnd))
  bin_end_hit[mbin_end_hit] <- shareEnd$subjectHits
  ########################################################################
  
  ratioEnd <- data.frame(df[,cols],dffEnd)
  ff <- rep(group,2)
  colnames(ratioEnd) <- paste(ff,rep(1:2, each = length(group)))
  dfSum <- t(apply(ratioEnd, 1, function(x){tapply(as.numeric(x), 
                INDEX=colnames(ratioEnd), sum  )}))

  colnames(dfSum) <- rep(unique(group), each = 2) # new version
  
  jratioEndRes <- t(apply(dfSum, 1, function(x){tapply(as.numeric(x), 
                INDEX=colnames(dfSum), jratio )}))

  
  et_merge <- data.frame(df,                       
      logFC,
      pvalue, 
      fdr,
      bin_start_hit,
      dffStart,
      jratioStartRes,
      bin_end_hit,
      dffEnd,
      jratioEndRes )
  return(et_merge)
  
}

# ---------------------------------------------------------------------------- #
# Calculates the matrix of offset values for normalization
# TODO: Que es el valor 10^-4 que aparece, se puede pasar como parametro?
.getOffsetMatrix <- function( df, dfGen, targets, 
    offsetAggregateMode = c( "geneMode","binMode" )[1], 
    offsetUseFitGeneX = TRUE, verbose = FALSE) {
  
  locus  <- df[, na.omit( match( c("locus","gene"), colnames(df) ) ) ]
  
  if( offsetAggregateMode=="geneMode" ) {
    if(offsetUseFitGeneX){
      if ( verbose ) message( "  Using geneMode for offset matrix with GLM fit")
      countData = dfGen[,rownames(targets)]
      
      yg <- DGEList( counts = countData, 
                     group  = targets$condition, 
                     genes  = data.frame( locus = rownames(countData) ) )
      
      #filter lowcount genes
      # TODO: Los datos que llegan aca ya estan filtrados por low counts usando
      # los filtros de ASpli. Es necesario incluir este filtro ?
#      keep <- rowSums(cpm(yg)>1) >= 2
#      yg <- yg[keep, , keep.lib.sizes=FALSE]
      
      yg     <- calcNormFactors(yg)
      fc     <- targets$condition
      groupFactor <- factor( fc, unique( fc ), ordered = TRUE )
      design <- model.matrix(~0+groupFactor)
      yg     <- estimateDisp(yg,design, robust=TRUE)
      fitg   <- glmFit(yg,design)
      maux   <- fitg$fitted.values + 10^-4
      rownames( maux ) <- rownames( dfGen)
      
    } else {
      if ( verbose ) message( "  Using geneMode for offset matrix with gene counts")     
      maux   <- as.matrix( dfGen[,rownames(targets)] ) + 10^-4
      rownames( maux ) <- rownames( dfGen )
    }
  } else {
    # TODO:  Es necesario vectorizar esto ?
    if ( verbose ) message( "  Using binMode for offset matrix")     
    
    if ( "junction" %in% colnames( df ) ) {
      stop( simpleError( "Differential usage with offset and 'binMode' is not available." ))
    }
    
    a <- by( data = df[,c("feature",rownames(targets))],
             INDICES = as.factor( locus ),
             FUN = function(x){ 
               apply( x [x[,1] == "E", 2:ncol(x) ], 2 , sum )
             })
    maux<- matrix(unlist(a),byrow=TRUE,ncol=nrow(targets))+10^-4
    rownames(maux)<-names(a)
    colnames(maux)<-names(a[[1]])
  }
  #mOffset <- do.call( rbind, list( A = maux[ locus ,] ) )
  mOffset <- maux[ locus ,]
  rownames( mOffset )<-rownames(df)
  return(mOffset)
}

.setDefaultOffsets <- function ( aDGEList , mOffset) {

   aDGEList$offset <- log(mOffset) 
   return ( aDGEList )
}

.edgeRtest <- function( 
    df,
    dfGen,
    targets,
    mOffset = NULL,
    contrast = NULL,
    verbose = FALSE) {
  
  cols <- match( rownames( targets ), colnames( df ) )
  
  group <- targets$condition
  
  if( is.null( contrast ) ) contrast <- .getDefaultContrasts(group)
  
  er <- DGEList( counts  = df[,cols],
                 samples = targets,
                 group   = factor( group, levels = unique(group), ordered = TRUE ) )
  
  er <- calcNormFactors(er)
  
  justTwoConditions <- sum( contrast != 0 ) == 2
  
  # TODO: Forzar GLM no tiene efecto si se pasa un offset. 
  if( is.null( mOffset ) & justTwoConditions ){

    captured <- capture.output(
      er   <- estimateDisp( er, robust=TRUE )
    )
    pair <- which( contrast != 0 )
    testResult   <- exactTest( er, pair = pair )
    
#    message( "ExactTest... done" )
    
  } else {
    if (verbose) message("Running GLM LRT")

    if( ! is.null( mOffset ) ) er <- .setDefaultOffsets( er, mOffset ) 
    
    groupFactor <- factor( group, unique( group ), ordered = TRUE )
    design     <- model.matrix( ~0 + groupFactor, data = er$samples )
    captured <- capture.output(
        er         <- estimateDisp( er, design = design , robust=TRUE) 
    )      
    glf        <- glmFit( er, design = design )  
    testResult <- glmLRT( glf, contrast = contrast )
    
#    message( "glmLRT... done" )

  } 
  return( testResult )
}

subsetBams <- function( x, targets, select) {
  nSamples <- sum( select %in% rownames( targets ) )
  nCond    <- sum( select %in% getConditions( targets ))
  selectFilter <- NULL
  targets <- .condenseTargetsConditions( targets )
  
  # subset by condition
  if ( nCond >0 & nSamples == 0 )  { selectFilter <- targets$condition %in% select }
  
  # subset by sample
  if ( nSamples > 0 & nCond == 0 ) { selectFilter <- rownames( targets ) %in% select }
  
  return( x[selectFilter] )
    
}

.getExpFactors <- function( targets ) {
  expFactors <- colnames( targets )[ colnames( targets ) != 'condition' ]
  expFactors[2:length(expFactors)]
}

subsetTargets <- function( targets, select, removeRedundantExpFactors = FALSE ) {
  nSamples <- sum( select %in% rownames( targets ) )
  nCond    <- sum( select %in% getConditions( targets ))
  
  selectFilter <- NULL
  targets2 <- .condenseTargetsConditions( targets )
  
  # subset by condition
  if ( nCond >0 & nSamples == 0 )  { selectFilter <- targets2$condition %in% select }
  
  # subset by sample
  if ( nSamples > 0 & nCond == 0 ) { selectFilter <- rownames( targets ) %in% select }

  # Subset Targets
  result <- targets[selectFilter, ]
  
  # Remove conditions with a unique value if required by user
  if ( removeRedundantExpFactors ) {
    for ( ef in .getExpFactors( result ) ) {
      nValues = length( unique( result[, ef]) )
      if ( nValues  == 1) {
        result[, ef] <- NULL
      } 
    }
  }
  
  return( result )
}

.subset.ASpliCounts <- function(x, targets, select) {
  
  nac <- new(Class="ASpliCounts")
  nSamples <- sum( select %in% rownames( targets ) )
  nCond    <- sum( select %in% getConditions( targets ))
  selectFilter <- NULL
  targets <- .condenseTargetsConditions( targets )
  
  # subset by condition
  if ( nCond >0 & nSamples == 0 )  { selectFilter <- targets$condition %in% select }
  
  # subset by sample
  if ( nSamples > 0 & nCond == 0 ) { selectFilter <- rownames( targets ) %in% select }
  
  
  if ( is.null( selectFilter ) ) {
    stop( "subset ASpliCounts can be done with samples or conditions only" )
  }
  
  countsg( nac ) <- cbind( 
      .extractDataColumns(  countsg( x ), targets ), 
      .extractCountColumns( countsg( x ), targets )[ , selectFilter] )
  
  countsb( nac ) <- cbind( 
      .extractDataColumns(  countsb( x ), targets ), 
      .extractCountColumns( countsb( x ), targets )[ , selectFilter] )
  
  countsj( nac ) <- cbind( 
      .extractDataColumns(  countsj( x ), targets ), 
      .extractCountColumns( countsj( x ), targets )[ , selectFilter] )
  
  countse1i( nac ) <- cbind(
      .extractDataColumns(  countse1i( x ), targets ), 
      .extractCountColumns( countse1i( x ), targets )[ , selectFilter] ) 
  
  countsie2( nac ) <- cbind(
      .extractDataColumns(  countsie2( x ), targets ), 
      .extractCountColumns( countsie2( x ), targets )[ , selectFilter] )
  
  rdsg( nac ) <- cbind(
      .extractDataColumns(  rdsg( x ), targets ), 
      .extractCountColumns( rdsg( x ), targets )[ , selectFilter] )
  
  rdsb( nac ) <- cbind(
      .extractDataColumns(  rdsb( x ), targets ), 
      .extractCountColumns( rdsb( x ), targets )[ , selectFilter] )
  
  return( nac )
}

.subset.ASpliAS <- function( x, targets, select ) {
  nas <- new(Class="ASpliAS")
  nSamples <- sum( select %in% rownames( targets ) )
  nCond    <- sum( select %in% getConditions( targets ))
  targets <- .condenseTargetsConditions( targets )
  sampleNames <- rownames( targets )
  
  acceptedSamples <- NULL
  acceptedConditions <- NULL
  
  # subset by condition
  if ( nCond == length(select) & nSamples == 0 )  { 
    acceptedSamples <- sampleNames[ targets$condition %in% select ]
    acceptedConditions <- select
  }
  
  # subset by sample
  if ( nSamples  == length(select) & nCond == 0 ) { 
    acceptedSamples <- select
    acceptedConditions <- targets[ select , 'condition']
  }
  
  
  if ( is.null( acceptedSamples ) ) {
    stop( "subset ASpliAS can be done with samples or conditions only" )
  }
  
  createMask <- function( cNames, sampleNames, conditionNames, 
      acceptedSamples, acceptedConditions ) {
    
    isSampleName <- cNames %in% sampleNames 
    isConditionName <- cNames %in% conditionNames
    isAcceptedSample <- cNames %in% acceptedSamples
    isAcceptedCondition <- cNames %in% acceptedConditions 
    
    return( ! ( isSampleName | isConditionName ) | 
        isAcceptedSample | isAcceptedCondition )

  }
  
  # irPIR / esPSI / altPSI / join tienen la misma estructura de columnas, 
  # Genera un solo filtro para subsetear estos dataframes
  binColNames <- colnames( irPIR( x ) )

  binsFilter <- createMask( binColNames, sampleNames, getConditions( targets ),
      acceptedSamples, acceptedConditions )
  
  irPIR( nas ) <- irPIR( x )[ , binsFilter ]
  colnames( irPIR( nas ) ) <- binColNames[ binsFilter ]
  altPSI( nas ) <- altPSI( x )[ , binsFilter ]
  colnames( altPSI( nas ) ) <- binColNames[ binsFilter ]
  esPSI( nas ) <- esPSI( x )[ , binsFilter ]
  colnames( esPSI( nas ) ) <- binColNames[ binsFilter ]
  joint( nas ) <- joint( x )[ , binsFilter ]
  colnames( joint( nas ) ) <- binColNames[ binsFilter ]
  
  # Junction PIR filter
  jpirNames <- colnames( junctionsPIR( x ) )

  jpirFilter <- createMask( jpirNames, sampleNames, getConditions( targets ),
      acceptedSamples, acceptedConditions )
  
  junctionsPIR( nas ) <- junctionsPIR( x )[ , jpirFilter ]
  colnames( junctionsPIR( nas ) ) <- jpirNames[ jpirFilter ]
  
  # Junction PIR filter

  jpsiNames <- colnames( junctionsPJU( x ) )
  jpsiNames <- sub( "(.start$)|(.end$)", "", jpsiNames )
  
  jpsiFilter <- createMask( jpsiNames, sampleNames, getConditions( targets ),
      acceptedSamples, acceptedConditions )

  junctionsPJU( nas ) <- junctionsPJU( x )[ , jpsiFilter ] 
  colnames( junctionsPJU( nas ) ) <- jpsiNames[ jpsiFilter ]
  
  return( nas )
  
}

# This file contains a collections of functions used ubiquitously throughout 
# the code.

# Replace all illegal chars in filenames to underscore chars.
# The filename provided should not have any folder name.
.makeValidFileName <- function( filename ) {
  filename <- gsub( '[<>:"/\\|?*]', '_', filename )
  return( filename )
}

# Subset a dataframe to contain only the columns that matchs the samples in the
# targets. That columns are the ones with the count data.
.extractCountColumns <- function ( aDataframe, targets ) {
  result <- aDataframe[ , match( row.names(targets), colnames( aDataframe ) ) , F]
  colnames( result ) <- as.character( row.names(targets) )
  return( result )
}

# Subset a dataframe to contain only the columns that do not matchs the samples
# in the targets. That columns are the ones that do not contain count data.
.extractDataColumns <- function ( aDataframe, targets ) {
  result <- aDataframe[ , - match( row.names(targets) , colnames( aDataframe ) ) ]
  return( result )
}

# create the names of the conditions of a targets by their factors
.condenseTargetsConditions <- function ( targets, collapse = "_" ) {
  if( ! "condition" %in% colnames( targets ) ) {
    for(i in 2:ncol(targets)){
      if(!is.character(targets[, i])){
        targets[, i] <- as.character(targets[, i])
      }
    }
    targets <- data.frame( 
        targets, 
        condition = apply( targets[ , -1 , drop = FALSE] ,1 ,paste, collapse = collapse),
        stringsAsFactors = FALSE)
    
  }
  return( targets )
}

# create the names of samples
.generateSamplesNames <- function ( targets, collapse = "_" ) {
  
  #Auxiliary functions
  is.sequential <- function(x){
    all(diff(x) == diff(x)[1])
  }
  
  my.make.unique <- function(s, sep = "_"){
    tab <- unique(s)
    tab <- setNames(rep(1, length(tab)), tab)
    sapply(s, function(ss){
      sss <- paste(ss, tab[ss], sep = sep)
      tab[ss] <<- tab[ss] + 1
      return(sss)
    })
  }
  
  #Do we need to generate the names or do they already exist? If they dont exists, they are a sequence of numbers from 1 to nrow(targets)
  r <- suppressWarnings(as.numeric(rownames(targets)))
  if(all(!is.na(r))){
    if(is.sequential(r)){
      if( ! "condition" %in% colnames( targets ) ) {
        targets <- .condenseTargetsConditions( targets, collapse )
      }      
      rownames(targets) <- my.make.unique(targets$condition, sep = collapse)      
    }
  }
  return( targets )
}


# This function sums counts of a data frame by condition.
# The conditions are given in the targets data.frame.
# the dataframe to be summed must have the same number of columns as samples 
# in the targets, and they must have the same order.
.sumByCond <- function( countDf, targets ) {
  countDf[ is.na( countDf )] <- 0
  uniqueConditions <- unique( targets$condition )
  nConditions <- length( uniqueConditions )
  result <- matrix( 
      data = 0, 
      nrow = nrow( countDf) , 
      ncol = nConditions )
  
  for( i in 1:nConditions ) {
    result[ , i ] <- rowSums( countDf[ , targets$condition == uniqueConditions[i], drop = FALSE ] )
  }
  colnames( result ) <- uniqueConditions
  return ( result )
}

.my_replace_na<-function(x,val){
  x[is.na(x)]<-val
}

\documentclass[hidelinks]{article}

% \VignetteIndexEntry{ASpli}

<<style, echo=FALSE, results=tex>>=
BiocStyle::latex()
options(continue=" ")
@

\usepackage{verbatim} 
\usepackage{caption} 
\usepackage{cite}
\usepackage{subcaption}
\usepackage{hyperref}
\usepackage{amsmath}
\usepackage{float}

\newcommand{\RNAseq}{\textrm{\textbf{RNA}-\textbf{Seq}}}
\newcommand{\secref}[1]{\ref{#1} : \nameref{#1}}

\newfloat{captionedEq}{thp}{eqc}
\floatname{captionedEq}{Equation}

\title{\texttt{ASpli}: An integrative R package for analysing alternative splicing using RNA-seq}

\author{Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz}

\begin{document}
\SweaveOpts{concordance=TRUE}

\maketitle

\tableofcontents

\section{Introduction}
Alternative splicing (AS) is a common mechanism of post-transcriptional gene 
regulation in eukaryotic organisms that expands the functional and regulatory 
diversity of a single gene by generating multiple mRNA isoforms that encode 
structurally and functionally distinct proteins. 

Genome-wide analysis of AS has been a very active field of research since 
the early days of NGS (Next generation sequencing) technologies.  Since then, evergrowing data availability and the development of increasingly sophisticated analysis methods have uncovered 
the complexity of the general splicing repertoire.  

In this vignette we describe how to use \texttt{ASpli}, an integrative and user-friendly
R package that facilitates the analysis of changes in both annotated and novel 
AS events. 

Differently form other approaches, ASpli was specifically designed to integrate several independent signals in order to deal with the complexity that might arise in splicing patterns. Taking into account genome annotation information, ASpli considers bin-based signals along  with junction inclusion indexes in order to assess for statistically significant changes in read coverage. In addition, annotation-independent signals are estimated based on the complete set of experimentally detected splice junctions.  ASpli makes use of a generalized linear model framework (as implemented in edgeR R-package \cite{Robinson2010}) to assess for the statistical  analysis of specific contrasts of interest. In this way, ASpli can provide a comprehensive description of genome-wide splicing alterations even for complex experimental designs. 

A typical ASpli workflow  involves: parsing the genome annotation into subgenic features called bins, overlapping read alignments against them, perform junction counting, fulfill inference tasks of differential bin and junction usage and, finally, report integrated splicing signals. At every step ASpli generates self-contained outcomes that, if required, can be easily exported and integrated into other processing pipelines. 

\section{Citation}
{\em ASpli: Integrative analysis of splicing landscapes through RNA-seq assays}, Mancini E, Rabinovich A, Iserte J, Yanovsky M, Chernomoretz A, Bioinformatics, March 2021,  [\href{https://doi.org/10.1093/bioinformatics/btab141}{journal},\href{https://tinyurl.com/mjvet53u}{preprint}]


\section{Quick start}\label{qstart}
Here is an example included in ASpli, for a pairwise comparison between 2 conditions (Control vs Treatment, 3 replicates each) using default parameters. For the sake of computational speed we will consider a custom gtf file (included in ASpli) containing info just for 10 artificial genes.\\

Extract features from genome, define {\em targets} data.frame with phenotype data, and {\em mBAMs} data.frame with phenotype data for merged BAMs:

<<quickStart1, echo=TRUE, eval=TRUE>>=
library(ASpli)
library(GenomicFeatures)

# gtf preprocessing ----
gtfFileName <- aspliExampleGTF()
genomeTxDb  <- txdbmaker::makeTxDbFromGFF( gtfFileName )

# feature extraction ----
features    <- binGenome( genomeTxDb )

#bams and target file ----
BAMFiles <- aspliExampleBamList()
targets  <- data.frame(row.names = paste0('Sample',c(1:6)),
                       bam = BAMFiles[1:6],
                       f1  = c( 'control','control','control','treatment','treatment','treatment'),
                       stringsAsFactors = FALSE)
mBAMs <- data.frame( bam = sub("_[012]","",targets$bam[c(1,4)]),
                     condition = c("control","treatment"))

@



Read counting against annotated features: 

<<quickStart2, echo=TRUE, eval=TRUE>>=
gbcounts <- gbCounts(features=features, targets=targets,
                     minReadLength = 100, maxISize = 50000)
gbcounts
@

Junction-based {\em de-novo} counting and splicing signal estimation:

<<quickStart2b, echo=TRUE, eval=TRUE>>=
asd <- jCounts(counts=gbcounts, features=features, minReadLength=100)
asd
@

Differential gene expression and bin usage signal estimation:
<<quickStart3, echo=TRUE, eval=TRUE>>=
gb  <- gbDUreport(gbcounts, contrast = c(-1,1))
gb
@

Differential junction usage analysis:
<<quickStart3b, echo=TRUE, eval=TRUE>>=
jdur <- jDUreport(asd, contrast=c(-1,1))
jdur
@

Bin and junction signal integration:
<<quickStart4, echo=TRUE, eval=TRUE>>=
sr <- splicingReport(gb, jdur, counts=gbcounts)
@

Summary of integration of splicing signals along genomic-regions. 
<<quickStart4b, echo=TRUE, eval=TRUE>>=
is <- integrateSignals(sr,asd)
@

Export results:
<<quickStart5, echo=TRUE, eval=TRUE>>=
exportIntegratedSignals(is,sr=sr,
                          output.dir = "aspliExample",
                          counts=gbcounts,features=features,asd=asd,
                          mergedBams = mBAMs)
@ 

\section{Getting started}

\subsection{Installation}
\texttt{ASpli} is available at the Bioconductor site and can be installed following these steps:
\texttt{biocLite()}:

<<installation, echo=TRUE, eval=FALSE>>=
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

# The following line initializes usage of Bioc devel branch and should not be necessary after
# the next official release scheduled for October 2020
if(Sys.Date()<"2020-11-01") BiocManager::install(version='devel')
BiocManager::install("ASpli")
library(ASpli)
@

\subsection{Required input data}

\texttt{ASpli} requires the following data in order to execute the analysis pipeline:
\begin{itemize}
\item \texttt{BAM} and \texttt{BAI} files for each analyzed sample.
\item A genome annotation file in the TxDb format, as produced by the \texttt{GenomicFeatures} package.
The \texttt{GenomicFeatures} package provides functions to create TxDb objects based on data downloaded from
UCSC Genome Bioinformatics, BioMart or gff/gtf files. 
See "Creating New TxDb Objects or Packages" in the \texttt{GenomicFeatures} vignette for more details. In this example, a TxDb is built from a gtf file:

<<makeTx, echo=TRUE, eval=FALSE>>=
library(GenomicFeatures)
TxDb <- txdbmaker::makeTxDbFromGFF(
  file="genes.gtf",
  format="gtf")
@


The building of a \texttt{TxDb} object might be time consuming, depending on the size of your genome. If a \texttt{TxDb} has been already created, we strongly recommend saving it as a \texttt{sqlite} file and reloading it any time the analysis is run. 

<<saveTx, echo=TRUE, eval=FALSE>>=
 saveDb(TxDB,file="gene.sqlite")
@

Please, \texttt{make sure all files use the same coordinate system}.
\item IMPORTANT: In order to estimate uniform coverage statistics and to generate graphical reports through the {\texttt exportIntegratedSignals} function, replicate merged \texttt{BAM} files for each contrasted condition are needed. These merged BAMs can easily be computed from individual replicate BAM files using {\bf samtools merge} utility (you can check \hyperref[samtools]{http://www.htslib.org/doc/samtools-merge.html}). Index for these merged BAM files should also be provided. They can be easily generated with {\bf samtools index} utility (https://www.htslib.org/doc/samtools-index.html).

\end{itemize}

\section{ASpli overview}
\texttt{ASpli} analyzes read coverage over {\em bins}, defined as maximal sub-genic features entirely included or entirely excluded from  annotated  mature tanscripts (see Figure \ref{fig:aspliWorkflow}). 
Read junctions are considered in order to provide supporting evidence of differential bin usage. Additionally, annotation-independent signals are estimated based on the complete set of experimentally detected splice junctions (see Figure \ref{fig:aspliWorkflow}). 

We leverage on the statistical framework implemented in \texttt{edgeR} to asses for the statistical significance of different splicing signals in a consistent and unified way. As depicted in Figure \ref{fig:aspliWorkflow}.3, statistically significant evidence is collected from: bin coverage differential signals, relative changes in junction's flanking genomic regions (junction-anchorage signal), and junction usage variations displayed inside junction clusters (junction-locale signal).\\
 
%In practice, a typical ASpli workflow  involves several steps: parsing the genome annotation into bins, counting aligned reads, assessing for differential bin and junction usage, consolidating junction and bin-coverage splicing evidence and, finally, reporting integrated splicing signals. At every step ASpli generates self-contained outcomes that, if required, could be easily exported and integrated into other processing pipelines. 
Figure \ref{fig:aspliWorkflow}.4 shows an example of the interactive html report generated as a final output.\\ 

\begin{figure*}[!htpb]%figure1
\centerline{\includegraphics[width=\textwidth]{images/newFig1_E.pdf}}
\caption{ ASpli main features.
Panel 1: binning of a three-isoform gene. Six bins (plus one intron-original bin) were defined. According to the local bin classification model two external, two intronic, one exonic and one alternative bin were recognized. Reads aligned to the genome are used to tally bin counts. In the figure, darker boxes represent non-annotated junctions and reads. Panel 2: Summary of splicing signals. 
Bin coverage is depicted in the blueish sub-panel. Junction-based signals are shown in the yellow sub-panel. 
The Percent-Spliced-In (PSI) statistics is used to quantify the inclusion evidence of exon-skipping and for the alternative use of 5' or 3' splicing sites. On the other hand, the Percent-of-Intron-Retention (PIR) is considered for IR events. It combines counts for the junction of interest and counts tallied over exon-intron boundaries ($r_{IE}$ and $r_{EI}$). The Percent-Junction-Usage (PJU) statistics (rightmost junction-panel) quantifies the relative strength of a given junction with respect to locally {\em competing} ones for alternative 5' or 3' splicing sites. The participation coefficient $\Pi$ serves to quantify the relative strength of a given junction $J$ with respect to the set of junctions of the corresponding junction-cluster.
For annotation-compliant events ASpli takes into account bin-coverage along with PSI\textsubscript{exon skip}, PSI\textsubscript{Alt i} 
or PIR signals depending on the event-class assigned to the analyzed bin. PIR and PJU\textsubscript{i} signals estimated for experimentally detected junctions are use to produce annotation-free statistics.
 Panel 3: Summary of differential splicing signals. ASpli applies a GLM approach on three different sets of reads and junctions to define complementary splicing cues: differential bin-coverage, junction anchorage and junction-locale signals. 4: Example of ASpli generated output.
}\label{fig:aspliWorkflow}
\end{figure*}


\section{Using \texttt{ASpli}}

The workflow intended to be used with \texttt{ASpli} is divided in six main steps (Figure \ref{fig:ASpliStructure}). 
\begin{enumerate}
  \item Extracting features from genome TxDb: \texttt{ binGenome() }
  \item Counting reads:  \texttt{ gbCounts()},  \texttt{ jCounts()}
  \item Estimating differential signals:\texttt{ gbDUreport()}, 
  \texttt{jDUreport()}
  \item Generering reports: \texttt{ splicingReport() }, \texttt{ integrateSignals() }
  \item Exporting HTML reports: \texttt{ exportSplicingReport() }, \texttt{ exportIntegrateSignals() }
\end{enumerate}

The main objects classes used to store data and perform operations are:
\begin{itemize}
  \item \texttt{ASpliFeatures}: Contains genomic coordinates
  \item \texttt{ASpliCounts}: Contains number of reads overlapping each genomic feature
  \item \texttt{ASpliAS}: Contains counts of aligned junctions   
  \item \texttt{ASpliDU}: Contains results of Differential expression and usage
  \item \texttt{ASpliJDU}: Contains results of Differential Junctions usage
  \item \texttt{ASpliSplicingReport}: Contains differential usage information using different evidences
  \item \texttt{ASpliIntegratedSignals}: Contains signals present in the region
  \end{itemize}
  
At each step it is possible to access intermediate results. 
See Section \ref{sec:outputs}:\nameref{sec:outputs} for more details.

\begin{figure}[ht!]
\centering
\includegraphics[width=0.85\textwidth]{images/workflow_ok.pdf}
\caption{ \texttt{ASpli} core Funcionalities }
\label{fig:ASpliStructure}
\end{figure}

\subsection{\texttt{binGenome}: Binning the genome }
\label{sectionBinG}

The \texttt{binGenome} method is a one-stop function to:
\begin{itemize}
 \item split genes into subgenic features called bins
 \item extract junction, gene and bin coordinates
 \item infer bin splicing events from annotation 
\end{itemize}

\texttt{binGenome}'s output is an object of class \texttt{ASpliFeatures}. 
Methods \texttt{featuresg}, \texttt{featuresb}, \texttt{featuresj} can be used to access genes, bins and junctions coordinates as \texttt{GRanges} (\texttt{GRanges} objects defined in the \texttt{GenomicRanges} package.) 

<<binGenome, echo=TRUE, eval=FALSE>>=
annFile       <- aspliExampleGTF()
aTxDb         <- makeTxDbFromGFF(annFile)
features      <- binGenome( aTxDb ) 
geneCoord     <- featuresg( features )
binCoord      <- featuresb( features )
junctionCoord <- featuresj( features )
@

In the case gene symbols were available, they could be appended as follow:

<<binGenome2, echo=TRUE, eval=FALSE>>=
symbols       <- data.frame( row.names = genes( aTxDb ), 
                             symbol = paste( 'This is symbol of gene:',
                                             genes( aTxDb ) ) )
features      <- binGenome( aTxDb, geneSymbols = symbols ) 
@

\subsubsection{Bin definition}\label{sec:binDefinition}

Exon and intron coordinates are extracted from the annotation, but only those from multi-exonic genes are saved for further evaluation. When more than one isoform exists, some exons and introns will overlap. In the same spirit of \cite{pmid22722343}, exons and introns are then subdivided into non-overlapping sub-genic features dubbed \texttt{bins},  defined by the boundaries of different exons across transcript variants. These so defined {\em bins} are maximal sub-genic features entirely included or entirely excluded from any mature transcript (see Fig \ref{fig:binDefinition}).

For an hypothetical gene named GeneAAA subgenic features are labelled as follow: 
\begin{itemize}
  \item \textbf{GeneAAA:E001}: defines first exonic bin
  \item \textbf{GeneAAA:I001}: defines first intronic bin
  \item \textbf{GeneAAA:Io001}: defines first \texttt{Intron original}
  \item \textbf{GeneAAA:J001}: defines first annotated junction of GeneAAA
  \item \textbf{chr.start.end}: defines an experimental junction
\end{itemize}

Bins and junctions are consecutively named from 5' to 3' of reference sequence, irrespective of their gene's strand. This implies that lower numbers are always closer to the 5' of forward strand. Alternative splicing bins are named as exons.\\


Exonic and intronic bins are further classified into {\em exclusively exonic bins}, {\em exclusively intronic bins}, or {\em alternative splicing bins} (AS) (See Figure \ref{fig:binDefinition}). 

\begin{figure}[ht!]
\centering
\includegraphics[width=12cm]{images/binDefinition.pdf}
\caption{ Schema of resulting bins from a gene with three hypothetical
  transcripts. Those bins that are exonic and intronic in different isoforms are     named \textit{AS bins}.
}
\label{fig:binDefinition}
\end{figure}


Bins that overlap with the beginning or end of any transcript are labelled as \textbf{external}. Please note that an external bin of a transcript may overlap to a non external bin of another transcript, in these cases the bin is still labelled as \textbf{external}. In addition to these non overlapping bins, full introns are extracted from annotation and labelled as \textbf{Io} )

\subsubsection{Splicing event assignment} \label{sec:eventAssign}

Each AS bin is further classified considering a three-bin {\em local splicing model}. Splicing-event categories are assigned to a given bin based on the intronic/exonic character of the analyzed bin and its first neighbors (Figure \ref{fig:binAssignment}). 

For genes presenting two isoforms, this model is able to unambiguously assign a well defined splicing event category to the analyzed bin: exon skipping (ES),  intron retention (IR), alternative five prime splicing site (Alt5'SS), or alternative three prime splicing site (Alt3'SS) (see first row of Figure \ref{fig:binAssignment}).


\begin{figure}[ht!]
\centering
\includegraphics[width=1.3\textwidth]{images/event_assignment.pdf}
\caption{ Summary of assignment of splicing events to bins from minimum gene model. The bin being evaluated has a green background highlight. The blue boxes represents exons, while the little light orange boxes represent introns. Gene
models shown are plus sense strand. }
\label{fig:binAssignment}
\end{figure}

When more than two isoforms are present, we still found it useful to use the three-bin local model to segment follow up analysis. For these cases (see rows 2-4 of Figure~\ref{fig:binAssignment}) \texttt{ASpli} identify splicing events that involve: intronic subgenic regions surrounded by exons in at least one isoform (bin labelled as IR*), exonic subgenic regions surrounded by two introns in at least one isoform (bin labelled as ES*), exonic regions surrounded by intronic and exonic neighbor bins (bin labelled as Alt5'SS* or Alt3'SS*). 

When it is not possible to get a clear splicing-type assignation (last row of Figure~\ref{fig:binAssignment}), bins are labeled as {\em undefined AS} (UAS).  \\



\subsection{Read counting}\label{sec:rcounts}

\subsubsection{Targets data.frame definition}\label{sec:targetsDef}

BAM file names and experimental factors should be provided as a dataframe 
that has as many rows as samples. The first column  should be named \textit{bam} and should contain the path to a BAM file. Next columns should be used to specify the different experimental factors for each sample.

For instance, for a two-factor design (e.g. {\em genotype} and {\em time}) the {\em targets} 
data.frame could have been defined like this:

<<targetsDF2, echo=TRUE, eval=FALSE>>=
BAMFiles <- c("path_to_bams/CT_time1_rep1.BAM", "path_to_bams/CT_time1_rep2.BAM",
              "path_to_bams/CT_time2_rep1.BAM", "path_to_bams/CT_time2_rep2.BAM",
              "path_to_bams/TR_time1_rep1.BAM", "path_to_bams/TR_time1_rep2.BAM",
              "path_to_bams/TR_time2_rep1.BAM", "path_to_bams/TR_time2_rep2.BAM")
(targets <- data.frame( bam = BAMFiles,
                        genotype = c( 'CT', 'CT', 'CT',  'CT', 
                                      'TR', 'TR', 'TR', 'TR' ),
                        time     = c( 't1', 't1', 't2', 't2', 
                                      't1', 't1', 't2', 't2' ),
                         stringsAsFactors = FALSE ))
@


The {\em targets} dataframe contains experimental factor values for each sample. \texttt{ASpli} generates simple code-name for each experimental condition concatenating the corresponding factor levels. We recommend to check using the \texttt{getConditions()} function. 

<<targetsDF2b, echo=TRUE, eval=FALSE>>=
getConditions( targets )
@


\textbf{Important 1} The keyword {\em condition} is internally used by \texttt{ASpli} to store experimental condition code-names and SHOULD NOT be used as an experimental factor name in the definition of the {\em targets} data.frame. 

\textbf{Important 2 } Row-names can be defined for the {\em targets} data.frame to univoqually identify each sample through the analysis. However this is not mandatory. \texttt{ASpli} automatically use condition code-names to generate unique sample ids whenever default rownames (i.e. consecutive numbers) were detected in {\em targets} data.frame.   

\subsubsection{\texttt{gbCounts}: Summarize read overlaps against all feature levels}

The method  \texttt{gbCounts()} counts the number of reads that overlaps each defined feature (i.e. genes, bins, junctions and intron/exon flanking regions). For genes and bins, read density values are also computed as the ratio between the number of reads and the length of a given feature. 

By default (PE=TRUE) library is considered as paired-end and unstranded (strandMode=1).

<<gbCounts, echo=TRUE, eval=FALSE>>=
gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
@

\begin{itemize}
\item \texttt{features}: An object of class \texttt{ASpliFeatures}. It is a list of GRanges at gene, bin and junction level
\item \texttt{targets}: A dataframe containing sample, BAM and experimental factors as defined in Section \secref{sec:targetsDef}. 
\item \texttt{minReadLength}: Reads shorter than {\em minReadLength} will not be considered to compute E1I and IE2 read coverage (see bellow).
\item \texttt{maxISize}: Maximum intron expected size. Junctions longer than \texttt{maxISize} will be dicarded.
\item \texttt{minAnchor}: Minimum percentage of {\em minReadLength} that should be aligned to an exon-intron boundary (see \secref{sec:intronFlanking} ). 
\end{itemize}

The result of \texttt{gbCounts()} method is an object of class 
\texttt{ASpliCounts}\label{sec:countsContents}. Count and read density dataframes can be extracted using accesors methods. An extensive summary of the information stored in these tables is included in \secref{sec:outputs}.

Access data:

<<gbCountAccessors, echo=TRUE, eval=FALSE>>=
GeneCounts <- countsg(counts)
GeneRd <- rdsg(counts)
BinCounts <- countsb(counts)
BinRd <- rdsb(counts)
JunctionCounts <- countsj(counts)
@

Export tables to text files:

<<gbCountsWrite, echo=TRUE, eval=FALSE>>=
writeCounts(counts=counts, output.dir = "example")
writeRds(counts=counts, output.dir = "example")
@

\paragraph{Additional considerations}
\label{sec:intronFlanking}
\begin{itemize}
\item At gene-level, for a given gene, the read count number is computed as
the number of reads overlapping any exon included in the corresponding annotated gene model. If a single read overlaps more than one exon, it is counted only once. Note that \textbf{one read can
overlap two different genes, in this case it is counted for both of them}.

\item Every intron is considered as a potential retained intron.  To analyze putative inton retention events, \texttt{ASpli} considers the  corresponding upstream and downstream exons (E1 and E2, always in the forward sense). Then, following \cite{pmid25258385}, new artificial ranges that overlap the two retention regions E1I 
(connecting exon E1 and intron I) and IE2 (connecting intron I and exon E2) are defined:

\begin{itemize}
  \item E1I: [I$_{s}$- readLength (1 - minAnchor/100), I$_{s}$+ readLength (1 - minAnchor/100)]
  \item IE2: [I$_{e}$- readLength (1 - minAnchor/100), I$_{e}$+ readLength (1 - minAnchor/100)]
\end{itemize}

where I$_{s}$ and I$_{e}$ are the intron start and end coordinates respectively. \texttt{ minAnchor } is 10\% of read length by default (parameter \texttt{minAnchor} )


\textbf{Please check before start the read length of your sequenced library} Only those reads whith minimum overlap \textit{minReadLength} with either $E1I$ or $IE2$ will be considered and counted. 

To access this data:

<<gbCountAccessors2, echo=TRUE, eval=FALSE>>=
e1iCounts <- countse1i(counts)
ie2Counts <- countsie2(counts)
@

\item Effective length: is the sum of the length of exonic bins and alternative bins (i.e. all bins except intronic bins).

\item Junctions are extracted from BAM files. They are defined as those reads
that aligned against disjoint region of the reference genome(N operator of CIGAR notation
for aligned reads \cite{pmid19505943} ), and are essential for alternative splicing event quantification and discovery. Junction alignment confidence is extremely important and it should be controlled at the alignment step.
\end{itemize}

\subsubsection{\texttt{jCounts}: Summarize junctions inclussion indices PSI, PIR and PJU}
PSI (percent of inclusion) and PIR (percent of intron retention) metrics (see bellow) are computed for each bin and experimental condition. The selection of which metric is used is based on the type of splicing event associated with each bin (see \secref{sec:eventAssign}). In addition, annotation-free inclussion indices (PIR$_J$ and PJU, see bellow) are estimated using  experimentally detected junctions.

<<asd, echo=TRUE, eval=FALSE>>=
asd         <-  jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0)
@

Novel arguments for this function call are:
\begin{itemize}
\item counts: An object of class \texttt{ASpliCounts}
\item threshold: Minimum number of reads supporting junctions (Default=5)
\end{itemize}

Results: An object of class \texttt{ASpliAS}.\label{sec:countsAS}. An extensive summary of the information stored in this object is included in \secref{sec:outputs}.


Accesors:

<<asdAccesor, echo=TRUE, eval=FALSE>>=
irPIR  <- irPIR( asd )
altPSI <- altPSI( asd )
esPSI  <- esPSI( asd )
allBins      <- joint( asd )

junctionsPJU <- junctionsPIR( asd )
junctionsPIR <- junctionsPIR( asd )
@

Export tables to text files:

<<asdAccesor2, echo=TRUE, eval=FALSE>>=
writeAS(as=asd, output.dir="example")
@

\paragraph{Junction supporting evidence of alternative bin usage}
\label{sec:psir}

\texttt{ASpli} makes use of junction data  as supporting evidence of alternative usage of bins. For a general differential splicing event affecting a given bin, it is always possible to define {\em exclusion} and {\em inclusion} junctions. The first class of junctions (noted as $J_3$) pass over the bin of interest, whereas the second ones (note as $J_1$ and/or $J_2$) quantify and support the inclusion of start and/or end bin boundaries in the mature transcript. Figure \ref{fig:pirEq} illustrates this point for the different types of splicing events that could affect a given bin. \texttt{ASpli} considers for this analysis junctions that are completely included within a unique gene and have more than a minimum number of reads supporting them (by default this number is five).\\

\begin{figure}[ht!]
    \centering
      \includegraphics[width=0.9 \textwidth]{images/psi_pir2.pdf}
    \caption{PSI and PIR metrics estimation and their relationship with junctions}
\label{fig:pirEq}
\end{figure}


PSI (percent spliced in) \cite{Schafer2015} and PIR (percent of intron retention) metrics are two well known statistics that can be used to quantify the relative weight of inclusion evidence for different kind of splicing events. For each bin, \texttt{ASpli} quantifies the inclusion strength in every experimental condition using the appropriate inclusion index (see Fig \ref{fig:pirEq}).


\paragraph{Annotation-free inclussion indices }

\texttt{ASpli} relies on the direct analysis of experimentally observed splicing junctions in order to study novel (i.e. non-annotated) splicing patterns. 

For every experimental junction, \texttt{ASpli} characterizes local splicing patterns  considering two hypothetical scenarios. For one hand, assuming that every detected junction might be associated to a possible intron that could be potentially retained, a $PIR_{junc}$ value is computed (upper panel of Figure \ref{fig:psir_junc}).\\

On the other hand, every junction also defines potential 5' and 3' splicing sites. It can be the case that one (in an alternative 5' or 3' scenario), or both ends (in case of exon skipping) were shared by other junctions. In this context, it is informative to characterize the relative abundance of the analyzed junction (dubbed $J_3$) with respect to the locally {\em competing} ones. \texttt{ASpli} estimates {\em percentage junction-usage} indices, $PJU_{J_1}$ and $PJU_{J_2}$, in order to evaluate and quantify this quantities (see bottom panel of figure \ref{fig:psir_junc}). In order to illustrate this point, we show in figure \ref{fig:jcluster} an hypothetical splicing scenario for a given junction of interest, $J_3$. It can be appreciated that $PJU_{J_1}$ quantifies the participation of this junction in the context of a splicing pattern involving the two orange competing junctions, whereas $PJU_{J_2}$ reports on the usage of $J_3$ in connection with the green competing junction.  

\begin{figure}[ht!]
  \centering
  \includegraphics[width=0.9\textwidth]{images/psi_pir_junc_ok.pdf}
  \caption{PIR and PJU metrics for junctions}
  \label{fig:psir_junc}
\end{figure}


\begin{figure}[ht!]
  \centering
  \includegraphics[width=0.9\textwidth]{images/clusters_ok.pdf}
  \caption{Percentage of junction usage.}
  \label{fig:jcluster}
\end{figure}


\paragraph{Additional considerations:}
\begin{itemize}

\item  Only those junctions with a minimum number of counts (default=5) in \textbf{all} samples of at least 1 condition are used for PIR/PSI analysis.

\item  For each bin, a PIR or a PSI  metric is calculated, depending on the splicing event category assigned to that bin (see section \secref{sec:eventAssign}).
If no splice event was assigned (\textit{ this bin is not alternative}), an exon will be considered to be involved in a putative exon skiping splicing event, and
an intron will be considered to be involved in a putative intron retention splicing event.

\end{itemize}


\subsection{Differential signals}\label{sec:difsignals}

\texttt{ASpli} leverages on the statistical framework developed by Smyth and collaborators, implemented in the edgeR R-package \cite{Robinson2010, McCarthy2012}, to assess for statistically significant changes in gene-expression, bin coverage and junction splicing signals. Under this approach, count data is modelled using a negative binomial model, and  an empirical Bayes procedure is considered to moderate the degree of overdispersion across units.

In order to study splicing patterns, gene expression changes should be deconvolved from overall count data. On a very general setting, what we are looking for is to test whether a given unit of a certain group of elements displays differential changes respect to the collective or average behavior. \texttt{ASpli} uses this general idea to assess for statistically significant changes in splicing patterns probed with different genomic features:
\begin{itemize}

\item bin-coverage signal:  \texttt{ASpli} assesses for differential usage of bins comparing bin's log-fold-changes  with the overall log-fold-change of the corresponding gene.
\item junction anchorage signal: For every experimentally detected junction, \texttt{ASpli} analyzes differential intron retention changes by considering  log-fold-changes of a given experimental junction relative to changes in coverage of left and right junction flanking regions. 
\item junction locale signal: In the same spirit than MAJIQ and LeafCutter, \texttt{ASpli} defines junction-clusters as  sets of junctions that share at least one end with another junction of the same cluster (see Figure \ref{fig:jcluster}). In order to characterize changes for a given junction along experimental conditions, \texttt{ASpli} weighs log-fold-change of the junction of interest relative to the mean log-fold-change of junctions belonging to the same cluster. 

\end{itemize}

\texttt{ASpli} makes use of the functionality implemented in the diffSpliceDGE function of the edgeR package to perform all of this comparisons within a unified statistical framework. Given a set of elements (i.e. bins or junctions) of a certain group (i.e. genes, anchorage group or junction-cluster), a negative binomial generalized log-linear model is fit at the element level, considering an offset term that accounts for library normalization and collective changes. Differential usage is assessed testing coefficients of the GLM. At the single element-level, the relative log-fold-change is reported along with the associated p-value and FDR adjusted q-values. In addition a group-level test is considered to check for differences in the usage of any element of the group between experimental conditions (see {\em diffSpliceDGE} documentation included in edgeR package for details \cite{Robinson2010}).


\subsubsection{\texttt{gbDUreport}: Bin-based coverage differential signals of AS}  \label{sec:du}

To run this analysis:

<<gbDUreport, echo=TRUE, eval=FALSE>>=
 gb <- gbDUreport( counts, 
             minGenReads = 10, 
             minBinReads = 5,
             minRds = 0.05, 
             contrast = NULL, 
             ignoreExternal = TRUE, 
             ignoreIo = TRUE, 
             ignoreI = FALSE,
             filterWithContrasted = TRUE,
             verbose = TRUE,
             formula = NULL,
             coef = NULL)
@

Summary of arguments:
\begin{itemize}
\item minGenReads (Default=10): Genes with at least an average of minGenReads reads for \textbf{any} condition are included into the differential expression test. Bins from genes with at least an average of minGenReads reads for \textbf{all} conditions are included into the differential bin usage test. 
\item minBinReads (Default=5): Bins with at least an average of minGenReads reads  for any condition are included into the differential bin usage test. 
\item minRds (Default=0.05) = genes with at least an average of read density for any condition are included into the differential expression test. Bins belonging to genes with at least an average of minRds read density for \textbf{all} conditions are included into the differential bin usage test. Bins with at least an average of minRds read density for \textbf{any} condition are included into the differential bin usage test. 
\item ignoreExternal (Default = TRUE): Ignore firts or last transcript bins 
\item ignoreI(Default = FALSE) : Ignore intronic bins, test is performed only for exons. 
\item ignoreIo (Default = TRUE): Ignore original introns. 
\item contrast: Numeric vector of length equal to the number of experimental conditions (as defined by \texttt{targets}). The values of this vector are the coefficients of each condition  (in the order given by given by \texttt{getConditions()}) to set up the contrast of interest.  If contrast = NULL (and also formula=NULL ), a pairwise comparison between the second and the first conditions will be considered for calculations(i.e. contrast= c(-1,1,0,...0))
\item filterWithContrasted: logical value. If TRUE (default) bins, genes and junctions will be filtered by read counts and read densities using data from the conditions that will be used in the sought comparison (i.e. those which coefficients in contrast argument are different from zero). If FALSE, all conditions will be considered at filtering time. \textit{It is strongly recommended do not change this value}
\item verbose:  shows details of calculations (Default=TRUE)
\item  formula: A formula can be used to specify a specific term to be tested. If {\em coef} is specified, then that coefficient will be tested. If not, it defaults to the last term in the formula.
\item coef: for formula only. The coefficient to be tested. If NULL the test defaults to the last term in the formula
\end{itemize}

The result of \texttt{gbDUreport()} method is an object of class 
\texttt{ASpliDU}. Gene expression and bin differential usage information can be extracted using accesors methods. An extensive summary of the information stored in this object is included in \secref{sec:outputs}.

Accesors:

<<asdAccesor, echo=TRUE, eval=FALSE>>=
geneX  <- genesDE( gb )
binDU  <- binsDU( gb )
@

Export tab delimited tables:

<<gbCountsWrite, echo=TRUE, eval=FALSE>>=
writeDU(gb, output.dir = "example")
@

\paragraph{Additional considerations}

\begin{itemize}
\item Bins and junctions from expressed genes are considered if they have enough supporting reads (Default=5) in at least one condition. 

\item {\em External bins} are excluded by default in the analysis. 
However, an {\em external} bin for one isoform can overlap to a {\em non external} bin from other isoform that can participate in alternative splicing regulation, \texttt{ASpli} allows to optionally include them. 
\item Io ({\em original intron}) bins, excluded by default.

Note that the inclusion of those bins affects the estimation of corrected p-values (fdr). The information provided by Io bins are highly correlated with their sub bins and increase largely the number of events to be analyzed. The fdr correction become more strict and there is a violation on the fdr correction assupmtion that all individual tests are independent from each other. If an Io bin shows a significant change, there is a very high chance that at least one of their sub bins also shows a significant change. 
\end{itemize}


\subsubsection{\texttt{jDUreport}: Junction-centered analysis of AS}\label{sec:jdureport}

Based on abundance information of experimentally detected junctions, \texttt{jDUreport} considers J$_1$, J$_2$ and J$_3$ junction sets, as defined in \secref{fig:psir_junc}, to analyze annotation-free {\em junction-anchorage} and {\em junction-locale} alternative splicing signals (see \secref{sec:difsignals}). In addition, for every annotated bin, this functions tests junction supporting evidence of bin usage (see \secref{fig:pirEq}).

To run this analysis:

<<jDUreport, echo=TRUE, eval=FALSE>>=
jdu <- jDUreport(asd, 
            minAvgCounts                       = 5, 
            contrast                           = NULL,
            filterWithContrasted               = TRUE,
            runUniformityTest                  = FALSE,
            mergedBAMs                         = NULL,
            maxPValForUniformityCheck          = 0.2,
            strongFilter                       = TRUE,
            maxConditionsForDispersionEstimate = 24,
            formula                            = NULL,
            coef                               = NULL,
            maxFDRForParticipation             = 0.05,
            useSubset                          = FALSE)
@

Summary of arguments:
\begin{itemize}
\item asd: An object of class \texttt{ASpliAS} with results of PSI and PIR using experimental junction
\item minAvgCounts (Default=5): Minimum average counts for filtering. 
\item runUniformityTest  (Defaults =   FALSE): Run uniformity test on \textbf{Intron Retention} in order to detect non-uniform read coverage along the intron. This test compares the standard deviation of the inner intron region (11 bases from both ends) to the mean of both intron ends. Numbers closer to 0 mean more uniform coverage. This is an experimental feature, requires the existence of one merged BAM per experimental condition and takes some time to run. 
\item mergedBAMs: Should be specified if {\em runUniformityTest}=TRUE. It is a two column data.frame specifying the path to replicate-merged BAMs for each tested condition.  Columns should be named: {\em bam} and {\em condition} respectively.\textit{ If no merged BAMs exist (for example, paired samples without replicates), use the same BAMs as targets.}
\item maxPValForUniformityCheck: To speed up uniformity test only check junctions with pval < maxPValForUniformityCheck (Default=0.2)
\item strongFilter: If strongFilter is TRUE, then we discard junction clusters with at least one junction that doesn't pass the filter.
\item  maxConditionsForDispersionEstimate: In order to reduce resource usage, estimate dispersion for statistics tests with a reduced number of conditions.
\item maxFDRForParticipation: In order to calculate junctionPSI participation, only use significant junctions \textit {(ie junctions with FDR < maxFDRForParticipation).} (Default=0.05)
\item useSubset: Experimental. \textit{It is strongly recomended to leave the default, FALSE.}
\end{itemize}

Results are stored in an \texttt{ASpliJDU} object. Note that this analysis considers junctions that are completely included within a unique gene and have enough supporting reads (MinAvgCounts, Default = 5)

Accesors:

<<jDUreportAccesors, echo=TRUE, eval=FALSE>>=
 localej( jdu )
 localec( jdu )
 
 anchorj( jdu )
 anchorc( jdu )
 
 jir( jdu )
 jes( jdu )
 jalt( jdu )
@

\texttt{localc} and \texttt{localj} together with \texttt{anchorc} and \texttt{anchorj} data.frames provide information regarding statistically significant changes observed in connection with junction usage inside {\em locale} and {\em anchorage}-junction clusters respectively. \texttt{jir}, \texttt{jes} and \texttt{jalt} accessors provide information regarding junction support of bin usage.

Export tab delimited table:

 <<jDUreportAccesorsX, echo=TRUE, eval=FALSE>>=
writeJDU(jdu,output.dir = "test")
@

\paragraph{Additional considerations}

As an option, \texttt{jDUreport} checks the non-uniformity level of the read coverage observed in intronic bins. We report the ratio between the standard deviation of the inner intronic bin region (11 bases from both ends) coverage to the mean of both bin's external ends. Values closer to 0 mean that the coverage can be considered uniform and the event is probably an Intron Retention. In order to perform this calculation  replicate merged BAMs for each condition are needed. The path to the bam files should be specify through the {\em mergeBams} argument (e.g. the {\em mBAMs} data.frame in the example of Section \ref{qstart}). 
The calculation takes some time to run so it defaults to FALSE.



\subsection{Integrative reports} \label{sec:integration}

\subsubsection{\texttt{splicingReport}: bin and junction signals integration}

This function combines differential splicing information from different sources. Bin and junction usage information is integrated in three steps. First, {\em bin} and annotated junction information (\texttt{jir}, \texttt{jes}, \texttt{jalt}) are consolidated. Then, bins that overlap with {\em locale}-J3 junctions (junctions that cover the entire locale region) are identified and the corresponding signals are combined. Finally, the same procedure is performed for bins and {\em anchorage}-J3 junctions.

To run this analysis

 <<splicingReport, echo=TRUE, eval=FALSE>>=
sr      <- splicingReport(gb, 
                          jdur, 
                          counts)
@

Results are stored in an \texttt{ASpliSplicingReport} object.

Accesors:

<<splicingReportA, echo=TRUE, eval=FALSE>>=
 binbased( sr )
 localebased( sr )
 anchorbased( sr )
@

\texttt{binbased(sr)} data.frame combines information from bins and annotated junctions. For each case, either $\Delta PSI$ or $\Delta PIR$ statistics is reported based on the {\em bin} splicing type. \texttt{localebased(sr)}  is a data.frame with information from bins and {\em locale} junctions. Statistics for each junction are located in columns prefixed with "junction" and statistics for the corresponding cluster are prefixed with the "cluster" keyword. Changes in {\em participation} coefficients are also reported. If {\em locale} clusters matched a {\em bin}, the coresponding bin statistics are also included. The data structure of \texttt{anchorbased(sr)} data.frame is similar to the {\em localebased(sd)} one. All data.frames also include junction count records for debugging purposes.

Export tab delimited table (see \ref{sec:reports} for interactive HTML reports):

<<splicingReportA, echo=TRUE, eval=FALSE>>=
writeSplicingReport( sr, output.dir = "test")
@

\subsubsection{\texttt{integrateSignals()}: Region specific summarization of differential usage signals.}
This function integrates different usage signals reported in overlaping genomic regions:
\begin{itemize}
\item bin signal:  a bin is called differentially-used by \texttt{ASpli} if it displays statistically significant coverage changes (fdr $< 0.05$, by default) and, additionally, one of the two supplementary conditions hold: either the bin fold-change level is greater than a given threshold (3 fold changes, by default) or changes in inclusion levels of bin-supporting junctions ($\Delta PIR$ or $\Delta PSI$ according to the bin class) surpass a predefined threshold ($0.2$ by default).

\item {\em anchorage} signal: statistically significant changes are found at the cluster level (cluster.fdr $<0.05$ by default) for the considered $\{J_1,J_2,J_3\}$ junction set (see upper panel of Fig \ref{fig:psir_junc}) and, at the same time, $|\Delta PIR_{J_3}|$ is larger than a given threshold (0.3 by default).  

\item {\em locale} signal: statistically significant changes are found at the cluster level  (cluster.fdr $<0.01$ by default) for the analysed junction cluster $\{J_1,...,J_S,...,J_n\}$ (see \ref{fig:jcluster}) and, at the same time, there is at least one junction $J_S$ within the cluster presenting statistically significant changes at the single unit level (junction.fdr $<0.05$, by default) with $|\Delta Participation_{J_S}|$ larger than a given threshold (0.3 by default). In the case that statistically significative changes were detected at the unit-level for more than one junction of a given cluster, the one displaying the largest participation change was considered and reported as the cluster's representative junction. 

\end{itemize}

<<integrateSignals, echo=TRUE, eval=FALSE>>=
is    <- integrateSignals(sr, asd,
                 bin.FC = 3, bin.fdr = 0.05, bin.inclussion = 0.2,
                 nonunif = 1, usenonunif = FALSE, 
                 bjs.inclussion = 10, bjs.fdr = 0.01, 
                 a.inclussion   = 0.3, a.fdr = 0.01, 
                 l.inclussion   = 0.3, l.fdr = 0.01,
                 otherSources = NULL, overlapType = "any")
@

Arguments:
\begin{itemize}
\item sr: An object of class ASpliSplicingReport
\item asd: An object of class ASpliDU
\item bin.FC: fold change threshold for bin signals. By default only bin signals with bin.fc > log2(3) are retained.
\item bin.fdr: Maximum FDR for bin signals.
\item bin.inclussion: Minimum level of change for junction support inclussion signals (either $\Delta$PIR or $\Delta$PSI) associated to bins who already passed bin.FC and bin.fdr filters.
\item nonunif: Maximum value of non-uniforimty for intronic bins (nonunif << 1 means homogeneous coverage)
\item usenonunif: Whether to use non uniformity as filter.
\item bjs.inclussion: Minimum level of change for junction support inclussion signals (either $\Delta$PIR or $\Delta$PSI).
\item bjs.fdr: Maximum FDR for annotated junctions.
\item a.inclussion:  Minimum level of inclussion change for {\em anchorage} junctions.
\item a.fdr: Maximum FDR for {\em anchorage} junctions.
\item l.inclussion: Minimum level of {\em participation} change for {\em locale} junctions..
\item l.fdr: Maximum FDR for {\em locale} junctions.
\item otherSources: If user wants to compare \texttt{ASpli} results with results from other methods, {\em otherSources} must be a GenomicRange object with all the regions found with the other methods. It will be integrated with a new column next to signals information.
\item overlapType: Matching criterium for region overlaps. Defaults to "any" and can be any of the following: "any", "start", "end", "within", "equal".
\end{itemize}

Results are stored in an \texttt{ASpliIntegratedSignals} object.

Accesors:

<<integrateSignalsA, echo=TRUE, eval=FALSE>>=
 signals( is )
 filters( is )
@

\texttt{filters(is)} stores the parameter values used to filter the different usage signals to be integrated (e.g. minimum fold-changes, statistical thresholds, minimal inclussion values, etc).  


\texttt{signals(is)} contains region-based information of splicing signals. Table \ref{tab:iiss} shows the first 5 columns of this data.frame. Columns b, bjs, ja and jl stand for bin, bin-junction-support, junction-anchorage and junction-locale signals. Non-zero entries indicate the presence of the corresponding signal for the considered genomic range.  An asterisk indicates overlap but not an exact match between the genomic ranges where the examined signals were observed.


\begin{table}[H]
  \begin{center}
    \begin{tabular}{rccccc}
              region & b & bjs & ja & jl & ....\\ \hline
 Chr1:45560-45645   & 1 & 1 & 0  & 0 &\\
 Chr1:387673-388267 & 1 & 1 & 1  & 1 & ...\\
 Chr1:406793-406902 & 1 & 1 & 0  & * &\\  
    \end{tabular}
  \end{center}
  \caption{First five columns of {\em signals(is)} data.frame}
  \label{tab:iiss}
\end{table}

In this example a bin-signal ({\em b}) was found in region {\em Chr1:406793-406902}. A matching bin-junction supporting signal was also reported ({\em bjs}), so both discoveries were merged. Finally, a significant {\em locale} cluster overlapped the region, but genomic ranges did not match, so an * was used for that signal.

\paragraph{Event assignement} We adopted the following heuristics to classify the region-centered integrated splicing signals. Eventhough we found this classification scheme usefull in most situations, it is strongly advised to use it as a preliminary categorization of events. Further examination is advised in order to disentangle complex splicing patterns. 

\begin{enumerate}
\item For each region with {\em bin-coverage} signal, we try to find a matching region in {\em binbased(sr)} table. If a match is found, we assign that event to the corresponding bin-event class and report the corresponding statistical information. Otherwise, the signal is marked as \textbf{*}.
\item For each region with {\em bin-junction support} (bjs) signal, we try to find a matching J3-junction in {\em binbased(sr)} table. If a match is found, junction statistics are retrieved. Otherwise, the signal is marked as \textbf{*} in the {\em bjs} column. 
\item For each region with {\em anchorage-signal}, we try to find a matching J3-junction in {\em anchorbased(sr)} table. If a match is found, junction statistics are retrieved. Otherwise, we try to find a matching J3-junction of a {\em Io bin} in the {\em binbased(sr)} table. If a match is found, the event is marked as \textbf{IoR}. Otherwise, we try to find a {\em bin-signal} matching region. In case no match is reported at this instance the event is marked as {\em Novel Alternative Splicing Pattern} \textbf{NASP}. If a match is reported but the bin is marked as \textbf{*}, then the event is marked as {\em Complex Splicing Pattern} \textbf{CSP}. Finally, if no J3-junction in {\em anchorbased(sr)} table is found, the signal is marked as \textbf{*}. 
\item For each region with {\em locale signal}, we look for a matching cluster  in {\em localebased(sr)} table. If any, we retrieve the statistical information from that cluster. Otherwise we try to find a cluster with a matching J3 junction. If no match is found, then the {\em locale} signal columns is marked with an \textbf{*}. In order to categorize the event we adopte the following heuristic: 
\begin{enumerate}
\item If all junctions share the same end or start coordinates, we check if all bins in between are of the same type (i.e. exons or introns). If this is the case, then this is an \textbf{Alt 5'/3'} event. Otherwise, the event is marked as \textbf{CSP}. 
\item If the cluster is composed of three junctions and not all junctions share the same end or start, we check it there is a cluster with a matching J3-junction. If this is the case, the event is labelled as an \textbf{ES} event. Otherwise, it is marked as a \textbf{CSP} event. If some of the junctions in the cluster were novel, then the event is classified as a novel one: \textbf{NASP}. 
\item For each of the other unclassified events, we check whether they involve {\em exonic} features. If this were the case, we mark them as {\em alternative splicing affecting a consensus exon} \textbf{ASCE} events. On the other hand, for {\em intronic} features, if some signals were marked as \textbf{*} we clasify the event as \textbf{CSP}. Othewise, the event is marked as an \textbf{IR}.
\end{enumerate}
\end{enumerate}


\begin{figure}[ht!]
\centering
\includegraphics[width=1.3\textwidth]{images/integrateSignals.png}
\caption{ Heuristics used to categorized splicing events }
\label{fig:integrateSignals}
\end{figure}


\subsubsection{\texttt{exportSplicingReport}: Export splicing reports in HTML pages.} \label{sec:reports}

This function makes use of the \texttt{DT} R-package \cite{DTpackage}, a wrapper of the JavaScript library 'DataTables' to export {\em splicing report} results into interactive HTML pages.

<<exportSplicingReports, echo=TRUE, eval=FALSE>>=
exportSplicingReports( sr, 
                       output.dir="sr",
                       openInBrowser = FALSE, 
                       maxBinFDR = 0.2, 
                       maxJunctionFDR = 0.2 )
@

Arguments:
\begin{itemize}
\item sr:	An object of class ASpliSplicingReport
\item output.dir: HTML reports output directory 
\item openInBrowser: (Default = FALSE) If TRUE, results are automatically displayed just after exporting.	
\item maxBinFDR (Default = 0.2) Export info for bins with FDR < maxBinFDR
\item maxJunctionFDR (Default = 0.2): Export info for junctions with FDR < maxJunctionFDR
\end{itemize}

The result is an HTML page, where you can easily browse the tables stored in an \em{ASpliSplicingReport}
object.


\subsubsection{\texttt{exportIntegratedSignals()}: Export integrated signals into HTML pages.} \label{sec:reports2}

This function makes use of the \texttt{DT} R-package \cite{DTpackage}, a wrapper of the JavaScript library 'DataTables', to export region-based integrated signal results into interactive HTML pages.

<<exportIntegratedSignals, echo=TRUE, eval=FALSE>>=
exportIntegratedSignals( is, output.dir="is", 
                         sr, counts, features, asd,
                         mergedBams, 
                         jCompletelyIncluded = FALSE, zoomRegion = 1.5, 
                         useLog = FALSE, tcex = 1, ntop = NULL, openInBrowser = F, 
                         makeGraphs = T, bforce=FALSE
                        )
@

Arguments:
\begin{itemize}
\item is:	An object of class ASpliIntegratedSignals
\item sr:	An object of class ASpliSplicingReport
\item counts: An object of class ASpliCount
\item features: An object of class ASpliFeatures
\item asd: An object of class ASpliAS
\item output.dir: HTML reports output directory 
\item{mergedBams}{
    Dataframe with two columns, bams and conditions. Bams are paths to merged bam files for each condition. These will be used to produce coverage plots if {\em mageGraph}=TRUE. 
  }
  \item{jCompletelyIncluded}{If TRUE only plot junctions completely included inside the plot region. Otherwise plot any overlapping junctions, not necessarily contained in the region of interest}
  \item{useLog}{Plot counts log}
  \item{tcex}{Text size}
  \item{ntop}{Only show n top signals}
  \item{openInBrowser}{Open reports in browser when done}
  \item{makeGraphs}{Generate graphs in reports}
  \item{bforce}{Force plot generation even if plot already exists on disk}
\end{itemize}

The result is an HTML page, where you can easily browse the tables stored in an \em{ASpliIntegratedSignals}
object.


\begin{figure}[ht!]
  \centering
  \includegraphics[width=0.95\textwidth]{images/aspliInteraction.png}
  \caption{Example of integrate signal DataTable report}
  \label{fig:integratedSignals}
\end{figure}



\section{Case studies}

\texttt{ASpli} provides a small synthetic data set to test the whole pipeline. It consists of
\begin{itemize}
 \item a \textbf{GTF} file for a a genome with ten genes with multiple isoforms with the corresponding annotation. 
 \item a set of twelve \textbf{BAM} files from an experiment with a two$\times$two factorial design
 \item four merged \textbf{BAM} files (merged replicates, one per condition)
  \end{itemize}
 
\subsection{2x2 experimental design} 
The two factors in this example are called \textbf{f1} and \textbf{f2}.\textbf{f1} can have value \textbf{A} or \textbf{B} and \textbf{f2} can have value \textbf{C} or
\textbf{D}, defining four conditions: \textbf{A.C}, \textbf{A.D}, \textbf{B.C}
and \textbf{B.D}. Table \ref{tab:Ex01} summarizes the  experimental design.

\begin{table}[H]
  \begin{center}
    \begin{tabular}{lllll}
    sample   & f1 & f2 & replicate & condition \\ \hline
    1        & A  & C  & 0         & A.C       \\
    2        & A  & C  & 1         & A.C       \\
    3        & A  & C  & 2         & A.C       \\
    4        & A  & D  & 0         & A.D       \\
    5        & A  & D  & 1         & A.D       \\
    6        & A  & D  & 2         & A.D       \\
    7        & B  & C  & 0         & B.C       \\
    8        & B  & C  & 1         & B.C       \\
    9        & B  & C  & 2         & B.C       \\
    10       & B  & D  & 0         & B.D       \\
    11       & B  & D  & 1         & B.D       \\
    12       & B  & D  & 2         & B.D       \\
    \end{tabular}
  \end{center}
  \caption{Experimental design of the example data set}
  \label{tab:Ex01}
\end{table}

The firts step of the workflow is to load the small {\em gtf}, build the TxDb object and extract their features. In this case \texttt{gtfFileName} contains the full path to the example gtf file in your system.

<<Ex02.a, echo=TRUE, eval=FALSE>>=
#library( ASpli )
library( GenomicFeatures )
gtfFileName <- aspliExampleGTF()
genomeTxDb <- makeTxDbFromGFF( gtfFileName )
features <- binGenome( genomeTxDb )
@

Then you should define your {\em targets} table.
\texttt{aspliExampleBAMList()} provides the full path to the BAMs files.

<<Ex02.e, echo=TRUE, eval=FALSE>>=
BAMFiles <- aspliExampleBamList()

targets <- data.frame( 
  row.names = paste0('Sample',c(1:12)),
  bam = BAMFiles,
  f1 = c( 'A','A','A','A','A','A',
          'B','B','B','B','B','B'),
  f2 = c( 'C','C','C','D','D','D',
          'C','C','C','D','D','D'),
  stringsAsFactors = FALSE)
@

Experimental conditions are inferred from the experimental factors in the {\em target} dataframe:

<<Ex02.g, echo=TRUE, eval=FALSE>>=
getConditions(targets)
@

We define a dataframe with path information for merged bams:

<<Ex02.f, echo=TRUE, eval=FALSE>>=
mBAMs <- data.frame(bam      = sub("_[02]","",targets$bam[c(1,4,7,10)]),
                    condition= c("A_C","A_D","B_C","B_D"))
@

Next step is to overlap reads and features:

<<Ex02.i, echo=TRUE, eval=FALSE>>=
gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
@

And also quantify junctions:

<<Ex02.j, echo=TRUE, eval=FALSE>>=
asd<- jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0,
                      threshold     = 5,
                      minAnchor     = 10)
@

At this point we can start asking different questions regarding differential gene expression and splicing patterns. \texttt{ASpli} allows to do this by defining {\em contrasts} or by using the {\em formula} approach. This feature allows the user to choose the framework that better (i.e. more easily) serve to test the sought effect.

\subsubsection{The contrast approach}\label{sec:contrast}
Table \ref{tab:Contrasts01} shows different contrasts that can be used to test different hypothesis:

\begin{table}[H]
  \noindent\makebox[\textwidth]{%
    \begin{tabular}{p{9cm}p{2cm}}
    Test & contrast\\ \hline
    AS between \textbf{f2} C and D conditions, for \textbf{f1}=A samples & c(-1, 1, 0, 0)\\
    AS between \textbf{f2} C and D conditions, for \textbf{f1}=B samples & c( 0, 0,-1, 1)\\
    Interaction effect (i.e. differences between the above-mentioned contrasts) & c( 1,-1,-1, 1)\\
    \end{tabular}}
  \caption{Test and contrasts.}
  \label{tab:Contrasts01}
\end{table}

To continue our mini-tutorial we will focus on the last contrast of Table \ref{tab:Contrasts01}. We will
test whether the differential patterns observed between D and C levels of \textbf{f2} are different for 
A and B \textbf{f1} levels. The interaction contrast corresponds to:
\begin{equation}
I = ( B.D - B.C ) - ( A.D - A.C ) 
\end{equation}

As Table \ref{tab:Contrasts01} shows, taking in consideration the order given
by \texttt{getConditions} function, the coefficients of the terms in this expression can be 
represented as the {\em contrast} vector $[ 1,-1,-1, 1]$.


We estimate gene differential expression and annotation-based differential splicing patterns for the contrast of interest as follow:  

<<Ex02.k, echo=TRUE, eval=FALSE>>=
gb      <- gbDUreport(gbcounts,contrast = c( 1, -1, -1, 1 ) )

@

\texttt{genesDE()} and \texttt{binsDU()} accesors report the statistical significance results. We can see that in this example no evidence of a statistically significant interaction term was found at gene expression level. However, 9 out of 14 bins displayed statistically significant interaction 
effect (fdr < 0.01) 

<<Ex02.k2, echo=TRUE, eval=FALSE>>=
genesDE(gb)[1:5,]
binsDU(gb)[1:5,]
@


The analysis of annotation-free junction-based AS events can be done with \footnote{Note that as we required to compute non-uniform intron coverage, we should specify merged-BAMs information}:

<<Ex02.l, echo=TRUE, eval=FALSE>>=
jdur    <- jDUreport(asd, contrast =  c( 1, -1, -1, 1 ))
@

Results for junction-based events matching bin ranges can be accessed through \texttt{jir(jdur)}, \texttt{jes(jdur)} and \texttt{jalt(jdur)} accesors (see \ref{sec:jdureport}).

Here we show the output corresponding to results of the {\em locale}-junction cluster analysis.
Information regarding {\em locale} cluster-level tests can be retrieved using:

<<Ex02.kk, echo=TRUE, eval=FALSE>>=
localec(jdur)[1:5,]
@

Rownames correspond to cluster-ids. Rows are ordered by FDR values. The {\em participation} and {\em dParticipation} values reported for each cluster correspond to the values obtained for the cluster's junction presenting the largest and most significant participation change. Note that NA's are reported for cluster-7 as no statistically significant changes were found for any junction of that cluster. 


{\em localej(jdur)} shows locale-information for each analyzed junction, reporting results of statistical tests at junction level in the first 8 columns:

<<Ex02.kkk, echo=TRUE, eval=FALSE>>=
localej(jdur)[1:5,1:8]
@

We integrate all our data:

<<Ex02.m, echo=TRUE, eval=FALSE>>=
sr      <- splicingReport(gb, jdur, counts = gbcounts)
is      <- integrateSignals(sr,asd)
@

And finally we export integrate signals into an interactive HTML page

<<Ex03, echo=TRUE, eval=FALSE>>=
exportIntegratedSignals( is, output.dir="aspliExample", 
                         sr, gbcounts, features, asd, mBAMs)

@

\subsubsection{The formula approach}\label{sec:formula}
In \texttt{ASpli} it is also possible to use {\em formulas} to test different hypothesis.
In our example we will consider the following formula to model our data:

<<Ex04, echo=TRUE, eval=FALSE>>=
 form <- formula(~f1+f2+f1:f2)
@

This formula corresponds to the following model matrix:

<<Ex05, echo=TRUE, eval=FALSE>>=
 model.matrix(form,targets)
@

Table \ref{tab:Formulas01} summarizes three statistical comparisons that could be easily implemented considering the second, third and fourth coefficient of the model:

\begin{table}[H]
  \noindent\makebox[\textwidth]{%
    \begin{tabular}{ccc}
    Test & contrast & coefficient\\ \hline
    B.C-A.C & c(-1, 0, 1, 0) & 2\\
    A.D-A.C & c(-1, 1, 0, 0) & 3\\
    (B.D-B.C)-(A.D-A.C) & c( 1,-1,-1, 1) & 4
    \end{tabular}}
  \caption{Experimental design of the example data set.}
  \label{tab:Formulas01}
\end{table}

In this way, to test for an interaction effect with the {\em formula} framework, we should run:

<<Ex02.k, echo=TRUE, eval=FALSE>>=
gb      <- gbDUreport(counts, formula = form , coef = 4)
jdur    <- jDUreport(asd, formula = form, coef = 4 ,
                     runUniformityTest = TRUE,
                     mergedBams = mBAMs)
@

\subsection{Paired experimental design}

The {\em formula} approach becomes extremely useful, for instance, to handle paired designs.
We will consider a subset of the originally included samples to simulate a paired experiment (see Table \ref{tab:ExPaired}). In this case \textbf{f1} could denote experimental units and \textbf{f2} levels, treatment-control conditions. 

\begin{table}[H]
  \begin{center}
    \begin{tabular}{lllll}
    sample   & f1 & f2 & replicate & condition \\ \hline
    1        & A  & C  & 0         & A.C       \\
    4        & A  & D  & 0         & A.D       \\
    7        & B  & C  & 0         & B.C       \\
    10       & B  & D  & 0         & B.D       \\
    \end{tabular}
  \end{center}
  \caption{Experimental design for a minimalistic paired design}
  \label{tab:ExPaired}
\end{table}


<<Ex02.kp, echo=TRUE, eval=FALSE>>=
targetPaired <- targets[c(1,4,7,10),]

gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
asd    <- jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0)
form   <- formula(~f1+f2)
gb     <- gbDUreport(gbcounts, formula = form)
#jdur   <- jDUreport(asd    , formula = form)
#sr <- splicingReport(gb, jdur, counts = counts)
#is <- integrateSignals(sr,asd,bjs.fdr = 0.1, bjs.inclussion = 0.1, l.inclussion=0.001,l.fdr = 1)
# exportSplicingReports(sr,output.dir="paired")
#exportIntegratedSignals(is,output.dir="paired",sr,counts,features,asd,mBAMs,tcex=2)
@

Note: for a large number of experimental units you might disable the graph generation option \texttt{makeGraphs=FALSE} in \texttt{exportIntegratedSignals} function call.


\section{Appendix: Ouputs Details}
Here is a brief explanation of the info  present in \texttt{ASpli} objects. Some columns are common in several tables.
\label{sec:outputs}

\subsection*{ASpliCounts}

\subsubsection*{Gene counts (\texttt{countsg}) and gene read densities (\texttt {rdsg}) }
(see table  \ref{tab:counts.gene} for an example)

\begin{description}
      \item[row.names]: Gene name as reported in annotation data.
      \item[symbol]: An optional name for the gene, that must be provided at the moment of feature extraction (see section
      \secref{sec:binDefinition}).
      \item[locus\_overlap]: overlapping \textit{loci}.
      \item[gene\_coordinates]: format \texttt{chromosome:start-end}.
      \item[start, end,length]: 
      \item[effective\_length]: gene length using only annotated exons.
      \item[sample data]: gene read counts/densities  (one column per sample).
      \end{description} 
\subsubsection*{ Bin counts (\texttt{countsb}) and bin read densities (\texttt{rdsb}) }

\begin{description}
      \item[row.names]: see \secref{sectionBinG}.
      \item[feature]: \textbf{E} for exonic bins, \textbf{I}
      for intronic bins and \textbf{Io} for introns before splitting.  See \secref{sectionBinG}
      \item[event]: Alternative splicing event asigned  (see section
      \ref{sec:binDefinition}:\nameref{sec:eventAssign})
      \item[sample data]: bin read counts/densities (one column per sample)
          \end{description}

\subsubsection*{Junction counts (\texttt{countsj})}

\begin{description}
      \item [row.names]: Junction's name in format
      \texttt{chromosome.start.end} (see \secref{sectionBinG}).
      \item [junction]: If junction coincides with a junction inferred from the annotation, the name is shown as is given in section       \ref{sectionBinG}:\nameref{sectionBinG}, otherwise it is \texttt{noHit}.
      \item [gene]: Locus that contains the junction.
      \item [strand]: gene's strand
      \item [multipleHit]: \texttt{yes} if junction spans multiple genes.
      \item [bin\_spanned]: Bin's names spanned by the junction.
      \item [j\_within\_bin]: If junction falls within a single bin, the name of   that bin is shown.
      \item [sample data]: Junction counts (one column per sample).
        \end{description}

\subsubsection*{E1I (\texttt{countse1i}) and IE2 (\texttt{countsie2}) }

\begin{description}
      \item [row.names]: Junction name in format \texttt{chromosome.start.end}
      (see \secref{sectionBinG}).
      \item [junction]: If junction coincides with a junction inferred
      from the annotation, the name is shown as is given in section
      \ref{sec:binDefinition}:\nameref{sec:binDefinition}, otherwise
      contains \texttt{noHit}.
      \item [gene]: Name of the locus that contains the junction.
      \item [strand]: Strand sense of the gene.
      \item [multipleHit]: \texttt{yes} if junction spans multiple
      genes.
    \item [sample data]: Junction counts (one column per sample).
\end{description}

\begin{table}
\centering
\begin{tabular}{lllllllllll}
\rotatebox{90}{Row names} & 
\rotatebox{90}{symbol} &
\rotatebox{90}{locus\_overlap} &
\rotatebox{90}{gene\_coordinates} &
\rotatebox{90}{start} &
\rotatebox{90}{end} &
\rotatebox{90}{length} &
\rotatebox{90}{effective\_length} &
\rotatebox{90}{Sample 1} & 
\rotatebox{90}{Sample 2} &
\rotatebox{90}{ ... } \\ \hline
GENE01 & GENE01 & - & chr1:1-700     & 1    &  700 & 700 & 700 & 324 & 314 & n\\
GENE02 & GENE02 & - & chr1:1001-1800 & 1001 & 1800 & 800 & 550 & 327 & 333 & n\\
GENE03 & GENE03 & - & chr1:2001-2800 & 2001 & 2800 & 800 & 650 & 342 & 321 & n\\  
GENE04 & GENE04 & - & chr1:3001-3800 & 3001 & 3800 & 800 & 650 & 313 & 337 & n\\  
...    & ...    &...& ...            & ...  & ...  & ... & ... & ... & ... &
...
\end{tabular}
\caption{Gene counts table example}
\label{tab:counts.gene}
\end{table}

\subsection*{ASpliAS}

\subsubsection*{irPIR}

\begin{description}
\item [event:] Type of event asigned by \texttt{ASpli} when binning. 
\item [J1:] Semicolon separated list of junctions with their \textbf{end} matching the \textbf{start} of the intron. 
\item [J2:] Semicolon separated list of junctions with an end matching the end of the intron. 
\item [J3:] Semicolon separated list of all the junctions overlaping the intron.
\item [*] Columns in between J1-J2 and J2-J3 represent junction counts in the samples for each bin. \textit{(junctions are the sum by condition).}
\item [PIR]   for each condition, calculated as: $ PIR = (J1 + J2)/(J1 + J2 + 2*J3) $
\end{description}

\subsubsection*{altPSI}
\begin{description}
\item [event:] Type of event asigned by \texttt{ASpli} when binning. 
\item [J1(J2):] Semicolon separated list of junctions with an \textbf{end} matching the \textbf{end} of alt5'SS or alt3'SS. 
\item [J3:] Semicolon separated list of junctions with an \textbf{end} matching the \textbf{start} of an alt5'SS or alt3'SS. 

\item [*] Columns in between J1-J2 and J2-J3 represent junction counts in the samples for each bin. \textit{(junctions are the sum by condition).}
\item [PIR] for each condition, calculated as: $$ PIR = (J1 + J2)/(J1 + J2 + 2*J3) $$
\item [PSI] for each condition, calculated as: $ PSI = (J12)/(J12 + J3)$
\textit{Where J12 is J1 if it's an alt 5' event or J2 if it's an alt 3' event}
\end{description}

\subsubsection*{esPSI}

\begin{description}
\item [event:] Type of event asigned by \texttt{ASpli} when binning. 
\item [J1:] Semicolon separated list of junctions with an \textbf{end} on the alternative exon. 
\item [J2:] Semicolon separated list of junctions with an \textbf{end} on the alternative exon. 
\item [J3:] Semicolon separated list of \textbf{exclusion} junctions of alternative exon. 

\item [*] Columns in between J1-J2 and J2-J3 represent junction counts in the samples for each bin. \textit{(junctions are the sum by condition).}

\item [PSI:] for each condition, calculated as: $$ PSI = (J1 + J2)/(J1 + J2 + 2*J3) $$ 
\end{description}

\subsubsection*{junctionsPIR}
\begin{description}
\item [PIR:] for each experimental junction, using \textbf{e1i} and \textbf{ie2} counts. \textit{Exclusion junction} is the junction \textit{itself}. This information is crutial to discover new introns as well as retention events. 
\item [hitIntron, hitIntronEvent:] If the junction matches a bin, name and type of event asigned by \texttt{ASpli} to this bin. 
\item [Columns] in between represent J1, J2 and J3 counts in the different samples 
\item [PIR:] calculated for each condition, as $ PIR = (J1 + J2)/(J1 + J2 + 2*J3) $ \textit{(junctions are the sum by condition.)}
\end{description}

\subsubsection*{junctionsPJU}
Given a junction, it is possible to analyze if it shares \textbf{start}, \textbf{end} or \textbf{both} with other junction. If so, it is possible due to there is alternative splicing in this region. 

\begin{description}
\item [Rownames:] J3 range. 
\item [Junction:] name of the junction. 
\item [Gene:] gene it belongs to. 
\item [Strand:] gene's strand. 
\item [multipleHit:] if junction overlaps several genes
\item [symbol:] gene symbol
\item [gene\_coordinates:] gene coordinates. 
\item [bin\_spanned:] semicolon separated list of bins spaned by this junction. \item [j\_within\_bin:] other junctions in this region 
\item [StartHit:] junctions sharing \textbf{start} with this junction and $PJU_J1=J3/(J1+J3)$ for each condition. 
\item [EndHit:] junctions sharing \textbf{end} with this junction and $PJU_J2=J3/(J2+J3)$ for each condition. 
\item [Columns] in between are:
\begin{itemize}
\item J3 counts in the different samples for each region.
\item J1 counts and $PJU_J1=J3/(J1+J3)$ for each condition.
\item J2 counts and $PJU_J2=J3/(J2+J3)$ for each condition. 
\end{itemize}

\item StartHit is J1 range and EndHit is J2 range.
\end{description}

\subsubsection*{ASpliJDU}

\begin{description}
\item [known or novel]
\item [spanned bins]
\item [exintron:] if the junction is completely included in a bin, it would indicate this AS event is a possible \emph{exintron} \cite{pmid25934563}.
\end{description}

\subsubsection*{localec}
Information about statistically significant changes in junction's usage within {\em locale}-juntion clusters.
  \begin{description}
   \item [size:] number of junctions belonging to the cluster.
   \item [cluster.LR:] cluster differential usage likelihood ratio 
   \item [pvalue, FDR] cluster differential usage pvalue and corresponding FDR 
   \item [range:] cluster genomic coordinates
   \item [participation:] junction maximal participation value inside the cluster  (FDR < maxFDRForParticipation)
   \item [dParticipation:] delta participation of the significant junction (FDR < maxFDRForParticipation) presenting maximal participation value inside the cluster 
  \end{description}
  
\subsubsection*{localej}
  \begin{description} 
   \item [cluster:] cluster's name to which junction belongs to
   \item [log.mean:] log of mean counts accross all conditions for this junction
   \item [logFC:] log fold change of junction accross conditions
   \item [pvalue and FDR] junction's pvalue and corresponding FDR
   \item [annotated:] if junction is annotated or new
   \item [participation:] maximal participation value observed across contrasted condictions 
   \item [dParticipation:] delta participation of the maximal participation value observed across contrasted condictions
   \item [Columns in between:] junction counts for all samples
  \end{description}  
  
\subsubsection*{anchorc}
\begin{description}
   \item [cluster.LR:] likelihood ratio of cluster differential usage.
   \item [pvalue and FDR:] cluster differential usage pvalue and corresponding FDR.
   \end{description}   

\subsubsection*{anchorj}
\begin{description}
   \item [log.mean:] log of mean counts accross all conditions for this junction
   \item [logFC:] log fold change of junction accross conditions
   \item [LR:] likelihood ratio of junction differential usage.
   \item [pvalue, FDR] junction's pvalue and corresponding FDR 
   \item [J1.pvalue]: J1 junction's pvalue
   \item [J2.pvalue]: J2 junction's pvalue 
   \item [NonUniformity:] if non uniformity test was performed, numbers closer to zero mean uniformity and closer to one mean non uniformity
   \item [dPIR:] junction's delta PIR
   \item [annotated:] if junction is annotated or new
   \item [J counts:] junctions' counts for all samples
\end{description}   


\subsubsection*{jir}
\begin{description}
   \item [J3:] J3 junctions
   \item [logFC:] log fold change of junction accross conditions
   \item [LR:] likelihood ratio of junction differential usage.
   \item [pvalue, FDR] junction's pvalue and corresponding FDR 
   \item [NonUniformity:] if non uniformity test was performed, numbers closer to zero mean uniformity and closer to one mean non uniformity
   \item [dPIR:] junction delta PIR
   \item [multiplicity:] do multiple junctions cross the region
   \item [J counts:] junctions' counts for all samples
  \end{description}      
 
 
\subsubsection*{jes}
  \begin{description}
  \item [event:] Type of event asigned by \texttt{ASpli} when binning. 
   \item [J3:] junctions
   \item [logFC:] log fold change of junction accross conditions
   \item [LR:] likelihood ratio of junction differential usage.
   \item [pvalue, FDR] junction's pvalue and corresponding FDR 
    \item [dPSI:] junction delta PSI
   \item [multiplicity:] do multiple junctions cross the region
   \item [J counts:] junctions' counts for all samples
\end{description}      
  
\subsubsection*{jalt}

  \begin{description}
   \item [event:] Type of event asigned by \texttt{ASpli} when binning. 
   \item [J3:] junctions
   \item [logFC]: log fold change of junction accross conditions
   \item [log.mean]: log of mean counts accross all conditions for this junction
   \item [logFC:] log fold change of junction accross conditions
   \item [LR:] likelihood ratio of junction differential usage.
   \item [pvalue, FDR] junction's pvalue and corresponding FDR 
   \item [dPSI:] junction delta PSI
   \item [multiplicity]: do multiple junctions cross the region
   \item [J counts:] junctions' counts for all samples
\end{description}      


\bibliography{ASpli}
\end{document}

\name{Subset ASpli objects}

\alias{subsetBams}
\alias{subsetTargets}
\alias{subset}

\title{ Subset ASpli objects }

\description{
  ASpli provides utility functions to easy subset ASpliCounts objects, 
  ASpliAS objects, targets data frame and lists GAlignments generated with 
  loadBAM function. The subset can be done selecting some of the experimental 
  conditions or samples names ( but not both ).
}

\usage{
  subset( x, ... )
  subsetBams( x, targets, select )
  subsetTargets( targets, select, removeRedundantExpFactors )
}

\arguments{
  \item{ x }{ 
    An ASpliCount or ASpliAS object for subset function, or list of GAlignments 
    for subsetrBams function.
  }
  \item{ targets }{
    A dataframe containing sample, bam and experimental factor columns.
  }
  \item{ select }{
    A character vector specifying the conditions or samples to be kept after 
    subset operation. It's assumed that condition names are different from 
    sample names. 
  }
  \item{ removeRedundantExpFactors }{
    When sub-setting the targets data frame, one or more experimental factors 
    can have only one value. If this argument is TRUE those experimental 
    factors are absent in the resulting target data frame. 
  }
  \item{ ... }{ Subsetting ASpliCounts and ASpliAS objects sub subset method 
    requires a targets argument and a select argument with the same 
    specifications that the arguments with the same name in subsetBams and 
    subsetTargets functions }
  
}
\value{ A data frame similar to x ( or targets for subsetTargets) with only the
 containing only the selected elements. }

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\examples{

  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  #library(GenomicFeatures)
  #genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
  #                               package="ASpli") )
  #
  # Create an ASpliFeatures object from TxDb
  #features <- binGenome( genomeTxDb )
  #
  # Define bam files, sample names and experimental factors for targets.
  #bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
  #                   "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )
  #targets <- data.frame( 
  #             row.names = paste0('Sample_',c(1:6)),
  #             bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
  #             factor1 = c( 'C','C','C','D','D','D') )
  #
  # Load reads from bam files
  #bams <- loadBAM( targets )
  #
  # Read counts from bam files
  #counts   <- readCounts( features, bams, targets, cores = 1, readLength = 100, 
  #                        maxISize = 50000 )
#  
 # # Create ASpliAS object                        
  #as       <- AsDiscover( counts, targets, features, bams, readLength = 100, 
   #                       threshold = 5, cores = 1 )
    #                      
  # Define selection
  #select <- c('Sample_1', 'Sample_2', 'Sample_4', 'Sample_5')                       
  #
  # Subset target 
  #targets2 <- subsetTargets( targets, select )
  
  # Subset bams 
  #bams2 <- subsetBams( bams, targets, select )
  
  # Subset ASpliCounts object 
  #counts2 <- subset( counts, targets, select )
  
  # Subset ASpliAS object 
  #as2 <- subset( as, targets, select )
  
}

\name{ASpliDU-class}

\Rdversion{1.1}

\docType{class}

\alias{ASpliDU}
\alias{ASpliDU-class}
\alias{binsDU,ASpliDU-method}
\alias{genesDE,ASpliDU-method}
\alias{junctionsDU,ASpliDU-method}
\alias{binsDU<-,ASpliDU-method}
\alias{genesDE<-,ASpliDU,data.frame-method}
\alias{junctionsDU<-,ASpliDU,data.frame-method}
\alias{writeDU,ASpliDU-method}
\alias{filterDU,ASpliDU-method}
\alias{mergeBinDUAS,ASpliDU,ASpliAS-method}
\alias{containsGenesAndBins,ASpliDU-method}
\alias{containsJunctions,ASpliDU-method}
\alias{splicingReport,ASpliDU-method}

\title{Class \code{"ASpliDU"}}

\description{ Contains results of differential expression at gene level and 
  differential usage at bin and junction level estimation using DEreport method.
}

\section{Slots}{
  \describe{
    \item{\code{genes}}{}
    \item{\code{bins}}{}
    \item{\code{junctions}}{}
    \item{\code{contrast}}{}
    \item{\code{.ASpliVersion}:}{
      ASpli version when this object was created. It should not be modified by the user.
    } 
  }
}


\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\name{Example data}

\alias{aspliASexample}
\alias{aspliBamsExample}
\alias{aspliCountsExample}
\alias{aspliDUexample1}
\alias{aspliDUexample2}
\alias{aspliExampleBamList}
\alias{aspliExampleGTF}
\alias{aspliFeaturesExample}
\alias{aspliJunctionDUexample}
\alias{aspliTargetsExample}


\title{
  Example Aspli objects
}
\description{
  ASpli includes functions to easily build ASpli objects, used in examples in 
  the vignette and man pages.
}

\usage{
  aspliASexample()
  aspliBamsExample()
  aspliCountsExample()
  aspliDUexample1()
  aspliDUexample2()
  aspliExampleBamList()
  aspliExampleGTF()
  aspliFeaturesExample()
  aspliJunctionDUexample()
  aspliTargetsExample()
}

\value{ An ASpli object with example data.}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\examples{
  #as <- aspliASexample()
  #bams <- aspliBamsExample()
  #counts <- aspliCountsExample()
  #du1 <- aspliDUexample1()
  #du2 <- aspliDUexample2()
  #bamfiles <- aspliExampleBamList()
  #gtffile <- aspliExampleGTF()
  #features <- aspliFeaturesExample()
  #jdu <- aspliJunctionDUexample()
  #targets <-aspliTargetsExample()
}

\name{binGenome-methods}

\docType{methods}

\alias{binGenome-methods}
\alias{binGenome,TxDb-method}

\title{ Feature coordinates extraction }

\description{ Feature coordinates extraction from a Transcript Database }

\section{Methods}{
  \describe{
    \item{\code{signature(genome = "TxDb")}}{
      An object of class transcriptDb (TxDb) 
    }
  }
}


\author{Estefania Mancini, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz }
\seealso{ \code{\link{featuresg}, \link{featuresb} , \link{featuresj} 
} 
}

\name{exportSplicingReports}

\alias{exportSplicingReports}

\title{
  Export splicing reports 
}
\description{
  Export splicing reports in easy to analyze HTML tables.
}

\usage{
exportSplicingReports( sr, output.dir="sr" ,
openInBrowser = FALSE, maxBinFDR = 0.2, maxJunctionFDR = 0.2 )
}

\arguments{
  \item{sr}{ 
    An object of class \code{ASpliSplicingReport}
  }
  \item{output.dir}{HTML reports output directory}
  \item{openInBrowser}{Open reports in browser when done}
  \item{maxBinFDR}{Only show bins with FDR < maxBinFDR}
  \item{maxJunctionFDR}{Only show junctions with FDR < maxJunctionFDR}
}

\value{ 
  Produces html reports
}
\author{   Andres Rabinovich, Estefania Mancini, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz }

\examples{
# Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  library(GenomicFeatures)
  genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
                                 package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
                     "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )

  targets <- data.frame( 
               row.names = paste0('Sample_',c(1:6)),
               bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
               factor1 = c( 'C','C','C','D','D','D'),
               subject = c(0, 1, 2, 0, 1, 2))
  
  # Read counts from bam files

gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
jcounts   <- jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0)
  
  # Test for factor1 controlling for paired subject
  gbPaired <- gbDUreport(gbcounts, formula = formula(~subject+factor1))
  jPaired  <- jDUreport(jcounts, formula = formula(~subject+factor1))
  
  # Generate a splicing report merging bins and junctions DU
  sr              <- splicingReport(gbPaired, jPaired, gbcounts)

  # Export splicing report
  exportSplicingReports(output.dir = paste0(tempdir(), "/sr"), sr)
  
}

\seealso{
  \code{\link{gbDUreport}}, \code{\link{jDUreport}}, \code{\link{splicingReport}}, \code{\link{ASpliSplicingReport}}
}

  \name{ASpliCounts}

\docType{class}

\alias{ASpliCounts}

\description{ Contains results of read overlaps against all feature levels 
  summarization }

\title{ Class \code{"ASpliCounts"} }

\section{Slots}{
  \describe{
    \item{\code{gene.counts}}{}
    \item{\code{exon.intron.counts}}{}
    \item{\code{junction.counts}}{}
    \item{\code{e1i.counts}}{}
    \item{\code{ie2.counts}}{}
    \item{\code{gene.rd}}{}
    \item{\code{bin.rd}}{}
    \item{\code{condition.order}}{}
  }
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\name{write-methods}

\alias{writeRds-methods}
\alias{writeCounts-methods}
\alias{writeAS-methods}
\alias{writeDU-methods}
\alias{writeJDU-methods}
\alias{writeSplicingReport-methods}
\alias{writeAll,ANY-method}

\title{ Write results }

\description{ Export tab delimited files in structured output}

\details{ Tab delimited files are exported in a tidy manner into output folder }

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\seealso{ \code{ \link{jCounts}, \link{binGenome},\link{DUreport.norm}, \link{DUreport.offset} } }

\name{exportIntegratedSignals}

\alias{exportIntegratedSignals}

\title{
  Export integrated signals.
}
\description{
  Export integrated signals in an easy to analyze HTML table.
}

\usage{
exportIntegratedSignals( is, output.dir="is", 
                         sr, counts, features, asd,
                         mergedBams, 
                         jCompletelyIncluded = FALSE, zoomRegion = 1.5, 
                         useLog = FALSE, tcex = 1, ntop = NULL, 
                         openInBrowser = FALSE, 
                         makeGraphs = TRUE, bforce=FALSE
                        )
}

\arguments{
  \item{is}{ 
    An object of class \code{ASpliIntegratedSignals}
  }
  \item{sr}{ 
    An object of class \code{ASpliSplicingReport}
  }
  \item{counts}{ 
    An object of class \code{ASpliCounts}
  }
  \item{features}{ 
    An object of class \code{ASpliFeatures}
  }
  \item{asd}{ 
    An object of class \code{ASpliAS}
  }  
  \item{output.dir}{HTML reports output directory}
  \item{mergedBams}{
    Dataframe with two columns, bams and conditions. Bams are paths to merged bams for each condition to be ploted. 
  }
  \item{jCompletelyIncluded}{If TRUE only plot junctions completely included in plot region. Else plot any overlapping junction in the region}
  \item{zoomRegion}{ Magnify plot region by this factor}
  \item{useLog}{Plot counts log}
  \item{tcex}{Text size}
  \item{ntop}{Only show n top signals}
  \item{openInBrowser}{Open reports in browser when done}
  \item{makeGraphs}{Generate graphs in reports}
  \item{bforce}{Force plot generation even if plot already exists}
}

\value{ 
  Produces html reports
}
\author{   Andres Rabinovich, Estefania Mancini, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz }

\examples{
  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  library(GenomicFeatures)
  genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
                                 package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
                     "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )

  targets <- data.frame( 
               row.names = paste0('Sample_',c(1:6)),
               bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
               factor1 = c( 'C','C','C','D','D','D'))
  
  # Read counts from bam files
  gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
jcounts   <- jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0)
                     

  # Test for factor1
  gbPaired <- gbDUreport(gbcounts, contrast = c(1, -1))
  jPaired  <- jDUreport(jcounts, , contrast = c(1, -1))
  
  # Generate a splicing report merging bins and junctions DU
  sr       <- splicingReport(gbPaired, jPaired, gbcounts)
  is       <- integrateSignals(sr, jcounts)
  
  #Make merged bams dataframe
  mergedBamsFileNames <- c( "A_C.bam", "A_D.bam" )
  mergedBams <- data.frame(bams = system.file( 'extdata', mergedBamsFileNames, package="ASpli" ), 
  condition = c("C", "D"), stringsAsFactors = FALSE)
  
  # Export integrated signals
  exportIntegratedSignals(is, output.dir = paste0(tempdir(), "/is"), sr, gbcounts,
                        features, jcounts, mergedBams, makeGraphs = TRUE, bforce = TRUE )
  
}

\seealso{
  \code{\link{gbDUreport}}, \code{\link{jDUreport}}, \code{\link{ASpliSplicingReport}},  \code{\link{splicingReport}}, \code{\link{ASpliIntegratedSignals}}
}

\name{show-methods}

\docType{methods}
\alias{show-methods}
\alias{show,ASpliAS-method}
\alias{show,ASpliCounts-method}
\alias{show,ASpliDU-method}
\alias{show,ASpliFeatures-method}
\alias{show,ASpliMergedReports-method}


\title{ Display a summary of data contained in ASpliObjects }

\description{ Display a summary of data contained in ASpliObjects}

\details{ Display a summary of data contained in ASpliObjects }


\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\name{getConditions}

\alias{getConditions}

\title{
  Retrieve condition names from a targets data frame.
}

\description{ Targets data frame contains experimental factors values for each 
  sample. This function generates a simple name for each unique condition 
  resulting from the combination of all experimental factors. The order of the 
  conditions given by \code{getConditions} is the same that in \code{contrast} 
  argument of \code{DUreport.norm} function. }

\usage{
  getConditions( targets )
}

\arguments{
  
  \item{ targets }{ A dataframe containing sample, bam and experimental factors 
    columns }

}

\value{
  A character vector with the names of the conditions derived from experimental
  factors.
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\seealso{
  \code{\link{DUreport.norm}},
  \code{\link{DUreport.offset}} 
}

\examples{
  
  # Define bam files, sample names and experimental factors for targets.
  #bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
  #                   "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )
  #targets <- data.frame( 
  #             row.names = paste0('Sample_',c(1:6)),
  #             bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
  #             factor1 = c( 'C','C','C','D','D','D') )
  
  # Load reads from bam files.
  # Return value is c('C', 'D') in this example. 
  #conditions <- getConditions(targets)


  # Define bam files, sample names and experimental factors for targets.
  #bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", "A_C_3.bam", 
  #                   "A_D_0.bam", "A_D_1.bam", "A_D_2.bam", "A_D_3.bam"  )
  #targets <- data.frame( 
  #             row.names = paste0('Sample_',c(1:8)),
  #             bam = file.path( 'extdata', bamFileNames, package="ASpli" ),
  #             factor1 = c( 'C','C','C','C','D','D','D','D'),
  #             factor2 = c( 'E','E','F','F','E','E','F','F')  )
  
  # Load reads from bam files.
  # Return value is c("C_E", "C_F", "D_E", "D_F") in this example. 
  #conditions <- getConditions(targets)

}

\name{ Examine ASpliDU objects }

\alias{containsJunctions}
\alias{containsGenesAndBins}

\title{ Examine ASpliDU objects }

\description{
  AspliDU object may contain results of differential expression of genes, 
  differential usage of bins and junctions, however not everything is 
  calculated at the same or even present. Calculations for genes and bins can 
  be done independently from junctions. Functions \code{containsJunctions} and
  \code{containsGenesAndBins} allow to interrogate an ASpliDU object about the 
  kind of results it contain. 
}

\usage{
  containsJunctions( du )
  containsGenesAndBins( du )
}

\arguments{
  \item{ du }{ 
    An ASpliDU object.
  }
}
\value{ 
  A logical value that indicates that results for genes and bins, or results for
  junctions are available in the object. }

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\examples{
# see ASpli package

}

\name{Features accesors}
\alias{featuresb}
\alias{featuresg}
\alias{featuresj}
\alias{transcriptExons}
\alias{featuresb<-}
\alias{featuresg<-}
\alias{featuresj<-}
\alias{transcriptExons<-}

\title{ Accessors for ASpliFeatures object }

\description{ Accessors for ASpliFeatures object }

\usage{
  featuresg( x )
  featuresb( x )
  featuresj( x )
  transcriptExons( x )
}

\arguments{
  \item{x}{ An ASpliFeatures object }
}

\value{
  Returns a GenomicRanges object. Function featuresg returns a GRangesList 
  object containing exon ranges for each gene. Functions featuresb and 
  featuresj, returns GRanges object for all bins and junctions. 
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz}

\examples{
  # Get data from an ASpliFeatures object
  
  features <- aspliFeaturesExample()
  
  fg <- featuresg( features )
  fb <- featuresb( features )
  fj <- featuresj( features )

  
  # Set data to an ASpliFeatures object
  
  featuresg( features ) <- fg 
  featuresb( features ) <- fb 
  featuresj( features ) <- fj 

}

\name{gbDUreport}

\alias{gbDUreport}

\title{
  Differential gene expression and differential bin usage estimation
}
\description{
  Estimate differential expression at gene level and differential usage at bin 
  level using diffSpliceDGE function from edgeR package.  
}

\usage{
  gbDUreport( counts, 
             minGenReads = 10, 
             minBinReads = 5,
             minRds = 0.05, 
             contrast = NULL, 
             ignoreExternal = TRUE, 
             ignoreIo = TRUE, 
             ignoreI = FALSE,
             filterWithContrasted = TRUE,
             verbose = TRUE,
             formula = NULL,
             coef = NULL)
}

\arguments{
  \item{ counts }{ 
    An object of class ASpliCounts
  }
  \item{ minGenReads }{
    Genes with at least an average of \code{minGenReads} reads for any condition 
    are included into the differential expression test.
    Bins from genes with at least an average of \code{minGenReads} reads for all
    conditions are included into the differential bin usage test.
    Default value is 10 reads.
  }
  \item{ minBinReads }{ 
    Bins with at least an average of \code{minGenReads} reads for any condition 
    are included into the differential bin usage test.
    Default value is 5 reads.
  }
  \item{ minRds }{
    Genes with at least an average of \code{minRds} read density for any 
    condition are included into the differential expression test.
    Bins from genes with at least an average of \code{minRds} read density for 
    all conditions are included into the differential bin usage test.
    Bins with at least an average of \code{minRds} read density for any 
    condition are included into the differential bin usage test.
    Default value is 0.05.
    }
  \item{ignoreExternal}{
    Ignore Exon Bins at the beginning or end of the transcript. 
    Default value is TRUE. }
  \item{ignoreIo}{ Ignore original introns.  Default TRUE }
  \item{ignoreI}{Ignore intron bins, test is performed only for exons. 
    Default FALSE }
  \item{contrast}{ 
    Either a formula or a contrast can be tested.
    If contrast is used, it defines the comparison between conditions to be tested.
    \code{contrast} should be a vector with length equal to the number of 
    experimental conditions defined by \code{targets}. The values of this vector
    are the coefficients that will be used to weight each condition, the order 
    of the values corresponds to the order given by \code{getConditions} 
    function. When \code{contrast} is NULL, defaults to a vector containing -1,
    as the first value, 1 as the second an zero for all the remaining values, 
    this corresponds to a pair comparison where the first condition is assumed 
    to be a control and the second condition is the treatment, all other 
    conditions are ignored. 
    Default = NULL}
  \item{filterWithContrasted}{
    A logical value specifying if bins, genes and junction will be filtered by
    read quantity and read density using data from those conditions that will 
    be used in the comparison, i.e. those which coefficients in contrast 
    argument are different from zero. The default value is TRUE, it is strongly
    recommended to do not change this value. }
  \item{verbose}{
    A logical value that indicates that detailed information about each step in 
    the analysis will be presented to the user. }
  \item{formula}{
    Either a formula or a contrast can be tested.
    If formula is used, complex tests can be run.
    \code{formula} should be a formula specifying which experimental conditions defined by \code{targets} to test.
    If coef is specified, then that coefficient will be tested. If not, it defaults to the last term in the formula.
    }
  \item{coef}{
    For formula only. The coefficient to be tested. If null the test defaults to the last term in the formula}    
}

\value{ 
  An ASpliDU object with results at \code{genes}, \code{bins} level.
  \item{genesDE}{
  symbol: gene symbol
  locus_overlap: genes overlaping the same locus
  gene_coordinates: gene coordinates
  start: gene start
  end: gene end
  length: gene length
  effective_length: gene effective length
  logFC: gene log2 fold change between conditions
  pvalue: p-value 
  gen.fdr: fdr corrected p-value for multiple testing
  }
  \item{binsDU}{
  feature: bin type
  event: type of event asigned by ASpli when bining.
  locus: gene locus
  locus_overlap: genes overlaping the same locus
  symbol: gene symbol
  gene_coordinates: gene coordinates
  start: bin start
  end: bin end
  length: bin length
  logFC: bin log2 fold change between conditions
  pvalue: p-value 
  bin.fdr: fdr corrected p-value for multiple testing
  }
  

}

\author{   Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz }

\examples{
  
  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  library(GenomicFeatures)
  genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
                                 package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
                     "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )

  targets <- data.frame( 
               row.names = paste0('Sample_',c(1:6)),
               bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
               factor1 = c( 'C','C','C','D','D','D'),
               subject = c(0, 1, 2, 0, 1, 2))
  
  # Read counts from bam files
   gbcounts  <- gbCounts( features = features, 
                        targets = targets, 
                        minReadLength = 100, 
                        maxISize = 50000,
                        libType="SE", 
                        strandMode=0)

# Test for factor1
  # Test for factor1 controlling for paired subject
  gbPaired   <- gbDUreport(gbcounts, formula = formula(~subject+factor1))
  
  # Show all genes and bins ordered by FDR
  genesDE(gbPaired)
  binsDU(gbPaired)
  
  # Test for factor1 without controlling for paired subject. 
  # Must change conditions inside gbcounts object to accommodate the contrast.
  gbcounts@targets$condition <- targets$factor1
  gbcounts@condition.order   <- c("C", "D") 
  gbContrast <- gbDUreport(gbcounts, contrast = c(1, -1))
  
  # Show all genes and bins ordered by FDR
  genesDE(gbContrast)
  binsDU(gbContrast)
  
  # Export results  
  writeDU( du = gbPaired, output.dir = paste0(tempdir(), "/gbPaired") )
  writeDU( du = gbContrast, output.dir = paste0(tempdir(), "/gbContrast") )
}

\seealso{
  \code{\link{edgeR}}, \code{\link{jDUreport}}
  Accessors: \code{\link{genesDE}}, \code{\link{binsDU}}
  Export: \code{ \link{writeDU} }
}

\name{DU accessors}
\alias{genesDE}
\alias{genesDE<-}
\alias{binsDU}
\alias{binsDU<-}
\alias{junctionsDU}
\alias{junctionsDU<-}

\title{Accessors for ASpliDU object}

\description{ Accessors for ASpliDU object }
\usage{ 
  genesDE( x )
  binsDU( x )
  junctionsDU( x )
}

\arguments{
  \item{ x }{ An ASpliDU object }
}

\value{ Returns dataframes with genomic metadata and logFC and pvalue }


\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\examples{
  
  # Get data tables from an ASpliDU object
  
  #du <- aspliDUexample1()
  
  #gde <- genesDE( du )
  #bdu <- binsDU( du )
  #jdu <- junctionsDU( du )
  
  # Set data tables to an ASpliDU object 
  
  #genesDE( du )     <- gde
  #binsDU( du )      <- bdu
  #junctionsDU( du ) <- jdu

}

\name{JDU accessors}
\alias{anchorc}
\alias{anchorc<-}
\alias{localec}
\alias{localec<-}
\alias{anchorj}
\alias{anchorj<-}
\alias{localej}
\alias{localej<-}
\alias{jir}
\alias{jir<-}
\alias{jes}
\alias{jes<-}
\alias{jalt}
\alias{jalt<-}

\title{Accessors for ASpliJDU object}

\description{ Accessors for ASpliJDU object }
\usage{ 
  anchorc( x )
  anchorj( x )
  localec( x )
  localej( x )
  jir( x )
  jes( x )
  jalt( x )
}

\arguments{
  \item{ x }{ An ASpliJDU object }
}

\value{ Returns dataframes  }

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\name{plotBins}

\alias{plotBins}

\title{
  Draw plots of gene counts, bin counts, PSI/PIR value, inclusion and exclusion
  junctions for selected bins. 
}

\description{ Creates a plot with gene counts, bin counts, PSI/PIR value, 
  inclusion and exclusion junctions for selected bins and conditions. }

\usage{
  plotBins( counts, 
            as,
            bin, 
            factorsAndValues, 
            targets,
            main            = NULL,
            colors          = c( '#2F7955', '#79552F', '#465579', 
                                 '#A04935', '#752020', '#A07C35') ,
            panelTitleColors = '#000000',
            panelTitleCex   = 1,
            innerMargins    = c( 2.1, 3.1, 1.1, 1.1 ),
            outerMargins    = c( 0, 0, 2.4, 0 ), 
            useBarplots     = NULL,
            barWidth        = 0.9,
            barSpacer       = 0.4,
            las.x           = 2,
            useHCColors     = FALSE,
            legendAtSide    = TRUE,
            outfolder       = NULL,
            outfileType     = c( 'png', 'bmp', 'jpeg', 'tiff', 'pdf')[1],
            deviceOpt       = NULL ) 
}

\arguments{
  
  \item{counts}{ An object of class \code{ASpliCounts} }
  
  \item{as}{ An object of class \code{ASpliAS} }
  
  \item{bin}{ A character vector with the names of the bins to be plotted. }
  
  \item{factorsAndValues}{ A list containing the factor and the values for each
    factor to be plotted. The order of the factors will modify how the 
    conditions are grouped in the plot. \code{factorsAndValues} must be a named
    list, where the name of each element is a factor and the list element itself
    is a character vector of the values of this factor in the order to be 
    plotted. See examples for more details.
  }
    
  \item{targets}{ A data frame containing sample, bam files and experimental 
    factor columns 
  }
  
  \item{main}{ Main title of the plot. If \code{NULL} the bin name is used as
    title.
  }
  
  \item{colors}{ A vector of character colors for lines and bar plots. }
  
  \item{panelTitleColors}{ A vector of character colors for the titles of each
    plot panel.
  }
  
  \item{panelTitleCex}{ Character size expansion for panel titles.}
  
  \item{innerMargins}{ A numerical vector of the form c(bottom, left, top, 
    right) which gives the size of each plot panel margins. Defaults to c( 2.1, 
    3.1, 1.1, 1.1 ) }
  
  \item{outerMargins}{ A numerical vector of the form c(bottom, left, top, 
    right) which gives the size of margins. Defaults to c( 0, 0, 2.4, 0 ) }

  \item{useBarplots}{ A logical value that indicates the type of plot to be 
    used. If \code{TRUE} bar plots are used, if \code{FALSE} lines are used. If
    \code{NULL} the type is bar plot if there just two conditions and lines if 
    there are more than two conditions.}
  
  \item{barWidth}{ The width of the bars in bar plots. \code{barWidth} must be 
    in (0,1] range. Default value is 0.9.}
  
  \item{barSpacer}{ Fraction of \code{barwidth} used as spacer between bar plot 
    groups. Defaule value is 0.4.}
  
  \item{las.x}{ Text orientation of x-axis labels. }
  
  \item{useHCColors}{ A logical value. If \code{TRUE} \code{panelTitleColors}} 
    are not used, instead panel title are automatically chosen to have high 
    contrast against \code{colors}.

  \item{legendAtSide}{ A logical value that forces panel title to be shown on 
    the y-axis, instead of over the plot. }

  \item{outfolder}{ Path to output folder to write plot images. Is \code{NULL},
    plot are rendered on the default device }
    
  \item{outfileType}{ File format of the output files used if \code{outfolder} 
    is not \code{NULL}. Accepted values are 'png', 'jpeg', 'tiff', 'pdf'. Each
    value selects the graphic device of the same name. The name of the image
    file is the name of bin with the corresponding extension given by the chosen
    type }
  
  \item{deviceOpt}{A list of named options to be passed to the graphic device 
    selected in \code{outfileType}}
    
}

\value{
Returns a png for each selected bin }

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\seealso{
  \code{\link{plotGenomicRegions}}, 
}

\examples{

  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  #library(GenomicFeatures)
  #genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
  #                               package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  #features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  #bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
  #                   "A_D_0.bam", "A_D_1.bam", "A_D_2.bam",
  #                   "B_C_0.bam", "B_C_1.bam", "B_C_2.bam", 
  #                   "B_D_0.bam", "B_D_1.bam", "B_D_2.bam" )
                     
  #targets <- data.frame( 
  #             row.names = paste0('Sample_',c(1:12)),
  #             bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
  #             factor1 = c( 'A','A','A','A','A','A','B','B','B','B','B','B'),
  #             factor2 = c( 'C','C','C','D','D','D','C','C','C','D','D','D') )
  
  # Load reads from bam files
  #bams <- loadBAM( targets )
  
  # Read counts from bam files
  #counts   <- readCounts( features, bams, targets, cores = 1, readLength = 100, 
  #                        maxISize = 50000 )
  
  # Calculate differential usage of genes, bins and junctions 
  #du       <- DUreport.norm( counts, targets , contrast = c(1,-1,-1,1))

  # Calculate PSI / PIR for bins and junction.
  #as       <- AsDiscover( counts, targets, features, bams, readLength = 100, 
  #                        threshold = 5, cores = 1 )
  
  # Plot bin data. Factor2 is the main factor for graphic representation in
  # this example as it is the first in factorsAndValues argument.
  # This makes a bar plot comparing four conditions, grouped by factor1.
  #plotBins( counts, as, 'GENE03:E002', 
  #  factorsAndValues = list( 
  #    factor2 = c('C','D'), 
  #    factor1 = c('A','B') ),
  #  las.x = 1,
  #  legendAtSide = TRUE,
  #  useHCColors = TRUE,   
  #  targets = targets,
  #  barWidth = 0.95,
  #  innerMargins = c( 2.1, 4.1, 1.1, 1.1 ) )
    
    
  # Redefine targets  
  #targets <- data.frame( 
  #             row.names = paste0('Sample_',c(1:12)),
  #             bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
  #             factor1 = c( 'A','A','B','B','C','C','D','D','E','E','F','F') )
  
  #as       <- AsDiscover( counts, targets, features, bams, readLength = 100, 
  #                        threshold = 5, cores = 1 )
  
  # This makes a line plot for six conditions, grouped by factor1.                       
  #plotBins( counts, as, 'GENE03:E002', 
  #  factorsAndValues = list( 
  #    factor1 = c('A','B','C','D','E','F') ),
  #  las.x = 1,
  #  legendAtSide = FALSE,
  #  targets = targets,
  #  innerMargins = c( 2.1, 4.1, 1.1, 1.1 ) )                        
  
}

\name{DUreport.offset}

\alias{DUreport.offset}

\title{
  Differential gene expression and differential bin usage estimation
}
\description{
  Estimate differential expression at gene level and differential usage at bin 
  level. When targets has only two conditions, and contrast is not set, the 
  estimation of differential expression and usage is done with an exact test,
  otherwise is estimated using a generalized linear model.    
}

\usage{
  DUreport.offset( counts, 
            minGenReads = 10, 
            minBinReads = 5,
            minRds = 0.05, 
            offsetAggregateMode =  c( "geneMode", "binMode" )[1],
            offsetUseFitGeneX = TRUE,
            contrast = NULL, 
            ignoreExternal = TRUE, 
            ignoreIo = TRUE, 
            ignoreI = FALSE,
            filterWithContrasted = TRUE,
            verbose = FALSE)
}

\arguments{
  \item{ counts }{ 
    An object of class ASpliCounts
  }
  \item{ minGenReads }{
    Genes with at least an average of \code{minGenReads} reads for any condition 
    are included into the differential expression test.
    Bins from genes with at least an average of \code{minGenReads} reads for all
    conditions are included into the differential bin usage test.
    Default value is 10 reads.
  }
  \item{ minBinReads }{ 
    Bins with at least an average of \code{minGenReads} reads for any condition 
    are included into the differential bin usage test.
    Default value is 5 reads.
  }
  \item{ minRds }{
    Genes with at least an average of \code{minRds} read density for any 
    condition are included into the differential expression test.
    Bins from genes with at least an average of \code{minRds} read density for 
    all conditions are included into the differential bin usage test.
    Bins with at least an average of \code{minRds} read density for any 
    condition are included into the differential bin usage test.
    Default value is 0.05.
    }
  \item{ignoreExternal}{
    Ignore Exon Bins at the beginning or end of the transcript. 
    Default value is TRUE. }
  \item{ignoreIo}{ Ignore original introns.  Default TRUE }
  \item{ignoreI}{Ignore intron bins, test is performed only for exons. 
    Default FALSE }
  \item{offset}{ Corrects bin expression using an offset matrix derived from 
    gene expression data. Default = FALSE}
  \item{offsetAggregateMode}{ Choose the method to aggregate gene counts to 
    create the offset matrix. When \code{offsetAggregateMode} is 'geneMode' and 
    option \code{offsetUseFitGeneX} is TRUE, a generalized linear model is used 
    to create the offset matrix. When \code{offsetAggregateMode} is 'geneMode' 
    and option \code{offsetUseFitGeneX} is FALSE, the offset matrix is generated
    by adding a prior count to the gene count matrix. When 
    \code{offsetAggregateMode} is 'binMode' a matrix from obtained from the sum
    of exonic bin counts, this only takes those bins that passes filters using 
    minGenReads, minBinReads and minRds.
    Options:=c( "geneMode", "binMode" )[ 1 ] },
  \item{offsetUseFitGeneX}{ Default= TRUE } 
  \item{contrast}{ Define the comparison between conditions to be tested.
    \code{contrast} should be a vector with length equal to the number of 
    experimental conditions defined by \code{targets}. The values of this vector
    are the coefficients that will be used to weight each condition, the order 
    of the values corresponds to the order given by \code{getConditions} 
    function. When \code{contrast} is NULL, defaults to a vector containing -1,
    as the first value, 1 as the second an zero for all the remaining values, 
    this corresponds to a pair comparison where the first condition is assumed 
    to be a control and the second condition is the treatment, all other 
    conditions are ignored. 
    Default = NULL}
  \item{filterWithContrasted}{
    A logical value specifying if bins, genes and junction will be filtered by
    read quantity and read density using data from those conditions that will 
    be used in the comparison, i.e. those which coefficients in contrast 
    argument are different from zero. The default value is TRUE, it is strongly
    recommended to do not change this value.}
  \item{verbose}{
    A logical value that indicates that detailed information about each step in 
    the analysis will be presented to the user. }
}

\value{ 
  An ASpliDU object with results at \code{genes}, \code{bins} level.}


\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }


\examples{
#check ASpli pacakge example}

\seealso{
  \code{\link{edgeR}}, \code{\link{jDUreport}}
  Accessors: \code{\link{genesDE}}, \code{\link{binsDU}}
  Export: \code{ \link{writeDU} }
}

\name{ASpliAS-class}

\Rdversion{1.1}

\docType{class}

\alias{ASpliAS}
\alias{ASpliAS-class}
\alias{altPSI,ASpliAS-method}
\alias{esPSI,ASpliAS-method}
\alias{irPIR,ASpliAS-method}
\alias{joint,ASpliAS-method}
\alias{junctionsPIR,ASpliAS-method}
\alias{junctionsPJU,ASpliAS-method}
\alias{altPSI<-,ASpliAS,data.frame-method}
\alias{esPSI<-,ASpliAS,data.frame-method}
\alias{irPIR<-,ASpliAS,data.frame-method}
\alias{joint<-,ASpliAS,data.frame-method}
\alias{junctionsPIR<-,ASpliAS,data.frame-method}
\alias{junctionsPJU<-,ASpliAS,data.frame-method}
\alias{subset,ASpliAS-method}
\alias{writeAS,ASpliAS-method}
\alias{jDUreport,ASpliAS-method}

\title{Class \code{"ASpliAS"}}

\description{ Results of PSI and PIR using experimental junctions }

\section{ Slots }{
  \describe{
    \item{\code{irPIR}:}{
      Reports: event, e1i counts (J1), ie1 counts (J2), j_within (J3), PIR by 
      condition. J1, J2, J3 sum of junctions (J1, J2, J3) by condition.}
    \item{\code{altPSI}:}{
      Reports: event, J1 (start), J2 (end), J3 (exclusion), PSI. J1, J2, J3 sum 
      of junctions (J1, J2, J3) by condition.}
    \item{\code{esPSI}:}{
      Reports: event, J1 (start), J2 (end), J3 (exclusion), PSI. J1, J2, J3 sum 
      of junctions (J1, J2, J3) by condition.}
    \item{\code{join}:}{
      It is a combination of irPIR, altPSI and esPSI tables}
    \item{\code{junctionsPIR}:}{
      PIR metric for each experimental junction using e1i and ie2 counts. 
      Exclusion junction is the junction itself. This output helps to discover 
      new introns as well as new retention events}
    \item{\code{junctionsPJU}:}{
      Given a junction, it is possible to analyze if it shares start, end or 
      both with another junction. If so, is because there is more than one way 
      for/of splicing. Ratio between them along samples is reported.}
    \item{\code{targets}:}{
      DataFrame with targets.}
    \item{\code{.ASpliVersion}:}{
      ASpli version when this object was created. It should not be modified by the user.}      
  }
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz}

\seealso{ 
  Methods: \code{\link{AsDiscover}}
  
  Accesors: \code{\link{altPSI}},
            \code{\link{irPIR}},
            \code{\link{esPSI}},
            \code{\link{joint}},
            \code{\link{junctionsPIR}},
            \code{\link{junctionsPJU}}
}

\name{integratedSignals accessors}
\alias{signals}
\alias{signals<-}
\alias{filters}
\alias{filters<-}


\title{Accessors for ASpliIntegratedSignals object}

\description{ Accessors for ASpliIntegratedSignals object }
\usage{ 
  signals( x )
  filters( x )
}

\arguments{
  \item{ x }{ An ASpliIntegratedSignals object }
}

\value{ Returns dataframes }

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz }

\name{filterSignals}

\alias{filterSignals}

\title{
  Filter signals
}
\description{
  Filter signals
}

\usage{
    filterSignals( sr,
                   bin.FC = 3,
                   bin.fdr = 0.05,
                   nonunif = 1,
                   bin.inclussion = 0.1,
                   bjs.inclussion = 0.2,
                   bjs.fdr = 0.1,
                   a.inclussion = 0.3,
                   a.fdr = 0.05,
                   l.inclussion = 0.3,
                   l.fdr = 0.05, 
                   bDetectionSummary = FALSE)
}

\arguments{
  \item{sr}{ 
    An object of class \code{ASpliSplicingReport}
  }
  \item{bin.FC}{Description TODO}
  \item{bin.fdr}{Description TODO}
  \item{nonunif}{Description TODO}
  \item{bin.inclussion}{Description TODO}
  \item{bjs.inclussion}{Description TODO}
  \item{bjs.fdr}{Description TODO}
  \item{a.inclussion}{Description TODO}
  \item{a.fdr}{Description TODO}
  \item{l.inclussion}{Description TODO}
  \item{l.fdr}{Description TODO}
  \item{bDetectionSummary}{Description TODO}
}

\value{ TODO }

\author{
  Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz
}

\examples{
  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored.
  
  #as <- new("ASpliAS")
  #targets <- 1
  #a <- junctionDUreportExt(as, targets)
  
}

\seealso{
  \code{\link{ASpliSplicingReport}}
}

\name{write}

\alias{writeRds}
\alias{writeCounts}
\alias{writeAS}
\alias{writeDU}
\alias{writeJDU}
\alias{writeSplicingReport}
\alias{writeAll}

\title{ Write results }

\description{ Export tab delimited files in structured output }

\usage{
  writeCounts(counts, output.dir="counts")
  writeRds(counts, output.dir="rds")
  writeDU(du, output.dir="du")
  writeAS(as, output.dir="as")
  writeJDU(jdu, output.dir="jdu")
  writeSplicingReport(sr, output.dir="sr")
  writeAll(counts, du, as, output.dir="output")
}

\arguments{
  \item{counts}{An ASpliCounts object}
  \item{as}{An ASpliAS object}
  \item{du}{An ASpliDU object}
  \item{jdu}{An ASpliJDU object}
  \item{sr}{An ASpliSplicingReport object}
  \item{output.dir}{ Name of output folder (new or existing) }
}

\value{ Tab delimited files are exported in a tidy manner into output folder }

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\seealso{ 
  \code{ \link{jCounts}}, 
  \code{ \link{binGenome}},
  \code{ \link{DUreport.norm}},
  \code{ \link{DUreport.offset}}
}

\name{mergeBinDUAS}

\alias{mergeBinDUAS}

\title{Differential usage of bins and PSI/PIR.}

\description{ 
  This function merges the results of differential usage of bins, from an 
  ASpliDU object, with PSI/PIR and junction information, from an ASpliAS object.
  Also, a delta PSI/PIR value is calculated from a contrast.  
}

\usage{
  mergeBinDUAS( du, 
                as,
                targets, 
                contrast = NULL ) 
}

\arguments{
  
  \item{du}{ An object of class \code{ASpliDU} }
  
  \item{as}{ An object of class \code{ASpliAS} }
  
  \item{targets}{ A data frame containing sample, bam files and experimental 
    factor columns. 
  }
  \item{contrast}{ Define the comparison between conditions to be tested.
    \code{contrast} should be a vector with length equal to the number of 
    experimental conditions defined by \code{targets}. The values of this vector
    are the coefficients that will be used to weight each condition, the order 
    of the values corresponds to the order given by \code{getConditions} 
    function. When \code{contrast} is NULL, defaults to a vector containing -1,
    as the first value, 1 as the second an zero for all the remaining values, 
    this corresponds to a pair comparison where the first condition is assumed 
    to be a control and the second condition is the treatment, all other 
    conditions are ignored. 
    The default value is NULL.
  }
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }


\value{
  A data frame containing feature, event, locus, locus_overlap, symbol, 
  gene coordinates, start of bin, end of bin, bin length, log-Fold-Change value,
  p-value, fdr corrected p-value, J1 inclusion junction, J1 junction counts for each 
  sample, J2 inclusion junction, J2 junction counts for each sample, J3
  exclusion junction, J3 junction counts for each sample, PSI or PIR value for 
  each bin, and delta PSI/PIR.
}

\seealso{
  \code{ \link{ASpliDU} },
  \code{ \link{ASpliAS} }
}

\examples{

  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  #library(GenomicFeatures)
  #genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
  #                               package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  #features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  #bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
  #                   "A_D_0.bam", "A_D_1.bam", "A_D_2.bam",
  #                   "B_C_0.bam", "B_C_1.bam", "B_C_2.bam", 
  #                   "B_D_0.bam", "B_D_1.bam", "B_D_2.bam" )
                     
  #targets <- data.frame( 
  #             row.names = paste0('Sample_',c(1:12)),
  #             bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
  #             factor1 = c( 'A','A','A','A','A','A','B','B','B','B','B','B'),
  #             factor2 = c( 'C','C','C','D','D','D','C','C','C','D','D','D') )
  
  # Load reads from bam files
  #bams <- loadBAM( targets )
  
  # Read counts from bam files
  #counts <- readCounts( features, bams, targets, cores = 1, readLength = 100, 
  #                        maxISize = 50000 )
  
  # Calculate differential usage of genes and bins
  #du <- DUreport.norm( counts, targets , contrast = c(1,-1,-1,1))
  
  # Calculate PSI / PIR for bins and junction.
  #as <- AsDiscover( counts, targets, features, bams, readLength = 100, 
  #                        threshold = 5, cores = 1 )

  #mas <- mergeBinDUAS( du, as, targets, contrast =  c(1,-1,-1,1) )                     
  
}

\name{binGenome}

\alias{binGenome}

\title{ Feature coordinates extraction }

\description{ 
  Exons and introns are subdivided into new features called exon and intron bins
  and are then classified into exclusively exonic bins, exclusively intronic 
  bins or alternative splicing (AS) bins .
}

\usage{ binGenome(genome,  geneSymbols = NULL, logTo = "ASpli_binFeatures.log", cores = 1) }

\arguments{
  \item{genome}{ An object of class transcriptDb (TxDb) }
  \item{geneSymbols}{ A dataframe with symbol (common names) of TxDb genes. 
    If geneSymbols is NULL, gene name will be repeated }
  \item{ logTo }{ Filename where to print features extraction log }
  \item{ cores }{ Number of cores to use in parallel when binning the genome }
 }

\details{ 
  Exon and intron coordinates are extracted from gene annotation, only those 
  from multi-exonic genes are saved for further evaluation. In case more than 
  one isoform exist, some exons and introns will overlap. Exons and introns are
  then disjoint into new features called exon and intron bins, and then they are
  classified into exclusively exonic bins, exclusively intronic bind or 
  alternative splicing bins (AS-bins), which are labeled according to which 
  alternative splicing event are assumed to came from: 
  
  \itemize{ 
     \item {ES: exon skipping} 
     \item {IR: intron retention}
     \item {Alt5|3'ss: alternative five/three prime splicing site}
     \item {"*" (ES*, IR*, AltSS*) means this AS bin/region is involved 
       simultaneously in more than one AS event type}
     \item {external:  from the beginning or the end of a transcript}
  }
  
  Subgenic features are labeled as follow (hypothetical GeneAAA):
  
  \itemize{
    \item {GeneAAA:E001: defines first exonic bin}
    \item {GeneAAA:I001: defines first intronic bin}
    \item {GeneAAA:Io001: defines first intron before disjoint into bins}
    \item {GeneAAA:J001: defines first junction}
  }

  Junctions are defined as the last position of five prime exon (donor position)
  and first position of three prime exon (aceptor position). Using TxDb object,
  it is possible to extract annotated/known junctions. This information will be
  useful for the analysis of "experimental" junctions (reads aligned with gaps). 
  Bins and junctions are labelled always in  5' to 3' sense. This notation is
  strand independent. It implies that bin / junction with lower numbering is 
  always at 5'.
}

\value{ An ASpliFeatures object. It is  a list of features using GRanges 
  format. }

\author{Estefania Mancini, Javier Iserte, Marcelo Yanovsky, 
  Ariel Chernomoretz}

\seealso{ 
  \code{\link{featuresg}}, 
  \code{\link{featuresb}},
  \code{\link{featuresj}} 
}


\examples{
  # Create a transcript DB from gff/gtf annotation file.
  library(GenomicFeatures)
  gtfFileName <- aspliExampleGTF()
  genomeTxDb <- txdbmaker::makeTxDbFromGFF( gtfFileName )
  
  # Create an ASpliFeatures object from TxDb
  features <- binGenome( genomeTxDb )

  # Extract gene, bin and junctions features
  GeneCoord <- featuresg(features)
  BinCoord <- featuresb(features)
  JunctionCoord <- featuresj(features)
  
} 

\name{ASpliJDU-class}

\Rdversion{1.1}

\docType{class}

\alias{ASpliJDU}
\alias{ASpliJDU-class}
\alias{anchorc,ASpliJDU-method}
\alias{anchorj,ASpliJDU-method}
\alias{localec,ASpliJDU-method}
\alias{localej,ASpliJDU-method}
\alias{jir,ASpliJDU-method}
\alias{jes,ASpliJDU-method}
\alias{jalt,ASpliJDU-method}
\alias{anchorc<-,ASpliJDU,data.frame-method}
\alias{anchorj<-,ASpliJDU,data.frame-method}
\alias{localec<-,ASpliJDU,data.frame-method}
\alias{localej<-,ASpliJDU,data.frame-method}
\alias{jir<-,ASpliJDU,data.frame-method}
\alias{jes<-,ASpliJDU,data.frame-method}
\alias{jalt<-,ASpliJDU,data.frame-method}
\alias{jDUreport,ASpliJDU-method}
\alias{show,ASpliJDU-method}
\alias{writeJDU,ASpliJDU-method}

\title{Class \code{"ASpliJDU"}}

\description{ Contains results of differential expression at junction level.
}

\section{Slots}{
  \describe{
    \item{\code{localec}}{}
    \item{\code{localej}}{}
    \item{\code{anchorc}}{}
    \item{\code{anchorj}}{}
    \item{\code{jir}}{}
    \item{\code{jes}}{}
    \item{\code{jalt}}{}
    \item{\code{contrast}}{}   
    \item{\code{.ASpliVersion}:}{
      ASpli version when this object was created. It should not be modified by the user.
    }     
  }
}

\author{ Andres Rabinovich, Estefania Mancini, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\name{jDUreport}

\alias{jDUreport}

\title{ Differential junction usage estimation }

\description{ 
This function estimates the differential usage of junctions combining different types of evidence

Differential junction usage is estimated using a combination of evidences


  }

\usage{
  jDUreport(asd, 
            minAvgCounts                       = 5, 
            contrast                           = NULL,
            filterWithContrasted               = TRUE,
            runUniformityTest                  = FALSE,
            mergedBams                         = NULL,
            maxPValForUniformityCheck          = 0.2,
            strongFilter                       = TRUE,
            maxConditionsForDispersionEstimate = 24,
            formula                            = NULL,
            coef                               = NULL,
            maxFDRForParticipation             = 0.05,
            useSubset                          = FALSE)
}

\details{
Estimation is made at junction level using diffSpliceDGE function from edgeR package. 
Junctions belonging to the same AS event comprises the event "set". 
Each junction is tested against this "set" in a similar fashion that bins are tested against their gene in diffSpliceDGE. Localec are clusters made of junctions that share an end with at least another junction in the cluster.
}
\arguments{
\item{asd}{ An object of class \code{ASpliAS} with results of PSI and PIR using experimental junctions}
\item{minAvgCounts}{ Minimum average counts for filtering}  
\item{contrast}{ Define the comparison between conditions to be tested.
  \code{contrast} should be a vector with length equal to the number of 
    experimental conditions defined by \code{targets}. The values of this vector
    are the coefficients that will be used to weight each condition, the order 
    of the values corresponds to the order given by \code{getConditions} 
    function. When \code{contrast} is NULL, defaults to a vector containing -1,
    as the first value, 1 as the second an zero for all the remaining values, 
    this corresponds to a pair comparison where the first condition is assumed 
    to be a control and the second condition is the treatment, all other 
    conditions are ignored. 
If NULL must provide a formula. }
    
\item{filterWithContrasted}{
    A logical value specifying if bins, genes and junction will be filtered by
    read quantity and read density using data from those conditions that will 
    be used in the comparison, i.e. those which coefficients in contrast 
    argument are different from zero. The default value is TRUE, it is strongly
    recommended to do not change this value.  }

\item{runUniformityTest}{ Run uniformity test on Intron Retention. Sometimes Mutually Exclusive Exons (MEX) events can be confused with Intron Retention events. This test compares the standard deviation of the inner intron region (11 bases from both ends) to the mean of both intron ends. Numbers closer to 0 mean the event is more probably an Intron Retention event than an MEX event. The test takes some time to run so it defaults to FALSE. }

\item{mergedBams}{     Path to merged bams for each testing condition. If no merged bams exist (for example, paired samples without replicates), use the same bams as targets.  }

\item{maxPValForUniformityCheck}{    To speed up uniformity test only check junctions with pval < maxPValForUniformityCheck  } 

\item{strongFilter}{  If strongFilter is TRUE, then we remove all events with at least one junction that doesn't pass the filter. }  

\item{maxConditionsForDispersionEstimate}{  In order to reduce resource usage, estimate dispersion for statistics tests with a reduced number of conditions.  }

\item{formula}{    Either a formula or a contrast can be tested.    If formula is used, complex tests can be run. 
\code{formula} should be a formula specifying which experimental conditions defined by \code{targets} to test.
    If coef is specified, then that coefficient will be tested. If not, it defaults to the last term in the formula.
    }

\item{coef}{
    For formula only. The coefficient to be tested. If null the test defaults to the last term in the formula}   
  \item{maxFDRForParticipation}{
   In order to calculate junctionPSI participation, only use significant junctions (ie junctions with FDR < maxFDRForParticipation).}   
  \item{useSubset}{    Experimental. It is strongly recomended to leave the default, FALSE.}

}

\value{ 
  An \code{ASpliJDU} object with results of differential usage at \code{junctions} level.
  \item{localec}{
  size: number of junctions belonging to the cluster.
  cluster.LR: likelihood ratio of cluster differential usage.
  pvalue: pvalue of cluster differential usage.
  FDR: fdr of cluster differential usage.
  range: cluster location.
  participation: participation of the significant junction (FDR < maxFDRForParticipation) presenting maximal participation value inside the cluster
  dParticipation: delta participation of the significant junction (FDR < maxFDRForParticipation) presenting maximal participation value inside the cluster 
  }
  \item{localej}{
  cluster: name of the cluster the junction belongs to
  log.mean: log of mean counts accross all conditions for this junction
  logFC: log fold change of junction accross conditions
  pvalue: pvalue of junction
  FDR: FDR of junction
  annotated: is junction annotated or new
  participation: the maximal participation value observed across contrasted condictions
  dParticipation: delta participation of the maximal participation value observed across contrasted condictions
  From dParticipation to the end, junction counts for all samples
  }  
  \item{anchorc}{
  cluster.LR: likelihood ratio of cluster differential usage.
  pvalue: pvalue of cluster differential usage.
  FDR: fdr of cluster differential usage.
  }   
  \item{anchorj}{
  log.mean: log of mean counts accross all conditions for this junction
  logFC: log fold change of junction accross conditions
  LR: likelihood ratio of junction differential usage.
  pvalue: pvalue of junction
  FDR: FDR of junction
  J1.pvalue: pvalue of J1 junction
  J2.pvalue: pvalue of J2 junction
  NonUniformity: if non uniformity test was performed, numbers closer to zero mean uniformity and closer to one mean non uniformity
  dPIR: junction delta PIR
  annotated: is junction annotated or new
  From annotated to the end, junction counts for all samples
  }   
  \item{jir}{
  J3: J3 junction/s
  logFC: log fold change of junction accross conditions
  log.mean: log of mean counts accross all conditions for this junction
  pvalue: pvalue of junction
  FDR: FDR of junction
  LR: likelihood ratio of junction differential usage.  
  NonUniformity: if non uniformity test was performed, numbers closer to zero mean uniformity and closer to one mean non uniformity
  dPIR: junction delta PIR
  multiplicity: do multiple junctions cross the region
  From multiplicity to the end, junction counts for all samples
  }      
  \item{jes}{
  event: type of event
  J3: J3 junction/s
  logFC: log fold change of junction accross conditions
  log.mean: log of mean counts accross all conditions for this junction
  pvalue: pvalue of junction
  FDR: FDR of junction
  LR: likelihood ratio of junction differential usage.  
  dPSI: junction delta PSI
  multiplicity: do multiple junctions cross the region
  From multiplicity to the end, junction counts for all samples
  }      
  \item{jalt}{
  event: type of event
  J3: J3 junction/s
  logFC: log fold change of junction accross conditions
  log.mean: log of mean counts accross all conditions for this junction
  pvalue: pvalue of junction
  FDR: FDR of junction
  LR: likelihood ratio of junction differential usage.  
  dPSI: junction delta PSI
  multiplicity: do multiple junctions cross the region
  From multiplicity to the end, junction counts for all samples   }      
  \item{contrast}{   Conditions contrasted by ASpli  }
}

\author{   Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz }

\seealso{
  Accesors: \code{\link{localec}}, 
            \code{\link{localej}},
            \code{\link{anchorc}},
            \code{\link{anchorj}},
            \code{\link{jir}},
            \code{\link{jes}},
            \code{\link{jalt}},
            \code{\link{junctionsDU}},
  Export:   \code{\link{writeJDU}},
  \code{\link{writeDU}},  \code{\link{edgeR}}, \code{\link{ASpliAS}}
}


\examples{

  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  library(GenomicFeatures)

  genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
                                 package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
                     "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )

  targets <- data.frame( 
               row.names = paste0('Sample_',c(1:6)),
               bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
               factor1 = c( 'C','C','C','D','D','D'),
               subject = c(0, 1, 2, 0, 1, 2))

  # Read counts from bam files
 gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
jcounts   <- jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0)
                     

  
  # Test for factor1 controlling for paired subject
  jPaired <- jDUreport(jcounts, formula = formula(~subject+factor1))
  
  # Show junctions information
  jPaired
  localej(jPaired)
  localec(jPaired)
  anchorj(jPaired)
  anchorc(jPaired)
  jir(jPaired)
  jes(jPaired)
  jalt(jPaired)
  
  # Export results  
  writeJDU( jPaired, output.dir = paste0(tempdir(), "/jPaired") )

}

\name{plotGenomicRegions}

\alias{plotGenomicRegions}

\title{ Create genomic regions coverage plots }

\description{
  Graphic representation of coverage and junctions is useful to complement 
  the results of differential usage of bins and junction and differential 
  expression analysis. 
  
  Function plotGenomicRegions allow to create plots for multiple conditions for
  bins and genes. Each individual plot can only correspond to a single gene or 
  bin, but can contain many panels for different experimental conditions. 
}

\usage{
  plotGenomicRegions( features, x, genomeTxDb, targets, xIsBin = TRUE, 
    layout = 'auto', colors = 'auto', plotTitles = 'auto', sashimi = FALSE, 
    zoomOnBins = FALSE, deviceOpt = NULL, highLightBin = TRUE, outfolder = NULL, 
    outfileType = 'png', mainFontSize = 24, annotationHeight = 0.2,
    annotationCol = 'black', annotationFill = 'gray', annotationColTitle = 'black',
    preMergedBAMs = NULL, useTransparency = FALSE, tempFolder = 'tmp', 
    avoidReMergeBams= FALSE, verbose = TRUE )
}

\arguments{
  \item{features}{
    An ASpliFeatures object, generated with \code{binGenoms} function.
  }
  \item{x}{ 
    A character vector with the names of bins or genes to plot. To plot into a
    window is recommended that the length of x be one.
  }
  \item{genomeTxDb}{
    A TxDb object with the annotation of reference genome.
  }
  \item{targets}{A data frame containing sample, bam files and experimental 
    factor columns }
  \item{xIsBin}{
    A logical value that indicates if values in x corresponds to gene names or
    bin names.
  }
  \item{layout}{ 
    A character with value 'auto' or a character matrix with condition names 
    arranged with the desired layout of the panels in plots. The dimensions of 
    layout matrix, colors matrix and plotTitles matrices must be the same. 
    Matrix can have NA values, however, the height of the panels corresponding
    to that column are modified to occupy the total height.  
    The default value is 'auto'.
  }
  \item{colors}{ 
    A character containing value 'auto' or containing colors strings, or a 
    character matrix with color names arranged with the layout specified in 
    layout argument. The dimensions of layout matrix, colors matrix and 
    plotTitles matrices must be the same. The default value is 'auto'. 
  }
  \item{plotTitles}{ 
    A character containing value 'auto', or a character matrix with titles for
    each panel arranged with the layout specified in 
    layout argument. The dimensions of layout matrix, colors matrix and 
    plotTitles matrices must be the same. The default value is 'auto'. 
  }
  \item{sashimi}{ 
    A logical value that specifies that a sashimi plot for junctions must be 
    included into each panel. The default value is FALSE.
  }
  \item{zoomOnBins}{ 
    A FALSE logical value or a double value between 0 and 1. If value is FALSE
    then the genomic range to be plotted correspond to the complete gene, 
    otherwise the genomic range is that the size of the bin corresponds to a 
    fraction equals to zoomOnBins value of the total and is centered in the bin. 
    Is used only when xIsBin is TRUE. The default value is FALSE.}
  
  \item{deviceOpt}{ 
    A named list of arguments to be passed to the graphic device used to plot.
    This allow to further customization of the plot. The default value is an
    empty list.}
  
  \item{highLightBin}{
    A logical value that indicates if the bin should be highlighted. 
    The default value is TRUE.
  }
  \item{outfolder}{
    NULL or a character vector representing a folder path that will be used to 
    save the plot images. If the folder doesn't exists it is created. 
    If NULL, the plot is made in a window. The default value is NULL.
    For each bin, a single image file is generated. The name of the file is the
    name of the bin, added with a '.gr.' string, and the file extension at the 
    end. If the name of the bin contains invalid character for a file name, 
    those will be replaced by an underscore character.
  }
  \item{outfileType}{
    A character value the specifies the file format of the plot to be created.
    Is used only when outfolder is not NULL. Accepted values are 'png', 'jpeg',
    'bmp', 'tiff', 'pdf'. Each value is the graphic device used to create the 
    image. The default value is 'png'. 
  }
  \item{mainFontSize}{
    A numeric value specifying the size of the main title. The default value is 
    24.
  }
  \item{annotationHeight}{
    A double value specifying the proportion of the total height used to 
    represent the gene model. The default value is 0.2. 
  }
  \item{annotationCol}{
    A character value that specifies the color of the borders of bars in gene 
    model representation. The default value is 'black'.
  }
  \item{annotationFill}{
    A character value that specifies the color of the filling of bars in gene 
    model representation. The default value is 'gray'.
  }
  \item{annotationColTitle}{
    A character value that specifies the color of text in gene model 
    representation. The default value is 'black'.
  }
  \item{preMergedBAMs}{
    A one column data frame that associates a condition, specified in the row 
    name, with a character value representing the path of bam file with the 
    reads for that condition. This bam file is typically generated by merging
    the bam files of all replicates for that condition. The default value is 
    NULL, this specifies that not merged bam files are used, instead on-the-fly
    read extraction and merging is done from the bam files specified in the
    targets argument.   
  }
  \item{useTransparency}{
    A logical value that specifies if transparency will be used to generate the
    plots, this leads to better looking plot, however not all graphic devices
    support transparency. The default value is FALSE.
  }
  \item{tempFolder}{
    A character value specifying the path to store intermediate files produced
    while extracting and merging reads from bam files. It is only used when 
    preMergedBAMs arguments is NULL. The files created are not automatically 
    removed after plotting because can be reused to create a new plot of the
    same genes or bins with different graphic options. 
    The default value is 'tmp', that means a new 'tmp' folder in the current
    working folder.
  }
  \item{avoidReMergeBams}{
    A logical value specifying that extraction and merging of bam files will be
    avoided. This is only meaningful when the extraction and merging of the same
    set of genes and bins was done in the previous execution of 
    plotGenomicRegions function. The default value is FALSE.  
  }
  \item{verbose}{
    A logical value specifying that detailed information about the execution
    will be informed to the user. The default value is TRUE. 
  }
}

\value{ Returns a png for each selected bin }

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }


\examples{
  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  #library(GenomicFeatures)
  #genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
  #                               package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  #features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  #bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
  #                   "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )
  #targets <- data.frame( 
  #             row.names = paste0('Sample_',c(1:6)),
  #             bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
  #             factor1 = c( 'C','C','C','D','D','D'),
  #             stringsAsFactors = FALSE )
  
  # Plot a single bin to a window
  #plotGenomicRegions( 
  #  features, 
  #  'GENE01:E002', 
  #  genomeTxDb, 
  #  targets, 
  #  sashimi = FALSE,
  #  colors = '#AA4444', 
  #  annotationHeight = 0.1, 
  #  tempFolder = 'tmp', 
  #  verbose = TRUE , 
  #  avoidReMergeBams = FALSE, 
  #  useTransparency = FALSE ) 
  #  
  # plot two bins to pdf files.
  #plotGenomicRegions( 
  #  features, c( 'GENE01:E002', 'GENE02:E002' ), 
  #  genomeTxDb, 
  #  targets, 
  #  layout = matrix( c( 'C', 'D'), ncol = 1),
  #  colors = matrix( c( '#663243', '#363273'), ncol = 1),
  #  plotTitles = matrix( c( 'C condition', 'D condition'), ncol = 1),
  #  sashimi = FALSE,
  #  mainFontSize = 12,
  #  annotationHeight = 0.1, 
  #  tempFolder = 'tmp', 
  #  verbose = TRUE , 
  #  avoidReMergeBams = FALSE, 
  #  useTransparency = TRUE,
  #  outfolder = '.',
  #  outfileType = 'pdf',
  #  deviceOpt = list( height = 6, width = 5, paper = 'a4r' ) ) 
}

\seealso{
  \code{\link{Devices}},
  \code{\link{pdf}}, 
  \code{\link{png}},
  \code{\link{bmp}},
  \code{\link{jpeg}},
  \code{\link{tiff}}
}

\name{ASpliFeatures-class}

\Rdversion{1.1}

\docType{class}

\alias{ASpliFeatures-class}
\alias{featuresb,ASpliFeatures-method}
\alias{featuresg,ASpliFeatures-method}
\alias{featuresj,ASpliFeatures-method}
\alias{transcriptExons,ASpliFeatures-method}
\alias{readCounts,ASpliFeatures-method}
\alias{gbCounts,ASpliFeatures-method}
\alias{plotGenomicRegions,ASpliFeatures-method}
\alias{featuresb<-,ASpliFeatures,GRanges-method}
\alias{featuresg<-,ASpliFeatures,GRangesList-method}
\alias{featuresj<-,ASpliFeatures,GRanges-method}
\alias{transcriptExons<-,ASpliFeatures,GRangesList-method}
\title{Class \code{"ASpliFeatures"}}

\description{Contains Genomic Ranges of different features extracted from a 
  TxDb}

\section{Slots}{
  \describe{
    \item{\code{genes}:}{}
    \item{\code{bins}:}{}
    \item{\code{junctions}:}{}
    \item{\code{transcriptExons}:}{}
  }
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz}

\name{ASpli-deprecated}
\alias{ASpli-deprecated}
\title{Deprecated functions in package \sQuote{ASpli}}

\description{
  These functions are provided for compatibility with older versions
  of \sQuote{ASpli} only, and will be defunct at the next release.
}

\details{

  The following functions are deprecated and will be made defunct; use
  the replacement indicated below:
  \itemize{
    \item{loadBAM: \code{\link{gbCounts}}}
    
    \item{readCounts: \code{\link{gbCounts}}}
    
    \item{AsDiscover: \code{\link{jCounts},
                            \link{splicingReport},    
                            \link{integrateSignals}}}
                            
    \item{DUreport: \code{\link{gbDUreport},
                          \link{jDUreport}}}

    \item{DUreportBinSplice: \code{\link{gbDUreport}}}
    \item{junctionDUreport: \code{\link{jDUreport}}}        
                        
    \item{mergeBinDUAS: \code{\link{splicingReport},
                              \link{integrateSignals}}}
                              
    \item{junctionsPSI: \code{\link{junctionsPJU}}}
    
    \item{plotGenomicRegions: \code{\link{exportSplicingReports}, \link{exportIntegratedSignals}}}   
        

}
    
}
 


 

\name{filterDU}

\alias{filterDU}

\title{Filtering ASpliDU objects}

\description{
  ASpliDU object can be filtered to retain genes, bins or junction according to
  their fdr corrected p-value estimated and log-fold-change.
}

\usage{ 
  filterDU( 
    du , 
    what = c( 'genes','bins','junctions'),
    fdr = 1,
    logFC = 0,
    absLogFC = TRUE,
    logFCgreater = TRUE
  )
}

\arguments{
  \item{du}{ 
    An ASpliDU object }
  \item{what}{ 
    A character vector that specifies the kind of features that will be 
    filtered. Accepted values are 'genes', 'bins', 'junctions'. Multiple values
    can be passed at the same time. The default value is c( 'genes','bins', 
    'junctions')}
  \item{fdr}{
    A double value representing the maximum accepted value of fdr corrected 
    p-value to pass the filter. The default value is 1, the neutral value for 
    fdr filtering operation.  
  }
  \item{logFC}{
    A double value representing the cut-off for accepted values of 
    log-fold-change  to pass the filter. The default value is 0, the neutral 
    value for logFC filtering operation if logFCgreater and absLocFC arguments 
    are both TRUE. 
  }
  \item{absLogFC}{ 
    A logical value that specifies that the absolute value of log-fold-change 
    will be used in the filter operation. The default value is TRUE.}
  \item{logFCgreater}{ 
    A logical value that specifies that the log-fold-change value ( or 
    abs(log-fold-change) if absLogFC argument is TRUE) of features 
    must be greater than the cut-off value to pass the filter.
    The default value is TRUE.}

}

\value{
  A new ASpliDU object with the results of the filtering operations. 
  The elements of features that were not specified to be filtered are kept from 
  the input ASpliDU object.
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\examples{

 # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  #library(GenomicFeatures)
  #genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
  #                               package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  #features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  #bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
  #                   "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )
  #targets <- data.frame( 
  #             row.names = paste0('Sample_',c(1:6)),
  #             bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
  #             factor1 = c( 'C','C','C','D','D','D') )
  
  # Load reads from bam files
  #bams <- loadBAM( targets )
  
  # Read counts from bam files
  #counts   <- readCounts( features, bams, targets, cores = 1, readLength = 100, 
  #                        maxISize = 50000 )
  
  # Calculate differential usage of junctions only 
  #du       <- DUreport.norm( counts, targets )
  
  # Filter by FDR
  #duFiltered1 <- filterDU( du, what=c('genes','bins'), 
  #   fdr = 0.01 )


  # Filter by logFC, only those that were up-regulated 
  #duFiltered2 <- filterDU( du, what=c('genes','bins'), 
  #   logFC = log( 1.5, 2 ),  absLogFC = FALSE )

}

\seealso{
  \code{\link{DUreport.norm}},
  \code{\link{DUreport.offset}},
  \code{\link{jDUreport}},
  \code{\link{gbDUreport}},
}

\name{gbCounts}

\alias{gbCounts}
\alias{readCounts}

\title{
  Summarize read overlaps
}

\description{ Summarize read overlaps against all feature levels }

\usage{
  gbCounts( features, targets, minReadLength,
            maxISize, minAnchor = 10, libType="SE", 
            strandMode=0, alignFastq = FALSE, dropBAM = FALSE)
}

\arguments{
  
  \item{features}{ An object of class ASpliFeatures. It is a list of GRanges 
    at gene, bin and junction level
  }
  
  
  \item{targets}{ A dataframe containing sample, bam and experimental factors 
    columns }
  
  \item{minReadLength}{ Minimum read length of sequenced library. It is used for computing 
    E1I and IE2 read summarization. Make sure this number is smaller than the maximum read length in every bam file, otherwise no E1I or IE2 will be found.}
    
  \item{maxISize}{Maximum intron expected size. Junctions longer than this size
    will be dicarded }
  
  
  \item{minAnchor}{ Minimum percentage of read that should be aligned to 
    an exon-intron boundary.}
    
  \item{libType}{Defines how reads will be treated according their sequencing lybrary type (paired (PE, default) or single end (SE))}
  \item{strandMode}{controls the behavior of the strand getter. It indicates how the strand of a pair should be inferred from the strand of the first and last alignments in the pair. 
  0: strand of the pair is always *.
  1: strand of the pair is strand of its first alignment. This mode should be used when the paired-end data was generated using one of the following stranded protocols: Directional Illumina (Ligation), Standard SOLiD.
  2: strand of the pair is strand of its last alignment. This mode should be used when the paired-end data was generated using one of the following stranded protocols: dUTP, NSR, NNSR, Illumina stranded TruSeq PE protocol. For more information see ?strandMode}

 \item{alignFastq}{Experimental (that means it's highly recommended to, leave the default, FALSE): executes an alignment step previous to Bam summarization. Useful if not enough space on local disks for beans so fasts can be aligned on the fly, even from a remote machine, and then the BAMs can be deleted after each summarization. If set to TRUE, targets data frame must have a column named alignerCall with complete call to aligner for each sample. ie: STAR --runMode alignReads --outSAMtype BAM SortedByCoordinate --readFilesCommand zcat --genomeDir /path/to/STAR/genome/folder -runThreadN 4 --outFileNamePrefix sample_name --readFilesIn /path/to/R1 /path/to/R2. Output must match bam files provided in targets. }

 \item{dropBAM}{Experimental (that means it's highly recommended to leave the default, FALSE): If alignFastq is TRUE, deletes BAMs after sumarization. Used in conjunction with alignFastq to delete BAMs when there's not enough free space on disk. Use with caution as it will delete all files in "bam" column in targets dataframe.}
}

\value{
  An object of class ASpliCounts. Each slot is a dataframe containing features 
  metadata and read counts. Summarization is reported at gene, bin, junction 
  and intron flanking regions (E1I, IE2).
  \item{countsg}{
  symbol: gene symbol
  locus_overlap: other genes overlaping this locus
  gene_coordinates: gene coordinates
  start: gene start
  end: gene end
  length: gene length
  effective_length: gene effective lengh
  From effective_length to the end, gene counts for all samples
  }
  \item{countsb}{
  feature: bin type
  event: type of event asigned by ASpli when bining.
  locus: gene locus
  locus_overlap: genes overlaping the same locus
  symbol: gene symbol
  gene_coordinates: gene coordinates
  start: bin start
  end: bin end
  length: bin length
  From length to the end, bin counts for all samples
  }  
  \item{countsj}{
  junction: annotated junction matching the current junction.
  gene: gene matching the current junction.
  strand: gene strand for the current junction in case a gene matches with the junction.
  multipleHit: semicolon separated list of junctions matching the current junction.
  symbol: gene symbol.
  gene_coordinates: gene coordinates.
  bin_spanned: semicolon separated list of all the bins spaned by this junction.
  j_within_bin: other junctions in the bins.
  From j_within_bin to the end, junction counts for all samples.
  }   
  \item{countse1i}{
  event: type of event asigned by ASpli when bining.
  locus: gene locus
  locus_overlap: genes overlaping the same locus
  symbol: gene symbol
  gene_coordinates: gene coordinates
  start: bin start
  end: bin end
  length: bin length
  From length to the end, bin counts for all samples
  }   
  \item{countsie2}{
  event: type of event asigned by ASpli when bining.
  locus: gene locus
  locus_overlap: genes overlaping the same locus
  symbol: gene symbol
  gene_coordinates: gene coordinates
  start: bin start
  end: bin end
  length: bin length
  From length to the end, bin counts for all samples
  }      
  \item{rdsg}{
  symbol: gene symbol
  locus_overlap: other genes overlaping this locus
  gene_coordinates: gene coordinates
  start: gene start
  end: gene end
  length: gene length
  effective_length: gene effective lengh
  From effective_length to the end, gene counts/effective_length for all samples
  }
  \item{countsb}{
  feature: bin type
  event: type of event asigned by ASpli when bining.
  locus: gene locus
  locus_overlap: genes overlaping the same locus
  symbol: gene symbol
  gene_coordinates: gene coordinates
  start: bin start
  end: bin end
  length: bin length
  From length to the end, bin counts/length for all samples
  }    
  \item{condition.order}{
    The order in which ASpli is reading the conditions. This is useful for contrast tests, in order to make sure which conditions are being contrasted.
  }
}

\author{   Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\seealso{
  Accesors: \code{\link{countsg}}, 
            \code{\link{countsb}},
            \code{\link{countsj}},
            \code{\link{countse1i}},
            \code{\link{countsie2}},
            \code{\link{rdsg}},
            \code{\link{rdsb}},
            \code{\link{condition.order}},
  Export:   \code{\link{writeCounts}}
}

\examples{
  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  library(GenomicFeatures)
  genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
                                 package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
                     "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )
                     
  targets <- data.frame( 
               row.names = paste0('Sample_',c(1:6)),
               bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
               factor1 = c( 'C','C','C','D','D','D'),
               subject = c(0, 1, 2, 0, 1, 2))
  
  # Read counts from bam files
  gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
  # Access summary and gene and bin counts and display them
  gbcounts
  countsg(gbcounts)
  countsb(gbcounts)

  # Export data
  writeCounts( gbcounts, output.dir = paste0(tempdir(), "/only_counts") )
  
}

\name{splicingReport}

\alias{splicingReport}

\title{
  Splicing report
}

\description{
This function integrates bin and junction usage in a comprehensive report
}

\usage{
  splicingReport(bdu, jdu, counts)
}

\arguments{
  \item{bdu}{ 
    An object of class \code{ASpliDU}
}
  \item{jdu}{ 
    An object of class \code{ASpliJDU}
  }
  \item{counts}{ 
    An object of class \code{ASpliCounts}
  }
}

\value{ 
  An \code{ASpliSplicingReport} object with junction differential usage report. See vignette for more details
  
}

\author{   Andres Rabinovich, Estefania Mancini, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz }

\seealso{
  Accesors: \code{\link{binbased}}, 
            \code{\link{localebased}},
            \code{\link{anchorbased}},
  Export:   \code{\link{writeSplicingReport}}
  \code{\link{gbDUreport}}, \code{\link{jDUreport}}, \code{\link{ASpliSplicingReport}},  \code{\link{splicingReport}}
}


\examples{

# Create a transcript DB from gff/gtf annotation file.
# Warnings in this examples can be ignored. 
library(GenomicFeatures)
genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
                                 package="ASpli") )
  
# Create an ASpliFeatures object from TxDb
features <- binGenome( genomeTxDb )
  
# Define bam files, sample names and experimental factors for targets.
bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
                     "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )

targets <- data.frame( 
               row.names = paste0('Sample_',c(1:6)),
               bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
               factor1 = c( 'C','C','C','D','D','D'),
               subject = c(0, 1, 2, 0, 1, 2))
  
# Read counts from bam files
gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
jcounts   <- jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0)
                     

# Test for factor1 controlling for paired subject
gbPaired <- gbDUreport(gbcounts, formula = formula(~subject+factor1))
jPaired  <- jDUreport(jcounts, formula = formula(~subject+factor1))
  
# Generate a splicing report merging bins and junctions DU
sr              <- splicingReport(gbPaired, jPaired, gbcounts)

# Access splicing report elements
sr  
localebased(sr)
anchorbased(sr)
binbased(sr)
}

\name{loadBAM}

\alias{loadBAM}

\title{ Load BAM files }

\description{
  Load BAM files into R session using a targets specification.
}

\usage{ loadBAM(targets, cores,  libType, strandMode) }

\arguments{
  \item{targets}{A data frame containing sample, bam and experimental factors 
    columns }
  \item{cores}{Number of processors to use}
  \item{libType}{Options are: "SE" or "PE"}
  \item{strandMode}{Options are: 0,1,2. See ?strandMode for more information}
}

\value{
  A list of GAlignments or GAlignmentPairs  . Each element of the list correspond to a samples BAM 
  file.
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\examples{

  # Define bam files, sample names and experimental factors for targets.
  #bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
  #                   "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )
  
  #targets <- data.frame( 
  #             row.names = paste0('Sample_',c(1:6)),
  #             bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
  #             factor1 = c( 'C','C','C','D','D','D') )
               
  # Load reads from bam files
  #bams <- loadBAM( targets )
  
}

\name{Counts accesors}
\alias{countsb}
\alias{countse1i}
\alias{countsg}
\alias{countsie2}
\alias{countsj}
\alias{rdsg}
\alias{rdsb}
\alias{condition.order}
\alias{targets}
\alias{countsb<-}
\alias{countse1i<-}
\alias{countsg<-}
\alias{countsie2<-}
\alias{countsj<-}
\alias{rdsg<-}
\alias{rdsb<-}

\title{
Accessors for ASpliCounts object
}
\description{
Accessors for ASpliCounts object
}
\usage{
countsb(x)
countse1i(x)
countsg(x)
countsie2(x)
countsj(x)
rdsg(x)
rdsb(x)
condition.order(x)
targets(x)
}
\arguments{
  \item{x}{   
  An ASpliCounts object 
  }
}
\value{
Returns dataframes with counts by sample and genomic metadata
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\examples{

# Get data tables from an ASpliCounts object

#counts <- aspliCountsExample() 

#cb1  <- countsb(counts)
#ce1i <- countse1i(counts)
#cg   <- countsg(counts)
#cie2 <- countsie2(counts)
#cj   <- countsj(counts)
#rg   <- rdsg(counts)
#rb   <- rdsb(counts)
#co   <- condition.order(counts)
#tg   <- targets(counts)

# Set data tables to an ASpliCounts object

#countsb(counts)   <- cb1
#countse1i(counts) <- ce1i
#countsg(counts)   <- cg
#countsie2(counts) <- cie2
#countsj(counts)   <- cj
#rdsg(counts)      <- rg
#rdsb(counts)      <- rb
}

\name{ASpliIntegratedSignals-class}

\Rdversion{1.1}

\docType{class}

\alias{ASpliIntegratedSignals}
\alias{ASpliIntegratedSignals-class}
\alias{signals,ASpliIntegratedSignals-method}
\alias{filters,ASpliIntegratedSignals-method}
\alias{signals<-,ASpliIntegratedSignals,data.frame-method}
\alias{filters<-,ASpliIntegratedSignals,data.frame-method}
\alias{splicingReport,ASpliIntegratedSignals-method}
\alias{show,ASpliIntegratedSignals-method}
\alias{writeIntegratedSignals,ASpliIntegratedSignals-method}
\alias{exportIntegratedSignals,ASpliIntegratedSignals-method}


\title{Class \code{"ASpliIntegratedSignals"}}

\description{ Contains results of differential expression at junction level.
}

\section{Slots}{
  \describe{
    \item{\code{signals}}{}
    \item{\code{filters}}{}
    \item{\code{.ASpliVersion}:}{
      ASpli version when this object was created. It should not be modified by the user.
    }     
  }
}

\author{ Andres Rabinovich, Estefania Mancini, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\name{AS accessors}

\alias{altPSI}
\alias{esPSI}
\alias{irPIR}
\alias{joint}
\alias{junctionsPIR}
\alias{junctionsPJU}
\alias{altPSI<-}
\alias{esPSI<-}
\alias{irPIR<-}
\alias{joint<-}
\alias{junctionsPIR<-}
\alias{junctionsPJU<-}

\title{ Accessors for ASpliAS object }

\description{ Methods to retrieve and set data in ASpliAS object. Setting data 
into an ASpliAS object is not a typical task and must be done with care, because
it can affect the integrity of the object. }

\usage{
altPSI( x )
esPSI( x )
irPIR( x )
joint( x )
junctionsPIR( x )
junctionsPJU( x )
}

\arguments{
  \item{ x }{ An ASpliAS object }
}
\value{ Returns dataframes with genomic metadata and  PSI and PIR metrics }

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\examples{

# Accessing data tables from an ASpliAS object

#as <- aspliASexample()

#ap <- altPSI(as)
#ep <- esPSI(as)
#ip <- irPIR(as)
#j  <- joint(as)
#jpi <- junctionsPIR(as)
#jps <- junctionsPJU(as)

# Setting data tables to an ASpliAS object

#as2 <- new( 'ASpliAS' )

#altPSI( as2 )  <- ap
#esPSI( as2 )  <- ep
#irPIR( as2 )  <- ip
#joint( as2 )  <- j
#junctionsPIR( as2 )  <- jpi
#junctionsPJU( as2 )  <- jps

}

\name{ASpliSplicingReport-class}

\Rdversion{1.1}

\docType{class}

\alias{ASpliSplicingReport}
\alias{ASpliSplicingReport-class}
\alias{anchorbased,ASpliSplicingReport-method}
\alias{binbased,ASpliSplicingReport-method}
\alias{localebased,ASpliSplicingReport-method}
\alias{anchorbased<-,ASpliSplicingReport,data.frame-method}
\alias{localebased<-,ASpliSplicingReport,data.frame-method}
\alias{binbased<-,ASpliSplicingReport,data.frame-method}
\alias{splicingReport,ASpliSplicingReport-method}
\alias{show,ASpliSplicingReport-method}
\alias{writeSplicingReport,ASpliSplicingReport-method}
\alias{integrateSignals,ASpliSplicingReport-method}
\alias{exportSplicingReports,ASpliSplicingReport-method}
\alias{filterSignals,ASpliSplicingReport-method}


\title{Class \code{"ASpliSplicingReport"}}

\description{ Contains results of differential expression at junction level.
}

\section{Slots}{
  \describe{
    \item{\code{binbased}}{}
    \item{\code{localebased}}{}
    \item{\code{anchorbased}}{}
    \item{\code{contrast}}{}
    \item{\code{.ASpliVersion}:}{
      ASpli version when this object was created. It should not be modified by the user.
    }     
  }
}

\author{ Andres Rabinovich, Estefania Mancini, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\name{ASpli-package}
\alias{ASpli-package}
\alias{ASpli}
\docType{package}

\title{ Analysis of Alternative Splicing Using RNAseq }

\description{
  ASpli is an integrative and flexible package that facilitates the 
  characterization of genome-wide changes in AS under different experimental 
  conditions. ASpli analyzes the differential usage of introns, exons, and splice 
  junctions using read counts, and estimates the magnitude of changes in AS by 
  calculating differences in the percentage of exon inclusion or intron retention 
  using splice junctions. This integrative approach allows the identification of 
  changes in both annotated and novel AS events.
  
  ASpli allows users to produce self-explanatory intermediate outputs, based on 
  the aim of their analysis. A typical workflow involves parsing the genome 
  annotation into new features called bins, overlapping read alignments against 
  those bins, and inferring differential bin usage based on the number of reads 
  aligning to the bins and junctions.
}

\details{
  \tabular{ll}{
    Package: \tab ASpli\cr
    Type: \tab Package\cr
    Version: \tab 1.5.1\cr
    Date: \tab 2018-02-22\cr
    License: \tab  GPL\cr
    Depends: \tab methods, GenomicRanges, GenomicFeatures, edgeR, methods, 
    BiocGenerics, IRanges, GenomicAlignments, Gviz
    \cr
  }
}


\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\references{
\itemize{
  \item Acute effects of light on alternative splicing in light-grown plants. 
    Photochemistry and Photobiology. Mancini, E, Sanchez, S, Romanowsky, A, 
    Yanovsky, MJ. DOI: 10.1111/php.12550
  
  \item GEMIN2 attenuates the effects of temperature on alternative splicing and 
    circadian rhythms in Arabidopsis thaliana. Proceedings of the National Academy
    of Sciences. Schlaen, RG, Mancini, E, Sanchez, SE, Perez-Santangelo, S, 
    Rugnone, ML, Simpson, CG, Brown, JWS, Zhang, X, Chernomoretz, A, Yanovsky, 
    MJ. DOI:10.1073/pnas.1504541112
  
  \item Genome wide comparative analysis of the effects of PRMT5 and PRMT4/CARM1 
    arginine methyltransferases on the Arabidopsis thaliana transcriptome. BMC 
    Genomics. Hernando, E, Sanchez, S, Mancini, E, Yanovsky MJ. 
    DOI:10.1186/s12864-015-1399-2
  
  \item A role for LSM genes in the regulation of circadian rhythms. Proceedings 
    of the National Academy of Sciences. Perez Santangelo, S, Mancini, E, Francey, 
    LJ, Schlaen, RG, Chernomoretz, A, Hogenesch, JB, Yanovsky MJ. 
    DOI: 10.1073/pnas.1409791111 
  
  \item The dengue virus NS5 protein intrudes in the cellular spliceosome and 
    modulates splicing. PLOS Pathogens. De Maio, F., Risso, G., Iglesias, G., 
    Shah, P, Pozzi, B., Gebhard, L., Mammi, L., Mancini, E., Yanovsky, M., 
    Andino, R., Krogan, N., Srebrow, A. and Gamarnik, A. 
    DOI:10.1371/journal.ppat.1005841
  }
}

\examples{ 
library(GenomicFeatures)
gtfFileName <- aspliExampleGTF()
genomeTxDb <- txdbmaker::makeTxDbFromGFF( gtfFileName )
features <- binGenome( genomeTxDb )
BAMFiles <- aspliExampleBamList()
targets <- data.frame( 
  row.names = paste0('Sample',c(1:12)),
  bam = BAMFiles,
  f1 = c( 'A','A','A','A','A','A',
          'B','B','B','B','B','B'),
  f2 = c( 'C','C','C','D','D','D',
          'C','C','C','D','D','D'),
  stringsAsFactors = FALSE)
  getConditions(targets)
  mBAMs <- data.frame(bam      = sub("_[02]","",targets$bam[c(1,4,7,10)]),
                      condition= c("A_C","A_D","B_C","B_D"))

gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
asd   <- jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0)
                     
   
gb      <- gbDUreport(counts=gbcounts,
contrast = c( 1, -1, -1, 1 ) )
jdur    <- jDUreport(asd, 
                     contrast =  c( 1, -1, -1, 1 ) ,
                     mergedBams = mBAMs)
sr      <- splicingReport(gb, jdur, counts =gbcounts    )
is      <- integrateSignals(sr,asd)
}

\keyword{ RNA-seq alternative splicing analysis using bin coverage and junctions }

\name{integrateSignals}

\alias{integrateSignals}

\title{
  Integrate signals
}
\description{
Integrates differential usage signals from different sources using overlaping regions. See vignette for more details
}

\usage{
  integrateSignals(sr = NULL, asd = NULL, bin.FC = 3, bin.fdr = 0.05,
                 nonunif = 1, usenonunif = FALSE, bin.inclussion = 0.2,
                 bjs.inclussion = 10.3, bjs.fdr = 0.01, a.inclussion =
                 0.3, a.fdr = 0.01, l.inclussion = 0.3, l.fdr = 0.01,
                 otherSources = NULL, overlapType = "any")
}

\arguments{
  \item{sr}{ 
    An object of class \code{ASpliSplicingReport}
  }
  \item{asd}{ 
    An object of class \code{ASpliDU}
  }  
  \item{bin.FC}{
    Filter bin signals by fold change. Actually, log2 fold change is return, so default would return only bin signlas with bin.fc > log2(3).
  }
  \item{bin.fdr}{
    Filter bin signals by fdr.
  }
  \item{nonunif}{
    Filter intronic bins with non uniform support (nonunif << 1 is uniform)
  }
  \item{usenonunif}{
    Use non uniformity as filter.
  }
  \item{bin.inclussion}{
    Filter bin signals by junction support with dPIR or dPSI accordingly.
  }
  \item{bjs.inclussion}{
    Filter annotated junction signals by junction inclussion with dPIR or dPSI accordingly.
  }
  \item{bjs.fdr}{
    Filter annotated junction signals by fdr.
  }
  \item{a.inclussion}{
    Filter anchor junction signals by junction inclussion with dPIR.
  }
  \item{a.fdr}{
    Filter anchor junction signals by fdr.
  }
  \item{l.inclussion}{
    Filter locale junction signals by junction inclussion with dPSI.
  }
  \item{l.fdr}{
    Filter locale junction signals by fdr.
  }
  \item{otherSources}{
    If user wants to compare ASpli results with results from other methods, otherSources must be a GenomicRange object with all the regions found with the other methods. It will be integrated with a new column next to signals information.  }
  
  \item{overlapType}{
  Type of regions overlap matching between the different signals. Defaults to "any" and can be any of the following: "any", "start", "end", "within", "equal".
  }    
}

\value{ 
  It returns A \code{ASpliIntegratedSignals} with all overlaping signals present in the region filtered by different parameters.
  }

\author{
  Andres Rabinovich, Estefania Mancini, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz
}


\examples{
  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  library(GenomicFeatures)
  genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
                                 package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  features <- binGenome( genomeTxDb )
  
  # Define bam files, sample names and experimental factors for targets.
  bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
                     "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )

  targets <- data.frame( 
               row.names = paste0('Sample_',c(1:6)),
               bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
               factor1 = c( 'C','C','C','D','D','D'),
               subject = c(0, 1, 2, 0, 1, 2))
  
  # Read counts from bam files
gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)
jcounts   <- jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0)
                     

  # Test for factor1 controlling for paired subject
  gbPaired <- gbDUreport(gbcounts, formula = formula(~subject+factor1))
  jPaired  <- jDUreport(jcounts, formula = formula(~subject+factor1))
  
  # Generate a splicing report merging bins and junctions DU
  sr       <- splicingReport(gbPaired, jPaired, gbcounts)
  is       <- integrateSignals(sr, jcounts)
  
  # Show integrate signals results and filters used
  signals(is)
  filters(is)

}

\seealso{
Accesors: \link{signals}, 
          \link{filters},
Export:   \link{exportIntegratedSignals}
  \code{\link{gbDUreport}}, \code{\link{jDUreport}}, \code{\link{ASpliSplicingReport}},  \code{\link{splicingReport}}, \code{\link{ASpliIntegratedSignals}}

}

\name{splicingReport accessors}
\alias{binbased}
\alias{binbased<-}
\alias{localebased}
\alias{localebased<-}
\alias{anchorbased}
\alias{anchorbased<-}


\title{Accessors for ASpliSplicingReport object}

\description{ Accessors for ASpliSplicingReport object }
\usage{ 
  binbased( x )
  localebased( x )
  anchorbased( x )
}

\arguments{
  \item{ x }{ An ASpliSplicingReport object }
}

\value{ Returns dataframes }


\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }

\name{jCounts}
\alias{jCounts}
\alias{AsDiscover}

\title{ Report PSI, PJU and PIR using experimental junctions }

\description{ Summarize read overlaps against junctions.
              Report PSI, PJU, PIR and counts for experimental junctions.
              PSI or PIR metrics are calculated for each bin and experimental condition.
              The selection of which metric is used is based on the kind of splicing event 
              associated with each bin. 
}
 
\usage{ 
 jCounts( counts, features, minReadLength, 
          threshold = 5, minAnchor = 10, libType="SE", 
          strandMode=0, alignFastq = FALSE, dropBAM = FALSE )
}
\arguments{
\item{counts}{
An object of class ASpliCounts.
}

\item{features}{ An object of class ASpliFeatures.}


\item{minReadLength}{ Minimum read length of sequenced library. It is used for computing 
    E1I and IE2 read summarization. Make sure this number is smaller than the maximum read length in every bam file, otherwise no junctions will be found.}

\item{threshold}{ Minimum  number of reads supporting junctions. Default=5 }
\item{minAnchor}{ An intronic junction must overlap completely and at least an minAnchor\% into the exon region and the intron region. The regions can be exon1-intron or intron-exon2.}
 \item{libType}{Defines how reads will be treated according their sequencing lybrary type (paired (PE, default) or single end (SE))}
 \item{strandMode}{controls the behavior of the strand getter. It indicates how the strand of a pair should be inferred from the strand of the first and last alignments in the pair. 
  0: strand of the pair is always *.
  1: strand of the pair is strand of its first alignment. This mode should be used when the paired-end data was generated using one of the following stranded protocols: Directional Illumina (Ligation), Standard SOLiD.
 2: strand of the pair is strand of its last alignment. This mode should be used when the paired-end data was generated using one of the following stranded protocols: dUTP, NSR, NNSR, Illumina stranded TruSeq PE protocol. For more information see ?strandMode}
 \item{alignFastq}{Experimental (that means it's highly recommended to, leave the default, FALSE): executes an alignment step previous to Bam summarization. Useful if not enough space on local disks for beans so fasts can be aligned on the fly, even from a remote machine, and then the BAMs can be deleted after each summarization. If set to TRUE, targets data frame must have a column named alignerCall with complete call to aligner for each sample. ie: STAR --runMode alignReads --outSAMtype BAM SortedByCoordinate --readFilesCommand zcat --genomeDir /path/to/STAR/genome/folder -runThreadN 4 --outFileNamePrefix sample-name --readFilesIn /path/to/R1 /path/to/R2. Output must match bam files provided in targets. }

 \item{dropBAM}{Experimental (that means it's highly recommended to leave the default, FALSE): If alignFastq is TRUE, deletes BAMs after sumarization. Used in conjunction with alignFastq to delete BAMs when there's not enough free space on disk. Use with caution as it will delete all files in "bam" column in targets dataframe.}

}
\value{ 
An object of class ASpliAS.
Accesors: irPIR, esPSI, altPSI, junctionsPIR, junctionsPJU

\item{irPIR}{
event: Type of event asigned by ASpli when bining.
J1: Semicolon separated list of all the junctions with an end matching the start of the intron.
J2: Semicolon separated list of all the junctions with an end matching the end of the intron.
J3: Semicolon separated list of all the junctions overlaping the intron.
All the columns from J1 to J2 represent the J1 counts in the different samples for each bin. The counts are the sum of all the J1 junctions.
All the columns from J2 to J3 represent the J2 counts in the different samples for each bin. The counts are the sum of all the J2 junctions.
All the columns from J3 to the first condition represent the J3 counts in the different samples for each bin. The counts are the sum of all the J3 junctions.
The last columns are the PIR metrics calculated for each condition. The PIR metric is calculated as:  
  \deqn{ PIR = \frac{J1 + J2}{J1 + J2 + 2*J3}}{PIR = (J1 + J2)/(J1 + J2 + 2*J3) }
  Where the junctions are the sum by condition.
}

\item{altPSI}{ 
event: Type of event asigned by ASpli when bining.
J1(J2): Semicolon separated list of all the junctions with an end matching the end of alt5'SS(alt3'SS).
J3: Semicolon separated list of all the junctions with an end matching the start of alt5'SS or the start of alt3'SS.
All the columns from J1 to J2 represent the J1 counts in the different samples for each bin. The counts are the sum of all the J1 junctions.
All the columns from J2 to J3 represent the J2 counts in the different samples for each bin. The counts are the sum of all the J2 junctions.
All the columns from J3 to the first condition represent the J3 counts in the different samples for each bin. The counts are the sum of all the J3 junctions.
The last columns are the PSI metrics calculated for each condition. The PSI metric is calculated as:  
  \deqn{ PSI = \frac{J12}{J12 + J3}}{PSI = (J12)/(J12 + J3) }  
  Where J12 is J1 if it's an alt 5' event or J2 if it's an alt 3' event and the junctions are the sum by condition.
}

\item{esPSI}{ 
event: Type of event asigned by ASpli when bining
J1: Semicolon separated list of all the junctions with an end on the alternative exon.
J2: Semicolon separated list of all the junctions with an end on the alternative exon.
J3: Semicolon separated list of all the junctions overlaping the alternative exon.
All the columns from J1 to J2 represent the J1 counts in the different samples for each bin. The counts are the sum of all the J1 junctions.
All the columns from J2 to J3 represent the J2 counts in the different samples for each bin. The counts are the sum of all the J2 junctions.
All the columns from J3 to the first condition represent the J3 counts in the different samples for each bin. The counts are the sum of all the J3 junctions.
The PSI metric is calculated as:  
  \deqn{ PSI = \frac{J1 + J2}{J1 + J2 + 2*J3}}{PSI = (J1 + J2)/(J1 + J2 + 2*J3) }  
  Where the junctions are the sum by condition.  
}

\item{junctionsPIR}{
PIR metric for each experimental junction using e1i and ie2 counts. Exclusion 
junction is the junction itself. This output helps to discover new introns as 
well as new retention events.
hitIntron: If the junction matches a bin, the bin is shown here. 
hitIntronEvent: If the junction matches a bin, the type of event asigned by ASpli to this bin.
All the columns from hitIntronEvent up to the first repetition of the samples names in the columns, represent the J1 counts in the different samples for each region. 
From there to the next time the names of the columns repeat themselves, the J2 counts and from there to the first condition, the J3 counts. 
The last columns are the PIR metrics calculated for each condition. The PIR metric is calculated as:  
  \deqn{ PIR = \frac{J1 + J2}{J1 + J2 + 2*J3}}{PIR = (J1 + J2)/(J1 + J2 + 2*J3) }  
  Where the junctions are the sum by condition.   
}

\item{junctionsPJU}{
  Given a junction, it is possible to analyze if it shares start, end or both with another junction. If so, it is because there is alternative splicing. 
  Junction: name of the junction.
  gene: gene it belongs to.
  strand: gene strand.
  multipleHit: if other gene overlaps the gene the junction belongs to.
  symbol: gene symbol.
  gene_coordinates: gene coordinates.
  bin_spanned: semicolon separated list of all the bins spaned by this junction.
  j_within_bin: other junctions in the bins.
  StartHit: all the junctions sharing the start with this junction and \eqn{PJU_{J1}=J3/(J1+J3)} for each condition, 
  EndHit: all the junctions sharing the end with this junction and \eqn{PJU_{J2}=J3/(J2+ J3)} for each condition. 
  All the columns between j_within_bin and StartHit are the counts for J3 in the different samples for each region. 
  From there to EndHit, the J1 counts and \eqn{PJU_{J1}=J3/(J1+ J3)} for each condition. 
  Then after EndHit, the J2 counts and \eqn{PJU_{J2}=J3/(J2+ J3)}.
  Rownames are J3 range. StartHit is J1 range and EndHit is J2 range.
}

}
\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky and Ariel Chernomoretz }

\examples{
  # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  library(GenomicFeatures)
  genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
                                 package="ASpli") )
  
  # Create an ASpliFeatures object from TxDb
  features <- binGenome( genomeTxDb )
    
  # Define bam files, sample names and experimental factors for targets.
  bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
                     "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )

  targets <- data.frame( 
               row.names = paste0('Sample_',c(1:6)),
               bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
               factor1 = c( 'C','C','C','D','D','D'),
               subject = c(0, 1, 2, 0, 1, 2))
  
  # Read counts from bam files
gbcounts  <- gbCounts( features = features, 
                           targets = targets, 
                           minReadLength = 100, maxISize = 50000,
                           libType="SE", 
                           strandMode=0)

jcounts   <- jCounts(counts = gbcounts, 
                     features = features, 
                     minReadLength = 100,
                     libType="SE", 
                     strandMode=0)
  
  # Access summary and gene and bin counts and display them
  gbcounts
  countsg(gbcounts)
  countsb(gbcounts)
  
  # Access summary and junction counts and display them
  jcounts
  irPIR(jcounts)
  esPSI(jcounts)
  altPSI(jcounts)
  junctionsPIR(jcounts)
  junctionsPJU(jcounts)
  
  
  # Export data
  writeAS( as = jcounts, output.dir = paste0(tempdir(), "/only_as") )

}

\seealso{

Accesors: \code{\link{irPIR}}, \code{\link{altPSI}}, \code{\link{esPSI}}, 
\code{\link{junctionsPIR}}, \code{\link{junctionsPJU} }

Export: \code{ \link{writeAS} }

}

\name{ASpliCounts-class}

\docType{class}

\alias{ASpliCounts-class}
\alias{jCounts,ASpliCounts-method}
\alias{DUreport,ASpliCounts-method}
\alias{DUreportBinSplice,ASpliCounts-method}
\alias{junctionDUreport,ASpliCounts-method}
\alias{AsDiscover,ASpliCounts-method}
\alias{countsb,ASpliCounts-method}
\alias{countse1i,ASpliCounts-method}
\alias{countsg,ASpliCounts-method}
\alias{countsie2,ASpliCounts-method}
\alias{countsj,ASpliCounts-method}
\alias{targets,ASpliCounts-method}
\alias{countsb<-,ASpliCounts,data.frame-method}
\alias{countse1i<-,ASpliCounts,data.frame-method}
\alias{countsg<-,ASpliCounts,data.frame-method}
\alias{countsie2<-,ASpliCounts,data.frame-method}
\alias{countsj<-,ASpliCounts,data.frame-method}
\alias{targets<-,ASpliCounts,data.frame-method}
\alias{gbDUreport,ASpliCounts-method}
\alias{DUreport.norm,ASpliCounts-method}
\alias{DUreport.offset,ASpliCounts-method}
\alias{plotBins,ASpliCounts-method}
\alias{rdsb,ASpliCounts-method}
\alias{rdsg,ASpliCounts-method}
\alias{rdsb<-,ASpliCounts,data.frame-method}
\alias{rdsg<-,ASpliCounts,data.frame-method}
\alias{condition.order,ASpliCounts-method}
\alias{rds,ASpliCounts-method}
\alias{subset,ASpliCounts-method}
\alias{writeAll,ASpliCounts-method}
\alias{writeCounts,ASpliCounts-method}
\alias{writeRds,ASpliCounts-method}


\title{Class \code{"ASpliCounts"}}

\description{ Contains results of read overlaps against all feature levels 
  summarization }

\section{ Slots }{
  \describe{
    \item{\code{gene.counts}:}{Object of class \code{"data.frame"}  }
    \item{\code{exon.intron.counts}:}{Object of class \code{"data.frame"}  }
    \item{\code{junction.counts}:}{Object of class \code{"data.frame"} }
    \item{\code{e1i.counts}:}{Object of class \code{"data.frame"} }
    \item{\code{ie2.counts}:}{Object of class \code{"data.frame"}  }
    \item{\code{gene.rd}:}{Object of class \code{"data.frame"} }
    \item{\code{bin.rd}:}{Object of class \code{"data.frame"} }
    \item{\code{condition.order}:}{Object of class \code{"character"} }
    \item{\code{targets}:}{Object of class \code{"data.frame"} }
    \item{\code{.ASpliVersion}:}{
      ASpli version when this object was created. It should not be modified by the user.
    }     
  }
}

\section{Methods}{
  \describe{
    \item{AsDiscover}{ psi and pir metrics}
    \item{countsb}{bin counts accesor}
    \item{countse1i}{ e1i counts accesor}
    \item{countsg}{ gene counts accesor}
    \item{countsie2}{ie2 counts accesor}
    \item{countsj}{junction counts accesor}
    \item{DUreport_DEXSeq}{ differential expression and usage estimation 
      using DEXSeq }
    \item{DUreport}{differential expression and usage estimation using DEXSeq}
    \item{rdsb}{bin read densities accesor}
    \item{rdsg}{gen read densities acceesor}
    \item{rds}{compute read densities on genes and bins}
    \item{writeCounts}{Export count tables}
    \item{writeRds}{Export read density tables}
	 }
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz}

\name{junctionDUreport}

\alias{junctionDUreport}

\title{
  Differential junction usage estimation
}
\description{
  Estimate differential usage at junction level. When targets has only two 
  conditions, and contrast is not set, the estimation of differential expression
  and usage is done with an exact test, otherwise is estimated using a 
  generalized linear model.
}

\usage{
  junctionDUreport( counts, 
                    targets,
                    appendTo = NULL, 
                    minGenReads = 10, 
                    minRds = 0.05,
                    threshold = 5,
                    offset = FALSE, 
                    offsetUseFitGeneX = TRUE,
                    contrast = NULL, 
                    forceGLM = FALSE)
}

\arguments{
  \item{ counts }{ 
    An object of class \code{ASpliCounts}
  }
  \item{ targets }{
    A dataframe containing sample, bam and experimental factor columns.
  }
  \item{ appendTo }{ An object of class \code{ASpliDU} to which append the 
    results of junction differential usage. If \code{appendTo} is \code{NULL} a 
    new \code{ASpliDU} is created
  }  
  \item{ minGenReads }{
    Junctions within genes with at least an average of \code{minGenReads} reads
    for all conditions are included into the differential junction usage test.
    Default value is 10 reads.
  }
  \item{ minRds }{
    Junctions within genes with at least an average of \code{minRds} read 
    density for all conditions are included into the differential bin usage 
    test. Junctions with at least an average of \code{minRds} read density for
    any condition are included into the differential junction usage test.
    Default value is 0.05.
  }
  \item{threshold}{
    Junction with at least \code{threshold} counts are included into the 
    differential usage test. }
  \item{offset}{ Corrects junction counts using an offset matrix derived from 
    gene expression data. Default = FALSE}
  \item{offsetUseFitGeneX}{ Fit a GLM using gene counts to build the offset 
    matrix. This argument is used only when 'offset' argument is set to TRUE.
    The default value is TRUE } 
  \item{contrast}{ Define the comparison between conditions to be tested.
    \code{contrast} should be a vector with length equal to the number of 
    experimental conditions defined by \code{targets}. The values of this vector
    are the coefficients that will be used to weight each condition, the order 
    of the values corresponds to the order given by \code{getConditions} 
    function. When \code{contrast} is NULL, defaults to a vector containing -1,
    as the first value, 1 as the second an zero for all the remaining values, 
    this corresponds to a pair comparison where the first condition is assumed 
    to be a control and the second condition is the treatment, all other 
    conditions are ignored. 
    Default = NULL}
  \item{forceGLM}{ Force the use of a generalized linear model to estimate 
    differential expression and usage. Default = FALSE }
}

\value{ 
  An \code{ASpliDU} object with results of differential usage of junctions }

\author{
  Estefania Mancini, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz
}

\examples{
	#This function has been deprecated. Please see vignette for new pipeline.
}

\seealso{
  \code{\link{edgeR}}, \code{\link{DUreport}}
  Accessors: \code{\link{junctionsDU}}
  Export: \code{\link{writeDU}}
}

\name{rds}
\alias{rds}

\title{
  Read density of gene and bins
}

\description{
  Read density of gene and bins is the quotient between the number of read 
  counts and the length of the feature. The results are appended into an 
  ASpliCounts object that must be given as argument. The explicit calculation 
  of read densities is usually not required because is automatically performed
  by \code{readCounts} function.
}

\usage{
  rds( counts, targets )
}

\arguments{
  \item{counts}{ An ASpliCounts object }
  \item{targets}{ A data frame containing sample, bam and experimental factors 
    columns}
}

\value{
  An ASpliCounts object containing read densities of genes and bins.
}

\examples{
    # Create a transcript DB from gff/gtf annotation file.
  # Warnings in this examples can be ignored. 
  #library(GenomicFeatures)
  #genomeTxDb <- txdbmaker::makeTxDbFromGFF( system.file('extdata','genes.mini.gtf', 
  #                               package="ASpli") )
  #
  ## Create an ASpliFeatures object from TxDb
  #features <- binGenome( genomeTxDb )
#  
#  # Define bam files, sample names and experimental factors for targets.
#  bamFileNames <- c( "A_C_0.bam", "A_C_1.bam", "A_C_2.bam", 
#                     "A_D_0.bam", "A_D_1.bam", "A_D_2.bam" )
#  targets <- data.frame( 
#               row.names = paste0('Sample_',c(1:6)),
#               bam = system.file( 'extdata', bamFileNames, package="ASpli" ),
#               factor1 = c( 'C','C','C','D','D','D') )
#  
#  # Load reads from bam files
#  bams <- loadBAM( targets )
#  
#  # Read counts from bam files
#  counts   <- readCounts( features, bams, targets, cores = 1, readLength = 100, 
#                          maxISize = 50000 )
#                          
#  # Calculates read densities
#  counts <- rds( counts, targets )
}

\author{ Estefania Mancini, Andres Rabinovich, Javier Iserte, Marcelo Yanovsky, Ariel Chernomoretz  }
